/**
 * Datascript v0.18.4
 *
 * Copyright 2014-2019 Nikita Prokopov
 *
 * Licensed under Eclipse Public License;
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://github.com/tonsky/datascript/blob/master/LICENSE
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function (definition) {
    // This file will function properly as a <script> tag, or a module
    // using CommonJS and NodeJS or RequireJS module formats. In
    // Common/Node/RequireJS, the module exports the mori API and when
    // executed as a simple <script>, it creates a mori global
    // instead.

    // Wrapper gratefully adapted from:
    // https://github.com/kriskowal/q/blob/v1/q.js
    // https://github.com/swannodette/mori/blob/master/support/wrapper.js

    // CommonJS
    if (typeof exports === "object") {
        module.exports = definition();

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
        define(definition);

    // <script>
    } else {
        datascript = definition();
    }
})(function () {
    return function () {
if(typeof Math.imul == "undefined" || (Math.imul(0xffffffff,5) == 0)) {
    Math.imul = function (a, b) {
        var ah  = (a >>> 16) & 0xffff;
        var al = a & 0xffff;
        var bh  = (b >>> 16) & 0xffff;
        var bl = b & 0xffff;
        // the shift by 0 fixes the sign on the high part
        // the final |0 converts the unsigned value into a signed value
        return ((al * bl) + (((ah * bl + al * bh) << 16) >>> 0)|0);
    }
}


var f,aa=this;
function ba(a){var b=typeof a;if("object"==b)if(a){if(a instanceof Array)return"array";if(a instanceof Object)return b;var c=Object.prototype.toString.call(a);if("[object Window]"==c)return"object";if("[object Array]"==c||"number"==typeof a.length&&"undefined"!=typeof a.splice&&"undefined"!=typeof a.propertyIsEnumerable&&!a.propertyIsEnumerable("splice"))return"array";if("[object Function]"==c||"undefined"!=typeof a.call&&"undefined"!=typeof a.propertyIsEnumerable&&!a.propertyIsEnumerable("call"))return"function"}else return"null";else if("function"==
b&&"undefined"==typeof a.call)return"object";return b}var da="closure_uid_"+(1E9*Math.random()>>>0),ea=0;function fa(a,b){a=a.split(".");var c=aa;a[0]in c||!c.execScript||c.execScript("var "+a[0]);for(var d;a.length&&(d=a.shift());)a.length||void 0===b?c=c[d]&&c[d]!==Object.prototype[d]?c[d]:c[d]={}:c[d]=b};function ha(a){return String(a.charAt(0)).toUpperCase()+String(a.substr(1)).toLowerCase()};function ia(a){var b=a.length;if(0<b){for(var c=Array(b),d=0;d<b;d++)c[d]=a[d];return c}return[]}function ja(a,b){a.sort(b||ka)}function la(a,b){for(var c=Array(a.length),d=0;d<a.length;d++)c[d]={index:d,value:a[d]};var e=b||ka;ja(c,function(a,b){return e(a.value,b.value)||a.index-b.index});for(d=0;d<a.length;d++)a[d]=c[d].value}function ka(a,b){return a>b?1:a<b?-1:0};function na(a){var b=[],c=0,d;for(d in a)b[c++]=d;return b};function oa(a,b){this.wa=[];this.Ba=b;for(var c=!0,d=a.length-1;0<=d;d--){var e=a[d]|0;c&&e==b||(this.wa[d]=e,c=!1)}}var pa={};function qa(a){if(-128<=a&&128>a){var b=pa[a];if(b)return b}b=new oa([a|0],0>a?-1:0);-128<=a&&128>a&&(pa[a]=b);return b}function ra(a){if(isNaN(a)||!isFinite(a))return sa;if(0>a)return ua(ra(-a));for(var b=[],c=1,d=0;a>=c;d++)b[d]=a/c|0,c*=va;return new oa(b,0)}var va=4294967296,sa=qa(0),wa=qa(1),xa=qa(16777216);
function za(a){if(-1==a.Ba)return-za(ua(a));for(var b=0,c=1,d=0;d<a.wa.length;d++){var e=Aa(a,d);b+=(0<=e?e:va+e)*c;c*=va}return b}f=oa.prototype;f.toString=function(a){a=a||10;if(2>a||36<a)throw Error("radix out of range: "+a);if(Ca(this))return"0";if(-1==this.Ba)return"-"+ua(this).toString(a);for(var b=ra(Math.pow(a,6)),c=this,d="";;){var e=Fa(c,b),g=e.multiply(b);c=c.add(ua(g));g=((0<c.wa.length?c.wa[0]:c.Ba)>>>0).toString(a);c=e;if(Ca(c))return g+d;for(;6>g.length;)g="0"+g;d=""+g+d}};
function Aa(a,b){return 0>b?0:b<a.wa.length?a.wa[b]:a.Ba}function Ca(a){if(0!=a.Ba)return!1;for(var b=0;b<a.wa.length;b++)if(0!=a.wa[b])return!1;return!0}f.compare=function(a){a=this.add(ua(a));return-1==a.Ba?-1:Ca(a)?0:1};function ua(a){for(var b=a.wa.length,c=[],d=0;d<b;d++)c[d]=~a.wa[d];return(new oa(c,~a.Ba)).add(wa)}
f.add=function(a){for(var b=Math.max(this.wa.length,a.wa.length),c=[],d=0,e=0;e<=b;e++){var g=d+(Aa(this,e)&65535)+(Aa(a,e)&65535),h=(g>>>16)+(Aa(this,e)>>>16)+(Aa(a,e)>>>16);d=h>>>16;g&=65535;h&=65535;c[e]=h<<16|g}return new oa(c,c[c.length-1]&-2147483648?-1:0)};
f.multiply=function(a){if(Ca(this)||Ca(a))return sa;if(-1==this.Ba)return-1==a.Ba?ua(this).multiply(ua(a)):ua(ua(this).multiply(a));if(-1==a.Ba)return ua(this.multiply(ua(a)));if(0>this.compare(xa)&&0>a.compare(xa))return ra(za(this)*za(a));for(var b=this.wa.length+a.wa.length,c=[],d=0;d<2*b;d++)c[d]=0;for(d=0;d<this.wa.length;d++)for(var e=0;e<a.wa.length;e++){var g=Aa(this,d)>>>16,h=Aa(this,d)&65535,k=Aa(a,e)>>>16,l=Aa(a,e)&65535;c[2*d+2*e]+=h*l;Ga(c,2*d+2*e);c[2*d+2*e+1]+=g*l;Ga(c,2*d+2*e+1);c[2*
d+2*e+1]+=h*k;Ga(c,2*d+2*e+1);c[2*d+2*e+2]+=g*k;Ga(c,2*d+2*e+2)}for(d=0;d<b;d++)c[d]=c[2*d+1]<<16|c[2*d];for(d=b;d<2*b;d++)c[d]=0;return new oa(c,0)};function Ga(a,b){for(;(a[b]&65535)!=a[b];)a[b+1]+=a[b]>>>16,a[b]&=65535,b++}
function Fa(a,b){if(Ca(b))throw Error("division by zero");if(Ca(a))return sa;if(-1==a.Ba)return-1==b.Ba?Fa(ua(a),ua(b)):ua(Fa(ua(a),b));if(-1==b.Ba)return ua(Fa(a,ua(b)));if(30<a.wa.length){if(-1==a.Ba||-1==b.Ba)throw Error("slowDivide_ only works with positive integers.");for(var c=wa;0>=b.compare(a);)c=c.shiftLeft(1),b=b.shiftLeft(1);var d=Ha(c,1),e=Ha(b,1);b=Ha(b,2);for(c=Ha(c,2);!Ca(b);){var g=e.add(b);0>=g.compare(a)&&(d=d.add(c),e=g);b=Ha(b,1);c=Ha(c,1)}return d}for(c=sa;0<=a.compare(b);){d=
Math.max(1,Math.floor(za(a)/za(b)));e=Math.ceil(Math.log(d)/Math.LN2);e=48>=e?1:Math.pow(2,e-48);g=ra(d);for(var h=g.multiply(b);-1==h.Ba||0<h.compare(a);)d-=e,g=ra(d),h=g.multiply(b);Ca(g)&&(g=wa);c=c.add(g);a=a.add(ua(h))}return c}f.and=function(a){for(var b=Math.max(this.wa.length,a.wa.length),c=[],d=0;d<b;d++)c[d]=Aa(this,d)&Aa(a,d);return new oa(c,this.Ba&a.Ba)};f.or=function(a){for(var b=Math.max(this.wa.length,a.wa.length),c=[],d=0;d<b;d++)c[d]=Aa(this,d)|Aa(a,d);return new oa(c,this.Ba|a.Ba)};
f.xor=function(a){for(var b=Math.max(this.wa.length,a.wa.length),c=[],d=0;d<b;d++)c[d]=Aa(this,d)^Aa(a,d);return new oa(c,this.Ba^a.Ba)};f.shiftLeft=function(a){var b=a>>5;a%=32;for(var c=this.wa.length+b+(0<a?1:0),d=[],e=0;e<c;e++)d[e]=0<a?Aa(this,e-b)<<a|Aa(this,e-b-1)>>>32-a:Aa(this,e-b);return new oa(d,this.Ba)};function Ha(a,b){var c=b>>5;b%=32;for(var d=a.wa.length-c,e=[],g=0;g<d;g++)e[g]=0<b?Aa(a,g+c)>>>b|Aa(a,g+c+1)<<32-b:Aa(a,g+c);return new oa(e,a.Ba)};function Ia(a,b){null!=a&&this.append.apply(this,arguments)}f=Ia.prototype;f.cc="";f.set=function(a){this.cc=""+a};f.append=function(a,b,c){this.cc+=String(a);if(null!=b)for(var d=1;d<arguments.length;d++)this.cc+=arguments[d];return this};f.clear=function(){this.cc=""};f.toString=function(){return this.cc};var Ka={},La={},Ma;if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof n)var n={};if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof Oa)var Oa=null;if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof Pa)var Pa=null;var Qa=null;if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof Ra)var Ra=null;function Sa(){return new q(null,5,[Ua,!0,Va,!0,Wa,!1,Xa,!1,Ya,null],null)}function r(a){return null!=a&&!1!==a}
function $a(a){return null==a}function ab(a){return a instanceof Array}function cb(a){return"number"===typeof a}function db(a){return null==a?!0:!1===a?!0:!1}function eb(a,b){return a[ba(null==b?null:b)]?!0:a._?!0:!1}function fb(a){return null==a?null:a.constructor}function gb(a,b){var c=fb(b);c=r(r(c)?c.Nd:c)?c.Vc:ba(b);return Error(["No protocol method ",a," defined for type ",c,": ",b].join(""))}function hb(a){var b=a.Vc;return r(b)?b:t.c(a)}
var ib="undefined"!==typeof Symbol&&"function"===ba(Symbol)?Symbol.iterator:"@@iterator";function jb(a){for(var b=a.length,c=Array(b),d=0;;)if(d<b)c[d]=a[d],d+=1;else break;return c}var kb=function kb(a){switch(arguments.length){case 2:return kb.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return kb.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};kb.b=function(a,b){return a[b]};
kb.h=function(a,b,c){return lb(kb,kb.b(a,b),c)};kb.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};kb.H=2;var mb=function mb(a){switch(arguments.length){case 3:return mb.f(arguments[0],arguments[1],arguments[2]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return mb.h(arguments[0],arguments[1],arguments[2],new v(c.slice(3),0,null))}};mb.f=function(a,b,c){return a[b]=c};mb.h=function(a,b,c,d){return nb(mb,kb.b(a,b),c,d)};
mb.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);d=y(d);return this.h(b,a,c,d)};mb.H=3;function ob(a){return A(function(a,c){a.push(c);return a},[],a)}function qb(){}function rb(){}var sb=function sb(a){if(null!=a&&null!=a.P)return a.P(a);var c=sb[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=sb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("ICounted.-count",a);};function tb(){}
var ub=function ub(a){if(null!=a&&null!=a.ia)return a.ia(a);var c=ub[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=ub._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IEmptyableCollection.-empty",a);};function vb(){}var wb=function wb(a,b){if(null!=a&&null!=a.T)return a.T(a,b);var d=wb[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=wb._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("ICollection.-conj",a);};function xb(){}
var B=function B(a){switch(arguments.length){case 2:return B.b(arguments[0],arguments[1]);case 3:return B.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};B.b=function(a,b){if(null!=a&&null!=a.Z)return a.Z(a,b);var c=B[ba(null==a?null:a)];if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);c=B._;if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);throw gb("IIndexed.-nth",a);};
B.f=function(a,b,c){if(null!=a&&null!=a.ga)return a.ga(a,b,c);var d=B[ba(null==a?null:a)];if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);d=B._;if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);throw gb("IIndexed.-nth",a);};B.H=3;function yb(){}
var zb=function zb(a){if(null!=a&&null!=a.xa)return a.xa(a);var c=zb[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=zb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("ISeq.-first",a);},Ab=function Ab(a){if(null!=a&&null!=a.Ea)return a.Ea(a);var c=Ab[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Ab._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("ISeq.-rest",a);};function Bb(){}
var Cb=function Cb(a){if(null!=a&&null!=a.na)return a.na(a);var c=Cb[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Cb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("INext.-next",a);};function Db(){}var Eb=function Eb(a){switch(arguments.length){case 2:return Eb.b(arguments[0],arguments[1]);case 3:return Eb.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};
Eb.b=function(a,b){if(null!=a&&null!=a.M)return a.M(a,b);var c=Eb[ba(null==a?null:a)];if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);c=Eb._;if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);throw gb("ILookup.-lookup",a);};Eb.f=function(a,b,c){if(null!=a&&null!=a.o)return a.o(a,b,c);var d=Eb[ba(null==a?null:a)];if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);d=Eb._;if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);throw gb("ILookup.-lookup",a);};Eb.H=3;
var Fb=function Fb(a,b,c){if(null!=a&&null!=a.I)return a.I(a,b,c);var e=Fb[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=Fb._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("IAssociative.-assoc",a);},Gb=function Gb(a,b){if(null!=a&&null!=a.Sb)return a.Sb(a,b);var d=Gb[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Gb._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IFind.-find",a);};function Hb(){}
var Ib=function Ib(a,b){if(null!=a&&null!=a.ba)return a.ba(a,b);var d=Ib[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Ib._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IMap.-dissoc",a);},Jb=function Jb(a){if(null!=a&&null!=a.gd)return a.key;var c=Jb[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Jb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IMapEntry.-key",a);},Kb=function Kb(a){if(null!=a&&null!=a.hd)return a.A;var c=Kb[ba(null==
a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Kb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IMapEntry.-val",a);};function Mb(){}
var Nb=function Nb(a,b){if(null!=a&&null!=a.jd)return a.jd(a,b);var d=Nb[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Nb._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("ISet.-disjoin",a);},Ob=function Ob(a){if(null!=a&&null!=a.Tb)return a.Tb(a);var c=Ob[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Ob._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IStack.-peek",a);};function Pb(){}
var Qb=function Qb(a,b,c){if(null!=a&&null!=a.Bb)return a.Bb(a,b,c);var e=Qb[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=Qb._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("IVector.-assoc-n",a);},Rb=function Rb(a){if(null!=a&&null!=a.rc)return a.rc(a);var c=Rb[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Rb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IDeref.-deref",a);};function Sb(){}
var Tb=function Tb(a){if(null!=a&&null!=a.R)return a.R(a);var c=Tb[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Tb._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IMeta.-meta",a);},Ub=function Ub(a,b){if(null!=a&&null!=a.S)return a.S(a,b);var d=Ub[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Ub._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IWithMeta.-with-meta",a);};function Vb(){}
var Wb=function Wb(a){switch(arguments.length){case 2:return Wb.b(arguments[0],arguments[1]);case 3:return Wb.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};Wb.b=function(a,b){if(null!=a&&null!=a.ta)return a.ta(a,b);var c=Wb[ba(null==a?null:a)];if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);c=Wb._;if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);throw gb("IReduce.-reduce",a);};
Wb.f=function(a,b,c){if(null!=a&&null!=a.ua)return a.ua(a,b,c);var d=Wb[ba(null==a?null:a)];if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);d=Wb._;if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);throw gb("IReduce.-reduce",a);};Wb.H=3;function Xb(){}
var Yb=function Yb(a,b,c){if(null!=a&&null!=a.$)return a.$(a,b,c);var e=Yb[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=Yb._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("IKVReduce.-kv-reduce",a);},Zb=function Zb(a,b){if(null!=a&&null!=a.C)return a.C(a,b);var d=Zb[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Zb._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IEquiv.-equiv",a);},$b=function $b(a){if(null!=a&&null!=a.O)return a.O(a);
var c=$b[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=$b._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IHash.-hash",a);};function ac(){}var bc=function bc(a){if(null!=a&&null!=a.N)return a.N(a);var c=bc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=bc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("ISeqable.-seq",a);};function dc(){}function ec(){}function fc(){}function gc(){}
var hc=function hc(a){if(null!=a&&null!=a.pb)return a.pb(a);var c=hc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=hc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IReversible.-rseq",a);},ic=function ic(a,b){if(null!=a&&null!=a.Md)return a.Md(a,b);var d=ic[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=ic._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IWriter.-write",a);};function jc(){}
var kc=function kc(a,b,c){if(null!=a&&null!=a.L)return a.L(a,b,c);var e=kc[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=kc._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("IPrintWithWriter.-pr-writer",a);},lc=function lc(a){if(null!=a&&null!=a.ec)return a.ec(a);var c=lc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=lc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IEditableCollection.-as-transient",a);},mc=function mc(a,b){if(null!=
a&&null!=a.fc)return a.fc(a,b);var d=mc[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=mc._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("ITransientCollection.-conj!",a);},nc=function nc(a){if(null!=a&&null!=a.lc)return a.lc(a);var c=nc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=nc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("ITransientCollection.-persistent!",a);},oc=function oc(a,b,c){if(null!=a&&null!=a.sc)return a.sc(a,b,c);
var e=oc[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=oc._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("ITransientAssociative.-assoc!",a);};function qc(){}
var rc=function rc(a,b){if(null!=a&&null!=a.Jb)return a.Jb(a,b);var d=rc[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=rc._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IComparable.-compare",a);},sc=function sc(a){if(null!=a&&null!=a.zc)return a.zc(a);var c=sc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=sc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IChunk.-drop-first",a);},tc=function tc(a){if(null!=a&&null!=a.Bc)return a.Bc(a);
var c=tc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=tc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IChunkedSeq.-chunked-first",a);},uc=function uc(a){if(null!=a&&null!=a.kc)return a.kc(a);var c=uc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=uc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IChunkedSeq.-chunked-rest",a);},vc=function vc(a){if(null!=a&&null!=a.Rc)return a.Rc(a);var c=vc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):
c.call(null,a);c=vc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("INamed.-name",a);},wc=function wc(a){if(null!=a&&null!=a.Sc)return a.Sc(a);var c=wc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=wc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("INamed.-namespace",a);},xc=function xc(a,b){if(null!=a&&null!=a.fe)return a.fe(a,b);var d=xc[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=xc._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);
throw gb("IReset.-reset!",a);},yc=function yc(a){switch(arguments.length){case 2:return yc.b(arguments[0],arguments[1]);case 3:return yc.f(arguments[0],arguments[1],arguments[2]);case 4:return yc.B(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return yc.V(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};
yc.b=function(a,b){if(null!=a&&null!=a.he)return a.he(a,b);var c=yc[ba(null==a?null:a)];if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);c=yc._;if(null!=c)return c.b?c.b(a,b):c.call(null,a,b);throw gb("ISwap.-swap!",a);};yc.f=function(a,b,c){if(null!=a&&null!=a.ie)return a.ie(a,b,c);var d=yc[ba(null==a?null:a)];if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);d=yc._;if(null!=d)return d.f?d.f(a,b,c):d.call(null,a,b,c);throw gb("ISwap.-swap!",a);};
yc.B=function(a,b,c,d){if(null!=a&&null!=a.je)return a.je(a,b,c,d);var e=yc[ba(null==a?null:a)];if(null!=e)return e.B?e.B(a,b,c,d):e.call(null,a,b,c,d);e=yc._;if(null!=e)return e.B?e.B(a,b,c,d):e.call(null,a,b,c,d);throw gb("ISwap.-swap!",a);};yc.V=function(a,b,c,d,e){if(null!=a&&null!=a.ke)return a.ke(a,b,c,d,e);var g=yc[ba(null==a?null:a)];if(null!=g)return g.V?g.V(a,b,c,d,e):g.call(null,a,b,c,d,e);g=yc._;if(null!=g)return g.V?g.V(a,b,c,d,e):g.call(null,a,b,c,d,e);throw gb("ISwap.-swap!",a);};
yc.H=5;var zc=function zc(a,b){if(null!=a&&null!=a.Uc)return a.Uc(a,b);var d=zc[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=zc._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IVolatile.-vreset!",a);};function Ac(){}var Bc=function Bc(a){if(null!=a&&null!=a.W)return a.W(a);var c=Bc[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Bc._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IIterable.-iterator",a);};
function Cc(a){this.ue=a;this.m=1073741824;this.F=0}Cc.prototype.Md=function(a,b){return this.ue.append(b)};function Dc(a){var b=new Ia;a.L(null,new Cc(b),Sa());return t.c(b)}var Ec="undefined"!==typeof Math&&"undefined"!==typeof Math.imul&&0!==Math.imul(4294967295,5)?function(a,b){return Math.imul(a,b)}:function(a,b){var c=a&65535,d=b&65535;return c*d+((a>>>16&65535)*d+c*(b>>>16&65535)<<16>>>0)|0};function Fc(a){a=Ec(a|0,-862048943);return Ec(a<<15|a>>>-15,461845907)}
function Gc(a,b){a=(a|0)^(b|0);return Ec(a<<13|a>>>-13,5)+-430675100|0}function Hc(a,b){a=(a|0)^b;a=Ec(a^a>>>16,-2048144789);a=Ec(a^a>>>13,-1028477387);return a^a>>>16}function Ic(a){a:{var b=1;for(var c=0;;)if(b<a.length){var d=b+2;c=Gc(c,Fc(a.charCodeAt(b-1)|a.charCodeAt(b)<<16));b=d}else{b=c;break a}}b=1===(a.length&1)?b^Fc(a.charCodeAt(a.length-1)):b;return Hc(b,Ec(2,a.length))}var Jc={},Kc=0;
function Nc(a){255<Kc&&(Jc={},Kc=0);if(null==a)return 0;var b=Jc[a];if("number"===typeof b)a=b;else{a:if(null!=a)if(b=a.length,0<b)for(var c=0,d=0;;)if(c<b){var e=c+1;d=Ec(31,d)+a.charCodeAt(c);c=e}else{b=d;break a}else b=0;else b=0;Jc[a]=b;Kc+=1;a=b}return a}
function Oc(a){if(null!=a&&(a.m&4194304||n===a.Hd))return $b(a)^0;if("number"===typeof a){if(r(isFinite(a)))return Math.floor(a)%2147483647;switch(a){case Infinity:return 2146435072;case -Infinity:return-1048576;default:return 2146959360}}else return!0===a?a=1231:!1===a?a=1237:"string"===typeof a?(a=Nc(a),0!==a&&(a=Fc(a),a=Gc(0,a),a=Hc(a,4))):a=a instanceof Date?a.valueOf()^0:null==a?0:$b(a)^0,a}function Pc(a,b){return a^b+2654435769+(a<<6)+(a>>2)}function Qc(a){return a instanceof E}
function Rc(a,b){if(a.Qb===b.Qb)return 0;var c=db(a.Xa);if(r(c?b.Xa:c))return-1;if(r(a.Xa)){if(db(b.Xa))return 1;c=ka(a.Xa,b.Xa);return 0===c?ka(a.name,b.name):c}return ka(a.name,b.name)}function E(a,b,c,d,e){this.Xa=a;this.name=b;this.Qb=c;this.hb=d;this.Ib=e;this.m=2154168321;this.F=4096}f=E.prototype;f.toString=function(){return this.Qb};f.equiv=function(a){return this.C(null,a)};f.C=function(a,b){return b instanceof E?this.Qb===b.Qb:!1};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return F.b(c,this);case 3:return F.f(c,this,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return F.b(c,this)};a.f=function(a,c,d){return F.f(c,this,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return F.b(a,this)};f.b=function(a,b){return F.f(a,this,b)};f.R=function(){return this.Ib};
f.S=function(a,b){return new E(this.Xa,this.name,this.Qb,this.hb,b)};f.O=function(){var a=this.hb;return null!=a?a:this.hb=a=Pc(Ic(this.name),Nc(this.Xa))};f.Rc=function(){return this.name};f.Sc=function(){return this.Xa};f.L=function(a,b){return ic(b,this.Qb)};var Sc=function Sc(a){switch(arguments.length){case 1:return Sc.c(arguments[0]);case 2:return Sc.b(arguments[0],arguments[1]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};
Sc.c=function(a){for(;;){if(a instanceof E)return a;if("string"===typeof a){var b=a.indexOf("/");return 1>b?Sc.b(null,a):Sc.b(a.substring(0,b),a.substring(b+1,a.length))}if(a instanceof H)a=a.X;else throw Error("no conversion to symbol");}};Sc.b=function(a,b){var c=null!=a?[t.c(a),"/",t.c(b)].join(""):b;return new E(a,b,c,null,null)};Sc.H=2;function Uc(a){return null!=a?a.F&131072||n===a.Ae?!0:a.F?!1:eb(Ac,a):eb(Ac,a)}
function I(a){if(null==a)return null;if(null!=a&&(a.m&8388608||n===a.Tc))return bc(a);if(ab(a)||"string"===typeof a)return 0===a.length?null:new v(a,0,null);if(eb(ac,a))return bc(a);throw Error([t.c(a)," is not ISeqable"].join(""));}function x(a){if(null==a)return null;if(null!=a&&(a.m&64||n===a.Ga))return zb(a);a=I(a);return null==a?null:zb(a)}function Vc(a){return null!=a?null!=a&&(a.m&64||n===a.Ga)?Ab(a):(a=I(a))?a.Ea(null):Wc:Wc}
function y(a){return null==a?null:null!=a&&(a.m&128||n===a.Cc)?Cb(a):I(Vc(a))}var J=function J(a){switch(arguments.length){case 1:return J.c(arguments[0]);case 2:return J.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return J.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};J.c=function(){return!0};J.b=function(a,b){return null==a?null==b:a===b||Zb(a,b)};
J.h=function(a,b,c){for(;;)if(J.b(a,b))if(y(c))a=b,b=x(c),c=y(c);else return J.b(b,x(c));else return!1};J.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};J.H=2;function Xc(a){this.da=a}Xc.prototype.next=function(){if(null!=this.da){var a=x(this.da);this.da=y(this.da);return{value:a,done:!1}}return{value:null,done:!0}};function Yc(a){return new Xc(I(a))}function Zc(a,b){a=Fc(a);a=Gc(0,a);return Hc(a,b)}
function $c(a){var b=0,c=1;for(a=I(a);;)if(null!=a)b+=1,c=Ec(31,c)+Oc(x(a))|0,a=y(a);else return Zc(c,b)}var ad=Zc(1,0);function bd(a){var b=0,c=0;for(a=I(a);;)if(null!=a)b+=1,c=c+Oc(x(a))|0,a=y(a);else return Zc(c,b)}var cd=Zc(0,0);rb["null"]=!0;sb["null"]=function(){return 0};Date.prototype.C=function(a,b){return b instanceof Date&&this.valueOf()===b.valueOf()};Date.prototype.dc=n;
Date.prototype.Jb=function(a,b){if(b instanceof Date)return ka(this.valueOf(),b.valueOf());throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};Zb.number=function(a,b){return a===b};qb["function"]=!0;Sb["function"]=!0;Tb["function"]=function(){return null};$b._=function(a){return a[da]||(a[da]=++ea)};function dd(a){return a+1}function ed(a){this.A=a;this.m=32768;this.F=0}ed.prototype.rc=function(){return this.A};function fd(a){return a instanceof ed}
function gd(a){return fd(a)?Rb(a):a}function hd(a,b){var c=sb(a);if(0===c)return b.G?b.G():b.call(null);for(var d=B.b(a,0),e=1;;)if(e<c){var g=B.b(a,e);d=b.b?b.b(d,g):b.call(null,d,g);if(fd(d))return Rb(d);e+=1}else return d}function id(a,b,c){var d=sb(a),e=c;for(c=0;;)if(c<d){var g=B.b(a,c);e=b.b?b.b(e,g):b.call(null,e,g);if(fd(e))return Rb(e);c+=1}else return e}
function jd(a,b){var c=a.length;if(0===a.length)return b.G?b.G():b.call(null);for(var d=a[0],e=1;;)if(e<c){var g=a[e];d=b.b?b.b(d,g):b.call(null,d,g);if(fd(d))return Rb(d);e+=1}else return d}function kd(a,b,c){var d=a.length,e=c;for(c=0;;)if(c<d){var g=a[c];e=b.b?b.b(e,g):b.call(null,e,g);if(fd(e))return Rb(e);c+=1}else return e}function ld(a,b,c,d){for(var e=a.length;;)if(d<e){var g=a[d];c=b.b?b.b(c,g):b.call(null,c,g);if(fd(c))return Rb(c);d+=1}else return c}
function md(a){return null!=a?a.m&2||n===a.dd?!0:a.m?!1:eb(rb,a):eb(rb,a)}function nd(a){return null!=a?a.m&16||n===a.Id?!0:a.m?!1:eb(xb,a):eb(xb,a)}function od(a,b,c){var d=L(a);if(c>=d)return-1;!(0<c)&&0>c&&(c+=d,c=0>c?0:c);for(;;)if(c<d){if(J.b(pd(a,c),b))return c;c+=1}else return-1}function qd(a,b,c){var d=L(a);if(0===d)return-1;0<c?(--d,c=d<c?d:c):c=0>c?d+c:c;for(;;)if(0<=c){if(J.b(pd(a,c),b))return c;--c}else return-1}function rd(a,b){this.l=a;this.J=b}
rd.prototype.va=function(){return this.J<this.l.length};rd.prototype.next=function(){var a=this.l[this.J];this.J+=1;return a};function v(a,b,c){this.l=a;this.J=b;this.D=c;this.m=166592766;this.F=139264}f=v.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.Z=function(a,b){a=b+this.J;if(0<=a&&a<this.l.length)return this.l[a];throw Error("Index out of bounds");};f.ga=function(a,b,c){a=b+this.J;return 0<=a&&a<this.l.length?this.l[a]:c};f.W=function(){return new rd(this.l,this.J)};
f.R=function(){return this.D};f.na=function(){return this.J+1<this.l.length?new v(this.l,this.J+1,null):null};f.P=function(){var a=this.l.length-this.J;return 0>a?0:a};f.pb=function(){var a=this.P(null);return 0<a?new sd(this,a-1,null):null};f.O=function(){return $c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return ld(this.l,b,this.l[this.J],this.J+1)};f.ua=function(a,b,c){return ld(this.l,b,c,this.J)};f.xa=function(){return this.l[this.J]};
f.Ea=function(){return this.J+1<this.l.length?new v(this.l,this.J+1,null):Wc};f.N=function(){return this.J<this.l.length?this:null};f.S=function(a,b){return b===this.D?this:new v(this.l,this.J,b)};f.T=function(a,b){return ud(b,this)};v.prototype[ib]=function(){return Yc(this)};function M(a){return 0<a.length?new v(a,0,null):null}function sd(a,b,c){this.Qc=a;this.J=b;this.D=c;this.m=32374990;this.F=8192}f=sd.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return 0<this.J?new sd(this.Qc,this.J-1,null):null};f.P=function(){return this.J+1};f.O=function(){return $c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};
f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return B.b(this.Qc,this.J)};f.Ea=function(){return 0<this.J?new sd(this.Qc,this.J-1,null):Wc};f.N=function(){return this};f.S=function(a,b){return b===this.D?this:new sd(this.Qc,this.J,b)};f.T=function(a,b){return ud(b,this)};sd.prototype[ib]=function(){return Yc(this)};function xd(a){return x(y(a))}function zd(a){return x(x(a))}function Ad(a){for(;;){var b=y(a);if(null!=b)a=b;else return x(a)}}
Zb._=function(a,b){return a===b};var Bd=function Bd(a){switch(arguments.length){case 0:return Bd.G();case 1:return Bd.c(arguments[0]);case 2:return Bd.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Bd.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Bd.G=function(){return Cd};Bd.c=function(a){return a};Bd.b=function(a,b){return null!=a?wb(a,b):new Dd(null,b,null,1,null)};
Bd.h=function(a,b,c){for(;;)if(r(c))a=Bd.b(a,b),b=x(c),c=y(c);else return Bd.b(a,b)};Bd.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Bd.H=2;function Ed(a){return null==a?null:null!=a&&(a.m&4||n===a.ed)?ub(a):(null!=a?a.m&4||n===a.ed||(a.m?0:eb(tb,a)):eb(tb,a))?ub(a):null}
function L(a){if(null!=a)if(null!=a&&(a.m&2||n===a.dd))a=sb(a);else if(ab(a))a=a.length;else if("string"===typeof a)a=a.length;else if(null!=a&&(a.m&8388608||n===a.Tc))a:{a=I(a);for(var b=0;;){if(md(a)){a=b+sb(a);break a}a=y(a);b+=1}}else a=sb(a);else a=0;return a}function Fd(a,b){for(var c=null;;){if(null==a)return c;if(0===b)return I(a)?x(a):c;if(nd(a))return B.f(a,b,c);if(I(a))a=y(a),--b;else return c}}
function pd(a,b){if("number"!==typeof b)throw Error("Index argument to nth must be a number");if(null==a)return a;if(null!=a&&(a.m&16||n===a.Id))return B.b(a,b);if(ab(a)){if(-1<b&&b<a.length)return a[b|0];throw Error("Index out of bounds");}if("string"===typeof a){if(-1<b&&b<a.length)return a.charAt(b|0);throw Error("Index out of bounds");}if(null!=a&&(a.m&64||n===a.Ga)||null!=a&&(a.m&16777216||n===a.Ld)){if(0>b)throw Error("Index out of bounds");a:for(;;){if(null==a)throw Error("Index out of bounds");
if(0===b){if(I(a)){a=x(a);break a}throw Error("Index out of bounds");}if(nd(a)){a=B.b(a,b);break a}if(I(a))a=y(a),--b;else throw Error("Index out of bounds");}return a}if(eb(xb,a))return B.b(a,b);throw Error(["nth not supported on this type ",t.c(hb(fb(a)))].join(""));}
function O(a,b){if("number"!==typeof b)throw Error("Index argument to nth must be a number.");if(null==a)return null;if(null!=a&&(a.m&16||n===a.Id))return B.f(a,b,null);if(ab(a))return-1<b&&b<a.length?a[b|0]:null;if("string"===typeof a)return-1<b&&b<a.length?a.charAt(b|0):null;if(null!=a&&(a.m&64||n===a.Ga)||null!=a&&(a.m&16777216||n===a.Ld))return 0>b?null:Fd(a,b);if(eb(xb,a))return B.f(a,b,null);throw Error(["nth not supported on this type ",t.c(hb(fb(a)))].join(""));}
var F=function F(a){switch(arguments.length){case 2:return F.b(arguments[0],arguments[1]);case 3:return F.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};F.b=function(a,b){return null==a?null:null!=a&&(a.m&256||n===a.Jd)?Eb.b(a,b):ab(a)?null!=b&&b<a.length?a[b|0]:null:"string"===typeof a?null!=b&&b<a.length?a.charAt(b|0):null:eb(Db,a)?Eb.b(a,b):null};
F.f=function(a,b,c){return null!=a?null!=a&&(a.m&256||n===a.Jd)?Eb.f(a,b,c):ab(a)?null!=b&&-1<b&&b<a.length?a[b|0]:c:"string"===typeof a?null!=b&&-1<b&&b<a.length?a.charAt(b|0):c:eb(Db,a)?Eb.f(a,b,c):c:c};F.H=3;var P=function P(a){switch(arguments.length){case 3:return P.f(arguments[0],arguments[1],arguments[2]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return P.h(arguments[0],arguments[1],arguments[2],new v(c.slice(3),0,null))}};
P.f=function(a,b,c){return null!=a?Fb(a,b,c):Gd([b,c])};P.h=function(a,b,c,d){for(;;)if(a=P.f(a,b,c),r(d))b=x(d),c=xd(d),d=y(y(d));else return a};P.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);d=y(d);return this.h(b,a,c,d)};P.H=3;
var Q=function Q(a){switch(arguments.length){case 1:return Q.c(arguments[0]);case 2:return Q.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Q.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Q.c=function(a){return a};Q.b=function(a,b){return null==a?null:Ib(a,b)};Q.h=function(a,b,c){for(;;){if(null==a)return null;a=Q.b(a,b);if(r(c))b=x(c),c=y(c);else return a}};
Q.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Q.H=2;function Hd(a){var b="function"==ba(a);return b?b:null!=a?n===a.Zd?!0:a.gc?!1:eb(qb,a):eb(qb,a)}function Id(a,b){this.s=a;this.D=b;this.m=393217;this.F=0}f=Id.prototype;f.R=function(){return this.D};f.S=function(a,b){return new Id(this.s,b)};f.Zd=n;
f.call=function(){function a(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,R,ma){return Jd(this.s,b,c,d,e,M([g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,R,ma]))}function b(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,R){a=this;return a.s.Ta?a.s.Ta(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,R):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,R)}function c(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y){a=this;return a.s.Sa?a.s.Sa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y)}function d(a,
b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K){a=this;return a.s.Ra?a.s.Ra(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K)}function e(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N){a=this;return a.s.Qa?a.s.Qa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N)}function g(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G){a=this;return a.s.Pa?a.s.Pa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G)}function h(a,b,c,d,e,g,h,k,l,m,p,u,
w,z,D,C){a=this;return a.s.Oa?a.s.Oa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C)}function k(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D){a=this;return a.s.Na?a.s.Na(b,c,d,e,g,h,k,l,m,p,u,w,z,D):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D)}function l(a,b,c,d,e,g,h,k,l,m,p,u,w,z){a=this;return a.s.Ma?a.s.Ma(b,c,d,e,g,h,k,l,m,p,u,w,z):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z)}function m(a,b,c,d,e,g,h,k,l,m,p,u,w){a=this;return a.s.La?a.s.La(b,c,d,e,g,h,k,l,m,p,u,w):a.s.call(null,b,c,d,
e,g,h,k,l,m,p,u,w)}function p(a,b,c,d,e,g,h,k,l,m,p,u){a=this;return a.s.Ka?a.s.Ka(b,c,d,e,g,h,k,l,m,p,u):a.s.call(null,b,c,d,e,g,h,k,l,m,p,u)}function u(a,b,c,d,e,g,h,k,l,m,p){a=this;return a.s.Ja?a.s.Ja(b,c,d,e,g,h,k,l,m,p):a.s.call(null,b,c,d,e,g,h,k,l,m,p)}function w(a,b,c,d,e,g,h,k,l,m){a=this;return a.s.Ua?a.s.Ua(b,c,d,e,g,h,k,l,m):a.s.call(null,b,c,d,e,g,h,k,l,m)}function z(a,b,c,d,e,g,h,k,l){a=this;return a.s.Fa?a.s.Fa(b,c,d,e,g,h,k,l):a.s.call(null,b,c,d,e,g,h,k,l)}function D(a,b,c,d,e,g,
h,k){a=this;return a.s.Ca?a.s.Ca(b,c,d,e,g,h,k):a.s.call(null,b,c,d,e,g,h,k)}function C(a,b,c,d,e,g,h){a=this;return a.s.la?a.s.la(b,c,d,e,g,h):a.s.call(null,b,c,d,e,g,h)}function G(a,b,c,d,e,g){a=this;return a.s.V?a.s.V(b,c,d,e,g):a.s.call(null,b,c,d,e,g)}function N(a,b,c,d,e){a=this;return a.s.B?a.s.B(b,c,d,e):a.s.call(null,b,c,d,e)}function K(a,b,c,d){a=this;return a.s.f?a.s.f(b,c,d):a.s.call(null,b,c,d)}function Y(a,b,c){a=this;return a.s.b?a.s.b(b,c):a.s.call(null,b,c)}function ma(a,b){a=this;
return a.s.c?a.s.c(b):a.s.call(null,b)}function ya(a){a=this;return a.s.G?a.s.G():a.s.call(null)}var R=null;R=function(ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc,Tc,yd,Ye,Wi,tm){switch(arguments.length){case 1:return ya.call(this,ta);case 2:return ma.call(this,ta,ca);case 3:return Y.call(this,ta,ca,Ea);case 4:return K.call(this,ta,ca,Ea,Da);case 5:return N.call(this,ta,ca,Ea,Da,Ba);case 6:return G.call(this,ta,ca,Ea,Da,Ba,Za);case 7:return C.call(this,ta,ca,Ea,Da,Ba,Za,Ja);case 8:return D.call(this,
ta,ca,Ea,Da,Ba,Za,Ja,Ta);case 9:return z.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb);case 10:return w.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na);case 11:return u.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb);case 12:return p.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb);case 13:return m.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R);case 14:return l.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc);case 15:return k.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc);case 16:return h.call(this,ta,ca,
Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc);case 17:return g.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc);case 18:return e.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc,Tc);case 19:return d.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc,Tc,yd);case 20:return c.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc,Tc,yd,Ye);case 21:return b.call(this,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc,Tc,yd,Ye,Wi);case 22:return a.call(this,ta,ca,Ea,Da,
Ba,Za,Ja,Ta,bb,Na,pb,Lb,R,cc,pc,Lc,Mc,Tc,yd,Ye,Wi,tm)}throw Error("Invalid arity: "+(arguments.length-1));};R.c=ya;R.b=ma;R.f=Y;R.B=K;R.V=N;R.la=G;R.Ca=C;R.Fa=D;R.Ua=z;R.Ja=w;R.Ka=u;R.La=p;R.Ma=m;R.Na=l;R.Oa=k;R.Pa=h;R.Qa=g;R.Ra=e;R.Sa=d;R.Ta=c;R.fd=b;R.ce=a;return R}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.G=function(){return this.s.G?this.s.G():this.s.call(null)};f.c=function(a){return this.s.c?this.s.c(a):this.s.call(null,a)};
f.b=function(a,b){return this.s.b?this.s.b(a,b):this.s.call(null,a,b)};f.f=function(a,b,c){return this.s.f?this.s.f(a,b,c):this.s.call(null,a,b,c)};f.B=function(a,b,c,d){return this.s.B?this.s.B(a,b,c,d):this.s.call(null,a,b,c,d)};f.V=function(a,b,c,d,e){return this.s.V?this.s.V(a,b,c,d,e):this.s.call(null,a,b,c,d,e)};f.la=function(a,b,c,d,e,g){return this.s.la?this.s.la(a,b,c,d,e,g):this.s.call(null,a,b,c,d,e,g)};
f.Ca=function(a,b,c,d,e,g,h){return this.s.Ca?this.s.Ca(a,b,c,d,e,g,h):this.s.call(null,a,b,c,d,e,g,h)};f.Fa=function(a,b,c,d,e,g,h,k){return this.s.Fa?this.s.Fa(a,b,c,d,e,g,h,k):this.s.call(null,a,b,c,d,e,g,h,k)};f.Ua=function(a,b,c,d,e,g,h,k,l){return this.s.Ua?this.s.Ua(a,b,c,d,e,g,h,k,l):this.s.call(null,a,b,c,d,e,g,h,k,l)};f.Ja=function(a,b,c,d,e,g,h,k,l,m){return this.s.Ja?this.s.Ja(a,b,c,d,e,g,h,k,l,m):this.s.call(null,a,b,c,d,e,g,h,k,l,m)};
f.Ka=function(a,b,c,d,e,g,h,k,l,m,p){return this.s.Ka?this.s.Ka(a,b,c,d,e,g,h,k,l,m,p):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p)};f.La=function(a,b,c,d,e,g,h,k,l,m,p,u){return this.s.La?this.s.La(a,b,c,d,e,g,h,k,l,m,p,u):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u)};f.Ma=function(a,b,c,d,e,g,h,k,l,m,p,u,w){return this.s.Ma?this.s.Ma(a,b,c,d,e,g,h,k,l,m,p,u,w):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w)};
f.Na=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z){return this.s.Na?this.s.Na(a,b,c,d,e,g,h,k,l,m,p,u,w,z):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z)};f.Oa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D){return this.s.Oa?this.s.Oa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D)};f.Pa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C){return this.s.Pa?this.s.Pa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C)};
f.Qa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G){return this.s.Qa?this.s.Qa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G)};f.Ra=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N){return this.s.Ra?this.s.Ra(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N)};
f.Sa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K){return this.s.Sa?this.s.Sa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K)};f.Ta=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y){return this.s.Ta?this.s.Ta(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y):this.s.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y)};f.fd=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma){return Jd(this.s,a,b,c,d,M([e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma]))};
function Kd(a,b){return"function"==ba(a)?new Id(a,b):null==a?null:Ub(a,b)}function Ld(a){var b=null!=a;return(b?null!=a?a.m&131072||n===a.Kd||(a.m?0:eb(Sb,a)):eb(Sb,a):b)?Tb(a):null}var Md=function Md(a){switch(arguments.length){case 1:return Md.c(arguments[0]);case 2:return Md.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Md.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Md.c=function(a){return a};
Md.b=function(a,b){return null==a?null:Nb(a,b)};Md.h=function(a,b,c){for(;;){if(null==a)return null;a=Md.b(a,b);if(r(c))b=x(c),c=y(c);else return a}};Md.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Md.H=2;function Nd(a){return null==a||db(I(a))}function Od(a){return null==a?!1:null!=a?a.m&8||n===a.ye?!0:a.m?!1:eb(vb,a):eb(vb,a)}function Pd(a){return null==a?!1:null!=a?a.m&4096||n===a.Ge?!0:a.m?!1:eb(Mb,a):eb(Mb,a)}
function Qd(a){return null!=a?a.m&16777216||n===a.Ld?!0:a.m?!1:eb(dc,a):eb(dc,a)}function Rd(a){return null==a?!1:null!=a?a.m&1024||n===a.De?!0:a.m?!1:eb(Hb,a):eb(Hb,a)}function Sd(a){return null!=a?a.m&67108864||n===a.Fe?!0:a.m?!1:eb(fc,a):eb(fc,a)}function Td(a){return null!=a?a.m&16384||n===a.He?!0:a.m?!1:eb(Pb,a):eb(Pb,a)}function Ud(a){return null!=a?a.F&512||n===a.xe?!0:!1:!1}function Vd(a,b,c,d,e){for(;0!==e;)c[d]=a[b],d+=1,--e,b+=1}var Wd={};
function Xd(a){return null==a?!1:null!=a?a.m&64||n===a.Ga?!0:a.m?!1:eb(yb,a):eb(yb,a)}function Yd(a){return null==a?!1:!1===a?!1:!0}function Zd(a,b){return F.f(a,b,Wd)===Wd?!1:!0}var $d=function $d(a){switch(arguments.length){case 1:return $d.c(arguments[0]);case 2:return $d.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return $d.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};$d.c=function(){return!0};
$d.b=function(a,b){return!J.b(a,b)};$d.h=function(a,b,c){if(J.b(a,b))return!1;a=ae([a,b]);for(b=c;;){var d=x(b);c=y(b);if(r(b)){if(Zd(a,d))return!1;a=Bd.b(a,d);b=c}else return!0}};$d.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};$d.H=2;
function be(a,b){if(a===b)return 0;if(null==a)return-1;if(null==b)return 1;if("number"===typeof a){if("number"===typeof b)return ka(a,b);throw Error(["Cannot compare ",t.c(a)," to ",t.c(b)].join(""));}if(null!=a?a.F&2048||n===a.dc||(a.F?0:eb(qc,a)):eb(qc,a))return rc(a,b);if("string"!==typeof a&&!ab(a)&&!0!==a&&!1!==a||fb(a)!==fb(b))throw Error(["Cannot compare ",t.c(a)," to ",t.c(b)].join(""));return ka(a,b)}
function ce(a,b){var c=L(a),d=L(b);if(c<d)a=-1;else if(c>d)a=1;else if(0===c)a=0;else a:for(d=0;;){var e=be(pd(a,d),pd(b,d));if(0===e&&d+1<c)d+=1;else{a=e;break a}}return a}function de(){return J.b(be,be)?be:function(a,b){var c=be.b?be.b(a,b):be.call(null,a,b);return"number"===typeof c?c:r(c)?-1:r(be.b?be.b(b,a):be.call(null,b,a))?1:0}}function ee(a){if(I(a)){a=fe(a);var b=de();la(a,b);return I(a)}return Wc}function vd(a,b){return(b=I(b))?A(a,x(b),y(b)):a.G?a.G():a.call(null)}
function wd(a,b,c){for(c=I(c);;)if(c){var d=x(c);b=a.b?a.b(b,d):a.call(null,b,d);if(fd(b))return Rb(b);c=y(c)}else return b}function ge(a,b){a=Bc(a);if(r(a.va()))for(var c=a.next();;)if(a.va()){var d=a.next();c=b.b?b.b(c,d):b.call(null,c,d);if(fd(c))return Rb(c)}else return c;else return b.G?b.G():b.call(null)}function he(a,b,c){for(a=Bc(a);;)if(a.va()){var d=a.next();c=b.b?b.b(c,d):b.call(null,c,d);if(fd(c))return Rb(c)}else return c}
function ie(a,b){return null!=b&&(b.m&524288||n===b.ee)?Wb.b(b,a):ab(b)?jd(b,a):"string"===typeof b?jd(b,a):eb(Vb,b)?Wb.b(b,a):Uc(b)?ge(b,a):vd(a,b)}function A(a,b,c){return null!=c&&(c.m&524288||n===c.ee)?Wb.f(c,a,b):ab(c)?kd(c,a,b):"string"===typeof c?kd(c,a,b):eb(Vb,c)?Wb.f(c,a,b):Uc(c)?he(c,a,b):wd(a,b,c)}function je(a,b,c){return null!=c?Yb(c,a,b):b}function ke(a){return a}function le(a,b,c,d){a=a.c?a.c(b):a.call(null,b);c=A(a,c,d);return a.c?a.c(c):a.call(null,c)}
var me=function me(a){switch(arguments.length){case 0:return me.G();case 1:return me.c(arguments[0]);case 2:return me.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return me.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};me.G=function(){return 0};me.c=function(a){return a};me.b=function(a,b){return a+b};me.h=function(a,b,c){return A(me,a+b,c)};me.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};
me.H=2;var oe=function oe(a){switch(arguments.length){case 1:return oe.c(arguments[0]);case 2:return oe.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return oe.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};oe.c=function(a){return-a};oe.b=function(a,b){return a-b};oe.h=function(a,b,c){return A(oe,a-b,c)};oe.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};oe.H=2;
var pe=function pe(a){switch(arguments.length){case 0:return pe.G();case 1:return pe.c(arguments[0]);case 2:return pe.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return pe.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};pe.G=function(){return 1};pe.c=function(a){return a};pe.b=function(a,b){return a*b};pe.h=function(a,b,c){return A(pe,a*b,c)};pe.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};
pe.H=2;var qe=function qe(a){switch(arguments.length){case 1:return qe.c(arguments[0]);case 2:return qe.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return qe.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};qe.c=function(a){return 1/a};qe.b=function(a,b){return a/b};qe.h=function(a,b,c){return A(qe,a/b,c)};qe.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};qe.H=2;
var re=function re(a){switch(arguments.length){case 1:return re.c(arguments[0]);case 2:return re.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return re.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};re.c=function(){return!0};re.b=function(a,b){return a<b};re.h=function(a,b,c){for(;;)if(a<b)if(y(c))a=b,b=x(c),c=y(c);else return b<x(c);else return!1};
re.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};re.H=2;var se=function se(a){switch(arguments.length){case 1:return se.c(arguments[0]);case 2:return se.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return se.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};se.c=function(){return!0};se.b=function(a,b){return a<=b};se.h=function(a,b,c){for(;;)if(a<=b)if(y(c))a=b,b=x(c),c=y(c);else return b<=x(c);else return!1};
se.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};se.H=2;var te=function te(a){switch(arguments.length){case 1:return te.c(arguments[0]);case 2:return te.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return te.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};te.c=function(){return!0};te.b=function(a,b){return a>b};te.h=function(a,b,c){for(;;)if(a>b)if(y(c))a=b,b=x(c),c=y(c);else return b>x(c);else return!1};
te.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};te.H=2;var ue=function ue(a){switch(arguments.length){case 1:return ue.c(arguments[0]);case 2:return ue.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return ue.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};ue.c=function(){return!0};ue.b=function(a,b){return a>=b};ue.h=function(a,b,c){for(;;)if(a>=b)if(y(c))a=b,b=x(c),c=y(c);else return b>=x(c);else return!1};
ue.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};ue.H=2;var ve=function ve(a){switch(arguments.length){case 1:return ve.c(arguments[0]);case 2:return ve.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return ve.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};ve.c=function(a){return a};ve.b=function(a,b){return a>b?a:b};ve.h=function(a,b,c){return A(ve,a>b?a:b,c)};
ve.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};ve.H=2;var we=function we(a){switch(arguments.length){case 1:return we.c(arguments[0]);case 2:return we.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return we.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};we.c=function(a){return a};we.b=function(a,b){return a<b?a:b};we.h=function(a,b,c){return A(we,a<b?a:b,c)};
we.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};we.H=2;function xe(a){if("number"===typeof a)return String.fromCharCode(a);if("string"===typeof a&&1===a.length)return a;throw Error("Argument to char must be a character or number");}function ye(a){return 0<=a?Math.floor(a):Math.ceil(a)}function ze(a,b){return(a%b+b)%b}function Ae(a,b){return ye((a-a%b)/b)}function Be(a){a-=a>>1&1431655765;a=(a&858993459)+(a>>2&858993459);return 16843009*(a+(a>>4)&252645135)>>24}
var Ce=function Ce(a){switch(arguments.length){case 1:return Ce.c(arguments[0]);case 2:return Ce.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Ce.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Ce.c=function(){return!0};Ce.b=function(a,b){return Zb(a,b)};Ce.h=function(a,b,c){for(;;)if(a===b)if(y(c))a=b,b=x(c),c=y(c);else return b===x(c);else return!1};
Ce.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Ce.H=2;var t=function t(a){switch(arguments.length){case 0:return t.G();case 1:return t.c(arguments[0]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return t.h(arguments[0],new v(c.slice(1),0,null))}};t.G=function(){return""};t.c=function(a){return null==a?"":[a].join("")};t.h=function(a,b){for(a=new Ia(t.c(a));;)if(r(b))a=a.append(t.c(x(b))),b=y(b);else return a.toString()};
t.K=function(a){var b=x(a);a=y(a);return this.h(b,a)};t.H=1;var De=function De(a){switch(arguments.length){case 2:return De.b(arguments[0],arguments[1]);case 3:return De.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};De.b=function(a,b){return a.substring(b)};De.f=function(a,b,c){return a.substring(b,c)};De.H=3;
function td(a,b){if(Qd(b))if(md(a)&&md(b)&&L(a)!==L(b))a=!1;else a:for(a=I(a),b=I(b);;){if(null==a){a=null==b;break a}if(null!=b&&J.b(x(a),x(b)))a=y(a),b=y(b);else{a=!1;break a}}else a=null;return Yd(a)}function Dd(a,b,c,d,e){this.D=a;this.first=b;this.Xb=c;this.count=d;this.j=e;this.m=65937646;this.F=8192}f=Dd.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,this.count)}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return 1===this.count?null:this.Xb};f.P=function(){return this.count};f.Tb=function(){return this.first};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Ub(Wc,this.D)};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return this.first};f.Ea=function(){return 1===this.count?Wc:this.Xb};f.N=function(){return this};f.S=function(a,b){return b===this.D?this:new Dd(b,this.first,this.Xb,this.count,this.j)};f.T=function(a,b){return new Dd(this.D,b,this,this.count+1,null)};
function Ee(a){return null!=a?a.m&33554432||n===a.Ce?!0:a.m?!1:eb(ec,a):eb(ec,a)}Dd.prototype[ib]=function(){return Yc(this)};function Fe(a){this.D=a;this.m=65937614;this.F=8192}f=Fe.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return null};f.P=function(){return 0};f.Tb=function(){return null};f.O=function(){return ad};f.C=function(a,b){return Ee(b)||Qd(b)?null==I(b):!1};f.ia=function(){return this};
f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return null};f.Ea=function(){return Wc};f.N=function(){return null};f.S=function(a,b){return b===this.D?this:new Fe(b)};f.T=function(a,b){return new Dd(this.D,b,null,1,null)};var Wc=new Fe(null);Fe.prototype[ib]=function(){return Yc(this)};function Ge(a){return(null!=a?a.m&134217728||n===a.ge||(a.m?0:eb(gc,a)):eb(gc,a))?(a=hc(a))?a:Wc:A(Bd,Wc,a)}
var He=function He(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return He.h(0<c.length?new v(c.slice(0),0,null):null)};He.h=function(a){if(a instanceof v&&0===a.J)var b=a.l;else a:for(b=[];;)if(null!=a)b.push(zb(a)),a=Cb(a);else break a;a=b.length;for(var c=Wc;;)if(0<a){var d=a-1;c=wb(c,b[a-1]);a=d}else return c};He.H=0;He.K=function(a){return this.h(I(a))};function Ie(a,b,c,d){this.D=a;this.first=b;this.Xb=c;this.j=d;this.m=65929452;this.F=8192}f=Ie.prototype;
f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return null==this.Xb?null:I(this.Xb)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};
f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return this.first};f.Ea=function(){return null==this.Xb?Wc:this.Xb};f.N=function(){return this};f.S=function(a,b){return b===this.D?this:new Ie(b,this.first,this.Xb,this.j)};f.T=function(a,b){return new Ie(null,b,this,null)};Ie.prototype[ib]=function(){return Yc(this)};function ud(a,b){return null==b?new Dd(null,a,null,1,null):null!=b&&(b.m&64||n===b.Ga)?new Ie(null,a,b,null):new Ie(null,a,I(b),null)}
function Je(a,b){if(a.X===b.X)return 0;var c=db(a.Xa);if(r(c?b.Xa:c))return-1;if(r(a.Xa)){if(db(b.Xa))return 1;c=ka(a.Xa,b.Xa);return 0===c?ka(a.name,b.name):c}return ka(a.name,b.name)}function H(a,b,c,d){this.Xa=a;this.name=b;this.X=c;this.hb=d;this.m=2153775105;this.F=4096}f=H.prototype;f.toString=function(){return[":",t.c(this.X)].join("")};f.equiv=function(a){return this.C(null,a)};f.C=function(a,b){return b instanceof H?this.X===b.X:!1};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return F.b(c,this);case 3:return F.f(c,this,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return F.b(c,this)};a.f=function(a,c,d){return F.f(c,this,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return F.b(a,this)};f.b=function(a,b){return F.f(a,this,b)};
f.O=function(){var a=this.hb;return null!=a?a:this.hb=a=Pc(Ic(this.name),Nc(this.Xa))+2654435769|0};f.Rc=function(){return this.name};f.Sc=function(){return this.Xa};f.L=function(a,b){return ic(b,[":",t.c(this.X)].join(""))};function S(a,b){return a===b?!0:a instanceof H&&b instanceof H?a.X===b.X:!1}function Ke(a){if(null!=a&&(a.F&4096||n===a.de))return wc(a);throw Error(["Doesn't support namespace: ",t.c(a)].join(""));}
var Le=function Le(a){switch(arguments.length){case 1:return Le.c(arguments[0]);case 2:return Le.b(arguments[0],arguments[1]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};Le.c=function(a){if(a instanceof H)return a;if(a instanceof E)return new H(Ke(a),Me(a),a.Qb,null);if("string"===typeof a){var b=a.split("/");return 2===b.length?new H(b[0],b[1],a,null):new H(null,b[0],a,null)}return null};
Le.b=function(a,b){a=a instanceof H?Me(a):a instanceof E?Me(a):a;b=b instanceof H?Me(b):b instanceof E?Me(b):b;return new H(a,b,[r(a)?[t.c(a),"/"].join(""):null,t.c(b)].join(""),null)};Le.H=2;function Ne(a,b,c,d){this.D=a;this.ca=b;this.da=c;this.j=d;this.m=32374988;this.F=1}f=Ne.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};function Oe(a){null!=a.ca&&(a.da=a.ca.G?a.ca.G():a.ca.call(null),a.ca=null);return a.da}
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){this.N(null);return null==this.da?null:y(this.da)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};
f.ia=function(){return Ub(Wc,this.D)};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){this.N(null);return null==this.da?null:x(this.da)};f.Ea=function(){this.N(null);return null!=this.da?Vc(this.da):Wc};f.N=function(){Oe(this);if(null==this.da)return null;for(var a=this.da;;)if(a instanceof Ne)a=Oe(a);else return this.da=a,I(this.da)};f.S=function(a,b){return b===this.D?this:new Ne(b,function(a){return function(){return a.N(null)}}(this),null,this.j)};
f.T=function(a,b){return ud(b,this)};Ne.prototype[ib]=function(){return Yc(this)};function Pe(a){this.jc=a;this.end=0;this.m=2;this.F=0}Pe.prototype.add=function(a){this.jc[this.end]=a;return this.end+=1};Pe.prototype.aa=function(){var a=new Qe(this.jc,0,this.end);this.jc=null;return a};Pe.prototype.P=function(){return this.end};function Re(a){return new Pe(Array(a))}function Qe(a,b,c){this.l=a;this.oa=b;this.end=c;this.m=524306;this.F=0}f=Qe.prototype;f.P=function(){return this.end-this.oa};
f.Z=function(a,b){return this.l[this.oa+b]};f.ga=function(a,b,c){return 0<=b&&b<this.end-this.oa?this.l[this.oa+b]:c};f.zc=function(){if(this.oa===this.end)throw Error("-drop-first of empty chunk");return new Qe(this.l,this.oa+1,this.end)};f.ta=function(a,b){return ld(this.l,b,this.l[this.oa],this.oa+1)};f.ua=function(a,b,c){return ld(this.l,b,c,this.oa)};function Se(a,b,c,d){this.aa=a;this.Fb=b;this.D=c;this.j=d;this.m=31850732;this.F=1536}f=Se.prototype;f.toString=function(){return Dc(this)};
f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return 1<sb(this.aa)?new Se(sc(this.aa),this.Fb,null,null):null==this.Fb?null:bc(this.Fb)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.xa=function(){return B.b(this.aa,0)};f.Ea=function(){return 1<sb(this.aa)?new Se(sc(this.aa),this.Fb,null,null):null==this.Fb?Wc:this.Fb};f.N=function(){return this};f.Bc=function(){return this.aa};f.kc=function(){return null==this.Fb?Wc:this.Fb};f.S=function(a,b){return b===this.D?this:new Se(this.aa,this.Fb,b,this.j)};f.T=function(a,b){return ud(b,this)};f.Ac=function(){return null==this.Fb?null:this.Fb};Se.prototype[ib]=function(){return Yc(this)};
function Te(a,b){return 0===sb(a)?b:new Se(a,b,null,null)}function Ue(a,b){a.add(b)}function fe(a){var b=[];for(a=I(a);;)if(null!=a)b.push(x(a)),a=y(a);else return b}function Ve(a,b){if(md(b))return L(b);var c=0;for(b=I(b);;)if(null!=b&&c<a)c+=1,b=y(b);else return c}
var We=function We(a){if(null==a)return null;var c=y(a);return null==c?I(x(a)):ud(x(a),We.c?We.c(c):We.call(null,c))},T=function T(a){switch(arguments.length){case 0:return T.G();case 1:return T.c(arguments[0]);case 2:return T.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return T.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};T.G=function(){return new Ne(null,function(){return null},null,null)};
T.c=function(a){return new Ne(null,function(){return a},null,null)};T.b=function(a,b){return new Ne(null,function(){var c=I(a);return c?Ud(c)?Te(tc(c),T.b(uc(c),b)):ud(x(c),T.b(Vc(c),b)):b},null,null)};T.h=function(a,b,c){return function h(a,b){return new Ne(null,function(){var c=I(a);return c?Ud(c)?Te(tc(c),h(uc(c),b)):ud(x(c),h(Vc(c),b)):r(b)?h(x(b),y(b)):null},null,null)}(T.b(a,b),c)};T.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};T.H=2;
function Xe(a,b,c){return ud(a,ud(b,c))}function Ze(a){return lc(a)}function $e(a){return nc(a)}var af=function af(a){switch(arguments.length){case 0:return af.G();case 1:return af.c(arguments[0]);case 2:return af.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return af.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};af.G=function(){return lc(Cd)};af.c=function(a){return a};af.b=function(a,b){return mc(a,b)};
af.h=function(a,b,c){for(;;)if(a=mc(a,b),r(c))b=x(c),c=y(c);else return a};af.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};af.H=2;var bf=function bf(a){switch(arguments.length){case 3:return bf.f(arguments[0],arguments[1],arguments[2]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return bf.h(arguments[0],arguments[1],arguments[2],new v(c.slice(3),0,null))}};bf.f=function(a,b,c){return oc(a,b,c)};
bf.h=function(a,b,c,d){for(;;)if(a=oc(a,b,c),r(d))b=x(d),c=xd(d),d=y(y(d));else return a};bf.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);d=y(d);return this.h(b,a,c,d)};bf.H=3;
function cf(a,b,c){var d=I(c);if(0===b)return a.G?a.G():a.call(null);c=zb(d);var e=Ab(d);if(1===b)return a.c?a.c(c):a.call(null,c);d=zb(e);var g=Ab(e);if(2===b)return a.b?a.b(c,d):a.call(null,c,d);e=zb(g);var h=Ab(g);if(3===b)return a.f?a.f(c,d,e):a.call(null,c,d,e);g=zb(h);var k=Ab(h);if(4===b)return a.B?a.B(c,d,e,g):a.call(null,c,d,e,g);h=zb(k);var l=Ab(k);if(5===b)return a.V?a.V(c,d,e,g,h):a.call(null,c,d,e,g,h);k=zb(l);var m=Ab(l);if(6===b)return a.la?a.la(c,d,e,g,h,k):a.call(null,c,d,e,g,h,k);
l=zb(m);var p=Ab(m);if(7===b)return a.Ca?a.Ca(c,d,e,g,h,k,l):a.call(null,c,d,e,g,h,k,l);m=zb(p);var u=Ab(p);if(8===b)return a.Fa?a.Fa(c,d,e,g,h,k,l,m):a.call(null,c,d,e,g,h,k,l,m);p=zb(u);var w=Ab(u);if(9===b)return a.Ua?a.Ua(c,d,e,g,h,k,l,m,p):a.call(null,c,d,e,g,h,k,l,m,p);u=zb(w);var z=Ab(w);if(10===b)return a.Ja?a.Ja(c,d,e,g,h,k,l,m,p,u):a.call(null,c,d,e,g,h,k,l,m,p,u);w=zb(z);var D=Ab(z);if(11===b)return a.Ka?a.Ka(c,d,e,g,h,k,l,m,p,u,w):a.call(null,c,d,e,g,h,k,l,m,p,u,w);z=zb(D);var C=Ab(D);
if(12===b)return a.La?a.La(c,d,e,g,h,k,l,m,p,u,w,z):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z);D=zb(C);var G=Ab(C);if(13===b)return a.Ma?a.Ma(c,d,e,g,h,k,l,m,p,u,w,z,D):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D);C=zb(G);var N=Ab(G);if(14===b)return a.Na?a.Na(c,d,e,g,h,k,l,m,p,u,w,z,D,C):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C);G=zb(N);var K=Ab(N);if(15===b)return a.Oa?a.Oa(c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G);N=zb(K);var Y=Ab(K);if(16===b)return a.Pa?a.Pa(c,d,e,g,h,k,l,
m,p,u,w,z,D,C,G,N):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N);K=zb(Y);var ma=Ab(Y);if(17===b)return a.Qa?a.Qa(c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K);Y=zb(ma);var ya=Ab(ma);if(18===b)return a.Ra?a.Ra(c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y);ma=zb(ya);ya=Ab(ya);if(19===b)return a.Sa?a.Sa(c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma);var R=zb(ya);Ab(ya);if(20===b)return a.Ta?
a.Ta(c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma,R):a.call(null,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma,R);throw Error("Only up to 20 arguments supported on functions");}function df(a){return null!=a&&(a.m&128||n===a.Cc)?a.na(null):I(Vc(a))}function ef(a,b,c){return null==c?a.c?a.c(b):a.call(a,b):ff(a,b,zb(c),df(c))}function ff(a,b,c,d){return null==d?a.b?a.b(b,c):a.call(a,b,c):gf(a,b,c,zb(d),df(d))}function gf(a,b,c,d,e){return null==e?a.f?a.f(b,c,d):a.call(a,b,c,d):hf(a,b,c,d,zb(e),df(e))}
function hf(a,b,c,d,e,g){if(null==g)return a.B?a.B(b,c,d,e):a.call(a,b,c,d,e);var h=zb(g),k=y(g);if(null==k)return a.V?a.V(b,c,d,e,h):a.call(a,b,c,d,e,h);g=zb(k);var l=y(k);if(null==l)return a.la?a.la(b,c,d,e,h,g):a.call(a,b,c,d,e,h,g);k=zb(l);var m=y(l);if(null==m)return a.Ca?a.Ca(b,c,d,e,h,g,k):a.call(a,b,c,d,e,h,g,k);l=zb(m);var p=y(m);if(null==p)return a.Fa?a.Fa(b,c,d,e,h,g,k,l):a.call(a,b,c,d,e,h,g,k,l);m=zb(p);var u=y(p);if(null==u)return a.Ua?a.Ua(b,c,d,e,h,g,k,l,m):a.call(a,b,c,d,e,h,g,k,
l,m);p=zb(u);var w=y(u);if(null==w)return a.Ja?a.Ja(b,c,d,e,h,g,k,l,m,p):a.call(a,b,c,d,e,h,g,k,l,m,p);u=zb(w);var z=y(w);if(null==z)return a.Ka?a.Ka(b,c,d,e,h,g,k,l,m,p,u):a.call(a,b,c,d,e,h,g,k,l,m,p,u);w=zb(z);var D=y(z);if(null==D)return a.La?a.La(b,c,d,e,h,g,k,l,m,p,u,w):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w);z=zb(D);var C=y(D);if(null==C)return a.Ma?a.Ma(b,c,d,e,h,g,k,l,m,p,u,w,z):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w,z);D=zb(C);var G=y(C);if(null==G)return a.Na?a.Na(b,c,d,e,h,g,k,l,m,p,u,w,z,D):a.call(a,
b,c,d,e,h,g,k,l,m,p,u,w,z,D);C=zb(G);var N=y(G);if(null==N)return a.Oa?a.Oa(b,c,d,e,h,g,k,l,m,p,u,w,z,D,C):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w,z,D,C);G=zb(N);var K=y(N);if(null==K)return a.Pa?a.Pa(b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G);N=zb(K);var Y=y(K);if(null==Y)return a.Qa?a.Qa(b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N);K=zb(Y);var ma=y(Y);if(null==ma)return a.Ra?a.Ra(b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N,K):a.call(a,b,c,d,e,h,g,
k,l,m,p,u,w,z,D,C,G,N,K);Y=zb(ma);var ya=y(ma);if(null==ya)return a.Sa?a.Sa(b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N,K,Y):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N,K,Y);ma=zb(ya);ya=y(ya);if(null==ya)return a.Ta?a.Ta(b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma):a.call(a,b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma);b=[b,c,d,e,h,g,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma];for(c=ya;;)if(c)b.push(zb(c)),c=y(c);else break;return a.apply(a,b)}
function jf(a,b){if(a.K){var c=a.H,d=Ve(c+1,b);return d<=c?cf(a,d,b):a.K(b)}b=I(b);return null==b?a.G?a.G():a.call(a):ef(a,zb(b),df(b))}function lb(a,b,c){if(a.K){b=ud(b,c);var d=a.H;c=Ve(d,c)+1;return c<=d?cf(a,c,b):a.K(b)}return ef(a,b,I(c))}function nb(a,b,c,d){return a.K?(b=Xe(b,c,d),c=a.H,d=2+Ve(c-1,d),d<=c?cf(a,d,b):a.K(b)):ff(a,b,c,I(d))}function kf(a,b,c,d,e){return a.K?(b=ud(b,ud(c,ud(d,e))),c=a.H,e=3+Ve(c-2,e),e<=c?cf(a,e,b):a.K(b)):gf(a,b,c,d,I(e))}
function Jd(a,b,c,d,e,g){return a.K?(g=We(g),b=ud(b,ud(c,ud(d,ud(e,g)))),c=a.H,g=4+Ve(c-3,g),g<=c?cf(a,g,b):a.K(b)):hf(a,b,c,d,e,We(g))}var lf=function lf(a){switch(arguments.length){case 1:return lf.c(arguments[0]);case 2:return lf.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return lf.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};lf.c=function(){return!1};lf.b=function(a,b){return!J.b(a,b)};
lf.h=function(a,b,c){return db(nb(J,a,b,c))};lf.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};lf.H=2;function mf(a){return I(a)?a:null}
function nf(){if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof Ma)Ma=function(a){this.re=a;this.m=393216;this.F=0},Ma.prototype.S=function(a,b){return new Ma(b)},Ma.prototype.R=function(){return this.re},Ma.prototype.va=function(){return!1},Ma.prototype.next=function(){return Error("No such element")},Ma.prototype.remove=function(){return Error("Unsupported operation")},Ma.Je=function(){return new U(null,1,5,V,[of],null)},Ma.Nd=!0,Ma.Vc="cljs.core/t_cljs$core7800",Ma.le=function(a){return ic(a,
"cljs.core/t_cljs$core7800")};return new Ma(pf)}var qf={},rf={};function sf(a){this.yc=qf;this.hc=a}sf.prototype.va=function(){this.yc===qf?(this.yc=rf,this.hc=I(this.hc)):this.yc===this.hc&&(this.hc=y(this.yc));return null!=this.hc};sf.prototype.next=function(){if(this.va())return this.yc=this.hc,x(this.hc);throw Error("No such element");};sf.prototype.remove=function(){return Error("Unsupported operation")};
function tf(a,b){for(;;){if(null==I(b))return!0;var c=x(b);c=a.c?a.c(c):a.call(null,c);if(r(c))b=y(b);else return!1}}function uf(a,b){for(;;)if(b=I(b)){var c=x(b);c=a.c?a.c(c):a.call(null,c);if(r(c))return c;b=y(b)}else return null}function vf(a){if("number"===typeof a&&!isNaN(a)&&Infinity!==a&&parseFloat(a)===parseInt(a,10))return 0===(a&1);throw Error(["Argument must be an integer: ",t.c(a)].join(""));}
function wf(a){return function(){function b(b,c){return db(a.b?a.b(b,c):a.call(null,b,c))}function c(b){return db(a.c?a.c(b):a.call(null,b))}function d(){return db(a.G?a.G():a.call(null))}var e=null,g=function(){function b(a,b,d){var e=null;if(2<arguments.length){e=0;for(var g=Array(arguments.length-2);e<g.length;)g[e]=arguments[e+2],++e;e=new v(g,0,null)}return c.call(this,a,b,e)}function c(b,c,d){return db(nb(a,b,c,d))}b.H=2;b.K=function(a){var b=x(a);a=y(a);var d=x(a);a=Vc(a);return c(b,d,a)};
b.h=c;return b}();e=function(a,e,l){switch(arguments.length){case 0:return d.call(this);case 1:return c.call(this,a);case 2:return b.call(this,a,e);default:var h=null;if(2<arguments.length){h=0;for(var k=Array(arguments.length-2);h<k.length;)k[h]=arguments[h+2],++h;h=new v(k,0,null)}return g.h(a,e,h)}throw Error("Invalid arity: "+arguments.length);};e.H=2;e.K=g.K;e.G=d;e.c=c;e.b=b;e.h=g.h;return e}()}
var xf=function xf(a){switch(arguments.length){case 0:return xf.G();case 1:return xf.c(arguments[0]);case 2:return xf.b(arguments[0],arguments[1]);case 3:return xf.f(arguments[0],arguments[1],arguments[2]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return xf.h(arguments[0],arguments[1],arguments[2],new v(c.slice(3),0,null))}};xf.G=function(){return ke};xf.c=function(a){return a};
xf.b=function(a,b){return function(){function c(c,d,e){c=b.f?b.f(c,d,e):b.call(null,c,d,e);return a.c?a.c(c):a.call(null,c)}function d(c,d){c=b.b?b.b(c,d):b.call(null,c,d);return a.c?a.c(c):a.call(null,c)}function e(c){c=b.c?b.c(c):b.call(null,c);return a.c?a.c(c):a.call(null,c)}function g(){var c=b.G?b.G():b.call(null);return a.c?a.c(c):a.call(null,c)}var h=null,k=function(){function c(a,b,c,e){var g=null;if(3<arguments.length){g=0;for(var h=Array(arguments.length-3);g<h.length;)h[g]=arguments[g+
3],++g;g=new v(h,0,null)}return d.call(this,a,b,c,g)}function d(c,d,e,g){c=kf(b,c,d,e,g);return a.c?a.c(c):a.call(null,c)}c.H=3;c.K=function(a){var b=x(a);a=y(a);var c=x(a);a=y(a);var e=x(a);a=Vc(a);return d(b,c,e,a)};c.h=d;return c}();h=function(a,b,h,u){switch(arguments.length){case 0:return g.call(this);case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,h);default:var l=null;if(3<arguments.length){l=0;for(var m=Array(arguments.length-3);l<m.length;)m[l]=arguments[l+
3],++l;l=new v(m,0,null)}return k.h(a,b,h,l)}throw Error("Invalid arity: "+arguments.length);};h.H=3;h.K=k.K;h.G=g;h.c=e;h.b=d;h.f=c;h.h=k.h;return h}()};
xf.f=function(a,b,c){return function(){function d(d,e,g){d=c.f?c.f(d,e,g):c.call(null,d,e,g);d=b.c?b.c(d):b.call(null,d);return a.c?a.c(d):a.call(null,d)}function e(d,e){d=c.b?c.b(d,e):c.call(null,d,e);d=b.c?b.c(d):b.call(null,d);return a.c?a.c(d):a.call(null,d)}function g(d){d=c.c?c.c(d):c.call(null,d);d=b.c?b.c(d):b.call(null,d);return a.c?a.c(d):a.call(null,d)}function h(){var d=c.G?c.G():c.call(null);d=b.c?b.c(d):b.call(null,d);return a.c?a.c(d):a.call(null,d)}var k=null,l=function(){function d(a,
b,c,d){var g=null;if(3<arguments.length){g=0;for(var h=Array(arguments.length-3);g<h.length;)h[g]=arguments[g+3],++g;g=new v(h,0,null)}return e.call(this,a,b,c,g)}function e(d,e,g,h){d=kf(c,d,e,g,h);d=b.c?b.c(d):b.call(null,d);return a.c?a.c(d):a.call(null,d)}d.H=3;d.K=function(a){var b=x(a);a=y(a);var c=x(a);a=y(a);var d=x(a);a=Vc(a);return e(b,c,d,a)};d.h=e;return d}();k=function(a,b,c,k){switch(arguments.length){case 0:return h.call(this);case 1:return g.call(this,a);case 2:return e.call(this,
a,b);case 3:return d.call(this,a,b,c);default:var m=null;if(3<arguments.length){m=0;for(var p=Array(arguments.length-3);m<p.length;)p[m]=arguments[m+3],++m;m=new v(p,0,null)}return l.h(a,b,c,m)}throw Error("Invalid arity: "+arguments.length);};k.H=3;k.K=l.K;k.G=h;k.c=g;k.b=e;k.f=d;k.h=l.h;return k}()};
xf.h=function(a,b,c,d){return function(a){return function(){function b(a){var b=null;if(0<arguments.length){b=0;for(var d=Array(arguments.length-0);b<d.length;)d[b]=arguments[b+0],++b;b=new v(d,0,null)}return c.call(this,b)}function c(b){b=jf(x(a),b);for(var c=y(a);;)if(c){var d=x(c);b=d.c?d.c(b):d.call(null,b);c=y(c)}else return b}b.H=0;b.K=function(a){a=I(a);return c(a)};b.h=c;return b}()}(Ge(ud(a,ud(b,ud(c,d)))))};
xf.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);d=y(d);return this.h(b,a,c,d)};xf.H=3;
function yf(a,b){return function(){function c(c,d,e){return a.B?a.B(b,c,d,e):a.call(null,b,c,d,e)}function d(c,d){return a.f?a.f(b,c,d):a.call(null,b,c,d)}function e(c){return a.b?a.b(b,c):a.call(null,b,c)}function g(){return a.c?a.c(b):a.call(null,b)}var h=null,k=function(){function c(a,b,c,e){var g=null;if(3<arguments.length){g=0;for(var h=Array(arguments.length-3);g<h.length;)h[g]=arguments[g+3],++g;g=new v(h,0,null)}return d.call(this,a,b,c,g)}function d(c,d,e,g){return Jd(a,b,c,d,e,M([g]))}c.H=
3;c.K=function(a){var b=x(a);a=y(a);var c=x(a);a=y(a);var e=x(a);a=Vc(a);return d(b,c,e,a)};c.h=d;return c}();h=function(a,b,h,u){switch(arguments.length){case 0:return g.call(this);case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,h);default:var l=null;if(3<arguments.length){l=0;for(var m=Array(arguments.length-3);l<m.length;)m[l]=arguments[l+3],++l;l=new v(m,0,null)}return k.h(a,b,h,l)}throw Error("Invalid arity: "+arguments.length);};h.H=3;h.K=k.K;h.G=g;
h.c=e;h.b=d;h.f=c;h.h=k.h;return h}()}
function zf(a,b){return function(){function c(c,d,e){c=null==c?b:c;return a.f?a.f(c,d,e):a.call(null,c,d,e)}function d(c,d){c=null==c?b:c;return a.b?a.b(c,d):a.call(null,c,d)}function e(c){c=null==c?b:c;return a.c?a.c(c):a.call(null,c)}var g=null,h=function(){function c(a,b,c,e){var g=null;if(3<arguments.length){g=0;for(var h=Array(arguments.length-3);g<h.length;)h[g]=arguments[g+3],++g;g=new v(h,0,null)}return d.call(this,a,b,c,g)}function d(c,d,e,g){return kf(a,null==c?b:c,d,e,g)}c.H=3;c.K=function(a){var b=
x(a);a=y(a);var c=x(a);a=y(a);var e=x(a);a=Vc(a);return d(b,c,e,a)};c.h=d;return c}();g=function(a,b,g,p){switch(arguments.length){case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,g);default:var k=null;if(3<arguments.length){k=0;for(var l=Array(arguments.length-3);k<l.length;)l[k]=arguments[k+3],++k;k=new v(l,0,null)}return h.h(a,b,g,k)}throw Error("Invalid arity: "+arguments.length);};g.H=3;g.K=h.K;g.c=e;g.b=d;g.f=c;g.h=h.h;return g}()}
function Af(a,b){return new Ne(null,function(){var c=I(b);if(c){if(Ud(c)){for(var d=tc(c),e=L(d),g=Re(e),h=0;;)if(h<e){var k=function(){var b=B.b(d,h);return a.c?a.c(b):a.call(null,b)}();null!=k&&g.add(k);h+=1}else break;return Te(g.aa(),Af(a,uc(c)))}e=function(){var b=x(c);return a.c?a.c(b):a.call(null,b)}();return null==e?Af(a,Vc(c)):ud(e,Af(a,Vc(c)))}return null},null,null)}function Bf(a,b,c){this.state=a;this.D=b;this.ve=c;this.Yd=null;this.F=16386;this.m=6455296}f=Bf.prototype;
f.equiv=function(a){return this.C(null,a)};f.C=function(a,b){return this===b};f.rc=function(){return this.state};f.R=function(){return this.D};f.O=function(){return this[da]||(this[da]=++ea)};function Cf(a){return new Bf(a,null,null)}function Df(a){var b=M([Wa,new q(null,1,[Ef,Cf(pf)],null)]),c=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b;b=F.b(c,Wa);c=F.b(c,Gf);return new Bf(a,b,c)}
function Hf(a,b){if(a instanceof Bf){var c=a.ve;if(null!=c&&!r(c.c?c.c(b):c.call(null,b)))throw Error("Validator rejected reference state");c=a.state;a.state=b;if(null!=a.Yd)a:for(var d=I(a.Yd),e=null,g=0,h=0;;)if(h<g){var k=e.Z(null,h),l=O(k,0);k=O(k,1);k.B?k.B(l,a,c,b):k.call(null,l,a,c,b);h+=1}else if(d=I(d))Ud(d)?(e=tc(d),d=uc(d),l=e,g=L(e),e=l):(e=x(d),l=O(e,0),k=O(e,1),k.B?k.B(l,a,c,b):k.call(null,l,a,c,b),d=y(d),e=null,g=0),h=0;else break a;return b}return xc(a,b)}
var If=function If(a){switch(arguments.length){case 2:return If.b(arguments[0],arguments[1]);case 3:return If.f(arguments[0],arguments[1],arguments[2]);case 4:return If.B(arguments[0],arguments[1],arguments[2],arguments[3]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return If.h(arguments[0],arguments[1],arguments[2],arguments[3],new v(c.slice(4),0,null))}};
If.b=function(a,b){if(a instanceof Bf){var c=a.state;b=b.c?b.c(c):b.call(null,c);a=Hf(a,b)}else a=yc.b(a,b);return a};If.f=function(a,b,c){if(a instanceof Bf){var d=a.state;b=b.b?b.b(d,c):b.call(null,d,c);a=Hf(a,b)}else a=yc.f(a,b,c);return a};If.B=function(a,b,c,d){if(a instanceof Bf){var e=a.state;b=b.f?b.f(e,c,d):b.call(null,e,c,d);a=Hf(a,b)}else a=yc.B(a,b,c,d);return a};If.h=function(a,b,c,d,e){return a instanceof Bf?Hf(a,kf(b,a.state,c,d,e)):yc.V(a,b,c,d,e)};
If.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);var e=y(d);d=x(e);e=y(e);return this.h(b,a,c,d,e)};If.H=4;function Jf(a){this.state=a;this.m=32768;this.F=0}Jf.prototype.Uc=function(a,b){return this.state=b};Jf.prototype.rc=function(){return this.state};
function Kf(){var a=Lf,b=Mf;return function(){function c(c,d,e){var g=a.c?a.c(c):a.call(null,c);if(r(g))return g;g=a.c?a.c(d):a.call(null,d);if(r(g))return g;g=a.c?a.c(e):a.call(null,e);if(r(g))return g;c=b.c?b.c(c):b.call(null,c);if(r(c))return c;d=b.c?b.c(d):b.call(null,d);return r(d)?d:b.c?b.c(e):b.call(null,e)}function d(c,d){var e=a.c?a.c(c):a.call(null,c);if(r(e))return e;e=a.c?a.c(d):a.call(null,d);if(r(e))return e;c=b.c?b.c(c):b.call(null,c);return r(c)?c:b.c?b.c(d):b.call(null,d)}function e(c){var d=
a.c?a.c(c):a.call(null,c);return r(d)?d:b.c?b.c(c):b.call(null,c)}var g=null,h=function(){function c(a,b,c,e){var g=null;if(3<arguments.length){g=0;for(var h=Array(arguments.length-3);g<h.length;)h[g]=arguments[g+3],++g;g=new v(h,0,null)}return d.call(this,a,b,c,g)}function d(c,d,e,h){c=g.f(c,d,e);return r(c)?c:uf(function(){return function(c){var d=a.c?a.c(c):a.call(null,c);return r(d)?d:b.c?b.c(c):b.call(null,c)}}(c),h)}c.H=3;c.K=function(a){var b=x(a);a=y(a);var c=x(a);a=y(a);var e=x(a);a=Vc(a);
return d(b,c,e,a)};c.h=d;return c}();g=function(a,b,g,p){switch(arguments.length){case 0:return null;case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,g);default:var k=null;if(3<arguments.length){k=0;for(var l=Array(arguments.length-3);k<l.length;)l[k]=arguments[k+3],++k;k=new v(l,0,null)}return h.h(a,b,g,k)}throw Error("Invalid arity: "+arguments.length);};g.H=3;g.K=h.K;g.G=function(){return null};g.c=e;g.b=d;g.f=c;g.h=h.h;return g}()}
var Nf=function Nf(a){switch(arguments.length){case 1:return Nf.c(arguments[0]);case 2:return Nf.b(arguments[0],arguments[1]);case 3:return Nf.f(arguments[0],arguments[1],arguments[2]);case 4:return Nf.B(arguments[0],arguments[1],arguments[2],arguments[3]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Nf.h(arguments[0],arguments[1],arguments[2],arguments[3],new v(c.slice(4),0,null))}};
Nf.c=function(a){return function(b){return function(){function c(c,d){d=a.c?a.c(d):a.call(null,d);return b.b?b.b(c,d):b.call(null,c,d)}function d(a){return b.c?b.c(a):b.call(null,a)}function e(){return b.G?b.G():b.call(null)}var g=null,h=function(){function c(a,b,c){var e=null;if(2<arguments.length){e=0;for(var g=Array(arguments.length-2);e<g.length;)g[e]=arguments[e+2],++e;e=new v(g,0,null)}return d.call(this,a,b,e)}function d(c,d,e){d=lb(a,d,e);return b.b?b.b(c,d):b.call(null,c,d)}c.H=2;c.K=function(a){var b=
x(a);a=y(a);var c=x(a);a=Vc(a);return d(b,c,a)};c.h=d;return c}();g=function(a,b,g){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b);default:var k=null;if(2<arguments.length){k=0;for(var l=Array(arguments.length-2);k<l.length;)l[k]=arguments[k+2],++k;k=new v(l,0,null)}return h.h(a,b,k)}throw Error("Invalid arity: "+arguments.length);};g.H=2;g.K=h.K;g.G=e;g.c=d;g.b=c;g.h=h.h;return g}()}};
Nf.b=function(a,b){return new Ne(null,function(){var c=I(b);if(c){if(Ud(c)){for(var d=tc(c),e=L(d),g=Re(e),h=0;;)if(h<e)Ue(g,function(){var b=B.b(d,h);return a.c?a.c(b):a.call(null,b)}()),h+=1;else break;return Te(g.aa(),Nf.b(a,uc(c)))}return ud(function(){var b=x(c);return a.c?a.c(b):a.call(null,b)}(),Nf.b(a,Vc(c)))}return null},null,null)};
Nf.f=function(a,b,c){return new Ne(null,function(){var d=I(b),e=I(c);if(d&&e){var g=x(d);var h=x(e);g=a.b?a.b(g,h):a.call(null,g,h);d=ud(g,Nf.f(a,Vc(d),Vc(e)))}else d=null;return d},null,null)};Nf.B=function(a,b,c,d){return new Ne(null,function(){var e=I(b),g=I(c),h=I(d);if(e&&g&&h){var k=x(e);var l=x(g),m=x(h);k=a.f?a.f(k,l,m):a.call(null,k,l,m);e=ud(k,Nf.B(a,Vc(e),Vc(g),Vc(h)))}else e=null;return e},null,null)};
Nf.h=function(a,b,c,d,e){var g=function l(a){return new Ne(null,function(){var b=Nf.b(I,a);return tf(ke,b)?ud(Nf.b(x,b),l(Nf.b(Vc,b))):null},null,null)};return Nf.b(function(){return function(b){return jf(a,b)}}(g),g(Bd.h(e,d,M([c,b]))))};Nf.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);var e=y(d);d=x(e);e=y(e);return this.h(b,a,c,d,e)};Nf.H=4;
function Of(a){return function(b){return function(a){return function(){function c(c,d){var e=Rb(a),g=a.Uc(null,a.rc(null)-1);c=0<e?b.b?b.b(c,d):b.call(null,c,d):c;return 0<g?c:fd(c)?c:new ed(c)}function e(a){return b.c?b.c(a):b.call(null,a)}function g(){return b.G?b.G():b.call(null)}var h=null;h=function(a,b){switch(arguments.length){case 0:return g.call(this);case 1:return e.call(this,a);case 2:return c.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};h.G=g;h.c=e;h.b=c;return h}()}(new Jf(a))}}
function Pf(a,b){return new Ne(null,function(){if(0<a){var c=I(b);return c?ud(x(c),Pf(a-1,Vc(c))):null}return null},null,null)}function Qf(a,b){return new Ne(null,function(c){return function(){return c(a,b)}}(function(a,b){for(;;)if(b=I(b),0<a&&b)--a,b=Vc(b);else return b}),null,null)}function Rf(a,b){return new Ne(null,function(c){return function(){return c(a,b)}}(function(a,b){for(;;){b=I(b);var c;if(c=b)c=x(b),c=a.c?a.c(c):a.call(null,c);if(r(c))b=Vc(b);else return b}}),null,null)}
function Sf(a,b,c,d){this.D=a;this.count=b;this.A=c;this.next=d;this.j=null;this.m=32374988;this.F=1}f=Sf.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,this.count)}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return null==this.next?1<this.count?this.next=new Sf(null,this.count-1,this.A,null):-1===this.count?this:null:this.next};
f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){if(-1===this.count)for(var c=b.b?b.b(this.A,this.A):b.call(null,this.A,this.A);;){if(fd(c))return Rb(c);c=b.b?b.b(c,this.A):b.call(null,c,this.A)}else for(a=1,c=this.A;;)if(a<this.count){c=b.b?b.b(c,this.A):b.call(null,c,this.A);if(fd(c))return Rb(c);a+=1}else return c};
f.ua=function(a,b,c){if(-1===this.count)for(c=b.b?b.b(c,this.A):b.call(null,c,this.A);;){if(fd(c))return Rb(c);c=b.b?b.b(c,this.A):b.call(null,c,this.A)}else for(a=0;;)if(a<this.count){c=b.b?b.b(c,this.A):b.call(null,c,this.A);if(fd(c))return Rb(c);a+=1}else return c};f.xa=function(){return this.A};f.Ea=function(){return null==this.next?1<this.count?this.next=new Sf(null,this.count-1,this.A,null):-1===this.count?this:Wc:this.next};f.N=function(){return this};
f.S=function(a,b){return b===this.D?this:new Sf(b,this.count,this.A,this.next)};f.T=function(a,b){return ud(b,this)};function Tf(a){return new Ne(null,function(){return ud(a.G?a.G():a.call(null),Tf(a))},null,null)}function Uf(a,b){return Pf(a,Tf(b))}
var Vf=function Vf(a){switch(arguments.length){case 0:return Vf.G();case 1:return Vf.c(arguments[0]);case 2:return Vf.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Vf.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Vf.G=function(){return Wc};Vf.c=function(a){return new Ne(null,function(){return a},null,null)};
Vf.b=function(a,b){return new Ne(null,function(){var c=I(a),d=I(b);return c&&d?ud(x(c),ud(x(d),Vf.b(Vc(c),Vc(d)))):null},null,null)};Vf.h=function(a,b,c){return new Ne(null,function(){var d=Nf.b(I,Bd.h(c,b,M([a])));return tf(ke,d)?T.b(Nf.b(x,d),jf(Vf,Nf.b(Vc,d))):null},null,null)};Vf.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Vf.H=2;function Wf(a,b){return jf(T,lb(Nf,a,b))}
function Xf(a){return function(b){return function(){function c(c,d){return r(a.c?a.c(d):a.call(null,d))?b.b?b.b(c,d):b.call(null,c,d):c}function d(a){return b.c?b.c(a):b.call(null,a)}function e(){return b.G?b.G():b.call(null)}var g=null;g=function(a,b){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};g.G=e;g.c=d;g.b=c;return g}()}}
function Yf(a,b){return new Ne(null,function(){var c=I(b);if(c){if(Ud(c)){for(var d=tc(c),e=L(d),g=Re(e),h=0;;)if(h<e){var k=B.b(d,h);k=a.c?a.c(k):a.call(null,k);r(k)&&(k=B.b(d,h),g.add(k));h+=1}else break;return Te(g.aa(),Yf(a,uc(c)))}d=x(c);c=Vc(c);return r(a.c?a.c(d):a.call(null,d))?ud(d,Yf(a,c)):Yf(a,c)}return null},null,null)}function Zf(a,b){return Yf(wf(a),b)}
var $f=function $f(a){switch(arguments.length){case 0:return $f.G();case 1:return $f.c(arguments[0]);case 2:return $f.b(arguments[0],arguments[1]);case 3:return $f.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};$f.G=function(){return Cd};$f.c=function(a){return a};$f.b=function(a,b){return null!=a?null!=a&&(a.F&4||n===a.Gd)?Ub(nc(A(mc,lc(a),b)),Ld(a)):A(wb,a,b):A(Bd,Wc,b)};
$f.f=function(a,b,c){return null!=a&&(a.F&4||n===a.Gd)?Ub(nc(le(b,af,lc(a),c)),Ld(a)):le(b,Bd,a,c)};$f.H=3;
var ag=function ag(a){switch(arguments.length){case 2:return ag.b(arguments[0],arguments[1]);case 3:return ag.f(arguments[0],arguments[1],arguments[2]);case 4:return ag.B(arguments[0],arguments[1],arguments[2],arguments[3]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return ag.h(arguments[0],arguments[1],arguments[2],arguments[3],new v(c.slice(4),0,null))}};ag.b=function(a,b){return nc(A(function(b,d){return af.b(b,a.c?a.c(d):a.call(null,d))},lc(Cd),b))};
ag.f=function(a,b,c){return $f.b(Cd,Nf.f(a,b,c))};ag.B=function(a,b,c,d){return $f.b(Cd,Nf.B(a,b,c,d))};ag.h=function(a,b,c,d,e){return $f.b(Cd,Jd(Nf,a,b,c,d,M([e])))};ag.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);var e=y(d);d=x(e);e=y(e);return this.h(b,a,c,d,e)};ag.H=4;function bg(a,b){return nc(A(function(b,d){return r(a.c?a.c(d):a.call(null,d))?af.b(b,d):b},lc(Cd),b))}
function cg(a,b,c){return new Ne(null,function(){var d=I(c);if(d){var e=Pf(a,d);return a===L(e)?ud(e,cg(a,b,Qf(b,d))):null}return null},null,null)}function dg(a,b){return A(F,a,b)}
var eg=function eg(a,b,c){b=I(b);var e=x(b),g=y(b);return g?P.f(a,e,function(){var b=F.b(a,e);return eg.f?eg.f(b,g,c):eg.call(null,b,g,c)}()):P.f(a,e,c)},fg=function fg(a){switch(arguments.length){case 3:return fg.f(arguments[0],arguments[1],arguments[2]);case 4:return fg.B(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return fg.V(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);case 6:return fg.la(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);
default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return fg.h(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5],new v(c.slice(6),0,null))}};fg.f=function(a,b,c){b=I(b);var d=x(b);return(b=y(b))?P.f(a,d,fg.f(F.b(a,d),b,c)):P.f(a,d,function(){var b=F.b(a,d);return c.c?c.c(b):c.call(null,b)}())};
fg.B=function(a,b,c,d){b=I(b);var e=x(b);return(b=y(b))?P.f(a,e,fg.B(F.b(a,e),b,c,d)):P.f(a,e,function(){var b=F.b(a,e);return c.b?c.b(b,d):c.call(null,b,d)}())};fg.V=function(a,b,c,d,e){b=I(b);var g=x(b);return(b=y(b))?P.f(a,g,fg.V(F.b(a,g),b,c,d,e)):P.f(a,g,function(){var b=F.b(a,g);return c.f?c.f(b,d,e):c.call(null,b,d,e)}())};
fg.la=function(a,b,c,d,e,g){b=I(b);var h=x(b);return(b=y(b))?P.f(a,h,fg.la(F.b(a,h),b,c,d,e,g)):P.f(a,h,function(){var b=F.b(a,h);return c.B?c.B(b,d,e,g):c.call(null,b,d,e,g)}())};fg.h=function(a,b,c,d,e,g,h){var k=I(b);b=x(k);return(k=y(k))?P.f(a,b,Jd(fg,F.b(a,b),k,c,d,M([e,g,h]))):P.f(a,b,Jd(c,F.b(a,b),d,e,g,M([h])))};fg.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);var e=y(d);d=x(e);var g=y(e);e=x(g);var h=y(g);g=x(h);h=y(h);return this.h(b,a,c,d,e,g,h)};fg.H=6;
function gg(a,b,c){return P.f(a,b,function(){var d=F.b(a,b);return c.c?c.c(d):c.call(null,d)}())}function hg(a,b,c,d){return P.f(a,b,function(){var e=F.b(a,b);return c.b?c.b(e,d):c.call(null,e,d)}())}function ig(a,b,c,d,e){return P.f(a,b,function(){var g=F.b(a,b);return c.f?c.f(g,d,e):c.call(null,g,d,e)}())}function jg(a,b){this.ma=a;this.l=b}
function kg(a){return new jg(a,[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null])}function lg(a){a=a.w;return 32>a?0:a-1>>>5<<5}function mg(a,b,c){for(;;){if(0===b)return c;var d=kg(a);d.l[0]=c;c=d;b-=5}}var ng=function ng(a,b,c,d){var g=new jg(c.ma,jb(c.l)),h=a.w-1>>>b&31;5===b?g.l[h]=d:(c=c.l[h],null!=c?(b-=5,a=ng.B?ng.B(a,b,c,d):ng.call(null,a,b,c,d)):a=mg(null,b-5,d),g.l[h]=a);return g};
function og(a,b){throw Error(["No item ",t.c(a)," in vector of length ",t.c(b)].join(""));}function pg(a,b){if(b>=lg(a))return a.cb;var c=a.root;for(a=a.shift;;)if(0<a){var d=a-5;c=c.l[b>>>a&31];a=d}else return c.l}var qg=function qg(a,b,c,d,e){var h=new jg(c.ma,jb(c.l));if(0===b)h.l[d&31]=e;else{var k=d>>>b&31;b-=5;c=c.l[k];a=qg.V?qg.V(a,b,c,d,e):qg.call(null,a,b,c,d,e);h.l[k]=a}return h};function rg(a,b,c,d,e,g){this.J=a;this.ad=b;this.l=c;this.v=d;this.start=e;this.end=g}
rg.prototype.va=function(){return this.J<this.end};rg.prototype.next=function(){32===this.J-this.ad&&(this.l=pg(this.v,this.J),this.ad+=32);var a=this.l[this.J&31];this.J+=1;return a};function sg(a,b,c){return new rg(b,b-b%32,b<L(a)?pg(a,b):null,a,b,c)}function tg(a,b,c,d){return c<d?ug(a,b,pd(a,c),c+1,d):b.G?b.G():b.call(null)}function ug(a,b,c,d,e){var g=c;c=d;for(d=pg(a,d);;)if(c<e){var h=c&31;d=0===h?pg(a,c):d;h=d[h];g=b.b?b.b(g,h):b.call(null,g,h);if(fd(g))return Rb(g);c+=1}else return g}
function U(a,b,c,d,e,g){this.D=a;this.w=b;this.shift=c;this.root=d;this.cb=e;this.j=g;this.m=167666463;this.F=139268}f=U.prototype;f.Sb=function(a,b){return 0<=b&&b<this.w?new W(b,pg(this,b)[b&31]):null};f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return"number"===typeof b?this.ga(null,b,c):c};
f.$=function(a,b,c){a=0;for(var d=c;;)if(a<this.w){var e=pg(this,a);c=e.length;a:for(var g=0;;)if(g<c){var h=g+a,k=e[g];d=b.f?b.f(d,h,k):b.call(null,d,h,k);if(fd(d)){e=d;break a}g+=1}else{e=d;break a}if(fd(e))return Rb(e);a+=c;d=e}else return d};f.cd=n;f.Z=function(a,b){return(0<=b&&b<this.w?pg(this,b):og(b,this.w))[b&31]};f.ga=function(a,b,c){return 0<=b&&b<this.w?pg(this,b)[b&31]:c};
f.Bb=function(a,b,c){if(0<=b&&b<this.w)return lg(this)<=b?(a=jb(this.cb),a[b&31]=c,new U(this.D,this.w,this.shift,this.root,a,null)):new U(this.D,this.w,this.shift,qg(this,this.shift,this.root,b,c),this.cb,null);if(b===this.w)return this.T(null,c);throw Error(["Index ",t.c(b)," out of bounds  [0,",t.c(this.w),"]"].join(""));};f.W=function(){return sg(this,0,this.w)};f.R=function(){return this.D};f.P=function(){return this.w};f.Tb=function(){return 0<this.w?this.Z(null,this.w-1):null};
f.pb=function(){return 0<this.w?new sd(this,this.w-1,null):null};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){if(b instanceof U)if(this.w===L(b))for(a=this.W(null),b=b.W(null);;)if(a.va()){var c=a.next(),d=b.next();if(!J.b(c,d))return!1}else return!0;else return!1;else return td(this,b)};
f.ec=function(){var a=this.w,b=this.shift,c=new jg({},jb(this.root.l)),d=this.cb,e=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];Vd(d,0,e,0,d.length);return new vg(a,b,c,e)};f.ia=function(){return Ub(Cd,this.D)};f.ta=function(a,b){return tg(this,b,0,this.w)};
f.ua=function(a,b,c){a=0;for(var d=c;;)if(a<this.w){var e=pg(this,a);c=e.length;a:for(var g=0;;)if(g<c){var h=e[g];d=b.b?b.b(d,h):b.call(null,d,h);if(fd(d)){e=d;break a}g+=1}else{e=d;break a}if(fd(e))return Rb(e);a+=c;d=e}else return d};f.I=function(a,b,c){if("number"===typeof b)return this.Bb(null,b,c);throw Error("Vector's key for assoc must be a number.");};
f.N=function(){if(0===this.w)var a=null;else if(32>=this.w)a=new v(this.cb,0,null);else{a:{a=this.root;for(var b=this.shift;;)if(0<b)b-=5,a=a.l[0];else{a=a.l;break a}}a=new wg(this,a,0,0,null)}return a};f.S=function(a,b){return b===this.D?this:new U(b,this.w,this.shift,this.root,this.cb,this.j)};
f.T=function(a,b){if(32>this.w-lg(this)){a=this.cb.length;for(var c=Array(a+1),d=0;;)if(d<a)c[d]=this.cb[d],d+=1;else break;c[a]=b;return new U(this.D,this.w+1,this.shift,this.root,c,null)}a=(c=this.w>>>5>1<<this.shift)?this.shift+5:this.shift;c?(c=kg(null),c.l[0]=this.root,d=mg(null,this.shift,new jg(null,this.cb)),c.l[1]=d):c=ng(this,this.shift,this.root,new jg(null,this.cb));return new U(this.D,this.w+1,a,c,[b],null)};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.Z(null,c);case 3:return this.ga(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.Z(null,c)};a.f=function(a,c,d){return this.ga(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.Z(null,a)};f.b=function(a,b){return this.ga(null,a,b)};
var V=new jg(null,[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null]),Cd=new U(null,0,5,V,[],ad);function xg(a){var b=a.length;if(32>b)return new U(null,b,5,V,a,null);for(var c=32,d=(new U(null,32,5,V,a.slice(0,32),null)).ec(null);;)if(c<b){var e=c+1;d=af.b(d,a[c]);c=e}else return nc(d)}U.prototype[ib]=function(){return Yc(this)};
function yg(a){return zg(a)?new U(null,2,5,V,[Jb(a),Kb(a)],null):Td(a)?Kd(a,null):ab(a)?xg(a):nc(A(mc,lc(Cd),a))}var Ag=function Ag(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Ag.h(0<c.length?new v(c.slice(0),0,null):null)};Ag.h=function(a){return a instanceof v&&0===a.J?xg(a.l):yg(a)};Ag.H=0;Ag.K=function(a){return this.h(I(a))};function wg(a,b,c,d,e){this.ob=a;this.node=b;this.J=c;this.oa=d;this.D=e;this.j=null;this.m=32375020;this.F=1536}f=wg.prototype;
f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){if(this.oa+1<this.node.length){var a=new wg(this.ob,this.node,this.J,this.oa+1,null);return null==a?null:a}return this.Ac()};
f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return tg(this.ob,b,this.J+this.oa,L(this.ob))};f.ua=function(a,b,c){return ug(this.ob,b,c,this.J+this.oa,L(this.ob))};f.xa=function(){return this.node[this.oa]};f.Ea=function(){if(this.oa+1<this.node.length){var a=new wg(this.ob,this.node,this.J,this.oa+1,null);return null==a?Wc:a}return this.kc(null)};f.N=function(){return this};
f.Bc=function(){var a=this.node;return new Qe(a,this.oa,a.length)};f.kc=function(){var a=this.J+this.node.length;return a<sb(this.ob)?new wg(this.ob,pg(this.ob,a),a,0,null):Wc};f.S=function(a,b){return b===this.D?this:new wg(this.ob,this.node,this.J,this.oa,b)};f.T=function(a,b){return ud(b,this)};f.Ac=function(){var a=this.J+this.node.length;return a<sb(this.ob)?new wg(this.ob,pg(this.ob,a),a,0,null):null};wg.prototype[ib]=function(){return Yc(this)};
function Bg(a,b,c,d,e){this.D=a;this.v=b;this.start=c;this.end=d;this.j=e;this.m=167666463;this.F=139264}f=Bg.prototype;f.Sb=function(a,b){if(0>b)return null;a=this.start+b;return a<this.end?new W(b,Eb.b(this.v,a)):null};f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return"number"===typeof b?this.ga(null,b,c):c};
f.$=function(a,b,c){a=this.start;for(var d=0;;)if(a<this.end){var e=d,g=B.b(this.v,a);c=b.f?b.f(c,e,g):b.call(null,c,e,g);if(fd(c))return Rb(c);d+=1;a+=1}else return c};f.Z=function(a,b){return 0>b||this.end<=this.start+b?og(b,this.end-this.start):B.b(this.v,this.start+b)};f.ga=function(a,b,c){return 0>b||this.end<=this.start+b?c:B.f(this.v,this.start+b,c)};
f.Bb=function(a,b,c){a=this.start+b;if(0>b||this.end+1<=a)throw Error(["Index ",t.c(b)," out of bounds [0,",t.c(this.P(null)),"]"].join(""));b=this.D;c=P.f(this.v,a,c);var d=this.end;a+=1;return Cg(b,c,this.start,d>a?d:a,null)};f.W=function(){return null!=this.v&&n===this.v.cd?sg(this.v,this.start,this.end):new sf(this)};f.R=function(){return this.D};f.P=function(){return this.end-this.start};f.Tb=function(){return B.b(this.v,this.end-1)};
f.pb=function(){return this.start!==this.end?new sd(this,this.end-this.start-1,null):null};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Ub(Cd,this.D)};f.ta=function(a,b){return null!=this.v&&n===this.v.cd?tg(this.v,b,this.start,this.end):hd(this,b)};f.ua=function(a,b,c){return null!=this.v&&n===this.v.cd?ug(this.v,b,c,this.start,this.end):id(this,b,c)};
f.I=function(a,b,c){if("number"===typeof b)return this.Bb(null,b,c);throw Error("Subvec's key for assoc must be a number.");};f.N=function(){var a=this;return function(b){return function e(d){return d===a.end?null:ud(B.b(a.v,d),new Ne(null,function(){return function(){return e(d+1)}}(b),null,null))}}(this)(a.start)};f.S=function(a,b){return b===this.D?this:Cg(b,this.v,this.start,this.end,this.j)};f.T=function(a,b){return Cg(this.D,Qb(this.v,this.end,b),this.start,this.end+1,null)};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.Z(null,c);case 3:return this.ga(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.Z(null,c)};a.f=function(a,c,d){return this.ga(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.Z(null,a)};f.b=function(a,b){return this.ga(null,a,b)};Bg.prototype[ib]=function(){return Yc(this)};
function Cg(a,b,c,d,e){for(;;)if(b instanceof Bg)c=b.start+c,d=b.start+d,b=b.v;else{if(!Td(b))throw Error("v must satisfy IVector");var g=L(b);if(0>c||0>d||c>g||d>g)throw Error("Index out of bounds");return new Bg(a,b,c,d,e)}}function Dg(a,b){return Cg(null,a,0,b|0,null)}function Eg(a,b){return a===b.ma?b:new jg(a,jb(b.l))}
var Fg=function Fg(a,b,c,d){c=Eg(a.root.ma,c);var g=a.w-1>>>b&31;if(5===b)a=d;else{var h=c.l[g];null!=h?(b-=5,a=Fg.B?Fg.B(a,b,h,d):Fg.call(null,a,b,h,d)):a=mg(a.root.ma,b-5,d)}c.l[g]=a;return c};function vg(a,b,c,d){this.w=a;this.shift=b;this.root=c;this.cb=d;this.F=88;this.m=275}f=vg.prototype;
f.fc=function(a,b){if(this.root.ma){if(32>this.w-lg(this))this.cb[this.w&31]=b;else{a=new jg(this.root.ma,this.cb);var c=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];c[0]=b;this.cb=c;this.w>>>5>1<<this.shift?(b=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null],c=this.shift+
5,b[0]=this.root,b[1]=mg(this.root.ma,this.shift,a),this.root=new jg(this.root.ma,b),this.shift=c):this.root=Fg(this,this.shift,this.root,a)}this.w+=1;return this}throw Error("conj! after persistent!");};f.lc=function(){if(this.root.ma){this.root.ma=null;var a=this.w-lg(this),b=Array(a);Vd(this.cb,0,b,0,a);return new U(null,this.w,this.shift,this.root,b,null)}throw Error("persistent! called twice");};
f.sc=function(a,b,c){if("number"===typeof b)return Gg(this,b,c);throw Error("TransientVector's key for assoc! must be a number.");};
function Gg(a,b,c){if(a.root.ma){if(0<=b&&b<a.w){if(lg(a)<=b)a.cb[b&31]=c;else{var d=function(){return function(){return function k(d,h){h=Eg(a.root.ma,h);if(0===d)h.l[b&31]=c;else{var g=b>>>d&31;d=k(d-5,h.l[g]);h.l[g]=d}return h}}(a)(a.shift,a.root)}();a.root=d}return a}if(b===a.w)return a.fc(null,c);throw Error(["Index ",t.c(b)," out of bounds for TransientVector of length",t.c(a.w)].join(""));}throw Error("assoc! after persistent!");}
f.P=function(){if(this.root.ma)return this.w;throw Error("count after persistent!");};f.Z=function(a,b){if(this.root.ma)return(0<=b&&b<this.w?pg(this,b):og(b,this.w))[b&31];throw Error("nth after persistent!");};f.ga=function(a,b,c){return 0<=b&&b<this.w?this.Z(null,b):c};f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return"number"===typeof b?this.ga(null,b,c):c};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};f.b=function(a,b){return this.o(null,a,b)};function Hg(a,b){this.uc=a;this.Nc=b}
Hg.prototype.va=function(){var a=null!=this.uc&&I(this.uc);return a?a:(a=null!=this.Nc)?this.Nc.va():a};Hg.prototype.next=function(){if(null!=this.uc){var a=x(this.uc);this.uc=y(this.uc);return a}if(null!=this.Nc&&this.Nc.va())return this.Nc.next();throw Error("No such element");};Hg.prototype.remove=function(){return Error("Unsupported operation")};function Ig(a,b,c,d){this.D=a;this.ib=b;this.tb=c;this.j=d;this.m=31850700;this.F=0}f=Ig.prototype;f.toString=function(){return Dc(this)};
f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){var a=y(this.ib);return a?new Ig(this.D,a,this.tb,null):null!=this.tb?new Ig(this.D,this.tb,null,null):null};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Ub(Wc,this.D)};f.xa=function(){return x(this.ib)};f.Ea=function(){var a=y(this.ib);return a?new Ig(this.D,a,this.tb,null):null==this.tb?this.ia(null):new Ig(this.D,this.tb,null,null)};f.N=function(){return this};f.S=function(a,b){return b===this.D?this:new Ig(b,this.ib,this.tb,this.j)};f.T=function(a,b){return ud(b,this)};Ig.prototype[ib]=function(){return Yc(this)};
function Jg(a,b,c,d,e){this.D=a;this.count=b;this.ib=c;this.tb=d;this.j=e;this.F=139264;this.m=31858766}f=Jg.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,this.count.c?this.count.c(this):this.count.call(null,this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.W=function(){return new Hg(this.ib,Bc(this.tb))};f.R=function(){return this.D};f.P=function(){return this.count};f.Tb=function(){return x(this.ib)};
f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Ub(Kg,this.D)};f.xa=function(){return x(this.ib)};f.Ea=function(){return Vc(I(this))};f.N=function(){var a=I(this.tb),b=this.ib;return r(r(b)?b:a)?new Ig(null,this.ib,I(a),null):null};f.S=function(a,b){return b===this.D?this:new Jg(b,this.count,this.ib,this.tb,this.j)};
f.T=function(a,b){r(this.ib)?(a=this.tb,b=new Jg(this.D,this.count+1,this.ib,Bd.b(r(a)?a:Cd,b),null)):b=new Jg(this.D,this.count+1,Bd.b(this.ib,b),Cd,null);return b};var Kg=new Jg(null,0,null,Cd,ad);Jg.prototype[ib]=function(){return Yc(this)};function Lg(){this.m=2097152;this.F=0}Lg.prototype.equiv=function(a){return this.C(null,a)};Lg.prototype.C=function(){return!1};var Mg=new Lg;
function Ng(a,b){return Yd(Rd(b)&&!Sd(b)?L(a)===L(b)?(null!=a?a.m&1048576||n===a.Be||(a.m?0:eb(Xb,a)):eb(Xb,a))?je(function(a,d,e){return J.b(F.f(b,d,Mg),e)?!0:new ed(!1)},!0,a):tf(function(a){return J.b(F.f(b,x(a),Mg),xd(a))},a):null:null)}function Og(a,b,c,d){this.J=0;this.te=a;this.Ed=b;this.qe=c;this.Qd=d}Og.prototype.va=function(){var a=this.J<this.Ed;return a?a:this.Qd.va()};Og.prototype.next=function(){if(this.J<this.Ed){var a=pd(this.qe,this.J);this.J+=1;return new W(a,Eb.b(this.te,a))}return this.Qd.next()};
Og.prototype.remove=function(){return Error("Unsupported operation")};function Pg(a){this.da=a}Pg.prototype.next=function(){if(null!=this.da){var a=x(this.da),b=O(a,0);a=O(a,1);this.da=y(this.da);return{value:[b,a],done:!1}}return{value:null,done:!0}};function Qg(a){this.da=a}Qg.prototype.next=function(){if(null!=this.da){var a=x(this.da);this.da=y(this.da);return{value:[a,a],done:!1}}return{value:null,done:!0}};
function Rg(a,b){if(b instanceof H)a:{var c=a.length;b=b.X;for(var d=0;;){if(c<=d){a=-1;break a}if(a[d]instanceof H&&b===a[d].X){a=d;break a}d+=2}}else if("string"==typeof b||"number"===typeof b)a:for(c=a.length,d=0;;){if(c<=d){a=-1;break a}if(b===a[d]){a=d;break a}d+=2}else if(b instanceof E)a:for(c=a.length,b=b.Qb,d=0;;){if(c<=d){a=-1;break a}if(a[d]instanceof E&&b===a[d].Qb){a=d;break a}d+=2}else if(null==b)a:for(b=a.length,c=0;;){if(b<=c){a=-1;break a}if(null==a[c]){a=c;break a}c+=2}else a:for(c=
a.length,d=0;;){if(c<=d){a=-1;break a}if(J.b(b,a[d])){a=d;break a}d+=2}return a}function W(a,b){this.key=a;this.A=b;this.j=null;this.m=166619935;this.F=0}f=W.prototype;f.Sb=function(a,b){switch(b){case 0:return new W(0,this.key);case 1:return new W(1,this.A);default:return null}};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.M=function(a,b){return this.ga(null,b,null)};f.o=function(a,b,c){return this.ga(null,b,c)};f.Z=function(a,b){if(0===b)return this.key;if(1===b)return this.A;throw Error("Index out of bounds");};
f.ga=function(a,b,c){return 0===b?this.key:1===b?this.A:c};f.Bb=function(a,b,c){return(new U(null,2,5,V,[this.key,this.A],null)).Bb(null,b,c)};f.R=function(){return null};f.P=function(){return 2};f.gd=function(){return this.key};f.hd=function(){return this.A};f.Tb=function(){return this.A};f.pb=function(){return new v([this.A,this.key],0,null)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return null};
f.ta=function(a,b){return hd(this,b)};f.ua=function(a,b,c){return id(this,b,c)};f.I=function(a,b,c){return P.f(new U(null,2,5,V,[this.key,this.A],null),b,c)};f.N=function(){return new v([this.key,this.A],0,null)};f.S=function(a,b){return Kd(new U(null,2,5,V,[this.key,this.A],null),b)};f.T=function(a,b){return new U(null,3,5,V,[this.key,this.A,b],null)};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.Z(null,c);case 3:return this.ga(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.Z(null,c)};a.f=function(a,c,d){return this.ga(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.Z(null,a)};f.b=function(a,b){return this.ga(null,a,b)};function zg(a){return null!=a?a.m&2048||n===a.Ee?!0:!1:!1}
function Sg(a,b,c){this.l=a;this.J=b;this.Ib=c;this.m=32374990;this.F=0}f=Sg.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.Ib};f.na=function(){return this.J<this.l.length-2?new Sg(this.l,this.J+2,null):null};f.P=function(){return(this.l.length-this.J)/2};f.O=function(){return $c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return new W(this.l[this.J],this.l[this.J+1])};f.Ea=function(){return this.J<this.l.length-2?new Sg(this.l,this.J+2,null):Wc};f.N=function(){return this};f.S=function(a,b){return b===this.Ib?this:new Sg(this.l,this.J,b)};f.T=function(a,b){return ud(b,this)};Sg.prototype[ib]=function(){return Yc(this)};
function Tg(a,b){this.l=a;this.J=0;this.w=b}Tg.prototype.va=function(){return this.J<this.w};Tg.prototype.next=function(){var a=new W(this.l[this.J],this.l[this.J+1]);this.J+=2;return a};function q(a,b,c,d){this.D=a;this.w=b;this.l=c;this.j=d;this.m=16647951;this.F=139268}f=q.prototype;f.Sb=function(a,b){a=Rg(this.l,b);return-1===a?null:new W(this.l[a],this.l[a+1])};f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.keys=function(){return Yc(Ug(this))};f.entries=function(){return new Pg(I(I(this)))};
f.values=function(){return Yc(Vg(this))};f.has=function(a){return Zd(this,a)};f.get=function(a,b){return this.o(null,a,b)};f.forEach=function(a){for(var b=I(this),c=null,d=0,e=0;;)if(e<d){var g=c.Z(null,e),h=O(g,0);g=O(g,1);a.b?a.b(g,h):a.call(null,g,h);e+=1}else if(b=I(b))Ud(b)?(c=tc(b),b=uc(b),h=c,d=L(c),c=h):(c=x(b),h=O(c,0),g=O(c,1),a.b?a.b(g,h):a.call(null,g,h),b=y(b),c=null,d=0),e=0;else return null};f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){a=Rg(this.l,b);return-1===a?c:this.l[a+1]};f.$=function(a,b,c){a=this.l.length;for(var d=0;;)if(d<a){var e=this.l[d],g=this.l[d+1];c=b.f?b.f(c,e,g):b.call(null,c,e,g);if(fd(c))return Rb(c);d+=2}else return c};f.W=function(){return new Tg(this.l,2*this.w)};f.R=function(){return this.D};f.P=function(){return this.w};f.O=function(){var a=this.j;return null!=a?a:this.j=a=bd(this)};
f.C=function(a,b){if(Rd(b)&&!Sd(b))if(a=this.l.length,this.w===b.P(null))for(var c=0;;)if(c<a){var d=b.o(null,this.l[c],Wd);if(d!==Wd)if(J.b(this.l[c+1],d))c+=2;else return!1;else return!1}else return!0;else return!1;else return!1};f.ec=function(){return new Wg(this.l.length,jb(this.l))};f.ia=function(){return Ub(pf,this.D)};f.ta=function(a,b){return ge(this,b)};f.ua=function(a,b,c){return he(this,b,c)};
f.ba=function(a,b){if(0<=Rg(this.l,b)){a=this.l.length;var c=a-2;if(0===c)return this.ia(null);c=Array(c);for(var d=0,e=0;;){if(d>=a)return new q(this.D,this.w-1,c,null);J.b(b,this.l[d])?d+=2:(c[e]=this.l[d],c[e+1]=this.l[d+1],e+=2,d+=2)}}else return this};
f.I=function(a,b,c){a=Rg(this.l,b);if(-1===a){if(this.w<Xg){a=this.l;for(var d=a.length,e=Array(d+2),g=0;;)if(g<d)e[g]=a[g],g+=1;else break;e[d]=b;e[d+1]=c;return new q(this.D,this.w+1,e,null)}return Ub(Fb($f.b(Yg,this),b,c),this.D)}if(c===this.l[a+1])return this;b=jb(this.l);b[a+1]=c;return new q(this.D,this.w,b,null)};f.N=function(){var a=this.l;return 0<=a.length-2?new Sg(a,0,null):null};f.S=function(a,b){return b===this.D?this:new q(b,this.w,this.l,this.j)};
f.T=function(a,b){if(Td(b))return this.I(null,B.b(b,0),B.b(b,1));a=this;for(b=I(b);;){if(null==b)return a;var c=x(b);if(Td(c))a=Fb(a,B.b(c,0),B.b(c,1)),b=y(b);else throw Error("conj on a map takes map entries or seqables of map entries");}};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};f.b=function(a,b){return this.o(null,a,b)};var pf=new q(null,0,[],cd),Xg=8;
function Gd(a){for(var b=[],c=0;;)if(c<a.length){var d=a[c],e=a[c+1],g=Rg(b,d);-1===g?(g=b,g.push(d),g.push(e)):b[g+1]=e;c+=2}else break;return new q(null,b.length/2,b,null)}q.prototype[ib]=function(){return Yc(this)};function Wg(a,b){this.tc={};this.wc=a;this.l=b;this.m=259;this.F=56}f=Wg.prototype;f.P=function(){if(r(this.tc))return Ae(this.wc,2);throw Error("count after persistent!");};f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){if(r(this.tc))return a=Rg(this.l,b),-1===a?c:this.l[a+1];throw Error("lookup after persistent!");};f.fc=function(a,b){if(r(this.tc)){if(zg(b))return this.sc(null,Jb(b),Kb(b));if(Td(b))return this.sc(null,b.c?b.c(0):b.call(null,0),b.c?b.c(1):b.call(null,1));a=I(b);for(b=this;;){var c=x(a);if(r(c))a=y(a),b=oc(b,Jb(c),Kb(c));else return b}}else throw Error("conj! after persistent!");};
f.lc=function(){if(r(this.tc))return this.tc=!1,new q(null,Ae(this.wc,2),this.l,null);throw Error("persistent! called twice");};f.sc=function(a,b,c){if(r(this.tc)){a=Rg(this.l,b);if(-1===a)return this.wc+2<=2*Xg?(this.wc+=2,this.l.push(b),this.l.push(c),this):bf.f(Zg(this.wc,this.l),b,c);c!==this.l[a+1]&&(this.l[a+1]=c);return this}throw Error("assoc! after persistent!");};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.o(null,c,null);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.o(null,c,null)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.o(null,a,null)};f.b=function(a,b){return this.o(null,a,b)};
function Zg(a,b){for(var c=lc(Yg),d=0;;)if(d<a)c=bf.f(c,b[d],b[d+1]),d+=2;else return c}function $g(){this.A=!1}function ah(a,b){return a===b?!0:S(a,b)?!0:J.b(a,b)}function bh(a,b,c){a=jb(a);a[b]=c;return a}function ch(a,b){var c=Array(a.length-2);Vd(a,0,c,0,2*b);Vd(a,2*(b+1),c,2*b,c.length-2*b);return c}function dh(a,b,c,d){a=a.nc(b);a.l[c]=d;return a}
function eh(a,b,c){for(var d=a.length,e=0,g=c;;)if(e<d){c=a[e];if(null!=c){var h=a[e+1];c=b.f?b.f(g,c,h):b.call(null,g,c,h)}else c=a[e+1],c=null!=c?c.pc(b,g):g;if(fd(c))return c;e+=2;g=c}else return g}function fh(a){this.l=a;this.J=0;this.Gb=this.Lc=null}fh.prototype.advance=function(){for(var a=this.l.length;;)if(this.J<a){var b=this.l[this.J],c=this.l[this.J+1];null!=b?b=this.Lc=new W(b,c):null!=c?(b=Bc(c),b=b.va()?this.Gb=b:!1):b=!1;this.J+=2;if(b)return!0}else return!1};
fh.prototype.va=function(){var a=null!=this.Lc;return a?a:(a=null!=this.Gb)?a:this.advance()};fh.prototype.next=function(){if(null!=this.Lc){var a=this.Lc;this.Lc=null;return a}if(null!=this.Gb)return a=this.Gb.next(),this.Gb.va()||(this.Gb=null),a;if(this.advance())return this.next();throw Error("No such element");};fh.prototype.remove=function(){return Error("Unsupported operation")};function gh(a,b,c){this.ma=a;this.pa=b;this.l=c;this.F=131072;this.m=0}f=gh.prototype;
f.nc=function(a){if(a===this.ma)return this;var b=Be(this.pa),c=Array(0>b?4:2*(b+1));Vd(this.l,0,c,0,2*b);return new gh(a,this.pa,c)};f.Jc=function(){return hh(this.l,0,null)};f.pc=function(a,b){return eh(this.l,a,b)};f.oc=function(a,b,c,d){var e=1<<(b>>>a&31);if(0===(this.pa&e))return d;var g=Be(this.pa&e-1);e=this.l[2*g];g=this.l[2*g+1];return null==e?g.oc(a+5,b,c,d):ah(c,e)?g:d};
f.Eb=function(a,b,c,d,e,g){var h=1<<(c>>>b&31),k=Be(this.pa&h-1);if(0===(this.pa&h)){var l=Be(this.pa);if(2*l<this.l.length){a=this.nc(a);b=a.l;g.A=!0;a:for(c=2*(l-k),g=2*k+(c-1),l=2*(k+1)+(c-1);;){if(0===c)break a;b[l]=b[g];--l;--c;--g}b[2*k]=d;b[2*k+1]=e;a.pa|=h;return a}if(16<=l){k=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];k[c>>>b&31]=ih.Eb(a,b+5,c,d,e,g);for(e=d=0;;)if(32>d)0===
(this.pa>>>d&1)?d+=1:(k[d]=null!=this.l[e]?ih.Eb(a,b+5,Oc(this.l[e]),this.l[e],this.l[e+1],g):this.l[e+1],e+=2,d+=1);else break;return new jh(a,l+1,k)}b=Array(2*(l+4));Vd(this.l,0,b,0,2*k);b[2*k]=d;b[2*k+1]=e;Vd(this.l,2*k,b,2*(k+1),2*(l-k));g.A=!0;a=this.nc(a);a.l=b;a.pa|=h;return a}l=this.l[2*k];h=this.l[2*k+1];if(null==l)return l=h.Eb(a,b+5,c,d,e,g),l===h?this:dh(this,a,2*k+1,l);if(ah(d,l))return e===h?this:dh(this,a,2*k+1,e);g.A=!0;g=b+5;b=Oc(l);if(b===c)e=new kh(null,b,2,[l,h,d,e]);else{var m=
new $g;e=ih.Eb(a,g,b,l,h,m).Eb(a,g,c,d,e,m)}d=2*k;k=2*k+1;a=this.nc(a);a.l[d]=null;a.l[k]=e;return a};
f.Db=function(a,b,c,d,e){var g=1<<(b>>>a&31),h=Be(this.pa&g-1);if(0===(this.pa&g)){var k=Be(this.pa);if(16<=k){h=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];h[b>>>a&31]=ih.Db(a+5,b,c,d,e);for(d=c=0;;)if(32>c)0===(this.pa>>>c&1)?c+=1:(h[c]=null!=this.l[d]?ih.Db(a+5,Oc(this.l[d]),this.l[d],this.l[d+1],e):this.l[d+1],d+=2,c+=1);else break;return new jh(null,k+1,h)}a=Array(2*(k+1));Vd(this.l,
0,a,0,2*h);a[2*h]=c;a[2*h+1]=d;Vd(this.l,2*h,a,2*(h+1),2*(k-h));e.A=!0;return new gh(null,this.pa|g,a)}var l=this.l[2*h];g=this.l[2*h+1];if(null==l)return k=g.Db(a+5,b,c,d,e),k===g?this:new gh(null,this.pa,bh(this.l,2*h+1,k));if(ah(c,l))return d===g?this:new gh(null,this.pa,bh(this.l,2*h+1,d));e.A=!0;e=this.pa;k=this.l;a+=5;var m=Oc(l);if(m===b)c=new kh(null,m,2,[l,g,c,d]);else{var p=new $g;c=ih.Db(a,m,l,g,p).Db(a,b,c,d,p)}a=2*h;h=2*h+1;d=jb(k);d[a]=null;d[h]=c;return new gh(null,e,d)};
f.Ic=function(a,b,c,d){var e=1<<(b>>>a&31);if(0===(this.pa&e))return d;var g=Be(this.pa&e-1);e=this.l[2*g];g=this.l[2*g+1];return null==e?g.Ic(a+5,b,c,d):ah(c,e)?new W(e,g):d};f.Kc=function(a,b,c){var d=1<<(b>>>a&31);if(0===(this.pa&d))return this;var e=Be(this.pa&d-1),g=this.l[2*e],h=this.l[2*e+1];return null==g?(a=h.Kc(a+5,b,c),a===h?this:null!=a?new gh(null,this.pa,bh(this.l,2*e+1,a)):this.pa===d?null:new gh(null,this.pa^d,ch(this.l,e))):ah(c,g)?new gh(null,this.pa^d,ch(this.l,e)):this};f.W=function(){return new fh(this.l)};
var ih=new gh(null,0,[]);function lh(a){this.l=a;this.J=0;this.Gb=null}lh.prototype.va=function(){for(var a=this.l.length;;){if(null!=this.Gb&&this.Gb.va())return!0;if(this.J<a){var b=this.l[this.J];this.J+=1;null!=b&&(this.Gb=Bc(b))}else return!1}};lh.prototype.next=function(){if(this.va())return this.Gb.next();throw Error("No such element");};lh.prototype.remove=function(){return Error("Unsupported operation")};function jh(a,b,c){this.ma=a;this.w=b;this.l=c;this.F=131072;this.m=0}f=jh.prototype;
f.nc=function(a){return a===this.ma?this:new jh(a,this.w,jb(this.l))};f.Jc=function(){return mh(this.l,0,null)};f.pc=function(a,b){for(var c=this.l.length,d=0;;)if(d<c){var e=this.l[d];if(null!=e){b=e.pc(a,b);if(fd(b))return b;d+=1}else d+=1}else return b};f.oc=function(a,b,c,d){var e=this.l[b>>>a&31];return null!=e?e.oc(a+5,b,c,d):d};
f.Eb=function(a,b,c,d,e,g){var h=c>>>b&31,k=this.l[h];if(null==k)return a=dh(this,a,h,ih.Eb(a,b+5,c,d,e,g)),a.w+=1,a;b=k.Eb(a,b+5,c,d,e,g);return b===k?this:dh(this,a,h,b)};f.Db=function(a,b,c,d,e){var g=b>>>a&31,h=this.l[g];if(null==h)return new jh(null,this.w+1,bh(this.l,g,ih.Db(a+5,b,c,d,e)));a=h.Db(a+5,b,c,d,e);return a===h?this:new jh(null,this.w,bh(this.l,g,a))};f.Ic=function(a,b,c,d){var e=this.l[b>>>a&31];return null!=e?e.Ic(a+5,b,c,d):d};
f.Kc=function(a,b,c){var d=b>>>a&31,e=this.l[d];if(null!=e){a=e.Kc(a+5,b,c);if(a===e)d=this;else if(null==a)if(8>=this.w)a:{e=this.l;a=e.length;b=Array(2*(this.w-1));c=0;for(var g=1,h=0;;)if(c<a)c!==d&&null!=e[c]?(b[g]=e[c],g+=2,h|=1<<c,c+=1):c+=1;else{d=new gh(null,h,b);break a}}else d=new jh(null,this.w-1,bh(this.l,d,a));else d=new jh(null,this.w,bh(this.l,d,a));return d}return this};f.W=function(){return new lh(this.l)};
function nh(a,b,c){b*=2;for(var d=0;;)if(d<b){if(ah(c,a[d]))return d;d+=2}else return-1}function kh(a,b,c,d){this.ma=a;this.Ub=b;this.w=c;this.l=d;this.F=131072;this.m=0}f=kh.prototype;f.nc=function(a){if(a===this.ma)return this;var b=Array(2*(this.w+1));Vd(this.l,0,b,0,2*this.w);return new kh(a,this.Ub,this.w,b)};f.Jc=function(){return hh(this.l,0,null)};f.pc=function(a,b){return eh(this.l,a,b)};f.oc=function(a,b,c,d){a=nh(this.l,this.w,c);return 0>a?d:ah(c,this.l[a])?this.l[a+1]:d};
f.Eb=function(a,b,c,d,e,g){if(c===this.Ub){b=nh(this.l,this.w,d);if(-1===b){if(this.l.length>2*this.w)return b=2*this.w,c=2*this.w+1,a=this.nc(a),a.l[b]=d,a.l[c]=e,g.A=!0,a.w+=1,a;c=this.l.length;b=Array(c+2);Vd(this.l,0,b,0,c);b[c]=d;b[c+1]=e;g.A=!0;d=this.w+1;a===this.ma?(this.l=b,this.w=d,a=this):a=new kh(this.ma,this.Ub,d,b);return a}return this.l[b+1]===e?this:dh(this,a,b+1,e)}return(new gh(a,1<<(this.Ub>>>b&31),[null,this,null,null])).Eb(a,b,c,d,e,g)};
f.Db=function(a,b,c,d,e){return b===this.Ub?(a=nh(this.l,this.w,c),-1===a?(a=2*this.w,b=Array(a+2),Vd(this.l,0,b,0,a),b[a]=c,b[a+1]=d,e.A=!0,new kh(null,this.Ub,this.w+1,b)):J.b(this.l[a+1],d)?this:new kh(null,this.Ub,this.w,bh(this.l,a+1,d))):(new gh(null,1<<(this.Ub>>>a&31),[null,this])).Db(a,b,c,d,e)};f.Ic=function(a,b,c,d){a=nh(this.l,this.w,c);return 0>a?d:ah(c,this.l[a])?new W(this.l[a],this.l[a+1]):d};
f.Kc=function(a,b,c){a=nh(this.l,this.w,c);return-1===a?this:1===this.w?null:new kh(null,this.Ub,this.w-1,ch(this.l,Ae(a,2)))};f.W=function(){return new fh(this.l)};function oh(a,b,c,d,e){this.D=a;this.Hb=b;this.J=c;this.da=d;this.j=e;this.m=32374988;this.F=0}f=oh.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return null==this.da?hh(this.Hb,this.J+2,null):hh(this.Hb,this.J,y(this.da))};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return null==this.da?new W(this.Hb[this.J],this.Hb[this.J+1]):x(this.da)};f.Ea=function(){var a=null==this.da?hh(this.Hb,this.J+2,null):hh(this.Hb,this.J,y(this.da));return null!=a?a:Wc};f.N=function(){return this};f.S=function(a,b){return b===this.D?this:new oh(b,this.Hb,this.J,this.da,this.j)};f.T=function(a,b){return ud(b,this)};
oh.prototype[ib]=function(){return Yc(this)};function hh(a,b,c){if(null==c)for(c=a.length;;)if(b<c){if(null!=a[b])return new oh(null,a,b,null,null);var d=a[b+1];if(r(d)&&(d=d.Jc(),r(d)))return new oh(null,a,b+2,d,null);b+=2}else return null;else return new oh(null,a,b,c,null)}function ph(a,b,c,d,e){this.D=a;this.Hb=b;this.J=c;this.da=d;this.j=e;this.m=32374988;this.F=0}f=ph.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){return mh(this.Hb,this.J,y(this.da))};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};
f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return x(this.da)};f.Ea=function(){var a=mh(this.Hb,this.J,y(this.da));return null!=a?a:Wc};f.N=function(){return this};f.S=function(a,b){return b===this.D?this:new ph(b,this.Hb,this.J,this.da,this.j)};f.T=function(a,b){return ud(b,this)};ph.prototype[ib]=function(){return Yc(this)};
function mh(a,b,c){if(null==c)for(c=a.length;;)if(b<c){var d=a[b];if(r(d)&&(d=d.Jc(),r(d)))return new ph(null,a,b+1,d,null);b+=1}else return null;else return new ph(null,a,b,c,null)}function qh(a,b){this.Va=a;this.Wd=b;this.yd=!1}qh.prototype.va=function(){return!this.yd||this.Wd.va()};qh.prototype.next=function(){if(this.yd)return this.Wd.next();this.yd=!0;return new W(null,this.Va)};qh.prototype.remove=function(){return Error("Unsupported operation")};
function rh(a,b,c,d,e,g){this.D=a;this.w=b;this.root=c;this.Wa=d;this.Va=e;this.j=g;this.m=16123663;this.F=139268}f=rh.prototype;f.Sb=function(a,b){return null==b?this.Wa?new W(null,this.Va):null:null==this.root?null:this.root.Ic(0,Oc(b),b,null)};f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.keys=function(){return Yc(Ug(this))};f.entries=function(){return new Pg(I(I(this)))};f.values=function(){return Yc(Vg(this))};f.has=function(a){return Zd(this,a)};
f.get=function(a,b){return this.o(null,a,b)};f.forEach=function(a){for(var b=I(this),c=null,d=0,e=0;;)if(e<d){var g=c.Z(null,e),h=O(g,0);g=O(g,1);a.b?a.b(g,h):a.call(null,g,h);e+=1}else if(b=I(b))Ud(b)?(c=tc(b),b=uc(b),h=c,d=L(c),c=h):(c=x(b),h=O(c,0),g=O(c,1),a.b?a.b(g,h):a.call(null,g,h),b=y(b),c=null,d=0),e=0;else return null};f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return null==b?this.Wa?this.Va:c:null==this.root?c:this.root.oc(0,Oc(b),b,c)};
f.$=function(a,b,c){a=this.Wa?b.f?b.f(c,null,this.Va):b.call(null,c,null,this.Va):c;return fd(a)?Rb(a):null!=this.root?gd(this.root.pc(b,a)):a};f.W=function(){var a=this.root?Bc(this.root):nf();return this.Wa?new qh(this.Va,a):a};f.R=function(){return this.D};f.P=function(){return this.w};f.O=function(){var a=this.j;return null!=a?a:this.j=a=bd(this)};f.C=function(a,b){return Ng(this,b)};f.ec=function(){return new sh(this.root,this.w,this.Wa,this.Va)};f.ia=function(){return Ub(Yg,this.D)};
f.ba=function(a,b){if(null==b)return this.Wa?new rh(this.D,this.w-1,this.root,!1,null,null):this;if(null==this.root)return this;a=this.root.Kc(0,Oc(b),b);return a===this.root?this:new rh(this.D,this.w-1,a,this.Wa,this.Va,null)};f.I=function(a,b,c){if(null==b)return this.Wa&&c===this.Va?this:new rh(this.D,this.Wa?this.w:this.w+1,this.root,!0,c,null);a=new $g;b=(null==this.root?ih:this.root).Db(0,Oc(b),b,c,a);return b===this.root?this:new rh(this.D,a.A?this.w+1:this.w,b,this.Wa,this.Va,null)};
f.N=function(){if(0<this.w){var a=null!=this.root?this.root.Jc():null;return this.Wa?ud(new W(null,this.Va),a):a}return null};f.S=function(a,b){return b===this.D?this:new rh(b,this.w,this.root,this.Wa,this.Va,this.j)};f.T=function(a,b){if(Td(b))return this.I(null,B.b(b,0),B.b(b,1));a=this;for(b=I(b);;){if(null==b)return a;var c=x(b);if(Td(c))a=Fb(a,B.b(c,0),B.b(c,1)),b=y(b);else throw Error("conj on a map takes map entries or seqables of map entries");}};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};f.b=function(a,b){return this.o(null,a,b)};var Yg=new rh(null,0,null,!1,null,cd);
function th(a,b){for(var c=a.length,d=0,e=lc(Yg);;)if(d<c){var g=d+1;e=oc(e,a[d],b[d]);d=g}else return nc(e)}rh.prototype[ib]=function(){return Yc(this)};function sh(a,b,c,d){this.ma={};this.root=a;this.count=b;this.Wa=c;this.Va=d;this.m=259;this.F=56}function uh(a,b,c){if(a.ma){if(null==b)a.Va!==c&&(a.Va=c),a.Wa||(a.count+=1,a.Wa=!0);else{var d=new $g;b=(null==a.root?ih:a.root).Eb(a.ma,0,Oc(b),b,c,d);b!==a.root&&(a.root=b);d.A&&(a.count+=1)}return a}throw Error("assoc! after persistent!");}f=sh.prototype;
f.P=function(){if(this.ma)return this.count;throw Error("count after persistent!");};f.M=function(a,b){return null==b?this.Wa?this.Va:null:null==this.root?null:this.root.oc(0,Oc(b),b)};f.o=function(a,b,c){return null==b?this.Wa?this.Va:c:null==this.root?c:this.root.oc(0,Oc(b),b,c)};
f.fc=function(a,b){a:if(this.ma)if(zg(b))a=uh(this,Jb(b),Kb(b));else if(Td(b))a=uh(this,b.c?b.c(0):b.call(null,0),b.c?b.c(1):b.call(null,1));else for(a=I(b),b=this;;){var c=x(a);if(r(c))a=y(a),b=uh(b,Jb(c),Kb(c));else{a=b;break a}}else throw Error("conj! after persistent");return a};f.lc=function(){if(this.ma){this.ma=null;var a=new rh(null,this.count,this.root,this.Wa,this.Va,null)}else throw Error("persistent! called twice");return a};f.sc=function(a,b,c){return uh(this,b,c)};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};f.b=function(a,b){return this.o(null,a,b)};
function vh(a,b,c){for(var d=b;;)if(null!=a)b=c?a.left:a.right,d=Bd.b(d,a),a=b;else return d}function wh(a,b,c,d,e){this.D=a;this.stack=b;this.ic=c;this.w=d;this.j=e;this.m=32374990;this.F=0}f=wh.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.D};f.na=function(){var a=x(this.stack);a=vh(this.ic?a.right:a.left,y(this.stack),this.ic);return null==a?null:new wh(null,a,this.ic,this.w-1,null)};f.P=function(){return 0>this.w?L(y(this))+1:this.w};
f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){var a=this.stack;return null==a?null:Ob(a)};f.Ea=function(){var a=x(this.stack);a=vh(this.ic?a.right:a.left,y(this.stack),this.ic);return null!=a?new wh(null,a,this.ic,this.w-1,null):Wc};f.N=function(){return this};
f.S=function(a,b){return b===this.D?this:new wh(b,this.stack,this.ic,this.w,this.j)};f.T=function(a,b){return ud(b,this)};wh.prototype[ib]=function(){return Yc(this)};function xh(a,b,c){return new wh(null,vh(a,null,b),b,c,null)}function yh(a,b,c,d){return c instanceof zh?c.left instanceof zh?new zh(c.key,c.A,c.left.Rb(),new Ah(a,b,c.right,d)):c.right instanceof zh?new zh(c.right.key,c.right.A,new Ah(c.key,c.A,c.left,c.right.left),new Ah(a,b,c.right.right,d)):new Ah(a,b,c,d):new Ah(a,b,c,d)}
function Bh(a,b,c,d){return d instanceof zh?d.right instanceof zh?new zh(d.key,d.A,new Ah(a,b,c,d.left),d.right.Rb()):d.left instanceof zh?new zh(d.left.key,d.left.A,new Ah(a,b,c,d.left.left),new Ah(d.key,d.A,d.left.right,d.right)):new Ah(a,b,c,d):new Ah(a,b,c,d)}
function Ch(a,b,c,d){if(c instanceof zh)return new zh(a,b,c.Rb(),d);if(d instanceof Ah)return Bh(a,b,c,d.Mc());if(d instanceof zh&&d.left instanceof Ah)return new zh(d.left.key,d.left.A,new Ah(a,b,c,d.left.left),Bh(d.key,d.A,d.left.right,d.right.Mc()));throw Error("red-black tree invariant violation");}
function Dh(a,b,c,d){if(d instanceof zh)return new zh(a,b,c,d.Rb());if(c instanceof Ah)return yh(a,b,c.Mc(),d);if(c instanceof zh&&c.right instanceof Ah)return new zh(c.right.key,c.right.A,yh(c.key,c.A,c.left.Mc(),c.right.left),new Ah(a,b,c.right.right,d));throw Error("red-black tree invariant violation");}
var Eh=function Eh(a,b,c){var e=null!=a.left?function(){var e=a.left;return Eh.f?Eh.f(e,b,c):Eh.call(null,e,b,c)}():c;if(fd(e))return e;var g=function(){var c=a.key,g=a.A;return b.f?b.f(e,c,g):b.call(null,e,c,g)}();if(fd(g))return g;if(null!=a.right){var h=a.right;return Eh.f?Eh.f(h,b,g):Eh.call(null,h,b,g)}return g};function Ah(a,b,c,d){this.key=a;this.A=b;this.left=c;this.right=d;this.j=null;this.m=166619935;this.F=0}f=Ah.prototype;
f.Sb=function(a,b){switch(b){case 0:return new W(0,this.key);case 1:return new W(1,this.A);default:return null}};f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();f.Bd=function(a){return a.Dd(this)};f.Mc=function(){return new zh(this.key,this.A,this.left,this.right)};f.Rb=function(){return this};f.Ad=function(a){return a.Cd(this)};f.replace=function(a,b,c,d){return new Ah(a,b,c,d)};
f.Cd=function(a){return new Ah(a.key,a.A,this,a.right)};f.Dd=function(a){return new Ah(a.key,a.A,a.left,this)};f.pc=function(a,b){return Eh(this,a,b)};f.M=function(a,b){return this.ga(null,b,null)};f.o=function(a,b,c){return this.ga(null,b,c)};f.Z=function(a,b){if(0===b)return this.key;if(1===b)return this.A;throw Error("Index out of bounds");};f.ga=function(a,b,c){return 0===b?this.key:1===b?this.A:c};f.Bb=function(a,b,c){return(new U(null,2,5,V,[this.key,this.A],null)).Bb(null,b,c)};f.R=function(){return null};
f.P=function(){return 2};f.gd=function(){return this.key};f.hd=function(){return this.A};f.Tb=function(){return this.A};f.pb=function(){return new v([this.A,this.key],0,null)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return null};f.ta=function(a,b){return hd(this,b)};f.ua=function(a,b,c){return id(this,b,c)};f.I=function(a,b,c){return P.f(new U(null,2,5,V,[this.key,this.A],null),b,c)};
f.N=function(){return new v([this.key,this.A],0,null)};f.S=function(a,b){return Ub(new U(null,2,5,V,[this.key,this.A],null),b)};f.T=function(a,b){return new U(null,3,5,V,[this.key,this.A,b],null)};f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.Z(null,c);case 3:return this.ga(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.Z(null,c)};a.f=function(a,c,d){return this.ga(null,c,d)};return a}();
f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.Z(null,a)};f.b=function(a,b){return this.ga(null,a,b)};Ah.prototype[ib]=function(){return Yc(this)};function zh(a,b,c,d){this.key=a;this.A=b;this.left=c;this.right=d;this.j=null;this.m=166619935;this.F=0}f=zh.prototype;f.Sb=function(a,b){switch(b){case 0:return new W(0,this.key);case 1:return new W(1,this.A);default:return null}};
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();f.Bd=function(a){return new zh(this.key,this.A,this.left,a)};f.Mc=function(){throw Error("red-black tree invariant violation");};f.Rb=function(){return new Ah(this.key,this.A,this.left,this.right)};
f.Ad=function(a){return new zh(this.key,this.A,a,this.right)};f.replace=function(a,b,c,d){return new zh(a,b,c,d)};f.Cd=function(a){return this.left instanceof zh?new zh(this.key,this.A,this.left.Rb(),new Ah(a.key,a.A,this.right,a.right)):this.right instanceof zh?new zh(this.right.key,this.right.A,new Ah(this.key,this.A,this.left,this.right.left),new Ah(a.key,a.A,this.right.right,a.right)):new Ah(a.key,a.A,this,a.right)};
f.Dd=function(a){return this.right instanceof zh?new zh(this.key,this.A,new Ah(a.key,a.A,a.left,this.left),this.right.Rb()):this.left instanceof zh?new zh(this.left.key,this.left.A,new Ah(a.key,a.A,a.left,this.left.left),new Ah(this.key,this.A,this.left.right,this.right)):new Ah(a.key,a.A,a.left,this)};f.pc=function(a,b){return Eh(this,a,b)};f.M=function(a,b){return this.ga(null,b,null)};f.o=function(a,b,c){return this.ga(null,b,c)};
f.Z=function(a,b){if(0===b)return this.key;if(1===b)return this.A;throw Error("Index out of bounds");};f.ga=function(a,b,c){return 0===b?this.key:1===b?this.A:c};f.Bb=function(a,b,c){return(new U(null,2,5,V,[this.key,this.A],null)).Bb(null,b,c)};f.R=function(){return null};f.P=function(){return 2};f.gd=function(){return this.key};f.hd=function(){return this.A};f.Tb=function(){return this.A};f.pb=function(){return new v([this.A,this.key],0,null)};
f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return null};f.ta=function(a,b){return hd(this,b)};f.ua=function(a,b,c){return id(this,b,c)};f.I=function(a,b,c){return P.f(new U(null,2,5,V,[this.key,this.A],null),b,c)};f.N=function(){return new v([this.key,this.A],0,null)};f.S=function(a,b){return Ub(new U(null,2,5,V,[this.key,this.A],null),b)};f.T=function(a,b){return new U(null,3,5,V,[this.key,this.A,b],null)};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.Z(null,c);case 3:return this.ga(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.Z(null,c)};a.f=function(a,c,d){return this.ga(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.Z(null,a)};f.b=function(a,b){return this.ga(null,a,b)};zh.prototype[ib]=function(){return Yc(this)};
var Fh=function Fh(a,b,c,d,e){if(null==b)return new zh(c,d,null,null);var h=function(){var d=b.key;return a.b?a.b(c,d):a.call(null,c,d)}();if(0===h)return e[0]=b,null;if(0>h)return h=function(){var h=b.left;return Fh.V?Fh.V(a,h,c,d,e):Fh.call(null,a,h,c,d,e)}(),null!=h?b.Ad(h):null;h=function(){var h=b.right;return Fh.V?Fh.V(a,h,c,d,e):Fh.call(null,a,h,c,d,e)}();return null!=h?b.Bd(h):null},Gh=function Gh(a,b){if(null==a)return b;if(null==b)return a;if(a instanceof zh){if(b instanceof zh){var d=function(){var d=
a.right,g=b.left;return Gh.b?Gh.b(d,g):Gh.call(null,d,g)}();return d instanceof zh?new zh(d.key,d.A,new zh(a.key,a.A,a.left,d.left),new zh(b.key,b.A,d.right,b.right)):new zh(a.key,a.A,a.left,new zh(b.key,b.A,d,b.right))}return new zh(a.key,a.A,a.left,function(){var d=a.right;return Gh.b?Gh.b(d,b):Gh.call(null,d,b)}())}if(b instanceof zh)return new zh(b.key,b.A,function(){var d=b.left;return Gh.b?Gh.b(a,d):Gh.call(null,a,d)}(),b.right);d=function(){var d=a.right,g=b.left;return Gh.b?Gh.b(d,g):Gh.call(null,
d,g)}();return d instanceof zh?new zh(d.key,d.A,new Ah(a.key,a.A,a.left,d.left),new Ah(b.key,b.A,d.right,b.right)):Ch(a.key,a.A,a.left,new Ah(b.key,b.A,d,b.right))},Hh=function Hh(a,b,c,d){if(null!=b){var g=function(){var d=b.key;return a.b?a.b(c,d):a.call(null,c,d)}();if(0===g)return d[0]=b,Gh(b.left,b.right);if(0>g)return g=function(){var g=b.left;return Hh.B?Hh.B(a,g,c,d):Hh.call(null,a,g,c,d)}(),null!=g||null!=d[0]?b.left instanceof Ah?Ch(b.key,b.A,g,b.right):new zh(b.key,b.A,g,b.right):null;
g=function(){var g=b.right;return Hh.B?Hh.B(a,g,c,d):Hh.call(null,a,g,c,d)}();return null!=g||null!=d[0]?b.right instanceof Ah?Dh(b.key,b.A,b.left,g):new zh(b.key,b.A,b.left,g):null}return null},Ih=function Ih(a,b,c,d){var g=b.key,h=a.b?a.b(c,g):a.call(null,c,g);return 0===h?b.replace(g,d,b.left,b.right):0>h?b.replace(g,b.A,function(){var g=b.left;return Ih.B?Ih.B(a,g,c,d):Ih.call(null,a,g,c,d)}(),b.right):b.replace(g,b.A,b.left,function(){var g=b.right;return Ih.B?Ih.B(a,g,c,d):Ih.call(null,a,g,
c,d)}())};function Jh(a,b,c,d,e){this.qb=a;this.$b=b;this.w=c;this.D=d;this.j=e;this.m=418776847;this.F=8192}f=Jh.prototype;f.Sb=function(a,b){return Kh(this,b)};f.forEach=function(a){for(var b=I(this),c=null,d=0,e=0;;)if(e<d){var g=c.Z(null,e),h=O(g,0);g=O(g,1);a.b?a.b(g,h):a.call(null,g,h);e+=1}else if(b=I(b))Ud(b)?(c=tc(b),b=uc(b),h=c,d=L(c),c=h):(c=x(b),h=O(c,0),g=O(c,1),a.b?a.b(g,h):a.call(null,g,h),b=y(b),c=null,d=0),e=0;else return null};f.get=function(a,b){return this.o(null,a,b)};
f.entries=function(){return new Pg(I(I(this)))};f.toString=function(){return Dc(this)};f.keys=function(){return Yc(Ug(this))};f.values=function(){return Yc(Vg(this))};f.equiv=function(a){return this.C(null,a)};function Kh(a,b){for(var c=a.$b;;)if(null!=c){var d=c.key;d=a.qb.b?a.qb.b(b,d):a.qb.call(null,b,d);if(0===d)return c;c=0>d?c.left:c.right}else return null}f.has=function(a){return Zd(this,a)};f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){a=Kh(this,b);return null!=a?a.A:c};
f.$=function(a,b,c){return null!=this.$b?gd(Eh(this.$b,b,c)):c};f.R=function(){return this.D};f.P=function(){return this.w};f.pb=function(){return 0<this.w?xh(this.$b,!1,this.w):null};f.O=function(){var a=this.j;return null!=a?a:this.j=a=bd(this)};f.C=function(a,b){return Ng(this,b)};f.ia=function(){return new Jh(this.qb,null,0,this.D,0)};
f.ba=function(a,b){a=[null];b=Hh(this.qb,this.$b,b,a);return null==b?null==pd(a,0)?this:new Jh(this.qb,null,0,this.D,null):new Jh(this.qb,b.Rb(),this.w-1,this.D,null)};f.I=function(a,b,c){a=[null];var d=Fh(this.qb,this.$b,b,c,a);return null==d?(a=pd(a,0),J.b(c,a.A)?this:new Jh(this.qb,Ih(this.qb,this.$b,b,c),this.w,this.D,null)):new Jh(this.qb,d.Rb(),this.w+1,this.D,null)};f.N=function(){return 0<this.w?xh(this.$b,!0,this.w):null};
f.S=function(a,b){return b===this.D?this:new Jh(this.qb,this.$b,this.w,b,this.j)};f.T=function(a,b){if(Td(b))return this.I(null,B.b(b,0),B.b(b,1));a=this;for(b=I(b);;){if(null==b)return a;var c=x(b);if(Td(c))a=Fb(a,B.b(c,0),B.b(c,1)),b=y(b);else throw Error("conj on a map takes map entries or seqables of map entries");}};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};f.b=function(a,b){return this.o(null,a,b)};var Lh=new Jh(be,null,0,null,cd);Jh.prototype[ib]=function(){return Yc(this)};
var Ff=function Ff(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Ff.h(0<c.length?new v(c.slice(0),0,null):null)};Ff.h=function(a){a=I(a);for(var b=lc(Yg);;)if(a){var c=y(y(a));b=bf.f(b,x(a),xd(a));a=c}else return nc(b)};Ff.H=0;Ff.K=function(a){return this.h(I(a))};var Mh=function Mh(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Mh.h(0<c.length?new v(c.slice(0),0,null):null)};
Mh.h=function(a){a=a instanceof v&&0===a.J?a.l:ob(a);return Gd(a)};Mh.H=0;Mh.K=function(a){return this.h(I(a))};function Nh(a){for(var b=[],c=arguments.length,d=0;;)if(d<c)b.push(arguments[d]),d+=1;else break;a:for(b=I(0<b.length?new v(b.slice(0),0,null):null),d=Lh;;)if(b)c=y(y(b)),d=P.f(d,x(b),xd(b)),b=c;else break a;return d}function Oh(a,b){this.ha=a;this.Ib=b;this.m=32374988;this.F=0}f=Oh.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.Ib};f.na=function(){var a=(null!=this.ha?this.ha.m&128||n===this.ha.Cc||(this.ha.m?0:eb(Bb,this.ha)):eb(Bb,this.ha))?this.ha.na(null):y(this.ha);return null==a?null:new Oh(a,null)};f.O=function(){return $c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return this.ha.xa(null).key};f.Ea=function(){var a=(null!=this.ha?this.ha.m&128||n===this.ha.Cc||(this.ha.m?0:eb(Bb,this.ha)):eb(Bb,this.ha))?this.ha.na(null):y(this.ha);return null!=a?new Oh(a,null):Wc};f.N=function(){return this};f.S=function(a,b){return b===this.Ib?this:new Oh(this.ha,b)};f.T=function(a,b){return ud(b,this)};
Oh.prototype[ib]=function(){return Yc(this)};function Ug(a){return(a=I(a))?new Oh(a,null):null}function Ph(a,b){this.ha=a;this.Ib=b;this.m=32374988;this.F=0}f=Ph.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};
f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();f.R=function(){return this.Ib};f.na=function(){var a=(null!=this.ha?this.ha.m&128||n===this.ha.Cc||(this.ha.m?0:eb(Bb,this.ha)):eb(Bb,this.ha))?this.ha.na(null):y(this.ha);return null==a?null:new Ph(a,null)};f.O=function(){return $c(this)};
f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return vd(b,this)};f.ua=function(a,b,c){return wd(b,c,this)};f.xa=function(){return this.ha.xa(null).A};f.Ea=function(){var a=(null!=this.ha?this.ha.m&128||n===this.ha.Cc||(this.ha.m?0:eb(Bb,this.ha)):eb(Bb,this.ha))?this.ha.na(null):y(this.ha);return null!=a?new Ph(a,null):Wc};f.N=function(){return this};f.S=function(a,b){return b===this.Ib?this:new Ph(this.ha,b)};f.T=function(a,b){return ud(b,this)};
Ph.prototype[ib]=function(){return Yc(this)};function Vg(a){return(a=I(a))?new Ph(a,null):null}var Qh=function Qh(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Qh.h(0<c.length?new v(c.slice(0),0,null):null)};Qh.h=function(a){return r(uf(ke,a))?ie(function(a,c){return Bd.b(r(a)?a:pf,c)},a):null};Qh.H=0;Qh.K=function(a){return this.h(I(a))};
function Rh(a,b){var c=pf;for(b=I(b);;)if(b){var d=x(b),e=F.f(a,d,Sh);c=lf.b(e,Sh)?P.f(c,d,e):c;b=y(b)}else return Ub(c,Ld(a))}function Th(a){this.rd=a}Th.prototype.va=function(){return this.rd.va()};Th.prototype.next=function(){if(this.rd.va())return this.rd.next().key;throw Error("No such element");};Th.prototype.remove=function(){return Error("Unsupported operation")};function Uh(a,b,c){this.D=a;this.Wb=b;this.j=c;this.m=15077647;this.F=139268}f=Uh.prototype;f.toString=function(){return Dc(this)};
f.equiv=function(a){return this.C(null,a)};f.keys=function(){return Yc(I(this))};f.entries=function(){return new Qg(I(I(this)))};f.values=function(){return Yc(I(this))};f.has=function(a){return Zd(this,a)};f.forEach=function(a){for(var b=I(this),c=null,d=0,e=0;;)if(e<d){var g=c.Z(null,e),h=O(g,0);g=O(g,1);a.b?a.b(g,h):a.call(null,g,h);e+=1}else if(b=I(b))Ud(b)?(c=tc(b),b=uc(b),h=c,d=L(c),c=h):(c=x(b),h=O(c,0),g=O(c,1),a.b?a.b(g,h):a.call(null,g,h),b=y(b),c=null,d=0),e=0;else return null};
f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){a=Gb(this.Wb,b);return r(a)?Jb(a):c};f.W=function(){return new Th(Bc(this.Wb))};f.R=function(){return this.D};f.P=function(){return sb(this.Wb)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=bd(this)};f.C=function(a,b){if(a=Pd(b)){var c=L(this)===L(b);if(c)try{return je(function(){return function(a,c){return(a=Zd(b,c))?a:new ed(!1)}}(c,a,this),!0,this.Wb)}catch(d){if(d instanceof Error)return!1;throw d;}else return c}else return a};
f.ec=function(){return new Vh(lc(this.Wb))};f.ia=function(){return Ub(Wh,this.D)};f.jd=function(a,b){return new Uh(this.D,Ib(this.Wb,b),null)};f.N=function(){return Ug(this.Wb)};f.S=function(a,b){return b===this.D?this:new Uh(b,this.Wb,this.j)};f.T=function(a,b){return new Uh(this.D,P.f(this.Wb,b,null),null)};
f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};f.b=function(a,b){return this.o(null,a,b)};var Wh=new Uh(null,pf,cd);
function ae(a){for(var b=a.length,c=lc(Wh),d=0;;)if(d<b)mc(c,a[d]),d+=1;else break;return nc(c)}Uh.prototype[ib]=function(){return Yc(this)};function Vh(a){this.Zb=a;this.F=136;this.m=259}f=Vh.prototype;f.fc=function(a,b){this.Zb=bf.f(this.Zb,b,null);return this};f.lc=function(){return new Uh(null,nc(this.Zb),null)};f.P=function(){return L(this.Zb)};f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return Eb.f(this.Zb,b,Wd)===Wd?c:b};
f.call=function(){function a(a,b,c){return Eb.f(this.Zb,b,Wd)===Wd?c:b}function b(a,b){return Eb.f(this.Zb,b,Wd)===Wd?null:b}var c=null;c=function(c,e,g){switch(arguments.length){case 2:return b.call(this,c,e);case 3:return a.call(this,c,e,g)}throw Error("Invalid arity: "+(arguments.length-1));};c.b=b;c.f=a;return c}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return Eb.f(this.Zb,a,Wd)===Wd?null:a};f.b=function(a,b){return Eb.f(this.Zb,a,Wd)===Wd?b:a};
function Xh(a){if(Pd(a))return Kd(a,null);a=I(a);if(null==a)return Wh;if(a instanceof v&&0===a.J)return ae(a.l);for(var b=lc(Wh);;)if(null!=a){var c=y(a);b=mc(b,zb(a));a=c}else return nc(b)}function Yh(a){return function e(a,d){return new Ne(null,function(){var c;a:{var h=a;for(c=d;;){var k=h;h=O(k,0);if(k=I(k))if(Zd(c,h))h=Vc(k);else{c=ud(h,e(Vc(k),Bd.b(c,h)));break a}else{c=null;break a}}}return c},null,null)}(a,Wh)}function Zh(a){for(var b=Cd;;)if(y(a))b=Bd.b(b,x(a)),a=y(a);else return I(b)}
function Me(a){if(null!=a&&(a.F&4096||n===a.de))return vc(a);if("string"===typeof a)return a;throw Error(["Doesn't support name: ",t.c(a)].join(""));}function $h(a,b){var c=lc(pf);a=I(a);for(b=I(b);;)if(a&&b)c=bf.f(c,x(a),x(b)),a=y(a),b=y(b);else return nc(c)}
var ai=function ai(a){switch(arguments.length){case 2:return ai.b(arguments[0],arguments[1]);case 3:return ai.f(arguments[0],arguments[1],arguments[2]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return ai.h(arguments[0],arguments[1],arguments[2],new v(c.slice(3),0,null))}};ai.b=function(a,b){return b};ai.f=function(a,b,c){return(a.c?a.c(b):a.call(null,b))>(a.c?a.c(c):a.call(null,c))?b:c};
ai.h=function(a,b,c,d){return A(function(b,c){return ai.f(a,b,c)},ai.f(a,b,c),d)};ai.K=function(a){var b=x(a),c=y(a);a=x(c);var d=y(c);c=x(d);d=y(d);return this.h(b,a,c,d)};ai.H=3;function bi(a,b){return new Ne(null,function(){var c=I(b);if(c){var d=x(c);d=a.c?a.c(d):a.call(null,d);c=r(d)?ud(x(c),bi(a,Vc(c))):null}else c=null;return c},null,null)}function ci(a,b,c){this.start=a;this.step=b;this.count=c;this.m=82;this.F=0}f=ci.prototype;f.P=function(){return this.count};f.xa=function(){return this.start};
f.Z=function(a,b){return this.start+b*this.step};f.ga=function(a,b,c){return 0<=b&&b<this.count?this.start+b*this.step:c};f.zc=function(){if(1>=this.count)throw Error("-drop-first of empty chunk");return new ci(this.start+this.step,this.step,this.count-1)};function di(a,b,c){this.J=a;this.end=b;this.step=c}di.prototype.va=function(){return 0<this.step?this.J<this.end:this.J>this.end};di.prototype.next=function(){var a=this.J;this.J+=this.step;return a};
function ei(a,b,c,d,e,g,h){this.D=a;this.start=b;this.end=c;this.step=d;this.aa=e;this.Pc=g;this.j=h;this.m=32375006;this.F=140800}f=ei.prototype;f.toString=function(){return Dc(this)};f.equiv=function(a){return this.C(null,a)};f.indexOf=function(){var a=null;a=function(a,c){switch(arguments.length){case 1:return od(this,a,0);case 2:return od(this,a,c)}throw Error("Invalid arity: "+arguments.length);};a.c=function(a){return od(this,a,0)};a.b=function(a,c){return od(this,a,c)};return a}();
f.lastIndexOf=function(){function a(a){return qd(this,a,L(this))}var b=null;b=function(b,d){switch(arguments.length){case 1:return a.call(this,b);case 2:return qd(this,b,d)}throw Error("Invalid arity: "+arguments.length);};b.c=a;b.b=function(a,b){return qd(this,a,b)};return b}();function fi(a){if(null==a.aa){var b=a.P(null);32<b?(a.Pc=new ei(null,a.start+32*a.step,a.end,a.step,null,null,null),a.aa=new ci(a.start,a.step,32)):a.aa=new ci(a.start,a.step,b)}}
f.Z=function(a,b){if(0<=b&&b<this.P(null))return this.start+b*this.step;if(0<=b&&this.start>this.end&&0===this.step)return this.start;throw Error("Index out of bounds");};f.ga=function(a,b,c){return 0<=b&&b<this.P(null)?this.start+b*this.step:0<=b&&this.start>this.end&&0===this.step?this.start:c};f.W=function(){return new di(this.start,this.end,this.step)};f.R=function(){return this.D};
f.na=function(){return 0<this.step?this.start+this.step<this.end?new ei(null,this.start+this.step,this.end,this.step,null,null,null):null:this.start+this.step>this.end?new ei(null,this.start+this.step,this.end,this.step,null,null,null):null};f.P=function(){return Math.ceil((this.end-this.start)/this.step)};f.O=function(){var a=this.j;return null!=a?a:this.j=a=$c(this)};f.C=function(a,b){return td(this,b)};f.ia=function(){return Wc};f.ta=function(a,b){return hd(this,b)};
f.ua=function(a,b,c){for(a=this.start;;)if(0<this.step?a<this.end:a>this.end){c=b.b?b.b(c,a):b.call(null,c,a);if(fd(c))return Rb(c);a+=this.step}else return c};f.xa=function(){return this.start};f.Ea=function(){var a=this.na(null);return null==a?Wc:a};f.N=function(){return this};f.Bc=function(){fi(this);return this.aa};f.kc=function(){fi(this);return null==this.Pc?Wc:this.Pc};f.S=function(a,b){return b===this.D?this:new ei(b,this.start,this.end,this.step,this.aa,this.Pc,this.j)};
f.T=function(a,b){return ud(b,this)};f.Ac=function(){return I(this.kc(null))};ei.prototype[ib]=function(){return Yc(this)};var gi=function gi(a){switch(arguments.length){case 0:return gi.G();case 1:return gi.c(arguments[0]);case 2:return gi.b(arguments[0],arguments[1]);case 3:return gi.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};gi.G=function(){return gi.f(0,Number.MAX_VALUE,1)};gi.c=function(a){return gi.f(0,a,1)};
gi.b=function(a,b){return gi.f(a,b,1)};gi.f=function(a,b,c){return 0<c?b<=a?Wc:new ei(null,a,b,c,null,null,null):0>c?b>=a?Wc:new ei(null,a,b,c,null,null,null):b===a?Wc:new Sf(null,-1,a,null)};gi.H=3;function hi(a,b){return new Ne(null,function(){var c=I(b);return c?ud(x(c),hi(a,Qf(a,c))):null},null,null)}function ii(a,b){return new U(null,2,5,V,[bi(a,b),Rf(a,b)],null)}
function ji(a,b){return new Ne(null,function(){var c=I(b);if(c){var d=x(c),e=a.c?a.c(d):a.call(null,d),g=ud(d,bi(function(b,c){return function(b){return J.b(c,a.c?a.c(b):a.call(null,b))}}(d,e,c,c),y(c)));return ud(g,ji(a,new Ne(null,function(a,b,c,d){return function(){return Qf(L(c),d)}}(d,e,g,c,c),null,null)))}return null},null,null)}function ki(a){return nc(A(function(a,c){return bf.f(a,c,F.f(a,c,0)+1)},lc(pf),a))}
function li(){var a=Me;return function(){function b(b,c,d){return new U(null,2,5,V,[Ke.f?Ke.f(b,c,d):Ke.call(null,b,c,d),a.f?a.f(b,c,d):a.call(null,b,c,d)],null)}function c(b,c){return new U(null,2,5,V,[Ke.b?Ke.b(b,c):Ke.call(null,b,c),a.b?a.b(b,c):a.call(null,b,c)],null)}function d(b){return new U(null,2,5,V,[Ke.c?Ke.c(b):Ke.call(null,b),a.c?a.c(b):a.call(null,b)],null)}function e(){return new U(null,2,5,V,[Ke.G?Ke.G():Ke.call(null),a.G?a.G():a.call(null)],null)}var g=null,h=function(){function b(a,
b,d,e){var g=null;if(3<arguments.length){g=0;for(var h=Array(arguments.length-3);g<h.length;)h[g]=arguments[g+3],++g;g=new v(h,0,null)}return c.call(this,a,b,d,g)}function c(b,c,d,e){return new U(null,2,5,V,[kf(Ke,b,c,d,e),kf(a,b,c,d,e)],null)}b.H=3;b.K=function(a){var b=x(a);a=y(a);var d=x(a);a=y(a);var e=x(a);a=Vc(a);return c(b,d,e,a)};b.h=c;return b}();g=function(a,g,m,p){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,g);case 3:return b.call(this,
a,g,m);default:var k=null;if(3<arguments.length){k=0;for(var l=Array(arguments.length-3);k<l.length;)l[k]=arguments[k+3],++k;k=new v(l,0,null)}return h.h(a,g,m,k)}throw Error("Invalid arity: "+arguments.length);};g.H=3;g.K=h.K;g.G=e;g.c=d;g.b=c;g.f=b;g.h=h.h;return g}()}function mi(a){a:for(var b=a;;)if(b=I(b))b=y(b);else break a;return a}
function ni(a,b){if("string"===typeof b)return a=a.exec(b),J.b(x(a),b)?1===L(a)?x(a):yg(a):null;throw new TypeError("re-matches must match against a string.");}function oi(a,b){if("string"===typeof b)return a=a.exec(b),null==a?null:1===L(a)?x(a):yg(a);throw new TypeError("re-find must match against a string.");}
var pi=function pi(a,b){var d=a.exec(b);if(null==d)return null;var e=d[0],g=1===d.length?e:yg(d);return ud(g,new Ne(null,function(d,e,g){return function(){var e=d.length;e=g.index+(1>e?1:e);return e<=b.length?(e=De.b(b,e),pi.b?pi.b(a,e):pi.call(null,a,e)):null}}(e,g,d,d),null,null))};
function X(a,b,c,d,e,g,h){var k=Qa;Qa=null==Qa?null:Qa-1;try{if(null!=Qa&&0>Qa)return ic(a,"#");ic(a,c);if(0===Ya.c(g))I(h)&&ic(a,function(){var a=qi.c(g);return r(a)?a:"..."}());else{if(I(h)){var l=x(h);b.f?b.f(l,a,g):b.call(null,l,a,g)}for(var m=y(h),p=Ya.c(g)-1;;)if(!m||null!=p&&0===p){I(m)&&0===p&&(ic(a,d),ic(a,function(){var a=qi.c(g);return r(a)?a:"..."}()));break}else{ic(a,d);var u=x(m);c=a;h=g;b.f?b.f(u,c,h):b.call(null,u,c,h);var w=y(m);c=p-1;m=w;p=c}}return ic(a,e)}finally{Qa=k}}
function ri(a,b){b=I(b);for(var c=null,d=0,e=0;;)if(e<d){var g=c.Z(null,e);ic(a,g);e+=1}else if(b=I(b))c=b,Ud(c)?(b=tc(c),d=uc(c),c=b,g=L(b),b=d,d=g):(g=x(c),ic(a,g),b=y(c),c=null,d=0),e=0;else return null}var si={'"':'\\"',"\\":"\\\\","\b":"\\b","\f":"\\f","\n":"\\n","\r":"\\r","\t":"\\t"};function ti(a){return['"',t.c(a.replace(/[\\"\b\f\n\r\t]/g,function(a){return si[a]})),'"'].join("")}function ui(a,b){return(a=Yd(F.b(a,Wa)))?(a=null!=b?b.m&131072||n===b.Kd?!0:!1:!1)?null!=Ld(b):a:a}
function vi(a,b,c){if(null==a)return ic(b,"nil");ui(c,a)&&(ic(b,"^"),wi(Ld(a),b,c),ic(b," "));if(a.Nd)return a.le(b);if(null!=a?a.m&2147483648||n===a.ka||(a.m?0:eb(jc,a)):eb(jc,a))return kc(a,b,c);if(!0===a||!1===a)return ic(b,t.c(a));if("number"===typeof a)return ic(b,isNaN(a)?"##NaN":a===Number.POSITIVE_INFINITY?"##Inf":a===Number.NEGATIVE_INFINITY?"##-Inf":t.c(a));if(null!=a&&a.constructor===Object)return ic(b,"#js "),xi(Nf.b(function(b){return new W(null!=ni(/[A-Za-z_\*\+\?!\-'][\w\*\+\?!\-']*/,
b)?Le.c(b):b,a[b])},na(a)),b,c);if(ab(a))return X(b,wi,"#js ["," ","]",c,a);if("string"==typeof a)return r(Va.c(c))?ic(b,ti(a)):ic(b,a);if("function"==ba(a)){var d=a.name;c=r(function(){var a=null==d;return a?a:/^[\s\xa0]*$/.test(d)}())?"Function":d;return ri(b,M(["#object[",c,"","]"]))}if(a instanceof Date)return c=function(a,b){for(a=t.c(a);;)if(L(a)<b)a=["0",a].join("");else return a},ri(b,M(['#inst "',t.c(a.getUTCFullYear()),"-",c(a.getUTCMonth()+1,2),"-",c(a.getUTCDate(),2),"T",c(a.getUTCHours(),
2),":",c(a.getUTCMinutes(),2),":",c(a.getUTCSeconds(),2),".",c(a.getUTCMilliseconds(),3),"-",'00:00"']));if(a instanceof RegExp)return ri(b,M(['#"',a.source,'"']));if(r(function(){var b=null==a?null:a.constructor;return null==b?null:b.Vc}()))return ri(b,M(["#object[",a.constructor.Vc.replace(/\//g,"."),"]"]));d=function(){var b=null==a?null:a.constructor;return null==b?null:b.name}();c=r(function(){var a=null==d;return a?a:/^[\s\xa0]*$/.test(d)}())?"Object":d;return null==a.constructor?ri(b,M(["#object[",
c,"]"])):ri(b,M(["#object[",c," ",t.c(a),"]"]))}function wi(a,b,c){var d=yi.c(c);return r(d)?(c=P.f(c,zi,vi),d.f?d.f(a,b,c):d.call(null,a,b,c)):vi(a,b,c)}function Ai(a,b){var c=new Ia;a:{var d=new Cc(c);wi(x(a),d,b);a=I(y(a));for(var e=null,g=0,h=0;;)if(h<g){var k=e.Z(null,h);ic(d," ");wi(k,d,b);h+=1}else if(a=I(a))e=a,Ud(e)?(a=tc(e),g=uc(e),e=a,k=L(a),a=g,g=k):(k=x(e),ic(d," "),wi(k,d,b),a=y(e),e=null,g=0),h=0;else break a}return c}function Bi(a,b){return Nd(a)?"":t.c(Ai(a,b))}
function Ci(a,b){if(Nd(a))return"\n";a=Ai(a,b);a.append("\n");return t.c(a)}var Di=function Di(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Di.h(0<c.length?new v(c.slice(0),0,null):null)};Di.h=function(a){return Bi(a,Sa())};Di.H=0;Di.K=function(a){return this.h(I(a))};var Ei=function Ei(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Ei.h(0<c.length?new v(c.slice(0),0,null):null)};
Ei.h=function(a){return Ci(a,Sa())};Ei.H=0;Ei.K=function(a){return this.h(I(a))};var Fi=function Fi(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Fi.h(0<c.length?new v(c.slice(0),0,null):null)};Fi.h=function(a){return Bi(a,P.f(Sa(),Va,!1))};Fi.H=0;Fi.K=function(a){return this.h(I(a))};var Gi=function Gi(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Gi.h(0<c.length?new v(c.slice(0),0,null):null)};
Gi.h=function(a){return Ci(a,P.f(Sa(),Va,!1))};Gi.H=0;Gi.K=function(a){return this.h(I(a))};function Hi(a,b,c,d,e){return X(d,function(a,b,d){var e=Jb(a);c.f?c.f(e,b,d):c.call(null,e,b,d);ic(b," ");a=Kb(a);return c.f?c.f(a,b,d):c.call(null,a,b,d)},[t.c(a),"{"].join(""),", ","}",e,I(b))}function xi(a,b,c){var d=wi,e=(Rd(a),null),g=O(e,0);e=O(e,1);return r(g)?Hi(["#:",t.c(g)].join(""),e,d,b,c):Hi(null,a,d,b,c)}Jf.prototype.ka=n;
Jf.prototype.L=function(a,b,c){ic(b,"#object[cljs.core.Volatile ");wi(new q(null,1,[Ii,this.state],null),b,c);return ic(b,"]")};v.prototype.ka=n;v.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Ne.prototype.ka=n;Ne.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};W.prototype.ka=n;W.prototype.L=function(a,b,c){return X(b,wi,"["," ","]",c,this)};wh.prototype.ka=n;wh.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};oh.prototype.ka=n;
oh.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Ah.prototype.ka=n;Ah.prototype.L=function(a,b,c){return X(b,wi,"["," ","]",c,this)};Sg.prototype.ka=n;Sg.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};wg.prototype.ka=n;wg.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Ie.prototype.ka=n;Ie.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};sd.prototype.ka=n;sd.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};
rh.prototype.ka=n;rh.prototype.L=function(a,b,c){return xi(this,b,c)};ph.prototype.ka=n;ph.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Bg.prototype.ka=n;Bg.prototype.L=function(a,b,c){return X(b,wi,"["," ","]",c,this)};Jh.prototype.ka=n;Jh.prototype.L=function(a,b,c){return xi(this,b,c)};Uh.prototype.ka=n;Uh.prototype.L=function(a,b,c){return X(b,wi,"#{"," ","}",c,this)};Se.prototype.ka=n;Se.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Bf.prototype.ka=n;
Bf.prototype.L=function(a,b,c){ic(b,"#object[cljs.core.Atom ");wi(new q(null,1,[Ii,this.state],null),b,c);return ic(b,"]")};Ph.prototype.ka=n;Ph.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};zh.prototype.ka=n;zh.prototype.L=function(a,b,c){return X(b,wi,"["," ","]",c,this)};Sf.prototype.ka=n;Sf.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};U.prototype.ka=n;U.prototype.L=function(a,b,c){return X(b,wi,"["," ","]",c,this)};Ig.prototype.ka=n;
Ig.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Fe.prototype.ka=n;Fe.prototype.L=function(a,b){return ic(b,"()")};Jg.prototype.ka=n;Jg.prototype.L=function(a,b,c){return X(b,wi,"#queue ["," ","]",c,I(this))};q.prototype.ka=n;q.prototype.L=function(a,b,c){return xi(this,b,c)};ei.prototype.ka=n;ei.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Oh.prototype.ka=n;Oh.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};Dd.prototype.ka=n;
Dd.prototype.L=function(a,b,c){return X(b,wi,"("," ",")",c,this)};E.prototype.dc=n;E.prototype.Jb=function(a,b){if(b instanceof E)return Rc(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};H.prototype.dc=n;H.prototype.Jb=function(a,b){if(b instanceof H)return Je(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};Bg.prototype.dc=n;
Bg.prototype.Jb=function(a,b){if(Td(b))return ce(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};U.prototype.dc=n;U.prototype.Jb=function(a,b){if(Td(b))return ce(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};W.prototype.dc=n;W.prototype.Jb=function(a,b){if(Td(b))return ce(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};Ah.prototype.dc=n;
Ah.prototype.Jb=function(a,b){if(Td(b))return ce(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};zh.prototype.dc=n;zh.prototype.Jb=function(a,b){if(Td(b))return ce(this,b);throw Error(["Cannot compare ",t.c(this)," to ",t.c(b)].join(""));};function Ji(a){return function(b,c){b=a.b?a.b(b,c):a.call(null,b,c);return fd(b)?new ed(b):b}}
function Ki(a){return function(b){return function(){function c(a,c){return A(b,a,c)}function d(b){return a.c?a.c(b):a.call(null,b)}function e(){return a.G?a.G():a.call(null)}var g=null;g=function(a,b){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};g.G=e;g.c=d;g.b=c;return g}()}(Ji(a))}function Li(){}
var Mi=function Mi(a){if(null!=a&&null!=a.be)return a.be(a);var c=Mi[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Mi._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IEncodeJS.-clj-\x3ejs",a);},Ni=function Ni(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Ni.h(arguments[0],1<c.length?new v(c.slice(1),0,null):null)};
Ni.h=function(a,b){var c=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b,d=F.f(c,Oi,Me),e=function(){return function(a){var b=g;return(null!=a?n===a.ae||(a.gc?0:eb(Li,a)):eb(Li,a))?Mi(a):"string"===typeof a||"number"===typeof a||a instanceof H||a instanceof E?b.c?b.c(a):b.call(null,a):Di.h(M([a]))}}(b,c,c,d),g=function(a,b,c,d){return function w(a){if(null==a)return null;if(null!=a?n===a.ae||(a.gc?0:eb(Li,a)):eb(Li,a))return Mi(a);if(a instanceof H)return d.c?d.c(a):d.call(null,a);if(a instanceof E)return t.c(a);
if(Rd(a)){var b={};a=I(a);for(var c=null,g=0,h=0;;)if(h<g){var k=c.Z(null,h),l=O(k,0),m=O(k,1);k=b;l=e(l);m=w(m);k[l]=m;h+=1}else if(a=I(a))Ud(a)?(g=tc(a),a=uc(a),c=g,g=L(g)):(c=x(a),g=O(c,0),h=O(c,1),c=b,g=e(g),h=w(h),c[g]=h,a=y(a),c=null,g=0),h=0;else break;return b}if(Od(a)){b=[];a=I(Nf.b(w,a));c=null;for(h=g=0;;)if(h<g)k=c.Z(null,h),b.push(k),h+=1;else if(a=I(a))c=a,Ud(c)?(a=tc(c),h=uc(c),c=a,g=L(a),a=h):(a=x(c),b.push(a),a=y(c),c=null,g=0),h=0;else break;return b}return a}}(b,c,c,d);return g(a)};
Ni.H=1;Ni.K=function(a){var b=x(a);a=y(a);return this.h(b,a)};function Pi(){}var Qi=function Qi(a,b){if(null!=a&&null!=a.$d)return a.$d(a,b);var d=Qi[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Qi._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IEncodeClojure.-js-\x3eclj",a);};
function Ri(a){var b=M([Si,!1]),c=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b,d=F.b(c,Si);return function(a,c,d,k){return function p(e){return(null!=e?n===e.ze||(e.gc?0:eb(Pi,e)):eb(Pi,e))?Qi(e,jf(Mh,b)):Xd(e)?mi(Nf.b(p,e)):zg(e)?new W(p(Jb(e)),p(Kb(e))):Od(e)?$f.f(Ed(e),Nf.c(p),e):ab(e)?nc(A(function(){return function(a,b){return af.b(a,p(b))}}(a,c,d,k),lc(Cd),e)):fb(e)===Object?nc(A(function(a,b,c,d){return function(a,b){return bf.f(a,d.c?d.c(b):d.call(null,b),p(null!==e&&b in e?e[b]:void 0))}}(a,c,
d,k),lc(pf),na(e))):e}}(b,c,d,r(d)?Le:t)(a)}var Ti=function Ti(a){switch(arguments.length){case 0:return Ti.G();case 1:return Ti.c(arguments[0]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};Ti.G=function(){return Ti.c(1)};Ti.c=function(a){return Math.random()*a};Ti.H=1;function Ui(a){return Math.floor(Math.random()*a)}function Vi(a,b){return nc(A(function(b,d){var c=a.c?a.c(d):a.call(null,d);return bf.f(b,c,Bd.b(F.f(b,c,Cd),d))},lc(pf),b))}var Xi=null;
function Yi(){null==Xi&&(Xi=Cf(new q(null,3,[Zi,pf,$i,pf,aj,pf],null)));return Xi}function bj(a,b,c){var d=J.b(b,c);if(d)return d;d=aj.c(a);d=d.c?d.c(b):d.call(null,b);if(!(d=Zd(d,c))&&(d=Td(c)))if(d=Td(b))if(d=L(c)===L(b)){d=!0;for(var e=0;;)if(d&&e!==L(c))d=bj(a,b.c?b.c(e):b.call(null,e),c.c?c.c(e):c.call(null,e)),e+=1;else return d}else return d;else return d;else return d}function cj(a){var b=Rb(Yi());return mf(F.b(Zi.c(b),a))}
function dj(a,b,c,d){If.b(a,function(){return Rb(b)});If.b(c,function(){return Rb(d)})}
var ej=function ej(a,b,c){var e=function(){var b=Rb(c);return b.c?b.c(a):b.call(null,a)}();e=r(r(e)?e.c?e.c(b):e.call(null,b):e)?!0:null;if(r(e))return e;e=function(){for(var e=cj(b);;)if(0<L(e)){var h=x(e);ej.f?ej.f(a,h,c):ej.call(null,a,h,c);e=Vc(e)}else return null}();if(r(e))return e;e=function(){for(var e=cj(a);;)if(0<L(e)){var h=x(e);ej.f?ej.f(h,b,c):ej.call(null,h,b,c);e=Vc(e)}else return null}();return r(e)?e:!1};function fj(a,b,c,d){c=ej(a,b,c);return r(c)?c:bj(d,a,b)}
var gj=function gj(a,b,c,d,e,g,h,k){var m=A(function(d,g){var h=O(g,0);O(g,1);if(bj(Rb(c),b,h)&&(d=null==d||fj(h,x(d),e,Rb(c))?g:d,!fj(x(d),h,e,Rb(c))))throw Error(["Multiple methods in multimethod '",t.c(a),"' match dispatch value: ",t.c(b)," -\x3e ",t.c(h)," and ",t.c(x(d)),", and neither is preferred"].join(""));return d},null,Rb(d)),p=function(){var a;if(a=null==m)a=Rb(d),a=a.c?a.c(k):a.call(null,k);return r(a)?new U(null,2,5,V,[k,a],null):m}();if(r(p)){if(J.b(Rb(h),Rb(c)))return If.B(g,P,b,xd(p)),
xd(p);dj(g,d,h,c);return gj.Fa?gj.Fa(a,b,c,d,e,g,h,k):gj.call(null,a,b,c,d,e,g,h,k)}return null};function hj(a,b){throw Error(["No method in multimethod '",t.c(a),"' for dispatch value: ",t.c(b)].join(""));}function ij(){var a=Sc.b("cljs.tools.reader.impl.inspect","inspect*"),b=jj,c=kj,d=lj,e=mj,g=nj,h=oj,k=pj;this.name=a;this.u=h;this.pe=k;this.Xc=b;this.$c=c;this.se=d;this.Zc=e;this.Oc=g;this.m=4194305;this.F=4352}f=ij.prototype;
f.call=function(){function a(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y,ma){a=this;var ta=Jd(a.u,b,c,d,e,M([g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y,ma])),ca=qj(this,ta);r(ca)||hj(a.name,ta);return Jd(ca,b,c,d,e,M([g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y,ma]))}function b(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y){a=this;var ta=a.u.Ta?a.u.Ta(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y),ca=qj(this,ta);r(ca)||hj(a.name,ta);return ca.Ta?ca.Ta(b,c,d,e,g,h,k,l,m,p,u,w,z,
D,C,G,N,K,R,Y):ca.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R,Y)}function c(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R){a=this;var ta=a.u.Sa?a.u.Sa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R),ca=qj(this,ta);r(ca)||hj(a.name,ta);return ca.Sa?ca.Sa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R):ca.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,R)}function d(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K){a=this;var ta=a.u.Ra?a.u.Ra(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):
a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K),ca=qj(this,ta);r(ca)||hj(a.name,ta);return ca.Ra?ca.Ra(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):ca.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K)}function e(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N){a=this;var K=a.u.Qa?a.u.Qa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N),ta=qj(this,K);r(ta)||hj(a.name,K);return ta.Qa?ta.Qa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N):ta.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N)}function g(a,
b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G){a=this;var N=a.u.Pa?a.u.Pa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G),K=qj(this,N);r(K)||hj(a.name,N);return K.Pa?K.Pa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):K.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G)}function h(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C){a=this;var G=a.u.Oa?a.u.Oa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C),N=qj(this,G);r(N)||hj(a.name,G);return N.Oa?N.Oa(b,c,d,e,g,h,k,l,m,p,u,w,z,D,C):N.call(null,
b,c,d,e,g,h,k,l,m,p,u,w,z,D,C)}function k(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D){a=this;var C=a.u.Na?a.u.Na(b,c,d,e,g,h,k,l,m,p,u,w,z,D):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D),G=qj(this,C);r(G)||hj(a.name,C);return G.Na?G.Na(b,c,d,e,g,h,k,l,m,p,u,w,z,D):G.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z,D)}function l(a,b,c,d,e,g,h,k,l,m,p,u,w,z){a=this;var D=a.u.Ma?a.u.Ma(b,c,d,e,g,h,k,l,m,p,u,w,z):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z),C=qj(this,D);r(C)||hj(a.name,D);return C.Ma?C.Ma(b,c,d,e,g,h,k,l,m,p,u,w,z):
C.call(null,b,c,d,e,g,h,k,l,m,p,u,w,z)}function m(a,b,c,d,e,g,h,k,l,m,p,u,w){a=this;var z=a.u.La?a.u.La(b,c,d,e,g,h,k,l,m,p,u,w):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u,w),D=qj(this,z);r(D)||hj(a.name,z);return D.La?D.La(b,c,d,e,g,h,k,l,m,p,u,w):D.call(null,b,c,d,e,g,h,k,l,m,p,u,w)}function p(a,b,c,d,e,g,h,k,l,m,p,u){a=this;var w=a.u.Ka?a.u.Ka(b,c,d,e,g,h,k,l,m,p,u):a.u.call(null,b,c,d,e,g,h,k,l,m,p,u),z=qj(this,w);r(z)||hj(a.name,w);return z.Ka?z.Ka(b,c,d,e,g,h,k,l,m,p,u):z.call(null,b,c,d,e,g,h,k,l,
m,p,u)}function u(a,b,c,d,e,g,h,k,l,m,p){a=this;var u=a.u.Ja?a.u.Ja(b,c,d,e,g,h,k,l,m,p):a.u.call(null,b,c,d,e,g,h,k,l,m,p),w=qj(this,u);r(w)||hj(a.name,u);return w.Ja?w.Ja(b,c,d,e,g,h,k,l,m,p):w.call(null,b,c,d,e,g,h,k,l,m,p)}function w(a,b,c,d,e,g,h,k,l,m){a=this;var p=a.u.Ua?a.u.Ua(b,c,d,e,g,h,k,l,m):a.u.call(null,b,c,d,e,g,h,k,l,m),u=qj(this,p);r(u)||hj(a.name,p);return u.Ua?u.Ua(b,c,d,e,g,h,k,l,m):u.call(null,b,c,d,e,g,h,k,l,m)}function z(a,b,c,d,e,g,h,k,l){a=this;var m=a.u.Fa?a.u.Fa(b,c,d,e,
g,h,k,l):a.u.call(null,b,c,d,e,g,h,k,l),p=qj(this,m);r(p)||hj(a.name,m);return p.Fa?p.Fa(b,c,d,e,g,h,k,l):p.call(null,b,c,d,e,g,h,k,l)}function D(a,b,c,d,e,g,h,k){a=this;var l=a.u.Ca?a.u.Ca(b,c,d,e,g,h,k):a.u.call(null,b,c,d,e,g,h,k),m=qj(this,l);r(m)||hj(a.name,l);return m.Ca?m.Ca(b,c,d,e,g,h,k):m.call(null,b,c,d,e,g,h,k)}function C(a,b,c,d,e,g,h){a=this;var k=a.u.la?a.u.la(b,c,d,e,g,h):a.u.call(null,b,c,d,e,g,h),l=qj(this,k);r(l)||hj(a.name,k);return l.la?l.la(b,c,d,e,g,h):l.call(null,b,c,d,e,g,
h)}function G(a,b,c,d,e,g){a=this;var h=a.u.V?a.u.V(b,c,d,e,g):a.u.call(null,b,c,d,e,g),k=qj(this,h);r(k)||hj(a.name,h);return k.V?k.V(b,c,d,e,g):k.call(null,b,c,d,e,g)}function N(a,b,c,d,e){a=this;var g=a.u.B?a.u.B(b,c,d,e):a.u.call(null,b,c,d,e),h=qj(this,g);r(h)||hj(a.name,g);return h.B?h.B(b,c,d,e):h.call(null,b,c,d,e)}function K(a,b,c,d){a=this;var e=a.u.f?a.u.f(b,c,d):a.u.call(null,b,c,d),g=qj(this,e);r(g)||hj(a.name,e);return g.f?g.f(b,c,d):g.call(null,b,c,d)}function Y(a,b,c){a=this;var d=
a.u.b?a.u.b(b,c):a.u.call(null,b,c),e=qj(this,d);r(e)||hj(a.name,d);return e.b?e.b(b,c):e.call(null,b,c)}function ma(a,b){a=this;var c=a.u.c?a.u.c(b):a.u.call(null,b),d=qj(this,c);r(d)||hj(a.name,c);return d.c?d.c(b):d.call(null,b)}function ya(a){a=this;var b=a.u.G?a.u.G():a.u.call(null),c=qj(this,b);r(c)||hj(a.name,b);return c.G?c.G():c.call(null)}var R=null;R=function(R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc,Tc,yd,Ye,Wi,tm){switch(arguments.length){case 1:return ya.call(this,R);case 2:return ma.call(this,
R,ca);case 3:return Y.call(this,R,ca,Ea);case 4:return K.call(this,R,ca,Ea,Da);case 5:return N.call(this,R,ca,Ea,Da,Ba);case 6:return G.call(this,R,ca,Ea,Da,Ba,Za);case 7:return C.call(this,R,ca,Ea,Da,Ba,Za,Ja);case 8:return D.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta);case 9:return z.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb);case 10:return w.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na);case 11:return u.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb);case 12:return p.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb);case 13:return m.call(this,
R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne);case 14:return l.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc);case 15:return k.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc);case 16:return h.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc);case 17:return g.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc);case 18:return e.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc,Tc);case 19:return d.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc,Tc,yd);case 20:return c.call(this,
R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc,Tc,yd,Ye);case 21:return b.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc,Tc,yd,Ye,Wi);case 22:return a.call(this,R,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,pb,Lb,ne,cc,pc,Lc,Mc,Tc,yd,Ye,Wi,tm)}throw Error("Invalid arity: "+(arguments.length-1));};R.c=ya;R.b=ma;R.f=Y;R.B=K;R.V=N;R.la=G;R.Ca=C;R.Fa=D;R.Ua=z;R.Ja=w;R.Ka=u;R.La=p;R.Ma=m;R.Na=l;R.Oa=k;R.Pa=h;R.Qa=g;R.Ra=e;R.Sa=d;R.Ta=c;R.fd=b;R.ce=a;return R}();
f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.G=function(){var a=this.u.G?this.u.G():this.u.call(null),b=qj(this,a);r(b)||hj(this.name,a);return b.G?b.G():b.call(null)};f.c=function(a){var b=this.u.c?this.u.c(a):this.u.call(null,a),c=qj(this,b);r(c)||hj(this.name,b);return c.c?c.c(a):c.call(null,a)};f.b=function(a,b){var c=this.u.b?this.u.b(a,b):this.u.call(null,a,b),d=qj(this,c);r(d)||hj(this.name,c);return d.b?d.b(a,b):d.call(null,a,b)};
f.f=function(a,b,c){var d=this.u.f?this.u.f(a,b,c):this.u.call(null,a,b,c),e=qj(this,d);r(e)||hj(this.name,d);return e.f?e.f(a,b,c):e.call(null,a,b,c)};f.B=function(a,b,c,d){var e=this.u.B?this.u.B(a,b,c,d):this.u.call(null,a,b,c,d),g=qj(this,e);r(g)||hj(this.name,e);return g.B?g.B(a,b,c,d):g.call(null,a,b,c,d)};f.V=function(a,b,c,d,e){var g=this.u.V?this.u.V(a,b,c,d,e):this.u.call(null,a,b,c,d,e),h=qj(this,g);r(h)||hj(this.name,g);return h.V?h.V(a,b,c,d,e):h.call(null,a,b,c,d,e)};
f.la=function(a,b,c,d,e,g){var h=this.u.la?this.u.la(a,b,c,d,e,g):this.u.call(null,a,b,c,d,e,g),k=qj(this,h);r(k)||hj(this.name,h);return k.la?k.la(a,b,c,d,e,g):k.call(null,a,b,c,d,e,g)};f.Ca=function(a,b,c,d,e,g,h){var k=this.u.Ca?this.u.Ca(a,b,c,d,e,g,h):this.u.call(null,a,b,c,d,e,g,h),l=qj(this,k);r(l)||hj(this.name,k);return l.Ca?l.Ca(a,b,c,d,e,g,h):l.call(null,a,b,c,d,e,g,h)};
f.Fa=function(a,b,c,d,e,g,h,k){var l=this.u.Fa?this.u.Fa(a,b,c,d,e,g,h,k):this.u.call(null,a,b,c,d,e,g,h,k),m=qj(this,l);r(m)||hj(this.name,l);return m.Fa?m.Fa(a,b,c,d,e,g,h,k):m.call(null,a,b,c,d,e,g,h,k)};f.Ua=function(a,b,c,d,e,g,h,k,l){var m=this.u.Ua?this.u.Ua(a,b,c,d,e,g,h,k,l):this.u.call(null,a,b,c,d,e,g,h,k,l),p=qj(this,m);r(p)||hj(this.name,m);return p.Ua?p.Ua(a,b,c,d,e,g,h,k,l):p.call(null,a,b,c,d,e,g,h,k,l)};
f.Ja=function(a,b,c,d,e,g,h,k,l,m){var p=this.u.Ja?this.u.Ja(a,b,c,d,e,g,h,k,l,m):this.u.call(null,a,b,c,d,e,g,h,k,l,m),u=qj(this,p);r(u)||hj(this.name,p);return u.Ja?u.Ja(a,b,c,d,e,g,h,k,l,m):u.call(null,a,b,c,d,e,g,h,k,l,m)};f.Ka=function(a,b,c,d,e,g,h,k,l,m,p){var u=this.u.Ka?this.u.Ka(a,b,c,d,e,g,h,k,l,m,p):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p),w=qj(this,u);r(w)||hj(this.name,u);return w.Ka?w.Ka(a,b,c,d,e,g,h,k,l,m,p):w.call(null,a,b,c,d,e,g,h,k,l,m,p)};
f.La=function(a,b,c,d,e,g,h,k,l,m,p,u){var w=this.u.La?this.u.La(a,b,c,d,e,g,h,k,l,m,p,u):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u),z=qj(this,w);r(z)||hj(this.name,w);return z.La?z.La(a,b,c,d,e,g,h,k,l,m,p,u):z.call(null,a,b,c,d,e,g,h,k,l,m,p,u)};f.Ma=function(a,b,c,d,e,g,h,k,l,m,p,u,w){var z=this.u.Ma?this.u.Ma(a,b,c,d,e,g,h,k,l,m,p,u,w):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w),D=qj(this,z);r(D)||hj(this.name,z);return D.Ma?D.Ma(a,b,c,d,e,g,h,k,l,m,p,u,w):D.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w)};
f.Na=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z){var D=this.u.Na?this.u.Na(a,b,c,d,e,g,h,k,l,m,p,u,w,z):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z),C=qj(this,D);r(C)||hj(this.name,D);return C.Na?C.Na(a,b,c,d,e,g,h,k,l,m,p,u,w,z):C.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z)};
f.Oa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D){var C=this.u.Oa?this.u.Oa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D),G=qj(this,C);r(G)||hj(this.name,C);return G.Oa?G.Oa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D):G.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D)};
f.Pa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C){var G=this.u.Pa?this.u.Pa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C),N=qj(this,G);r(N)||hj(this.name,G);return N.Pa?N.Pa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C):N.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C)};
f.Qa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G){var N=this.u.Qa?this.u.Qa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G),K=qj(this,N);r(K)||hj(this.name,N);return K.Qa?K.Qa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G):K.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G)};
f.Ra=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N){var K=this.u.Ra?this.u.Ra(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N),Y=qj(this,K);r(Y)||hj(this.name,K);return Y.Ra?Y.Ra(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N):Y.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N)};
f.Sa=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K){var Y=this.u.Sa?this.u.Sa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K),ma=qj(this,Y);r(ma)||hj(this.name,Y);return ma.Sa?ma.Sa(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K):ma.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K)};
f.Ta=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y){var ma=this.u.Ta?this.u.Ta(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y):this.u.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y),ya=qj(this,ma);r(ya)||hj(this.name,ma);return ya.Ta?ya.Ta(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y):ya.call(null,a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y)};
f.fd=function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma){var ya=Jd(this.u,a,b,c,d,M([e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma])),R=qj(this,ya);r(R)||hj(this.name,ya);return Jd(R,a,b,c,d,M([e,g,h,k,l,m,p,u,w,z,D,C,G,N,K,Y,ma]))};function rj(a,b){var c=sj;If.B(c.$c,P,a,b);dj(c.Zc,c.$c,c.Oc,c.Xc)}function qj(a,b){J.b(Rb(a.Oc),Rb(a.Xc))||dj(a.Zc,a.$c,a.Oc,a.Xc);var c=Rb(a.Zc);c=c.c?c.c(b):c.call(null,b);return r(c)?c:gj(a.name,b,a.Xc,a.$c,a.se,a.Zc,a.Oc,a.pe)}f.Rc=function(){return vc(this.name)};f.Sc=function(){return wc(this.name)};
f.O=function(){return this[da]||(this[da]=++ea)};function tj(a){this.qc=a;this.j=null;this.m=2153775104;this.F=2048}f=tj.prototype;f.toString=function(){return this.qc};f.equiv=function(a){return this.C(null,a)};f.C=function(a,b){return b instanceof tj&&this.qc===b.qc};f.L=function(a,b){return ic(b,['#uuid "',t.c(this.qc),'"'].join(""))};f.O=function(){null==this.j&&(this.j=Oc(this.qc));return this.j};f.Jb=function(a,b){return ka(this.qc,b.qc)};
function uj(a,b,c){var d=Error(a);this.message=a;this.data=b;this.Fd=c;this.name=d.name;this.description=d.description;this.fileName=d.fileName;this.lineNumber=d.lineNumber;this.columnNumber=d.columnNumber;this.stack=d.stack;return this}uj.prototype.__proto__=Error.prototype;uj.prototype.ka=n;uj.prototype.L=function(a,b,c){ic(b,"#error {:message ");wi(this.message,b,c);r(this.data)&&(ic(b,", :data "),wi(this.data,b,c));r(this.Fd)&&(ic(b,", :cause "),wi(this.Fd,b,c));return ic(b,"}")};
uj.prototype.toString=function(){return Dc(this)};function vj(a,b){return new uj(a,b,null)}if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof wj)var wj=null;"undefined"!==typeof console&&(Oa=function(){return console.log.apply(console,ia(arguments))},Pa=function(){return console.error.apply(console,ia(arguments))});if("undefined"===typeof Ka||"undefined"===typeof La||"undefined"===typeof xj)var xj=function(){throw Error("cljs.core/*eval* not bound");};var yj=new H("transact","unique","transact/unique",-940992320),zj=new H(null,"used-args","used-args",23596256),Aj=new H(null,"args","args",1315556576),Bj=new H("parser","in","parser/in",1617442048),Cj=new E(null,"uuid","uuid",-504564192,null),Dj=new E(null,"contains?","contains?",-1676812576,null),Ej=new H(null,"find","find",496279456),Fj=new H(null,"ex-kind","ex-kind",1581199296),Gj=new E(null,"subs","subs",1453849536,null),Hj=new E(null,"set","set",1945134081,null),Ij=new H(null,"tempids","tempids",
1767509089),Jj=new H(null,"schema","schema",-1582001791),Kj=new E(null,"get-else","get-else",1312024065,null),Lj=new H(null,"reader-error","reader-error",1610253121),Mj=new E(null,"println-str","println-str",-2049216703,null),Nj=new H(null,"tuples","tuples",-676032639),Oj=new H("parser","find","parser/find",-801023103),Pj=new H(null,"attribute","attribute",-2074029119),Qj=new E(null,"aggregate","aggregate",-1142967327,null),Rj=new H("transact","cas","transact/cas",816687170),Sj=new E("clojure.string",
"starts-with?","clojure.string/starts-with?",656256322,null),Tj=new H("lookup-ref","unique","lookup-ref/unique",-960647710),Uj=new H(null,"expand-kvps","expand-kvps",44141154),Vj=new H("db.unique","identity","db.unique/identity",1675950722),Wj=new H("db","fn","db/fn",-1175261470),Xj=new E(null,"pull","pull",779986722,null),Yj=new H(null,"*","*",-1294732318),Zj=new E(null,"namespace","namespace",1263021155,null),ak=new H("db","index","db/index",-1531680669),bk=new H("datascript.pull-api","expand-rev",
"datascript.pull-api/expand-rev",2143627459),ck=new E(null,"\x3d","\x3d",-1501502141,null),dk=new H(null,"max-tx","max-tx",1119558339),ek=new E(null,"rand-int","rand-int",-495012157,null),fk=new E(null,"dec","dec",-766002333,null),gk=new H(null,"multi?","multi?",-749311069),hk=new H(null,"where","where",-2044795965),ik=new H(null,"v","v",21465059),jk=new H(null,"fn","fn",-1175266204),kk=new E(null,"\x3c","\x3c",993667236,null),lk=new H("db","unique","db/unique",329396388),mk=new H(null,"wildcard",
"wildcard",-622473020),nk=new H(null,"hash","hash",-13781596),ok=new H(null,"namespaced-map","namespaced-map",1235665380),pk=new E("clojure.string","blank?","clojure.string/blank?",1772874244,null),qk=new H(null,"done","done",-889844188),Wa=new H(null,"meta","meta",1499536964),rk=new H(null,"variable","variable",-281346492),sk=new E(null,"re-seq","re-seq",-2105554076,null),tk=new E(null,"some?","some?",234752293,null),Xa=new H(null,"dup","dup",556298533),uk=new H(null,"aevt","aevt",-585148059),vk=
new H(null,"pred","pred",1927423397),wk=new H(null,"rattr","rattr",-1122345563),xk=new E(null,"range","range",-1014743483,null),yk=new H(null,"key","key",-1516042587),zk=new H(null,"element","element",1974019749),Ak=new H(null,"limit","limit",-1355822363),Bk=new E(null,"sum","sum",1777518341,null),Ck=new H("parser","where","parser/where",-966053850),Dk=new H(null,"datom","datom",-371556090),Ek=new H(null,"reader-exception","reader-exception",-1938323098),Fk=new E(null,"pos?","pos?",-244377722,null),
Gk=new H(null,"db-after","db-after",-571884666),Hk=new H("parser","rule-vars","parser/rule-vars",-1493174969),Ik=new E(null,"neg?","neg?",-1902175577,null),Gf=new H(null,"validator","validator",-1966190681),Jk=new H(null,"fragment","fragment",826775688),pj=new H(null,"default","default",-1987822328),Kk=new H(null,"rule-vars","rule-vars",1665972520),Lk=new H(null,"free","free",801364328),Mk=new H(null,"added","added",2057651688),Nk=new H(null,"new","new",-2085437848),Ok=new H(null,"other","other",
995793544),Pk=new H(null,"bindings","bindings",1271397192),Qk=new H("db","valueType","db/valueType",1827971944),Rk=new H(null,"symbol","symbol",-1038572696),Sk=new H(null,"avet","avet",1383857032),Tk=new H(null,"sources","sources",-321166424),Uk=new H(null,"name","name",1843675177),Vk=new E(null,"\x3c\x3d","\x3c\x3d",1244895369,null),Wk=new H(null,"as","as",1148689641),Xk=new E(null,"NaN","NaN",666918153,null),Yk=new H("query","binding","query/binding",698240489),Zk=new E(null,"*","*",345799209,null),
$k=new E(null,"re-pattern","re-pattern",1047705161,null),al=new E(null,"min","min",2085523049,null),bl=new H("db.type","ref","db.type/ref",-1728373079),cl=new E(null,"prn-str","prn-str",-145225943,null),dl=new H(null,"value","value",305978217),el=new H(null,"prefix-context","prefix-context",-1269613591),fl=new H("datascript.pull-api","recursion","datascript.pull-api/recursion",-1897884534),gl=new H(null,"file","file",-1269645878),hl=new H(null,"expand-rev","expand-rev",1249112650),il=new H(null,"operation",
"operation",-1267664310),jl=new E(null,"get-some","get-some",409442058,null),kl=new E(null,"identity","identity",-1007039734,null),ll=new E(null,"js","js",-886355190,null),ml=new H(null,"readers","readers",-2118263030),nl=new H(null,"max-eid","max-eid",2134868075),ol=new E(null,"meta","meta",-1154898805,null),pl=new E("clojure.string","ends-with?","clojure.string/ends-with?",-745964149,null),ql=new E(null,"empty?","empty?",76408555,null),rl=new E(null,"quot","quot",-1125214196,null),sl=new E("clojure.string",
"includes?","clojure.string/includes?",-1842146260,null),Ii=new H(null,"val","val",128701612),tl=new E(null,"stddev","stddev",775056588,null),ul=new H(null,"qfind","qfind",1529332972),vl=new E(null,"not\x3d","not\x3d",1466536204,null),wl=new E(null,"limit","limit",284709164,null),xl=new E(null,"inst","inst",-2008473268,null),yl=new H(null,"type","type",1174270348),zl=new H(null,"eids","eids",1546550700),of=new E(null,"meta7801","meta7801",210433548,null),Al=new E(null,"or-join","or-join",591375469,
null),Bl=new E(null,"ground","ground",-1460862835,null),Cl=new H(null,"state","state",-1988618099),Dl=new E(null,"rand","rand",-1745930995,null),El=new H(null,"entity-id","entity-id",1485898093),Fl=new E(null,"\x3e","\x3e",1085014381,null),zi=new H(null,"fallback-impl","fallback-impl",-1501286995),Gl=new H(null,"op","op",-1882987955),Oi=new H(null,"keyword-fn","keyword-fn",-64566675),Hl=new E(null,"Inf","Inf",647172781,null),Il=new H(null,"source","source",-433931539),Jl=new H("transaction","filtered",
"transaction/filtered",1699706605),Ua=new H(null,"flush-on-newline","flush-on-newline",-151457939),Kl=new E(null,"db","db",-1661185010,null),Ll=new H("db","isComponent","db/isComponent",423352398),Ml=new E(null,"even?","even?",-1827825394,null),Nl=new H(null,"string","string",-1989541586),Ol=new E(null,"queue","queue",-1198599890,null),Pl=new E(null,"_","_",-1201019570,null),Ql=new H(null,"vector","vector",1902966158),Rl=new H(null,"illegal-argument","illegal-argument",-1845493170),Sl=new H("db.fn",
"call","db.fn/call",-151594418),Tl=new H("db","cas","db/cas",-451542322),Ul=new H("transact","upsert","transact/upsert",412688078),Vl=new H(null,"e","e",1381269198),Wl=new H(null,"rules","rules",1198912366),Xl=new H(null,"qwhere","qwhere",-1645067378),Yl=new E(null,"%","%",-950237169,null),Zl=new E(null,"pr-str","pr-str",-2066912145,null),$l=new H(null,"elements","elements",657646735),am=new H(null,"strable","strable",1877668047),$i=new H(null,"descendants","descendants",1824886031),bm=new E(null,
"mod","mod",1510044207,null),cm=new H(null,"eavt","eavt",-666437073),dm=new H(null,"qin","qin",1372651151),em=new H("db.fn","retractEntity","db.fn/retractEntity",-1423535441),fm=new H(null,"column","column",2078222095),gm=new E(null,"default","default",-347290801,null),hm=new E("datascript","Datom","datascript/Datom",-901340080,null),aj=new H(null,"ancestors","ancestors",-776045424),im=new H("db.unique","value","db.unique/value",276903088),jm=new H(null,"qwith","qwith",-45809392),km=new E(null,"-",
"-",-471816912,null),lm=new E(null,"or","or",1876275696,null),mm=new E(null,"name","name",-810760592,null),nm=new H(null,"db-before","db-before",-553691536),Va=new H(null,"readably","readably",1129599760),qi=new H(null,"more-marker","more-marker",-14717935),om=new H(null,"tx-data","tx-data",934159761),pm=new H(null,"rels","rels",1770187185),qm=new H("db","retractEntity","db/retractEntity",-1452737935),rm=new H("db","retract","db/retract",-1549825231),sm=new E(null,"zero?","zero?",325758897,null),
um=new H(null,"binding","binding",539932593),vm=new E(null,"rem","rem",664046770,null),wm=new H(null,"tx","tx",466630418),xm=new E(null,"nil?","nil?",1612038930,null),ym=new H(null,"porrl","porrl",-1693905102),zm=new E(null,"variance","variance",-1522424942,null),Am=new H("parser","with","parser/with",-386255821),Bm=new H(null,"recursion","recursion",-749738765),Cm=new H(null,"seen","seen",-518999789),Dm=new H(null,"line","line",212345235),Em=new H(null,"list","list",765357683),Fm=new H(null,"var",
"var",-769682797),Gm=new E(null,"re-find","re-find",1143444147,null),Hm=new H(null,"keyword","keyword",811389747),Im=new E(null,"not","not",1044554643,null),Jm=new E(null,"type","type",-1480165421,null),Km=new E(null,"identical?","identical?",-745864205,null),Lm=new E(null,"$","$",-1580747756,null),Mm=new H(null,"with","with",-1536296876),Nm=new H(null,"pending-guards","pending-guards",-1255527308),Om=new H("db","current-tx","db/current-tx",1600722132),Ya=new H(null,"print-length","print-length",
1931866356),Pm=new H(null,"col","col",-1959363084),Qm=new E(null,"not-join","not-join",-645515756,null),Rm=new H("db.fn","retractAttribute","db.fn/retractAttribute",937402164),Sm=new H("lookup-ref","syntax","lookup-ref/syntax",-317304012),Tm=new H("db.fn","cas","db.fn/cas",-379352172),Um=new H(null,"opts","opts",155075701),Vm=new H(null,"nil","nil",99600501),Wm=new H("entity-id","syntax","entity-id/syntax",1921317045),Xm=new E(null,"resolve-datom","resolve-datom",-294110827,null),Ym=new E(null,"true?",
"true?",-1600332395,null),Zm=new H(null,"specs","specs",1426570741),Zi=new H(null,"parents","parents",-2027538891),$m=new H("db","cardinality","db/cardinality",-104975659),an=new H(null,"expected","expected",1583670997),bn=new E(null,"/","/",-1371932971,null),cn=new E(null,"vector","vector",-751469611,null),dn=new E(null,"\x3e\x3d","\x3e\x3d",1016916022,null),en=new E(null,"not-empty","not-empty",2029453590,null),fn=new E(null,"distinct","distinct",-148347594,null),gn=new H("db","id","db/id",-1388397098),
hn=new H("entity-id","missing","entity-id/missing",1234588374),jn=new H(null,"attrs","attrs",-2090668713),kn=new H(null,"context","context",-830191113),ln=new E(null,"-Inf","-Inf",-2123243689,null),mn=new H(null,"subpattern","subpattern",45002743),nn=new E(null,"sample","sample",1719555128,null),on=new E("datascript","DB","datascript/DB",-487332776,null),pn=new H("db","ident","db/ident",-737096),qn=new H(null,"error","error",-978969032),rn=new H(null,"depth","depth",1768663640),sn=new E(null,"re-matches",
"re-matches",-1865705768,null),tn=new E(null,"array-map","array-map",1555038968,null),un=new H("parser","binding","parser/binding",-346395752),vn=new H("schema","validation","schema/validation",1178447161),wn=new H("db","add","db/add",235286841),xn=new H(null,"clauses","clauses",1454841241),yn=new E(null,"odd?","odd?",-1458588199,null),zn=new H(null,"form","form",-1624062471),An=new H(null,"tag","tag",-1290361223),Bn=new H(null,"unfiltered-db","unfiltered-db",-1363720391),Cn=new E(null,"inc","inc",
324505433,null),Dn=new E(null,".",".",1975675962,null),En=new H(null,"eid","eid",559519930),Fn=new E(null,"list","list",-1889078086,null),Gn=new E(null,"+","+",-740910886,null),Hn=new E(null,"missing?","missing?",-1710383910,null),In=new H(null,"rschema","rschema",-1196134054),Jn=new H(null,"set","set",304602554),Kn=new H(null,"tx-meta","tx-meta",1159283194),Ln=new E(null,"median","median",-2084869638,null),Mn=new H("db.cardinality","many","db.cardinality/many",772806234),Nn=new H("transact","syntax",
"transact/syntax",-299207078),On=new E(null,"str","str",-1564826950,null),Pn=new E(null,"hash-map","hash-map",-439030950,null),Qn=new H(null,"wildcard?","wildcard?",-686044101),Rn=new E(null,"false?","false?",-1522377573,null),Sn=new H(null,"eof","eof",-489063237),Tn=new H(null,"hierarchy","hierarchy",-1053470341),yi=new H(null,"alt-impl","alt-impl",670969595),Un=new E(null,"max","max",1701898075,null),Vn=new H("query","where","query/where",-1935159429),Wn=new E(null,"...","...",-1926939749,null),
Xn=new E(null,"!\x3d","!\x3d",-201205829,null),Yn=new E(null,"\x3d\x3d","\x3d\x3d",-234118149,null),Zn=new H("parser","pull","parser/pull",-2147427204),$n=new E(null,"count","count",-514511684,null),ao=new H(null,"entity","entity",-450970276),bo=new H(null,"prefix-clauses","prefix-clauses",1294180028),Si=new H(null,"keywordize-keys","keywordize-keys",1310784252),co=new H(null,"expand","expand",595248157),eo=new E(null,"-differ?","-differ?",1465687357,null),Ef=new H(null,"listeners","listeners",394544445),
fo=new H(null,"character","character",380652989),go=new H(null,"map","map",1371690461),ho=new E(null,"compare","compare",1109853757,null),io=new H(null,"conflict","conflict",1978796605),jo=new E(null,"complement","complement",-913606051,null),ko=new H(null,"kvps","kvps",65308317),lo=new E(null,"count-distinct","count-distinct",-1566572514,null),mo=new H("db.cardinality","one","db.cardinality/one",1428352190),no=new H(null,"required","required",1807647006),oo=new E(null,"-index-range","-index-range",
898114142,null),po=new E(null,"and","and",668631710,null),qo=new H(null,"a","a",-2123407586),ro=new E(null,"print-str","print-str",-699700354,null),so=new H(null,"datoms","datoms",-290874434),to=new H(null,"assertion","assertion",-1645134882),uo=new H(null,"old","old",-1825222690),vo=new E(null,"avg","avg",1837937727,null),wo=new H(null,"in","in",-1531184865),xo=new H(null,"vars","vars",-2046957217),yo=new H(null,"pattern","pattern",242135423),Sh=new H("cljs.core","not-found","cljs.core/not-found",
-1572889185),zo=new H("parser","query","parser/query",1877320671),Ao=new H(null,"attr","attr",-604132353),Bo=new H(null,"results","results",-1134170113);function Co(a,b){a=lb(ai,a,b);return ud(a,Zf(function(a){return function(b){return a===b}}(a),b))}function Do(a,b){return L(a)<L(b)?A(Bd,b,a):A(Bd,a,b)}var Eo=function Eo(a){switch(arguments.length){case 1:return Eo.c(arguments[0]);case 2:return Eo.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Eo.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Eo.c=function(a){return a};
Eo.b=function(a,b){for(;;)if(L(b)<L(a)){var c=a;a=b;b=c}else return A(function(a,b){return function(a,c){return Zd(b,c)?a:Md.b(a,c)}}(a,b),a,a)};Eo.h=function(a,b,c){a=Co(function(a){return-L(a)},Bd.h(c,b,M([a])));return A(Eo,x(a),Vc(a))};Eo.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Eo.H=2;
var Fo=function Fo(a){switch(arguments.length){case 1:return Fo.c(arguments[0]);case 2:return Fo.b(arguments[0],arguments[1]);default:for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Fo.h(arguments[0],arguments[1],new v(c.slice(2),0,null))}};Fo.c=function(a){return a};Fo.b=function(a,b){return L(a)<L(b)?A(function(a,d){return Zd(b,d)?Md.b(a,d):a},a,a):A(Md,a,b)};Fo.h=function(a,b,c){return A(Fo,a,Bd.b(c,b))};
Fo.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};Fo.H=2;function Go(a,b){return L(a)<=L(b)&&tf(function(a){return Zd(b,a)},a)};function Ho(a){return A(function(a,c){a.push(c);return a},[],a)};var Io=x(Yf(function(a){return 0!=(32&1<<a)},gi.f(31,-1,-1)))+1,Jo=(1<<Io)-1;function Ko(a,b,c,d){for(var e=0,g=ye(c);;)if(e<=g){c=e+g>>>1;var h=b[c];0>(a.b?a.b(h,d):a.call(null,h,d))?e=c+1:g=c-1}else return e}function Lo(a,b,c,d){for(var e=0,g=ye(c);;)if(e<=g){c=e+g>>>1;var h=b[c];0<(a.b?a.b(h,d):a.call(null,h,d))?g=c-1:e=c+1}else return e}function Mo(a,b,c){var d=b.length,e=Ko(a,b,d-1,c);if(d=e<d)b=b[e],d=0===(a.b?a.b(b,c):a.call(null,b,c));return d?e:-1}
function No(a,b,c){var d=b.length;a=Ko(a,b,d-1,c);return a===d?-1:a}function Oo(a,b,c,d,e,g){var h=g.length,k=d-b,l=k+h,m=Array(k+h+(c-e));d-=b;for(var p=0;;)if(p<d)m[p+0]=a[p+b],p+=1;else break;b=h-0;for(h=0;;)if(h<b)m[h+k]=g[h+0],h+=1;else break;c-=e;for(g=0;;)if(g<c)m[g+l]=a[g+e],g+=1;else break;return m}function Po(a,b,c,d){return Oo(a,0,a.length,b,c,d)}
function Qo(a,b){var c=a.length,d=b.length,e=c+d,g=e>>>1,h=Array(g);e=Array(e-g);if(c<=g){for(var k=c-0,l=0;;)if(l<k)h[l+0]=a[l+0],l+=1;else break;a=g-c;for(k=0;;)if(k<a)h[k+c]=b[k+0],k+=1;else break;d-=g-c;for(a=0;;)if(a<d)e[a+0]=b[a+(g-c)],a+=1;else break}else{k=g-0;for(l=0;;)if(l<k)h[l+0]=a[l+0],l+=1;else break;k=c-g;for(l=0;;)if(l<k)e[l+0]=a[l+g],l+=1;else break;d-=0;for(a=0;;)if(a<d)e[a+(c-g)]=b[a+0],a+=1;else break}return[h,e]}
function Ro(a,b,c,d,e,g){d-=c;if(g=d===g-0)for(g=0;;){if(g===d)return!0;var h=b[g+c],k=e[g+0];if(0!==(a.b?a.b(h,k):a.call(null,h,k)))return!1;g+=1}else return g}function So(a,b){return r(a)?r(b)?[a,b]:[a]:[b]}function To(a,b,c){return r(a)?r(b)?r(c)?[a,b,c]:[a,b]:r(c)?[a,c]:[a]:r(b)?r(c)?[b,c]:[b]:[c]}
var Uo=function Uo(a){if(null!=a&&null!=a.ud)return a.ud(a);var c=Uo[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Uo._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("INode.node-lim-key",a);},Vo=function Vo(a){if(null!=a&&null!=a.Ud)return a.keys.length;var c=Vo[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Vo._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("INode.node-len",a);},Wo=function Wo(a,b){if(null!=a&&null!=a.wd)return a.wd(a,b);var d=
Wo[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Wo._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("INode.node-merge",a);},Xo=function Xo(a,b){if(null!=a&&null!=a.xd)return a.xd(a,b);var d=Xo[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Xo._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("INode.node-merge-n-split",a);},Yo=function Yo(a,b,c){if(null!=a&&null!=a.vd)return a.vd(a,b,c);var e=Yo[ba(null==a?null:a)];if(null!=e)return e.f?
e.f(a,b,c):e.call(null,a,b,c);e=Yo._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("INode.node-lookup",a);},Zo=function Zo(a,b,c){if(null!=a&&null!=a.sd)return a.sd(a,b,c);var e=Zo[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=Zo._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("INode.node-conj",a);},$o=function $o(a,b,c,d,e,g){if(null!=a&&null!=a.td)return a.td(a,b,c,d,e,g);var k=$o[ba(null==a?null:a)];if(null!=k)return k.la?k.la(a,b,c,d,e,
g):k.call(null,a,b,c,d,e,g);k=$o._;if(null!=k)return k.la?k.la(a,b,c,d,e,g):k.call(null,a,b,c,d,e,g);throw gb("INode.node-disj",a);};function ap(a,b,c,d){if(r(b))return[a];if(16<Vo(a))return To(c,a,d);if(r(r(c)?16>=Vo(c):c))return So(Wo(c,a),d);if(r(r(d)?16>=Vo(d):d))return So(c,Wo(a,d));if(r(r(c)?null==d||Vo(c)<Vo(d):c))return a=Xo(c,a),To(a[0],a[1],d);a=Xo(a,d);return To(c,a[0],a[1])}function bp(a,b){this.keys=a;this.Da=b}f=bp.prototype;f.ud=function(){var a=this.keys;return a[a.length-1]};
f.Ud=function(){return this.keys.length};f.wd=function(a,b){return new bp(this.keys.concat(b.keys),this.Da.concat(b.Da))};f.xd=function(a,b){a=Qo(this.keys,b.keys);b=Qo(this.Da,b.Da);return So(new bp(a[0],b[0]),new bp(a[1],b[1]))};f.vd=function(a,b,c){a=No(b,this.keys,c);return-1===a?null:Yo(this.Da[a],b,c)};
f.sd=function(a,b,c){a=Ko(b,this.keys,this.keys.length-2,c);c=Zo(this.Da[a],b,c);if(r(c)){var d=this.keys,e=a+1,g=c.map(Uo);b=Ro(b,d,a,e,g,g.length)?d:Po(d,a,e,g);a=Po(this.Da,a,a+1,c);if(32>=a.length)return[new bp(b,a)];c=a.length>>>1;return[new bp(b.slice(0,c),a.slice(0,c)),new bp(b.slice(c),a.slice(c))]}return null};
f.td=function(a,b,c,d,e,g){var h=No(b,this.keys,c);if(-1===h)return null;a=0<=h-1?this.Da[h-1]:null;var k=h+1<this.Da.length?this.Da[h+1]:null;c=$o(this.Da[h],b,c,!1,a,k);if(r(c)){a=r(a)?h-1:h;h=r(k)?2+h:1+h;k=this.keys;var l=c.map(Uo);b=Ro(b,k,a,h,l,l.length)?k:Po(k,a,h,l);c=Po(this.Da,a,h,c);return ap(new bp(b,c),d,e,g)}return null};function cp(a){this.keys=a}f=cp.prototype;f.ud=function(){var a=this.keys;return a[a.length-1]};f.Ud=function(){return this.keys.length};f.wd=function(a,b){return new cp(this.keys.concat(b.keys))};
f.xd=function(a,b){a=Qo(this.keys,b.keys);return So(new cp(a[0]),new cp(a[1]))};f.vd=function(a,b,c){a=Mo(b,this.keys,c);return-1===a?null:this.keys[a]};f.sd=function(a,b,c){a=Ko(b,this.keys,this.keys.length-1,c);var d=this.keys.length,e;if(e=a<d)e=this.keys[a],e=0===(b.b?b.b(c,e):b.call(null,c,e));return e?null:32===d?(b=d+1>>>1,a>b?[new cp(this.keys.slice(0,b)),new cp(Oo(this.keys,b,d,a,a,[c]))]:[new cp(Oo(this.keys,0,b,a,a,[c])),new cp(this.keys.slice(b,d))]):[new cp(Po(this.keys,a,a,[c]))]};
f.td=function(a,b,c,d,e,g){a=Mo(b,this.keys,c);if(-1===a)return null;a=Po(this.keys,a,a+1,[]);return ap(new cp(a),d,e,g)};function dp(a,b,c,d,e,g){this.root=a;this.shift=b;this.w=c;this.jb=d;this.D=e;this.hb=g;this.m=2297303311;this.F=8332}f=dp.prototype;f.toString=function(){return Dc(this)};f.M=function(a,b){return Yo(this.root,this.jb,b)};f.o=function(a,b,c){a=Yo(this.root,this.jb,b);return r(a)?a:c};f.L=function(a,b,c){return X(b,wi,"#{"," ","}",c,I(this))};f.R=function(){return this.D};f.P=function(){return this.w};
f.pb=function(){return hc(ep.c?ep.c(this):ep.call(null,this))};f.O=function(){var a=this.hb;return null!=a?a:this.hb=a=bd(this)};f.C=function(a,b){return Pd(b)&&this.w===L(b)&&tf(function(a){return function(b){return Zd(a,b)}}(this),b)};f.ec=function(){return this};f.ia=function(){return new dp(new cp([]),0,0,this.jb,this.D,null)};f.jd=function(a,b){return fp.f?fp.f(this,b,this.jb):fp.call(null,this,b,this.jb)};
f.ta=function(a,b){a=ep.c?ep.c(this):ep.call(null,this);return r(a)?Wb.b(a,b):b.G?b.G():b.call(null)};f.ua=function(a,b,c){a=ep.c?ep.c(this):ep.call(null,this);return r(a)?Wb.f(a,b,c):c};f.fc=function(a,b){return gp.f?gp.f(this,b,this.jb):gp.call(null,this,b,this.jb)};f.lc=function(){return this};f.N=function(){return ep.c?ep.c(this):ep.call(null,this)};f.S=function(a,b){return new dp(this.root,this.shift,this.w,this.jb,b,this.hb)};
f.T=function(a,b){return gp.f?gp.f(this,b,this.jb):gp.call(null,this,b,this.jb)};f.call=function(){var a=null;a=function(a,c,d){switch(arguments.length){case 2:return this.M(null,c);case 3:return this.o(null,c,d)}throw Error("Invalid arity: "+(arguments.length-1));};a.b=function(a,c){return this.M(null,c)};a.f=function(a,c,d){return this.o(null,c,d)};return a}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return this.M(null,a)};
f.b=function(a,b){return this.o(null,a,b)};function hp(a,b){var c=a.shift;for(a=a.root;;)if(0<c)a=a.Da[Jo&b>>>c],c-=Io;else return a.keys}function ip(a,b,c,d){return new dp(b,c,d,a.jb,a.D,null)}var jp=function jp(a,b,c){var e=Jo&b>>>c;if(0<c){var g=a.Da[e],h=c-Io;b=jp.f?jp.f(g,b,h):jp.call(null,g,b,h);return-1===b?e+1<a.Da.length?0|e+1<<c:-1:b|e<<c}return e+1<a.keys.length?0|e+1<<0:-1};function kp(a,b){return jp(a.root,b,a.shift)}
function lp(a,b){for(var c=0;;)if(0<b)c|=a.Da.length-1<<b,b-=Io,a=a.Da,a=a[a.length-1];else return c|a.keys.length-1<<0}var mp=function mp(a,b,c){var e=Jo&b>>>c;if(0<c){var g=c-Io,h=a.Da[e];b=mp.f?mp.f(h,b,g):mp.call(null,h,b,g);return-1===b?0<=e-1?(--e,lp(a.Da[e],g)|e<<c):-1:b|e<<c}return 0<=e-1?0|e-1<<0:-1};function np(a,b){return mp(a.root,b,a.shift)}function ep(a){if(0<Vo(a.root)){var b=lp(a.root,a.shift)+1;return op.f?op.f(a,0,b):op.call(null,a,0,b)}return null}
function pp(a,b,c){this.l=a;this.oa=b;this.end=c;this.m=524306;this.F=0}f=pp.prototype;f.P=function(){return this.end-this.oa};f.Z=function(a,b){return kb.b(this.l,this.oa+b)};f.ga=function(a,b,c){return 0<=b&&b<this.end-this.oa?kb.b(this.l,this.oa+b):c};f.zc=function(){if(this.oa===this.end)throw Error("-drop-first of empty chunk");return new Qe(this.l,this.oa+1,this.end)};f.ta=function(a,b){return this.oa===this.end?b.G?b.G():b.call(null):Wb.f(this.zc(null),b,kb.b(this.l,this.oa))};
f.ua=function(a,b,c){for(a=this.oa;;)if(a<this.end){var d=kb.b(this.l,a);c=b.b?b.b(c,d):b.call(null,c,d);if(fd(c))return Rb(c);a+=1}else return c};function qp(a,b,c,d,e){this.set=a;this.left=b;this.right=c;this.keys=d;this.Kb=e;this.m=2309488832;this.F=1536}f=qp.prototype;f.toString=function(){return Dc(this)};f.L=function(a,b,c){return X(b,wi,"("," ",")",c,I(this))};
f.na=function(){if(r(this.keys)){if(this.Kb+1<this.keys.length)return this.left+1<this.right?new qp(this.set,this.left+1,this.right,this.keys,this.Kb+1):null;var a=kp(this.set,this.left);return lf.b(-1,a)&&a<this.right?this.Yc(a,this.right):null}return null};f.pb=function(){if(r(this.keys)){var a=this.set,b=np(this.set,this.left),c=np(this.set,this.right);return rp.f?rp.f(a,b,c):rp.call(null,a,b,c)}return null};f.C=function(a,b){return td(this,b)};
f.ta=function(a,b){if(null==this.keys)return b.G?b.G():b.call(null);a=this.xa(null);var c=this.na(null);return null==c?a:Wb.f(c,b,a)};f.ua=function(a,b,c){a=this.left;for(var d=this.keys,e=this.Kb;;){if(null==d)return c;var g=d[e];c=b.b?b.b(c,g):b.call(null,c,g);if(fd(c))return Rb(c);if(e+1<d.length)if(a+1<this.right)e+=1,a+=1;else return c;else if(a=kp(this.set,a),-1!==a&&a<this.right)d=hp(this.set,a),e=Jo&a>>>0;else return c}};f.xa=function(){return r(this.keys)?this.keys[this.Kb]:null};
f.Ea=function(){var a=this.na(null);return r(a)?a:Wc};f.N=function(){return r(this.keys)?this:null};f.Bc=function(){var a=J.b(this.left|Jo,this.right|Jo)?this.right&Jo:this.keys.length;return new pp(this.keys,this.Kb,a)};f.kc=function(){var a=this.Ac();return r(a)?a:Wc};f.Yc=function(a,b){return new qp(this.set,a,b,hp(this.set,a),Jo&a>>>0)};f.Ac=function(){var a=kp(this.set,this.left+(this.keys.length-this.Kb-1));return lf.b(-1,a)&&a<this.right?this.Yc(a,this.right):null};
function op(a,b,c){return new qp(a,b,c,hp(a,b),Jo&b>>>0)}function sp(a,b,c,d,e){this.set=a;this.left=b;this.right=c;this.keys=d;this.Kb=e;this.m=2308964544;this.F=0}f=sp.prototype;f.toString=function(){return Dc(this)};f.L=function(a,b,c){return X(b,wi,"("," ",")",c,I(this))};
f.na=function(){if(r(this.keys)){if(0<=this.Kb-1)return this.right-1>this.left?new sp(this.set,this.left,this.right-1,this.keys,this.Kb-1):null;var a=np(this.set,this.right);return lf.b(-1,a)&&a>this.left?this.Yc(this.left,a):null}return null};f.pb=function(){if(r(this.keys)){var a=-1===this.left?0:kp(this.set,this.left),b=kp(this.set,this.right);return op(this.set,a,-1===b?this.right+1:b)}return null};f.C=function(a,b){return td(this,b)};f.xa=function(){return r(this.keys)?this.keys[this.Kb]:null};
f.Ea=function(){var a=this.na(null);return r(a)?a:Wc};f.N=function(){return r(this.keys)?this:null};f.Yc=function(a,b){return new sp(this.set,a,b,hp(this.set,b),Jo&b>>>0)};function rp(a,b,c){return new sp(a,b,c,hp(a,c),Jo&c>>>0)}
function tp(a,b,c,d){a:for(var e=a.root,g=0,h=a.shift;;){var k=Vo(e);if(0===h){var l=e.keys;l=Ko(d,l,k-1,b);b=k===l?-1:g|l<<0;break a}l=e.keys;l=Ko(d,l,k-2,b);g|=l<<h;h-=Io;e=e.Da[l]}if(0>b)return null;a:for(e=a.root,g=0,h=a.shift;;){l=Vo(e);if(0===h){k=e.keys;l=Lo(d,k,l-1,c);c=g|l<<0;break a}k=e.keys;l=Lo(d,k,l-2,c);g|=l<<h;h-=Io;e=e.Da[l]}return c>b?new qp(a,b,c,hp(a,b),Jo&b>>>0):null}
function up(a,b){for(var c=b.length,d=0;;)if(d<c){var e=d;var g=b[d];g=a.c?a.c(g):a.call(null,g);b[e]=g;d+=1}else break;return b}function vp(a){var b=a.length,c=lc(Cd);if(0<b)for(var d=0;;){var e=b-d;if(32>=e){af.b(c,a.slice(d));break}else 40<=e?(af.b(c,a.slice(d,d+24)),d+=24):(e>>>=1,af.b(c,a.slice(d,d+e)),d+=e)}return fe(nc(c))}function gp(a,b,c){b=Zo(a.root,c,b);return null==b?a:1===b.length?ip(a,b[0],a.shift,a.w+1):ip(a,new bp(b.map(Uo),b),a.shift+Io,a.w+1)}
function fp(a,b,c){b=$o(a.root,c,b,!0,null,null);if(null==b)return a;b=b[0];return b instanceof bp&&1===b.Da.length?ip(a,b.Da[0],a.shift-Io,a.w-1):ip(a,b,a.shift,a.w-1)}function wp(a,b,c){return tp(a,b,c,a.jb)}function xp(a){var b=yp.B(536870911,null,null,2147483647),c=yp.B(0,null,null,536870912);a=tp(a,c,b,a.jb);return null==a?null:hc(a)}
function zp(a,b){for(var c=up(function(a){return new cp(a)},vp(b)),d=c,e=0;;){var g=L(d);switch(g){case 0:return new dp(new cp([]),0,0,a,null,null);case 1:return new dp(x(d),e,b.length,a,null,null);default:d=up(function(){return function(a){return new bp(a.map(Uo),a)}}(d,e,g,c),vp(d)),e+=Io}}}function Ap(a){return new dp(new cp([]),0,0,a,null,null)};function Bp(a,b,c){if(Ee(c)){var d=jf(He,Nf.b(a,c));return b.c?b.c(d):b.call(null,d)}return zg(c)?(d=new W(function(){var b=Jb(c);return a.c?a.c(b):a.call(null,b)}(),function(){var b=Kb(c);return a.c?a.c(b):a.call(null,b)}()),b.c?b.c(d):b.call(null,d)):Xd(c)?(d=mi(Nf.b(a,c)),b.c?b.c(d):b.call(null,d)):Sd(c)?(d=A(function(b,c){return Bd.b(b,a.c?a.c(c):a.call(null,c))},c,c),b.c?b.c(d):b.call(null,d)):Od(c)?(d=$f.b(Ed(c),Nf.b(a,c)),b.c?b.c(d):b.call(null,d)):b.c?b.c(c):b.call(null,c)}
var Cp=function Cp(a,b){return Bp(yf(Cp,a),a,b)};var datascript={},Dp=Error;function Ep(a){var b;if(b="string"!==typeof a)b=null==a,b||(b=(b=null!=a?a.m&8388608||n===a.Tc?!0:a.m?!1:eb(ac,a):eb(ac,a))?b:ab(a)||"string"===typeof a),b=b||a instanceof Array;return b}function Fp(a,b){return Pc(a,b)}var Gp=function Gp(a){if(null!=a&&null!=a.ja)return a.ja(a);var c=Gp[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Gp._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IDatom.datom-tx",a);};
function Hp(a,b,c,d,e){this.e=a;this.a=b;this.v=c;this.tx=d;this.hb=e;this.m=2162164496;this.F=0}f=Hp.prototype;f.ja=function(){return 0<this.tx?this.tx:-this.tx};f.O=function(){return 0===this.hb?this.hb=Ip.c?Ip.c(this):Ip.call(null,this):this.hb};f.C=function(a,b){return(a=b instanceof Hp)?Jp.b?Jp.b(this,b):Jp.call(null,this,b):a};f.N=function(){return Kp.c?Kp.c(this):Kp.call(null,this)};f.M=function(a,b){return Lp.f?Lp.f(this,b,null):Lp.call(null,this,b,null)};
f.o=function(a,b,c){return Lp.f?Lp.f(this,b,c):Lp.call(null,this,b,c)};f.Z=function(a,b){return Mp?Mp(this,b):Np.call(null,this,b)};f.ga=function(a,b,c){return Op?Op(this,b,c):Np.call(null,this,b,c)};f.I=function(a,b,c){return Pp.f?Pp.f(this,b,c):Pp.call(null,this,b,c)};f.L=function(a,b,c){return X(b,wi,"#datascript/Datom ["," ","]",c,new U(null,5,5,V,[this.e,this.a,this.v,this.ja(null),0<this.tx],null))};fa("datascript.db.Datom",Hp);
var yp=function yp(a){switch(arguments.length){case 3:return yp.f(arguments[0],arguments[1],arguments[2]);case 4:return yp.B(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return yp.V(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};yp.f=function(a,b,c){return new Hp(a,b,c,536870912,0)};yp.B=function(a,b,c,d){return new Hp(a,b,c,d,0)};yp.V=function(a,b,c,d,e){return new Hp(a,b,c,r(e)?d:-d,0)};
yp.H=5;function Ip(a){return Fp(Fp(Oc(a.e),Oc(a.a)),Oc(a.v))}function Jp(a,b){return a.e===b.e&&J.b(a.a,b.a)&&J.b(a.v,b.v)}function Kp(a){return new Dd(null,a.e,new Dd(null,a.a,new Dd(null,a.v,new Dd(null,a.ja(null),new Dd(null,0<a.tx,null,1,null),2,null),3,null),4,null),5,null)}function Lp(a,b,c){return J.b(ik,b)?a.v:J.b("e",b)?a.e:J.b(Mk,b)?0<a.tx:J.b("v",b)?a.v:J.b(Vl,b)?a.e:J.b("a",b)?a.a:J.b(wm,b)?a.ja(null):J.b("added",b)?0<a.tx:J.b("tx",b)?a.ja(null):J.b(qo,b)?a.a:c}
function Np(a){switch(arguments.length){case 2:return Mp(arguments[0],arguments[1]);case 3:return Op(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}}function Mp(a,b){switch(b){case 0:return a.e;case 1:return a.a;case 2:return a.v;case 3:return a.ja(null);case 4:return 0<a.tx;default:throw Error(["Datom/-nth: Index out of bounds: ",t.c(b)].join(""));}}
function Op(a,b,c){switch(b){case 0:return a.e;case 1:return a.a;case 2:return a.v;case 3:return a.ja(null);case 4:return 0<a.tx;default:return c}}
function Pp(a,b,c){switch(b instanceof H?b.X:null){case "e":return yp.V(c,a.a,a.v,a.ja(null),0<a.tx);case "a":return yp.V(a.e,c,a.v,a.ja(null),0<a.tx);case "v":return yp.V(a.e,a.a,c,a.ja(null),0<a.tx);case "tx":return yp.V(a.e,a.a,a.v,c,0<a.tx);case "added":return yp.V(a.e,a.a,a.v,a.ja(null),c);default:throw new Dp(["invalid key for #datascript/Datom: ",t.c(b)].join(""));}}function Qp(a,b){return null==a?0:null==b?0:be(a,b)}
function Rp(a,b){var c=a.e-b.e;return 0===c&&(c=Qp(a.a,b.a),0===c&&(c=Qp(a.v,b.v),0===c))?(a=a.ja(null)-b.ja(null),0===a?0:a):c}function Sp(a,b){var c=Qp(a.a,b.a);return 0===c&&(c=a.e-b.e,0===c&&(c=Qp(a.v,b.v),0===c))?(a=a.ja(null)-b.ja(null),0===a?0:a):c}function Tp(a,b){var c=Qp(a.a,b.a);return 0===c&&(c=Qp(a.v,b.v),0===c&&(c=a.e-b.e,0===c))?(a=a.ja(null)-b.ja(null),0===a?0:a):c}function Up(a,b){return a instanceof H?rc(a,b):ka(a,b)}
function Vp(a,b){var c=a.e-b.e;return 0===c&&(c=Up(a.a,b.a),0===c&&(c=be(a.v,b.v),0===c))?(a=a.ja(null)-b.ja(null),0===a?0:a):c}function Wp(a,b){var c=Up(a.a,b.a);return 0===c&&(c=a.e-b.e,0===c&&(c=be(a.v,b.v),0===c))?(a=a.ja(null)-b.ja(null),0===a?0:a):c}function Xp(a,b){var c=Up(a.a,b.a);return 0===c&&(c=be(a.v,b.v),0===c&&(c=a.e-b.e,0===c))?(a=a.ja(null)-b.ja(null),0===a?0:a):c}function Yp(){}
var Zp=function Zp(a,b){if(null!=a&&null!=a.qd)return a.qd(a,b);var d=Zp[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=Zp._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("ISearch.-search",a);},$p=function $p(a,b,c){if(null!=a&&null!=a.nd)return a.nd(a,b,c);var e=$p[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=$p._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("IIndexAccess.-datoms",a);},aq=function aq(a,b,c){if(null!=a&&
null!=a.pd)return a.pd(a,b,c);var e=aq[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=aq._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("IIndexAccess.-seek-datoms",a);},bq=function bq(a,b,c,d){if(null!=a&&null!=a.od)return a.od(a,b,c,d);var g=bq[ba(null==a?null:a)];if(null!=g)return g.B?g.B(a,b,c,d):g.call(null,a,b,c,d);g=bq._;if(null!=g)return g.B?g.B(a,b,c,d):g.call(null,a,b,c,d);throw gb("IIndexAccess.-index-range",a);};function cq(){}
var dq=function dq(a){if(null!=a&&null!=a.md)return a.md(a);var c=dq[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=dq._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IDB.-schema",a);},eq=function eq(a,b){if(null!=a&&null!=a.ld)return a.ld(a,b);var d=eq[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=eq._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IDB.-attrs-by",a);};
function fq(a,b,c,d,e,g,h,k,l,m,p){this.Ya=a;this.Ha=b;this.ab=c;this.Za=d;this.eb=e;this.fb=g;this.bb=h;this.hash=k;this.i=l;this.g=m;this.j=p;this.m=2230716170;this.F=139264}f=fq.prototype;f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "schema":return this.Ya;case "eavt":return this.Ha;case "aevt":return this.ab;case "avet":return this.Za;case "max-eid":return this.eb;case "max-tx":return this.fb;case "rschema":return this.bb;case "hash":return this.hash;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.db.DB{",", ","}",c,T.b(new U(null,8,5,V,[new U(null,2,5,V,[Jj,this.Ya],null),new U(null,2,5,V,[cm,this.Ha],null),new U(null,2,5,V,[uk,this.ab],null),new U(null,2,5,V,[Sk,this.Za],null),new U(null,2,5,V,[nl,this.eb],null),new U(null,2,5,V,[dk,this.fb],null),new U(null,2,5,V,[In,this.bb],null),new U(null,2,5,V,[nk,this.hash],null)],null),this.g))};
f.W=function(){return new Og(this,8,new U(null,8,5,V,[Jj,cm,uk,Sk,nl,dk,In,nk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 8+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1515640948^bd(a)}}(b,a)(a)}();return this.j=c};
f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.Ya,b.Ya)&&J.b(this.Ha,b.Ha)&&J.b(this.ab,b.ab)&&J.b(this.Za,b.Za)&&J.b(this.eb,b.eb)&&J.b(this.fb,b.fb)&&J.b(this.bb,b.bb)&&J.b(this.hash,b.hash)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,8,[Jj,null,dk,null,nk,null,uk,null,Sk,null,nl,null,cm,null,In,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new fq(this.Ya,this.Ha,this.ab,this.Za,this.eb,this.fb,this.bb,this.hash,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Jj,b):S.call(null,Jj,b))?new fq(c,this.Ha,this.ab,this.Za,this.eb,this.fb,this.bb,this.hash,this.i,this.g,null):r(S.b?S.b(cm,b):S.call(null,cm,b))?new fq(this.Ya,c,this.ab,this.Za,this.eb,this.fb,this.bb,this.hash,this.i,this.g,null):r(S.b?S.b(uk,b):S.call(null,uk,b))?new fq(this.Ya,this.Ha,c,this.Za,this.eb,this.fb,this.bb,this.hash,this.i,this.g,null):r(S.b?S.b(Sk,b):S.call(null,Sk,b))?new fq(this.Ya,this.Ha,this.ab,c,this.eb,this.fb,this.bb,this.hash,this.i,
this.g,null):r(S.b?S.b(nl,b):S.call(null,nl,b))?new fq(this.Ya,this.Ha,this.ab,this.Za,c,this.fb,this.bb,this.hash,this.i,this.g,null):r(S.b?S.b(dk,b):S.call(null,dk,b))?new fq(this.Ya,this.Ha,this.ab,this.Za,this.eb,c,this.bb,this.hash,this.i,this.g,null):r(S.b?S.b(In,b):S.call(null,In,b))?new fq(this.Ya,this.Ha,this.ab,this.Za,this.eb,this.fb,c,this.hash,this.i,this.g,null):r(S.b?S.b(nk,b):S.call(null,nk,b))?new fq(this.Ya,this.Ha,this.ab,this.Za,this.eb,this.fb,this.bb,c,this.i,this.g,null):new fq(this.Ya,
this.Ha,this.ab,this.Za,this.eb,this.fb,this.bb,this.hash,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,8,5,V,[new W(Jj,this.Ya),new W(cm,this.Ha),new W(uk,this.ab),new W(Sk,this.Za),new W(nl,this.eb),new W(dk,this.fb),new W(In,this.bb),new W(nk,this.hash)],null),this.g))};f.S=function(a,b){return new fq(this.Ya,this.Ha,this.ab,this.Za,this.eb,this.fb,this.bb,this.hash,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};
function gq(a){var b=Q.h(a,Jj,M([cm,uk,Sk,nl,dk,In,nk]));b=Sd(a)?$f.b(pf,b):b;return new fq(Jj.c(a),cm.c(a),uk.c(a),Sk.c(a),nl.c(a),dk.c(a),In.c(a),nk.c(a),null,mf(b),null)}f.ka=n;f.L=function(a,b,c){return hq.f?hq.f(this,b,c):hq.call(null,this,b,c)};f.dd=n;f.P=function(){return L(this.Ha)};f.ge=n;f.pb=function(){return hc(this.Ha)};f.Hd=n;f.O=function(){return iq.c?iq.c(this):iq.call(null,this)};f.C=function(a,b){return jq.b?jq.b(this,b):jq.call(null,this,b)};f.Gd=n;
f.ec=function(){return gg(gg(gg(this,cm,Ze),uk,Ze),Sk,Ze)};f.ed=n;f.ia=function(){var a=this.Ya;return kq?kq(a):lq.call(null,a)};f.fc=function(){throw vj("datascript.DB/conj! is not supported",pf);};f.lc=function(){return gg(gg(gg(this,cm,$e),uk,$e),Sk,$e)};f.Tc=n;f.N=function(){return bc(this.Ha)};f.nd=function(a,b,c){return wp(F.b(this,b),mq.V?mq.V(this,b,c,0,536870912):mq.call(null,this,b,c,0,536870912),mq.V?mq.V(this,b,c,2147483647,2147483647):mq.call(null,this,b,c,2147483647,2147483647))};
f.pd=function(a,b,c){return wp(F.b(this,b),mq.V?mq.V(this,b,c,0,536870912):mq.call(null,this,b,c,0,536870912),yp.B(2147483647,null,null,2147483647))};
f.od=function(a,b,c,d){if(!r(nq.b?nq.b(this,b):nq.call(null,this,b)))throw vj(["Attribute ",Di.h(M([b]))," should be marked as :db/index true"].join(""),pf);a=new Dd(null,oo,new Dd(null,Kl,new Dd(null,b,new Dd(null,c,new Dd(null,d,null,1,null),2,null),3,null),4,null),5,null);oq.b?oq.b(b,a):oq.call(null,b,a);return wp(this.Za,pq.Ca?pq.Ca(this,null,b,c,null,0,536870912):pq.call(null,this,null,b,c,null,0,536870912),pq.Ca?pq.Ca(this,null,b,d,null,2147483647,2147483647):pq.call(null,this,null,b,d,null,
2147483647,2147483647))};f.kd=n;f.md=function(){return this.Ya};f.ld=function(a,b){a=this.bb;return a.c?a.c(b):a.call(null,b)};f.Pd=n;
f.qd=function(a,b){a=O(b,0);var c=O(b,1),d=O(b,2),e=O(b,3),g=this.Ha,h=this.ab,k=this.Za;return r(a)?r(c)?null!=d?r(e)?wp(g,yp.B(a,c,d,e),yp.B(a,c,d,e)):wp(g,yp.B(a,c,d,536870912),yp.B(a,c,d,2147483647)):r(e)?Yf(function(a,b,c,d,e){return function(a){return J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),wp(g,yp.B(a,c,null,536870912),yp.B(a,c,null,2147483647))):wp(g,yp.B(a,c,null,536870912),yp.B(a,c,null,2147483647)):null!=d?r(e)?Yf(function(a,b,c,d,e){return function(a){return J.b(d,a.v)&&J.b(e,a.ja(null))}}(b,
a,c,d,e,g,h,k,this),wp(g,yp.B(a,null,null,536870912),yp.B(a,null,null,2147483647))):Yf(function(a,b,c,d){return function(a){return J.b(d,a.v)}}(b,a,c,d,e,g,h,k,this),wp(g,yp.B(a,null,null,536870912),yp.B(a,null,null,2147483647))):r(e)?Yf(function(a,b,c,d,e){return function(a){return J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),wp(g,yp.B(a,null,null,536870912),yp.B(a,null,null,2147483647))):wp(g,yp.B(a,null,null,536870912),yp.B(a,null,null,2147483647)):r(c)?null!=d?r(e)?r(nq.b?nq.b(this,c):nq.call(null,
this,c))?Yf(function(a,b,c,d,e){return function(a){return J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),wp(k,yp.B(0,c,d,536870912),yp.B(2147483647,c,d,2147483647))):Yf(function(a,b,c,d,e){return function(a){return J.b(d,a.v)&&J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),wp(h,yp.B(0,c,null,536870912),yp.B(2147483647,c,null,2147483647))):r(nq.b?nq.b(this,c):nq.call(null,this,c))?wp(k,yp.B(0,c,d,536870912),yp.B(2147483647,c,d,2147483647)):Yf(function(a,b,c,d){return function(a){return J.b(d,a.v)}}(b,a,c,d,
e,g,h,k,this),wp(h,yp.B(0,c,null,536870912),yp.B(2147483647,c,null,2147483647))):r(e)?Yf(function(a,b,c,d,e){return function(a){return J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),wp(h,yp.B(0,c,null,536870912),yp.B(2147483647,c,null,2147483647))):wp(h,yp.B(0,c,null,536870912),yp.B(2147483647,c,null,2147483647)):null!=d?r(e)?Yf(function(a,b,c,d,e){return function(a){return J.b(d,a.v)&&J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),g):Yf(function(a,b,c,d){return function(a){return J.b(d,a.v)}}(b,a,c,d,e,g,
h,k,this),g):r(e)?Yf(function(a,b,c,d,e){return function(a){return J.b(e,a.ja(null))}}(b,a,c,d,e,g,h,k,this),g):g};function qq(a,b,c,d,e,g){this.$a=a;this.gb=b;this.hash=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}f=qq.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "unfiltered-db":return this.$a;case "pred":return this.gb;case "hash":return this.hash;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.db.FilteredDB{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[Bn,this.$a],null),new U(null,2,5,V,[vk,this.gb],null),new U(null,2,5,V,[nk,this.hash],null)],null),this.g))};
f.W=function(){return new Og(this,3,new U(null,3,5,V,[Bn,vk,nk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-351969977^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.$a,b.$a)&&J.b(this.gb,b.gb)&&J.b(this.hash,b.hash)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[nk,null,vk,null,Bn,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new qq(this.$a,this.gb,this.hash,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Bn,b):S.call(null,Bn,b))?new qq(c,this.gb,this.hash,this.i,this.g,null):r(S.b?S.b(vk,b):S.call(null,vk,b))?new qq(this.$a,c,this.hash,this.i,this.g,null):r(S.b?S.b(nk,b):S.call(null,nk,b))?new qq(this.$a,this.gb,c,this.i,this.g,null):new qq(this.$a,this.gb,this.hash,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(Bn,this.$a),new W(vk,this.gb),new W(nk,this.hash)],null),this.g))};
f.S=function(a,b){return new qq(this.$a,this.gb,this.hash,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.Jd=n;f.M=function(){throw Error("-lookup is not supported on FilteredDB");};f.o=function(){throw Error("-lookup is not supported on FilteredDB");};f.ka=n;f.L=function(a,b,c){return hq.f?hq.f(this,b,c):hq.call(null,this,b,c)};f.dd=n;f.P=function(){return L($p(this,cm,Cd))};f.Hd=n;f.O=function(){return rq.c?rq.c(this):rq.call(null,this)};
f.C=function(a,b){return jq.b?jq.b(this,b):jq.call(null,this,b)};f.ed=n;f.ia=function(){throw Error("-empty is not supported on FilteredDB");};f.I=function(){throw Error("-assoc is not supported on FilteredDB");};f.Tc=n;f.N=function(){return $p(this,cm,Cd)};f.nd=function(a,b,c){return Yf(this.gb,$p(this.$a,b,c))};f.pd=function(a,b,c){return Yf(this.gb,aq(this.$a,b,c))};f.od=function(a,b,c,d){return Yf(this.gb,bq(this.$a,b,c,d))};f.kd=n;f.md=function(){return dq(this.$a)};
f.ld=function(a,b){return eq(this.$a,b)};f.Pd=n;f.qd=function(a,b){return Yf(this.gb,Zp(this.$a,b))};
function sq(a,b){switch(b instanceof H?b.X:null){case "db.unique/identity":return new U(null,3,5,V,[lk,Vj,ak],null);case "db.unique/value":return new U(null,3,5,V,[lk,im,ak],null);case "db.cardinality/many":return new U(null,1,5,V,[Mn],null);case "db.type/ref":return new U(null,2,5,V,[bl,ak],null);default:if(!0===b)switch(a instanceof H?a.X:null){case "db/isComponent":return new U(null,1,5,V,[Ll],null);case "db/index":return new U(null,1,5,V,[ak],null);default:return Cd}else return null}}
function tq(a){return je(function(a,c,d){return je(function(a,b,d){return A(function(a,b){return P.f(a,b,Bd.b(F.f(a,b,Wh),c))},a,sq(b,d))},a,d)},pf,a)}function uq(a,b,c,d){if(null!=c&&!Zd(d,c))throw vj(["Bad attribute specification for ",Di.h(M([Gd([a,Gd([b,c])])])),", expected one of ",t.c(d)].join(""),new q(null,4,[qn,vn,Pj,a,yk,b,dl,c],null));}
function vq(a){a=I(a);for(var b=null,c=0,d=0;;)if(d<c){var e=b.Z(null,d),g=O(e,0),h=O(e,1),k=Ll.b(h,!1);uq(g,Ll,Ll.c(h),new Uh(null,new q(null,2,[!0,null,!1,null],null),null));if(r(function(){var a=k;return r(a)?lf.b(Qk.c(h),bl):a}()))throw vj(["Bad attribute specification for ",t.c(g),": {:db/isComponent true} should also have {:db/valueType :db.type/ref}"].join(""),new q(null,3,[qn,vn,Pj,g,yk,Ll],null));uq(g,lk,lk.c(h),new Uh(null,new q(null,2,[Vj,null,im,null],null),null));uq(g,Qk,Qk.c(h),new Uh(null,
new q(null,1,[bl,null],null),null));uq(g,$m,$m.c(h),new Uh(null,new q(null,2,[Mn,null,mo,null],null),null));d+=1}else if(a=I(a)){if(Ud(a))b=tc(a),a=uc(a),g=b,c=L(b),b=g;else{b=x(a);g=O(b,0);h=O(b,1);var l=Ll.b(h,!1);uq(g,Ll,Ll.c(h),new Uh(null,new q(null,2,[!0,null,!1,null],null),null));if(r(function(){var a=l;return r(a)?lf.b(Qk.c(h),bl):a}()))throw vj(["Bad attribute specification for ",t.c(g),": {:db/isComponent true} should also have {:db/valueType :db.type/ref}"].join(""),new q(null,3,[qn,vn,
Pj,g,yk,Ll],null));uq(g,lk,lk.c(h),new Uh(null,new q(null,2,[Vj,null,im,null],null),null));uq(g,Qk,Qk.c(h),new Uh(null,new q(null,1,[bl,null],null),null));uq(g,$m,$m.c(h),new Uh(null,new q(null,2,[Mn,null,mo,null],null),null));a=y(a);b=null;c=0}d=0}else break}function lq(a){switch(arguments.length){case 0:return kq(null);case 1:return kq(arguments[0]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}}
function kq(a){vq(a);return gq(new q(null,8,[Jj,a,In,tq(Qh.h(M([new q(null,1,[pn,new q(null,1,[lk,Vj],null)],null),a]))),cm,Ap(Rp),uk,Ap(Sp),Sk,Ap(Tp),nl,0,dk,536870912,nk,Cf(0)],null))}function wq(a){a=Vl.c(x(xp(a)));return r(a)?a:0}function xq(a){switch(arguments.length){case 1:return yq(arguments[0],null);case 2:return yq(arguments[0],arguments[1]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}}
function yq(a,b){vq(b);var c=tq(Qh.h(M([new q(null,1,[pn,new q(null,1,[lk,Vj],null)],null),b]))),d=ak.c(c),e=a instanceof Array?a:Ho(a),g=e.sort(Vp),h=zp(Rp,e),k=e.sort(Wp),l=zp(Sp,e),m=Yf(function(a,b){return function(a){return Zd(b,a.a)}}(c,d,e,g,h,k,l),a),p=fe(m),u=p.sort(Xp);a=zp(Tp,p);var w=wq(h);d=le(Nf.c(function(){return function(a){return a.ja(null)}}(c,d,e,g,h,k,l,m,p,u,a,w)),ve,536870912,h);return gq(new q(null,8,[Jj,b,In,c,cm,h,uk,l,Sk,a,nl,w,dk,d,nk,Cf(0)],null))}
function iq(a){var b=Rb(a.hash);return 0===b?Hf(a.hash,Fp(Oc(a.Ya),Oc(a.Ha))):b}function rq(a){var b=Rb(a.hash);(function(){var b=$p(a,cm,Cd);return r(b)?b:Wh})();return 0===b?(b=function(){var b=$p(a,cm,Cd);return r(b)?b:Wh}(),Hf(a.hash,Fp(Oc(dq(a)),bd(b)))):b}function jq(a,b){var c;if(c=(b instanceof fq||b instanceof qq)&&J.b(dq(a),dq(b)))a:for(a=$p(a,cm,Cd),c=$p(b,cm,Cd),b=I(a),a=I(c);;){if(null==b){c=null==a;break a}if(J.b(x(b),x(a)))b=y(b),a=y(a);else{c=!1;break a}}return c}
function hq(a,b,c){ic(b,"#datascript/DB {");ic(b,":schema ");wi(dq(a),b,c);ic(b,", :datoms ");X(b,function(a,b,c){return X(b,wi,"["," ","]",c,new U(null,4,5,V,[a.e,a.a,a.v,Gp(a)],null))},"["," ","]",c,$p(a,cm,Cd));return ic(b,"}")}
function pq(a,b,c,d,e,g,h){if(r(c)){var k=new Dd(null,Xm,new Dd(null,Kl,new Dd(null,b,new Dd(null,c,new Dd(null,d,new Dd(null,e,null,1,null),2,null),3,null),4,null),5,null),6,null);oq.b?oq.b(c,k):oq.call(null,c,k)}return yp.B(function(){var c=zq.b?zq.b(a,b):zq.call(null,a,b);return r(c)?c:g}(),c,r(function(){var b=null!=d;return b?Aq.b?Aq.b(a,c):Aq.call(null,a,c):b}())?Bq.b?Bq.b(a,d):Bq.call(null,a,d):d,function(){var b=zq.b?zq.b(a,e):zq.call(null,a,e);return r(b)?b:h}())}
function mq(a,b,c,d,e){var g=O(c,0),h=O(c,1),k=O(c,2);c=O(c,3);b=b instanceof H?b.X:null;switch(b){case "eavt":return pq(a,g,h,k,c,d,e);case "aevt":return pq(a,h,g,k,c,d,e);case "avet":return pq(a,k,g,h,c,d,e);default:throw Error(["No matching clause: ",t.c(b)].join(""));}}function Cq(a,b,c,d,e,g,h,k){this.sb=a;this.rb=b;this.wb=c;this.vb=d;this.xb=e;this.i=g;this.g=h;this.j=k;this.m=2230716170;this.F=139264}f=Cq.prototype;f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "db-before":return this.sb;case "db-after":return this.rb;case "tx-data":return this.wb;case "tempids":return this.vb;case "tx-meta":return this.xb;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.db.TxReport{",", ","}",c,T.b(new U(null,5,5,V,[new U(null,2,5,V,[nm,this.sb],null),new U(null,2,5,V,[Gk,this.rb],null),new U(null,2,5,V,[om,this.wb],null),new U(null,2,5,V,[Ij,this.vb],null),new U(null,2,5,V,[Kn,this.xb],null)],null),this.g))};f.W=function(){return new Og(this,5,new U(null,5,5,V,[nm,Gk,om,Ij,Kn],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 5+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-2022644885^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.sb,b.sb)&&J.b(this.rb,b.rb)&&J.b(this.wb,b.wb)&&J.b(this.vb,b.vb)&&J.b(this.xb,b.xb)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,5,[Ij,null,Gk,null,nm,null,om,null,Kn,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Cq(this.sb,this.rb,this.wb,this.vb,this.xb,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(nm,b):S.call(null,nm,b))?new Cq(c,this.rb,this.wb,this.vb,this.xb,this.i,this.g,null):r(S.b?S.b(Gk,b):S.call(null,Gk,b))?new Cq(this.sb,c,this.wb,this.vb,this.xb,this.i,this.g,null):r(S.b?S.b(om,b):S.call(null,om,b))?new Cq(this.sb,this.rb,c,this.vb,this.xb,this.i,this.g,null):r(S.b?S.b(Ij,b):S.call(null,Ij,b))?new Cq(this.sb,this.rb,this.wb,c,this.xb,this.i,this.g,null):r(S.b?S.b(Kn,b):S.call(null,Kn,b))?new Cq(this.sb,this.rb,this.wb,this.vb,c,this.i,this.g,
null):new Cq(this.sb,this.rb,this.wb,this.vb,this.xb,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,5,5,V,[new W(nm,this.sb),new W(Gk,this.rb),new W(om,this.wb),new W(Ij,this.vb),new W(Kn,this.xb)],null),this.g))};f.S=function(a,b){return new Cq(this.sb,this.rb,this.wb,this.vb,this.xb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function Dq(a,b,c){return Zd(eq(a,c),b)}function Aq(a,b){return Dq(a,b,bl)}
function nq(a,b){return Dq(a,b,ak)}
function Eq(a,b){for(;;){if("number"===typeof b&&0<b)return b;if(Qd(b)){var c=b,d=O(c,0);c=O(c,1);if(lf.b(L(b),2))throw vj(["Lookup ref should contain 2 elements: ",Di.h(M([b]))].join(""),new q(null,2,[qn,Sm,El,b],null));if(Dq(a,d,lk))return null==c?null:Vl.c(x($p(a,Sk,b)));throw vj(["Lookup ref attribute should be marked as :db/unique: ",Di.h(M([b]))].join(""),new q(null,2,[qn,Tj,El,b],null));}if(ab(b))b=M(b);else{if(b instanceof H)return Vl.c(x($p(a,Sk,new U(null,2,5,V,[pn,b],null))));throw vj(["Expected number or lookup ref for entity id, got ",
Di.h(M([b]))].join(""),new q(null,2,[qn,Wm,El,b],null));}}}function Bq(a,b){a=Eq(a,b);if(r(a))return a;throw vj(["Nothing found for entity id ",Di.h(M([b]))].join(""),new q(null,2,[qn,hn,El,b],null));}function zq(a,b){return r(b)?Bq(a,b):null}function oq(a,b){if(a instanceof H||"string"===typeof a)return null;throw vj(["Bad entity attribute ",Di.h(M([a]))," at ",Di.h(M([b])),", expected keyword or string"].join(""),new q(null,3,[qn,Nn,Pj,a,kn,b],null));}
function Fq(a,b){if(null==a)throw vj(["Cannot store nil as a value at ",Di.h(M([b]))].join(""),new q(null,3,[qn,Nn,dl,a,kn,b],null));return null}function Gq(a){return dg(a,new U(null,2,5,V,[nm,dk],null))+1}function Hq(a){return J.b(a,Om)||J.b(a,":db/current-tx")||J.b(a,"datomic.tx")||J.b(a,"datascript.tx")}function Iq(a){return"number"===typeof a&&0>a||"string"===typeof a}function Jq(a,b){return b>nl.c(a)&&536870912>b?P.f(a,nl,b):a}
function Kq(a,b,c){a=Hq(b)?eg(a,new U(null,2,5,V,[Ij,b],null),c):a;b=Iq(b)?eg(a,new U(null,2,5,V,[Ij,b],null),c):a;return fg.B(b,new U(null,1,5,V,[Gk],null),Jq,c)}
function Lq(a,b){var c=0<b.tx;c=r(c)?Dq(a,b.a,lk):c;if(r(c)&&(c=mf($p(a,Sk,new U(null,2,5,V,[b.a,b.v],null))),null!=c))throw vj(["Cannot add ",Di.h(M([b]))," because of unique constraint: ",Di.h(M([c]))].join(""),new q(null,3,[qn,yj,Pj,b.a,Dk,b],null));c=nq(a,b.a);if(r(0<b.tx))return a=fg.V(a,new U(null,1,5,V,[cm],null),gp,b,Vp),a=fg.V(a,new U(null,1,5,V,[uk],null),gp,b,Wp),c=c?fg.V(a,new U(null,1,5,V,[Sk],null),gp,b,Xp):a,b=Jq(c,b.e),P.f(b,nk,Cf(0));b=x(Zp(a,new U(null,3,5,V,[b.e,b.a,b.v],null)));
if(null==b)return a;a=fg.V(a,new U(null,1,5,V,[cm],null),fp,b,Vp);a=fg.V(a,new U(null,1,5,V,[uk],null),fp,b,Wp);b=c?fg.V(a,new U(null,1,5,V,[Sk],null),fp,b,Xp):a;return P.f(b,nk,Cf(0))}function Mq(a,b){return fg.B(fg.B(a,new U(null,1,5,V,[Gk],null),Lq,b),new U(null,1,5,V,[om],null),Bd,b)}
function Nq(a){if(a instanceof H)return J.b("_",pd(Me(a),0));if("string"===typeof a)return Yd(ni(/(?:([^\/]+)\/)?_([^\/]+)/,a));throw vj(["Bad attribute type: ",Di.h(M([a])),", expected keyword or string"].join(""),new q(null,2,[qn,Nn,Pj,a],null));}
function Oq(a){if(a instanceof H)return Nq(a)?Le.b(Ke(a),De.b(Me(a),1)):Le.b(Ke(a),["_",Me(a)].join(""));if("string"===typeof a){var b=ni(/(?:([^\/]+)\/)?([^\/]+)/,a);O(b,0);a=O(b,1);b=O(b,2);return J.b("_",pd(b,0))?r(a)?[t.c(a),"/",t.c(De.b(b,1))].join(""):De.b(b,1):r(a)?[t.c(a),"/_",t.c(b)].join(""):["_",t.c(b)].join("")}throw vj(["Bad attribute type: ",Di.h(M([a])),", expected keyword or string"].join(""),new q(null,2,[qn,Nn,Pj,a],null));}
function Pq(a,b){var c=O(b,0),d=O(b,1),e=O(b,2),g=gn.c(a);if(null==g||Iq(g)||null==b||g===c)return b;throw vj(["Conflicting upsert: ",Di.h(M([new U(null,2,5,V,[d,e],null)]))," resolves to ",Di.h(M([c])),", but entity already has :db/id ",Di.h(M([g]))].join(""),new q(null,3,[qn,Ul,ao,a,to,b],null));}
function Qq(a,b){var c=mf(eq(a,Vj));return null==c?null:x(Pq(b,je(function(c){return function(d,g,h){if(Zd(c,g)){var e=Vl.c(x($p(a,Sk,new U(null,2,5,V,[g,h],null))));if(null==e)return d;if(null==d)return new U(null,3,5,V,[e,g,h],null);if(J.b(F.b(d,0),e))return d;var l=O(d,0),m=O(d,1);d=O(d,2);throw vj(["Conflicting upserts: ",Di.h(M([new U(null,2,5,V,[m,d],null)]))," resolves to ",Di.h(M([l])),", but ",Di.h(M([new U(null,2,5,V,[g,h],null)]))," resolves to ",Di.h(M([e]))].join(""),new q(null,4,[qn,
Ul,ao,b,to,new U(null,3,5,V,[e,g,h],null),io,new U(null,3,5,V,[l,m,d],null)],null));}return d}}(c,c),null,b)))}function Rq(a,b,c){return Nq(b)||Dq(a,b,Mn)?c instanceof Array||Od(c)&&!Rd(c)?J.b(L(c),2)&&Dq(a,x(c),Vj)?new U(null,1,5,V,[c],null):c:new U(null,1,5,V,[c],null):new U(null,1,5,V,[c],null)}
function Sq(a,b){return function(b){return function g(c){return new Ne(null,function(b){return function(){for(var e=c;;){var h=I(e);if(h){var m=h,p=x(m),u=O(p,0),w=O(p,1);if(lf.b(u,gn)){var z=oq(u,Gd([gn,b,u,w])),D=Nq(u),C=D?Oq(u):u;if(D&&!Aq(a,C))throw vj(["Bad attribute ",Di.h(M([u])),": reverse attribute name requires {:db/valueType :db.type/ref} in schema"].join(""),new q(null,3,[qn,Nn,Pj,u,kn,Gd([gn,b,u,w])],null));if(h=I(function(b,c,e,g,h,k,l,m,p,u,w){return function Ja(z){return new Ne(null,
function(b,c,e,g,h,k,l,m,p,u,w){return function(){for(;;){var b=I(z);if(b){if(Ud(b)){var c=tc(b),h=L(c),k=Re(h);a:for(var m=0;;)if(m<h){var p=B.b(c,m);p=Aq(a,g)&&Rd(p)?P.f(p,Oq(l),w):e?new U(null,4,5,V,[wn,p,g,w],null):new U(null,4,5,V,[wn,w,g,p],null);k.add(p);m+=1}else{c=!0;break a}return c?Te(k.aa(),Ja(uc(b))):Te(k.aa(),null)}k=x(b);return ud(Aq(a,g)&&Rd(k)?P.f(k,Oq(l),w):e?new U(null,4,5,V,[wn,k,g,w],null):new U(null,4,5,V,[wn,w,g,k],null),Ja(Vc(b)))}return null}}}(b,c,e,g,h,k,l,m,p,u,w),null,
null)}}(e,z,D,C,null,p,u,w,m,h,b)(Rq(a,u,w))))return T.b(h,g(Vc(e)))}e=Vc(e)}else return null}}}(b),null,null)}}(gn.c(b))(b)}function Tq(a,b){O(b,0);var c=O(b,1),d=O(b,2),e=O(b,3),g=O(b,4);oq(d,b);Fq(e,b);b=r(g)?g:Gq(a);g=Gk.c(a);c=Bq(g,c);e=Aq(g,d)?Bq(g,e):e;var h=yp.B(c,d,e,b);if(Dq(g,d,Mn))return Nd(Zp(g,new U(null,3,5,V,[c,d,e],null)))?Mq(a,h):a;g=x(Zp(g,new U(null,2,5,V,[c,d],null)));return null==g?Mq(a,h):J.b(g.v,e)?a:Mq(Mq(a,yp.V(c,d,g.v,b,!1)),h)}
function Uq(a,b){var c=Gq(a);return Mq(a,yp.V(b.e,b.a,b.v,c,!1))}function Vq(a,b){return $f.f(Wh,xf.b(Xf(function(b){return Dq(a,b.a,Ll)}),Nf.c(function(a){return new U(null,2,5,V,[em,a.v],null)})),b)}function Wq(a,b,c,d,e){if(Zd(Ij.c(a),d))throw vj(["Conflicting upsert: ",Di.h(M([d]))," resolves both to ",Di.h(M([e]))," and ",Di.h(M([dg(a,new U(null,2,5,V,[Ij,d],null))]))].join(""),new q(null,1,[qn,Ul],null));b=P.f(Ij.c(b),d,e);a=P.f(a,Ij,b);return Xq.b?Xq.b(a,c):Xq.call(null,a,c)}
var Yq=new Uh(null,new q(null,8,[Sl,null,Tl,null,em,null,qm,null,rm,null,Rm,null,Tm,null,wn,null],null),null);
function Xq(a,b){if(null!=b&&!Qd(b))throw vj(["Bad transaction data ",Di.h(M([b])),", expected sequential collection"].join(""),new q(null,2,[qn,Nn,om,b],null));for(var c=gg(a,Gk,Ze),d=b;;){var e=d,g=I(e),h=x(g),k=y(g),l=h,m=k,p=Gk.c(c),u=c,w=null!=u&&(u.m&64||n===u.Ga)?jf(Ff,u):u,z=F.b(w,Ij);if(Nd(d))return gg(fg.f(eg(c,new U(null,2,5,V,[Ij,Om],null),Gq(c)),new U(null,2,5,V,[Gk,dk],null),dd),Gk,$e);if(null==l)d=m;else if(Rd(l)){var D=gn.c(l);if(Hq(D)){var C=Gq(c);c=Kq(c,D,C);d=m=ud(P.f(l,gn,C),m)}else if(Qd(D))C=
Bq(p,D),d=m=ud(P.f(l,gn,C),m);else{var G=Qq(p,l);if(null!=G){if(Iq(D)&&Zd(z,D)&&lf.b(G,F.b(z,D)))return Wq(a,c,b,D,G);c=Kq(c,D,G);d=m=T.b(Sq(p,P.f(l,gn,G)),m)}else if("number"===typeof D||null==D||"string"===typeof D)C=null==D?nl.c(p)+1:Iq(D)?function(){var a=F.b(z,D);return r(a)?a:nl.c(p)+1}():D,l=P.f(l,gn,C),c=Kq(c,D,C),d=m=T.b(Sq(p,l),m);else throw vj(["Expected number, string or lookup ref for :db/id, got ",Di.h(M([D]))].join(""),new q(null,2,[qn,Wm,ao,l],null));}}else if(Qd(l)){var N=l,K=O(N,
0),Y=O(N,1);C=O(N,2);var ma=O(N,3);if(J.b(K,Sl)){C=I(l);l=x(C);C=y(C);var ya=l;l=x(C);C=y(C);d=m=T.b(lb(l,p,C),m)}else if(K instanceof H&&db(Yq.c?Yq.c(K):Yq.call(null,K))){ya=Eq(p,K);if(null==ya)throw vj(["Can’t find entity for transaction fn ",Di.h(M([K]))].join(""),new q(null,3,[qn,Nn,il,Sl,om,l],null));Y=ik.c(x(Zp(p,new U(null,2,5,V,[ya,Wj],null))));C=y(l);if(Hd(Y))d=m=T.b(lb(Y,p,C),m);else throw vj(["Entity ",Di.h(M([K]))," expected to have :db/fn attribute with fn? value"].join(""),new q(null,
3,[qn,Nn,il,Sl,om,l],null));}else{if(Iq(Y)&&lf.b(K,wn))throw vj(["Can't use tempid in '",Di.h(M([l])),"'. Tempids are allowed in :db/add only"].join(""),new q(null,2,[qn,Nn,Gl,l],null));if(J.b(K,Tm)||J.b(K,Tl)){var R=l;ya=O(R,0);var ta=O(R,1),ca=O(R,2),Ea=O(R,3),Da=O(R,4),Ba=Bq(p,ta),Za=oq(ca,l),Ja=Aq(p,ca)?Bq(p,Ea):Ea,Ta=Aq(p,ca)?Bq(p,Da):Da,bb=Fq(Ta,l),Na=yg(Zp(p,new U(null,2,5,V,[Ba,ca],null)));if(Dq(p,ca,Mn))if(r(uf(function(a,b,c,d,e,g,h,k,l,m,p){return function(a){return J.b(a.v,p)}}(c,d,R,
ya,ta,ca,Ea,Da,Ba,Za,Ja,Ta,bb,Na,N,K,Y,C,ma,e,g,h,k,l,m,p,u,w,z),Na)))c=Tq(c,new U(null,4,5,V,[wn,Ba,ca,Ta],null)),d=m;else throw vj([":db.fn/cas failed on datom [",Di.h(M([Ba]))," ",Di.h(M([ca]))," ",Di.h(M([Nf.b(ik,Na)])),"], expected ",Di.h(M([Ja]))].join(""),new q(null,4,[qn,Rj,uo,Na,an,Ja,Nk,Ta],null));else if(K=ik.c(x(Na)),J.b(K,Ja))c=Tq(c,new U(null,4,5,V,[wn,Ba,ca,Ta],null)),d=m;else throw vj([":db.fn/cas failed on datom [",Di.h(M([Ba]))," ",Di.h(M([ca]))," ",Di.h(M([K])),"], expected ",Di.h(M([Ja]))].join(""),
new q(null,4,[qn,Rj,uo,x(Na),an,Ja,Nk,Ta],null));}else if(Hq(Y))l=Kq(c,Y,Gq(c)),m=ud(new U(null,4,5,V,[K,Gq(c),C,ma],null),m),c=l,d=m;else if(Aq(p,C)&&Hq(ma))l=Kq(c,ma,Gq(c)),m=ud(new U(null,4,5,V,[K,Y,C,Gq(c)],null),m),c=l,d=m;else if(Aq(p,C)&&Iq(ma))ya=F.b(z,ma),null==ya?(c=Kq(c,ma,nl.c(p)+1),d=m=d):d=m=ud(new U(null,4,5,V,[K,Y,C,ya],null),m);else if(Iq(Y)){G=Dq(p,C,Vj)?Vl.c(x($p(p,Sk,new U(null,2,5,V,[C,ma],null)))):null;var pb=F.b(z,Y);if(r(function(){var a=G;return r(a)?(a=pb,r(a)?lf.b(G,pb):
a):a}()))return Wq(a,c,b,Y,G);l=function(){var a=G;if(r(a))return a;a=pb;return r(a)?a:nl.c(p)+1}();c=Kq(c,Y,l);d=m=ud(new U(null,4,5,V,[K,l,C,ma],null),m)}else if(J.b(K,wn))c=Tq(c,l),d=m;else if(J.b(K,rm))ya=Eq(p,Y),null==ya?d=m:(ta=ya,K=Aq(p,C)?Bq(p,ma):ma,oq(C,l),Fq(K,l),C=x(Zp(p,new U(null,3,5,V,[ta,C,K],null))),null==C?d=m:(c=Uq(c,C),d=m));else if(J.b(K,Rm))ya=Eq(p,Y),null==ya?d=m:(ta=ya,ya=oq(C,l),Na=yg(Zp(p,new U(null,2,5,V,[ta,C],null))),c=A(Uq,c,Na),d=m=T.b(Vq(p,Na),m));else if(J.b(K,em)||
J.b(K,qm))ya=Eq(p,Y),null==ya?d=m:(ta=ya,Na=yg(Zp(p,new U(null,1,5,V,[ta],null))),C=yg(Wf(function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,D,C,G){return function(a){return Zp(G,new U(null,3,5,V,[null,a,d],null))}}(c,d,Na,ta,ya,N,K,Y,C,ma,e,g,h,k,l,m,p,u,w,z),M([eq(p,bl)]))),c=A(Uq,c,T.b(Na,C)),d=m=T.b(Vq(p,Na),m));else throw vj(["Unknown operation at ",Di.h(M([l])),", expected :db/add, :db/retract, :db.fn/call, :db.fn/retractAttribute, :db.fn/retractEntity or an ident corresponding to an installed transaction function (e.g. {:db/ident \x3ckeyword\x3e :db/fn \x3cIfn\x3e}, usage of :db/ident requires {:db/unique :db.unique/identity} in schema)"].join(""),
new q(null,3,[qn,Nn,il,K,om,l],null));}}else if(l instanceof Hp)K=l,Y=O(K,0),C=O(K,1),ma=O(K,2),l=O(K,3),K=O(K,4),r(K)?(c=Tq(c,new U(null,5,5,V,[wn,Y,C,ma,l],null)),d=m):d=m=ud(new U(null,4,5,V,[rm,Y,C,ma],null),m);else throw vj(["Bad entity type at ",Di.h(M([l])),", expected map or vector"].join(""),new q(null,2,[qn,Nn,om,l],null));}};function Zq(){}var $q=function $q(a,b,c){if(null!=a&&null!=a.ra)return a.ra(a,b,c);var e=$q[ba(null==a?null:a)];if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);e=$q._;if(null!=e)return e.f?e.f(a,b,c):e.call(null,a,b,c);throw gb("ITraversable.-collect",a);},ar=function ar(a,b){if(null!=a&&null!=a.sa)return a.sa(a,b);var d=ar[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=ar._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("ITraversable.-collect-vars",a);};
function br(a,b){return Qd(a)&&J.b(L(a),b)}function cr(a,b){return Qd(b)?A(function(b,d){d=a.c?a.c(d):a.call(null,d);return r(d)?Bd.b(b,d):new ed(null)},Cd,b):null}function dr(a,b){return er(a,b,Cd)}function er(a,b,c){return r(a.c?a.c(b):a.call(null,b))?Bd.b(c,b):(null!=b?n===b.qa||(b.gc?0:eb(Zq,b)):eb(Zq,b))?$q(b,a,c):Ep(b)?A(function(b,c){return er(a,c,b)},c,b):c}function fr(a){var b=Nd(a);return b?b:jf($d,a)}function gr(a,b){return Kd(a,new q(null,1,[Il,b],null))}
function hr(a){var b=Il.c(Ld(a));return r(b)?b:a}function ir(a,b,c){this.i=a;this.g=b;this.j=c;this.m=2230716170;this.F=139264}f=ir.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return F.f(this.g,b,c)};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Placeholder{",", ","}",c,T.b(Cd,this.g))};f.W=function(){return new Og(this,0,Cd,r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 0+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-528488587^bd(a)}}(b,a)(a)}();return this.j=c};
f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(Wh,b)?Q.b(Ub($f.b(pf,this),this.i),b):new ir(this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return new ir(this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(Cd,this.g))};f.S=function(a,b){return new ir(b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return c};f.sa=function(a,b){return b};
function jr(a,b,c,d){this.ea=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=jr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "symbol":return this.ea;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Variable{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Rk,this.ea],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Rk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 736891289^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ea,b.ea)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Rk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new jr(this.ea,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Rk,b):S.call(null,Rk,b))?new jr(c,this.i,this.g,null):new jr(this.ea,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Rk,this.ea)],null),this.g))};f.S=function(a,b){return new jr(this.ea,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.ea,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.ea):Z.call(null,b,this.ea)};
function kr(a,b,c,d){this.ea=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=kr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "symbol":return this.ea;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.SrcVar{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Rk,this.ea],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Rk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1648766309^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ea,b.ea)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Rk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new kr(this.ea,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Rk,b):S.call(null,Rk,b))?new kr(c,this.i,this.g,null):new kr(this.ea,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Rk,this.ea)],null),this.g))};f.S=function(a,b){return new kr(this.ea,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.ea,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.ea):Z.call(null,b,this.ea)};
function lr(a,b,c){this.i=a;this.g=b;this.j=c;this.m=2230716170;this.F=139264}f=lr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return F.f(this.g,b,c)};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.DefaultSrc{",", ","}",c,T.b(Cd,this.g))};
f.W=function(){return new Og(this,0,Cd,r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 0+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-350962559^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(Wh,b)?Q.b(Ub($f.b(pf,this),this.i),b):new lr(this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return new lr(this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(Cd,this.g))};f.S=function(a,b){return new lr(b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return c};f.sa=function(a,b){return b};function mr(a,b,c){this.i=a;this.g=b;this.j=c;this.m=2230716170;this.F=139264}f=mr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return F.f(this.g,b,c)};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.RulesVar{",", ","}",c,T.b(Cd,this.g))};f.W=function(){return new Og(this,0,Cd,r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 0+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1504050517^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(Wh,b)?Q.b(Ub($f.b(pf,this),this.i),b):new mr(this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return new mr(this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(Cd,this.g))};f.S=function(a,b){return new mr(b,this.g,this.j)};
f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return c};f.sa=function(a,b){return b};function nr(a,b,c,d){this.value=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=nr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "value":return this.value;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Constant{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[dl,this.value],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[dl],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-812884714^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.value,b.value)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[dl,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new nr(this.value,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(dl,b):S.call(null,dl,b))?new nr(c,this.i,this.g,null):new nr(this.value,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(dl,this.value)],null),this.g))};f.S=function(a,b){return new nr(this.value,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.value,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.value):Z.call(null,b,this.value)};
function or(a,b,c,d){this.ea=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=or.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "symbol":return this.ea;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.PlainSymbol{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Rk,this.ea],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Rk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 1509921913^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ea,b.ea)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Rk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new or(this.ea,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Rk,b):S.call(null,Rk,b))?new or(c,this.i,this.g,null):new or(this.ea,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Rk,this.ea)],null),this.g))};f.S=function(a,b){return new or(this.ea,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.ea,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.ea):Z.call(null,b,this.ea)};
function pr(a){return a instanceof E&&J.b(x(Me(a)),"?")?new jr(a,null,null,null):null}function qr(a){return a instanceof E&&J.b(x(Me(a)),"$")?new kr(a,null,null,null):null}function rr(a){return a instanceof E?null:new nr(a,null,null,null)}function tr(a){return a instanceof E&&db(pr(a))&&db(qr(a))&&db(J.b(Yl,a)?new mr(null,null,null):null)&&db(J.b(Pl,a)?new ir(null,null,null):null)?new or(a,null,null,null):null}function ur(a){return r(tr(a))?new jr(a,null,null,null):null}
function vr(a){var b=pr(a);if(r(b))return b;b=rr(a);return r(b)?b:qr(a)}function wr(a,b,c,d,e){this.required=a;this.Cb=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=wr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "required":return this.required;case "free":return this.Cb;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.RuleVars{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[no,this.required],null),new U(null,2,5,V,[Lk,this.Cb],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[no,Lk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 892963297^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.required,b.required)&&J.b(this.Cb,b.Cb)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Lk,null,no,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new wr(this.required,this.Cb,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(no,b):S.call(null,no,b))?new wr(c,this.Cb,this.i,this.g,null):r(S.b?S.b(Lk,b):S.call(null,Lk,b))?new wr(this.required,c,this.i,this.g,null):new wr(this.required,this.Cb,this.i,P.f(this.g,b,c),null)};
f.N=function(){return I(T.b(new U(null,2,5,V,[new W(no,this.required),new W(Lk,this.Cb)],null),this.g))};f.S=function(a,b){return new wr(this.required,this.Cb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.Cb,er(b,this.required,c))};f.sa=function(a,b){a=Z.b?Z.b(b,this.required):Z.call(null,b,this.required);b=this.Cb;return Z.b?Z.b(a,b):Z.call(null,a,b)};
function xr(a,b,c){this.i=a;this.g=b;this.j=c;this.m=2230716170;this.F=139264}f=xr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return F.f(this.g,b,c)};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.BindIgnore{",", ","}",c,T.b(Cd,this.g))};
f.W=function(){return new Og(this,0,Cd,r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 0+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-890522983^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(Wh,b)?Q.b(Ub($f.b(pf,this),this.i),b):new xr(this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return new xr(this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(Cd,this.g))};f.S=function(a,b){return new xr(b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return c};f.sa=function(a,b){return b};function yr(a,b,c,d){this.ya=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=yr.prototype;f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "variable":return this.ya;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.BindScalar{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[rk,this.ya],null)],null),this.g))};
f.W=function(){return new Og(this,1,new U(null,1,5,V,[rk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1522792445^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ya,b.ya)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[rk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new yr(this.ya,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(rk,b):S.call(null,rk,b))?new yr(c,this.i,this.g,null):new yr(this.ya,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(rk,this.ya)],null),this.g))};f.S=function(a,b){return new yr(this.ya,b,this.g,this.j)};
f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.ya,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.ya):Z.call(null,b,this.ya)};function zr(a,b,c,d){this.zb=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=zr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "bindings":return this.zb;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.BindTuple{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Pk,this.zb],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Pk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1637239347^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.zb,b.zb)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Pk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new zr(this.zb,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Pk,b):S.call(null,Pk,b))?new zr(c,this.i,this.g,null):new zr(this.zb,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Pk,this.zb)],null),this.g))};f.S=function(a,b){return new zr(this.zb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.zb,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.zb):Z.call(null,b,this.zb)};
function Ar(a,b,c,d){this.za=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=Ar.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "binding":return this.za;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.BindColl{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[um,this.za],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[um],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1930368089^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.za,b.za)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[um,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Ar(this.za,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(um,b):S.call(null,um,b))?new Ar(c,this.i,this.g,null):new Ar(this.za,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(um,this.za)],null),this.g))};f.S=function(a,b){return new Ar(this.za,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.za,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.za):Z.call(null,b,this.za)};
function Br(a){return J.b(Pl,a)?gr(new xr(null,null,null),a):null}function Cr(a){var b=Br(a);return r(b)?b:Dr.c?Dr.c(a):Dr.call(null,a)}function Er(a){var b=cr(Cr,a);if(r(b)){if(Nd(b))throw vj("Tuple binding cannot be empty",new q(null,2,[qn,un,zn,a],null));return gr(new zr(b,null,null,null),a)}return null}
function Dr(a){a:{if(br(a,2)&&J.b(xd(a),Wn)){var b=x(a);b=Dr.c?Dr.c(b):Dr.call(null,b);if(r(b)){b=gr(new Ar(b,null,null,null),a);break a}throw vj("Cannot parse collection binding",new q(null,2,[qn,un,zn,a],null));}b=null}if(r(b))return b;b=br(a,1)&&Qd(x(a))?gr(new Ar(Er(x(a)),null,null,null),a):null;if(r(b))return b;b=Er(a);if(r(b))return b;b=Br(a);if(r(b))return b;b=pr(a);b=r(b)?gr(new yr(b,null,null,null),a):null;if(r(b))return b;throw vj("Cannot parse binding, expected (bind-scalar | bind-tuple | bind-coll | bind-rel)",
new q(null,2,[qn,un,zn,a],null));}var Fr=function Fr(a){if(null!=a&&null!=a.Wc)return a.Wc(a);var c=Fr[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Fr._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IFindVars.-find-vars",a);};jr.prototype.Wc=function(){return new U(null,1,5,V,[this.ea],null)};function Gr(a,b,c,d,e){this.ca=a;this.Y=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=Gr.prototype;f.Wc=function(){return Fr(Ad(this.Y))};
f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "fn":return this.ca;case "args":return this.Y;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Aggregate{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[jk,this.ca],null),new U(null,2,5,V,[Aj,this.Y],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[jk,Aj],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-91097383^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ca,b.ca)&&J.b(this.Y,b.Y)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Aj,null,jk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Gr(this.ca,this.Y,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(jk,b):S.call(null,jk,b))?new Gr(c,this.Y,this.i,this.g,null):r(S.b?S.b(Aj,b):S.call(null,Aj,b))?new Gr(this.ca,c,this.i,this.g,null):new Gr(this.ca,this.Y,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(jk,this.ca),new W(Aj,this.Y)],null),this.g))};f.S=function(a,b){return new Gr(this.ca,this.Y,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;
f.ra=function(a,b,c){return er(b,this.Y,er(b,this.ca,c))};f.sa=function(a,b){a=Z.b?Z.b(b,this.ca):Z.call(null,b,this.ca);b=this.Y;return Z.b?Z.b(a,b):Z.call(null,a,b)};function Hr(a,b,c,d,e,g){this.source=a;this.ya=b;this.pattern=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}f=Hr.prototype;f.Wc=function(){return Fr(this.ya)};f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "source":return this.source;case "variable":return this.ya;case "pattern":return this.pattern;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Pull{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[Il,this.source],null),new U(null,2,5,V,[rk,this.ya],null),new U(null,2,5,V,[yo,this.pattern],null)],null),this.g))};f.W=function(){return new Og(this,3,new U(null,3,5,V,[Il,rk,yo],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-2108867663^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.source,b.source)&&J.b(this.ya,b.ya)&&J.b(this.pattern,b.pattern)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[rk,null,Il,null,yo,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Hr(this.source,this.ya,this.pattern,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Il,b):S.call(null,Il,b))?new Hr(c,this.ya,this.pattern,this.i,this.g,null):r(S.b?S.b(rk,b):S.call(null,rk,b))?new Hr(this.source,c,this.pattern,this.i,this.g,null):r(S.b?S.b(yo,b):S.call(null,yo,b))?new Hr(this.source,this.ya,c,this.i,this.g,null):new Hr(this.source,this.ya,this.pattern,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(Il,this.source),new W(rk,this.ya),new W(yo,this.pattern)],null),this.g))};
f.S=function(a,b){return new Hr(this.source,this.ya,this.pattern,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.pattern,er(b,this.ya,er(b,this.source,c)))};f.sa=function(a,b){a=Z.b?Z.b(b,this.source):Z.call(null,b,this.source);b=this.ya;a=Z.b?Z.b(a,b):Z.call(null,a,b);b=this.pattern;return Z.b?Z.b(a,b):Z.call(null,a,b)};
var Ir=function Ir(a){if(null!=a&&null!=a.Ec)return a.Ec(a);var c=Ir[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=Ir._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IFindElements.find-elements",a);};function Jr(a,b,c,d){this.elements=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=Jr.prototype;f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "elements":return this.elements;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.FindRel{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[$l,this.elements],null)],null),this.g))};
f.W=function(){return new Og(this,1,new U(null,1,5,V,[$l],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 744809563^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.elements,b.elements)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[$l,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Jr(this.elements,this.i,mf(Q.b(this.g,b)),null)};f.Ec=function(){return this.elements};f.I=function(a,b,c){return r(S.b?S.b($l,b):S.call(null,$l,b))?new Jr(c,this.i,this.g,null):new Jr(this.elements,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W($l,this.elements)],null),this.g))};f.S=function(a,b){return new Jr(this.elements,b,this.g,this.j)};
f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.elements,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.elements):Z.call(null,b,this.elements)};function Kr(a,b,c,d){this.element=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=Kr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "element":return this.element;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.FindColl{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[zk,this.element],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[zk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 124241361^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.element,b.element)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[zk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Kr(this.element,this.i,mf(Q.b(this.g,b)),null)};
f.Ec=function(){return new U(null,1,5,V,[this.element],null)};f.I=function(a,b,c){return r(S.b?S.b(zk,b):S.call(null,zk,b))?new Kr(c,this.i,this.g,null):new Kr(this.element,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(zk,this.element)],null),this.g))};f.S=function(a,b){return new Kr(this.element,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.element,c)};
f.sa=function(a,b){return Z.b?Z.b(b,this.element):Z.call(null,b,this.element)};function Lr(a,b,c,d){this.element=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=Lr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "element":return this.element;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.FindScalar{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[zk,this.element],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[zk],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-661542332^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.element,b.element)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[zk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Lr(this.element,this.i,mf(Q.b(this.g,b)),null)};f.Ec=function(){return new U(null,1,5,V,[this.element],null)};
f.I=function(a,b,c){return r(S.b?S.b(zk,b):S.call(null,zk,b))?new Lr(c,this.i,this.g,null):new Lr(this.element,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(zk,this.element)],null),this.g))};f.S=function(a,b){return new Lr(this.element,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.element,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.element):Z.call(null,b,this.element)};
function Mr(a,b,c,d){this.elements=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=Mr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "elements":return this.elements;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.FindTuple{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[$l,this.elements],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[$l],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 681530371^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.elements,b.elements)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[$l,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Mr(this.elements,this.i,mf(Q.b(this.g,b)),null)};f.Ec=function(){return this.elements};
f.I=function(a,b,c){return r(S.b?S.b($l,b):S.call(null,$l,b))?new Mr(c,this.i,this.g,null):new Mr(this.elements,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W($l,this.elements)],null),this.g))};f.S=function(a,b){return new Mr(this.elements,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.elements,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.elements):Z.call(null,b,this.elements)};
function Nr(a){return a instanceof Gr}function Or(a){return a instanceof Hr}
function Pr(a){var b=pr(a);if(r(b))return b;a:{if(Qd(a)&&J.b(x(a),Xj)){if(3<=L(a)&&4>=L(a)){var c=(b=J.b(L(a),4))?pd(a,1):Lm;b=b?y(y(a)):y(a);var d=O(b,0);b=O(b,1);c=qr(c);d=pr(d);var e=pr(b);r(e)?b=e:(e=ur(b),b=r(e)?e:rr(b));if(r(r(c)?r(d)?b:d:c)){b=new Hr(c,d,b,null,null,null);break a}}throw vj("Cannot parse pull expression, expect ['pull' src-var? variable (constant | variable | plain-symbol)]",new q(null,2,[qn,Oj,Jk,a],null));}b=null}if(r(b))return b;a:{if(Qd(a)&&J.b(x(a),Qj)){if(3<=L(a)&&(b=
I(a),x(b),c=y(b),b=x(c),c=y(c),b=pr(b),c=cr(vr,c),r(r(b)?c:b))){b=new Gr(b,c,null,null,null);break a}throw vj("Cannot parse custom aggregate call, expect ['aggregate' variable fn-arg+]",new q(null,2,[qn,Oj,Jk,a],null));}b=null}r(b)?a=b:Qd(a)&&2<=L(a)?(b=I(a),a=x(b),b=y(b),a=tr(a),b=cr(vr,b),a=r(r(a)?b:a)?new Gr(a,b,null,null,null):null):a=null;return a}
function Qr(a){var b=cr(Pr,a);b=null==b?null:new Jr(b,null,null,null);if(r(b))return b;a:{if(Qd(a)&&J.b(L(a),1)&&(b=x(a),Qd(b)&&J.b(L(b),2)&&J.b(xd(b),Wn))){b=Pr(x(b));b=null==b?null:new Kr(b,null,null,null);break a}b=null}if(r(b))return b;Qd(a)&&J.b(L(a),2)&&J.b(xd(a),Dn)?(b=Pr(x(a)),b=null==b?null:new Lr(b,null,null,null)):b=null;if(r(b))return b;Qd(a)&&J.b(L(a),1)?(b=x(a),b=cr(Pr,b),b=null==b?null:new Mr(b,null,null,null)):b=null;if(r(b))return b;throw vj("Cannot parse :find, expected: (find-rel | find-coll | find-tuple | find-scalar)",
new q(null,2,[qn,Oj,Jk,a],null));}function Rr(a){var b=qr(a);r(b)||(b=J.b(Yl,a)?new mr(null,null,null):null,b=r(b)?b:ur(a));return r(b)?gr(new yr(b,null,null,null),a):Dr(a)}function Sr(a,b,c,d,e){this.source=a;this.pattern=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=Sr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "source":return this.source;case "pattern":return this.pattern;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Pattern{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Il,this.source],null),new U(null,2,5,V,[yo,this.pattern],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Il,yo],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 575220587^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.source,b.source)&&J.b(this.pattern,b.pattern)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Il,null,yo,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Sr(this.source,this.pattern,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Il,b):S.call(null,Il,b))?new Sr(c,this.pattern,this.i,this.g,null):r(S.b?S.b(yo,b):S.call(null,yo,b))?new Sr(this.source,c,this.i,this.g,null):new Sr(this.source,this.pattern,this.i,P.f(this.g,b,c),null)};
f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Il,this.source),new W(yo,this.pattern)],null),this.g))};f.S=function(a,b){return new Sr(this.source,this.pattern,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.pattern,er(b,this.source,c))};f.sa=function(a,b){a=Z.b?Z.b(b,this.source):Z.call(null,b,this.source);b=this.pattern;return Z.b?Z.b(a,b):Z.call(null,a,b)};
function Tr(a,b,c,d,e){this.ca=a;this.Y=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=Tr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "fn":return this.ca;case "args":return this.Y;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Predicate{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[jk,this.ca],null),new U(null,2,5,V,[Aj,this.Y],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[jk,Aj],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1523376880^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ca,b.ca)&&J.b(this.Y,b.Y)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Aj,null,jk,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Tr(this.ca,this.Y,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(jk,b):S.call(null,jk,b))?new Tr(c,this.Y,this.i,this.g,null):r(S.b?S.b(Aj,b):S.call(null,Aj,b))?new Tr(this.ca,c,this.i,this.g,null):new Tr(this.ca,this.Y,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(jk,this.ca),new W(Aj,this.Y)],null),this.g))};f.S=function(a,b){return new Tr(this.ca,this.Y,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;
f.ra=function(a,b,c){return er(b,this.Y,er(b,this.ca,c))};f.sa=function(a,b){a=Z.b?Z.b(b,this.ca):Z.call(null,b,this.ca);b=this.Y;return Z.b?Z.b(a,b):Z.call(null,a,b)};function Ur(a,b,c,d,e,g){this.ca=a;this.Y=b;this.za=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}f=Ur.prototype;f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "fn":return this.ca;case "args":return this.Y;case "binding":return this.za;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Function{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[jk,this.ca],null),new U(null,2,5,V,[Aj,this.Y],null),new U(null,2,5,V,[um,this.za],null)],null),this.g))};f.W=function(){return new Og(this,3,new U(null,3,5,V,[jk,Aj,um],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 589494199^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.ca,b.ca)&&J.b(this.Y,b.Y)&&J.b(this.za,b.za)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[Aj,null,jk,null,um,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Ur(this.ca,this.Y,this.za,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(jk,b):S.call(null,jk,b))?new Ur(c,this.Y,this.za,this.i,this.g,null):r(S.b?S.b(Aj,b):S.call(null,Aj,b))?new Ur(this.ca,c,this.za,this.i,this.g,null):r(S.b?S.b(um,b):S.call(null,um,b))?new Ur(this.ca,this.Y,c,this.i,this.g,null):new Ur(this.ca,this.Y,this.za,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(jk,this.ca),new W(Aj,this.Y),new W(um,this.za)],null),this.g))};
f.S=function(a,b){return new Ur(this.ca,this.Y,this.za,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.za,er(b,this.Y,er(b,this.ca,c)))};f.sa=function(a,b){a=Z.b?Z.b(b,this.ca):Z.call(null,b,this.ca);b=this.Y;a=Z.b?Z.b(a,b):Z.call(null,a,b);b=this.za;return Z.b?Z.b(a,b):Z.call(null,a,b)};function Vr(a,b,c,d,e,g){this.source=a;this.name=b;this.Y=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}
f=Vr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "source":return this.source;case "name":return this.name;case "args":return this.Y;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.RuleExpr{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[Il,this.source],null),new U(null,2,5,V,[Uk,this.name],null),new U(null,2,5,V,[Aj,this.Y],null)],null),this.g))};f.W=function(){return new Og(this,3,new U(null,3,5,V,[Il,Uk,Aj],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-444662011^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.source,b.source)&&J.b(this.name,b.name)&&J.b(this.Y,b.Y)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[Aj,null,Uk,null,Il,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Vr(this.source,this.name,this.Y,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Il,b):S.call(null,Il,b))?new Vr(c,this.name,this.Y,this.i,this.g,null):r(S.b?S.b(Uk,b):S.call(null,Uk,b))?new Vr(this.source,c,this.Y,this.i,this.g,null):r(S.b?S.b(Aj,b):S.call(null,Aj,b))?new Vr(this.source,this.name,c,this.i,this.g,null):new Vr(this.source,this.name,this.Y,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(Il,this.source),new W(Uk,this.name),new W(Aj,this.Y)],null),this.g))};
f.S=function(a,b){return new Vr(this.source,this.name,this.Y,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.Y,er(b,this.name,er(b,this.source,c)))};f.sa=function(a,b){a=Z.b?Z.b(b,this.source):Z.call(null,b,this.source);b=this.name;a=Z.b?Z.b(a,b):Z.call(null,a,b);b=this.Y;return Z.b?Z.b(a,b):Z.call(null,a,b)};
function Wr(a,b,c,d,e,g){this.source=a;this.yb=b;this.fa=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}f=Wr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "source":return this.source;case "vars":return this.yb;case "clauses":return this.fa;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Not{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[Il,this.source],null),new U(null,2,5,V,[xo,this.yb],null),new U(null,2,5,V,[xn,this.fa],null)],null),this.g))};f.W=function(){return new Og(this,3,new U(null,3,5,V,[Il,xo,xn],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 1394671061^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.source,b.source)&&J.b(this.yb,b.yb)&&J.b(this.fa,b.fa)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[Il,null,xn,null,xo,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Wr(this.source,this.yb,this.fa,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Il,b):S.call(null,Il,b))?new Wr(c,this.yb,this.fa,this.i,this.g,null):r(S.b?S.b(xo,b):S.call(null,xo,b))?new Wr(this.source,c,this.fa,this.i,this.g,null):r(S.b?S.b(xn,b):S.call(null,xn,b))?new Wr(this.source,this.yb,c,this.i,this.g,null):new Wr(this.source,this.yb,this.fa,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(Il,this.source),new W(xo,this.yb),new W(xn,this.fa)],null),this.g))};
f.S=function(a,b){return new Wr(this.source,this.yb,this.fa,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.fa,er(b,this.yb,er(b,this.source,c)))};f.sa=function(a,b){a=Z.b?Z.b(b,this.source):Z.call(null,b,this.source);b=this.yb;a=Z.b?Z.b(a,b):Z.call(null,a,b);b=this.fa;return Z.b?Z.b(a,b):Z.call(null,a,b)};
function Xr(a,b,c,d,e,g){this.source=a;this.ub=b;this.fa=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}f=Xr.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "source":return this.source;case "rule-vars":return this.ub;case "clauses":return this.fa;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Or{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[Il,this.source],null),new U(null,2,5,V,[Kk,this.ub],null),new U(null,2,5,V,[xn,this.fa],null)],null),this.g))};f.W=function(){return new Og(this,3,new U(null,3,5,V,[Il,Kk,xn],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 1461934571^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.source,b.source)&&J.b(this.ub,b.ub)&&J.b(this.fa,b.fa)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[Kk,null,Il,null,xn,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Xr(this.source,this.ub,this.fa,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Il,b):S.call(null,Il,b))?new Xr(c,this.ub,this.fa,this.i,this.g,null):r(S.b?S.b(Kk,b):S.call(null,Kk,b))?new Xr(this.source,c,this.fa,this.i,this.g,null):r(S.b?S.b(xn,b):S.call(null,xn,b))?new Xr(this.source,this.ub,c,this.i,this.g,null):new Xr(this.source,this.ub,this.fa,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(Il,this.source),new W(Kk,this.ub),new W(xn,this.fa)],null),this.g))};
f.S=function(a,b){return new Xr(this.source,this.ub,this.fa,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.fa,er(b,this.ub,er(b,this.source,c)))};f.sa=function(a,b){a=Z.b?Z.b(b,this.source):Z.call(null,b,this.source);b=this.ub;a=Z.b?Z.b(a,b):Z.call(null,a,b);b=this.fa;return Z.b?Z.b(a,b):Z.call(null,a,b)};function Yr(a,b,c,d){this.fa=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=Yr.prototype;
f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "clauses":return this.fa;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.And{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[xn,this.fa],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[xn],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-131856804^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.fa,b.fa)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[xn,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Yr(this.fa,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(xn,b):S.call(null,xn,b))?new Yr(c,this.i,this.g,null):new Yr(this.fa,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(xn,this.fa)],null),this.g))};f.S=function(a,b){return new Yr(this.fa,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.fa,c)};f.sa=function(a,b){return Z.b?Z.b(b,this.fa):Z.call(null,b,this.fa)};
function Zr(a){var b=J.b(Pl,a)?new ir(null,null,null):null;if(r(b))return b;b=pr(a);return r(b)?b:rr(a)}function $r(a){if(Qd(a)){var b=qr(x(a));return r(b)?new U(null,2,5,V,[b,y(a)],null):new U(null,2,5,V,[new lr(null,null,null),a],null)}return null}function as(a){if(Qd(a)){var b=I(a);a=x(b);b=y(b);b=null==b?Cd:b;var c=tr(a);a=r(c)?c:pr(a);b=cr(vr,b);return r(r(a)?b:a)?new U(null,2,5,V,[a,b],null):null}return null}
var Z=function Z(a,b){return b instanceof jr?Bd.b(a,b):b instanceof Wr?$f.b(a,xo.c(b)):b instanceof Xr?(b=Kk.c(b),Z.b?Z.b(a,b):Z.call(null,a,b)):(null!=b?n===b.qa||(b.gc?0:eb(Zq,b)):eb(Zq,b))?ar(b,a):Qd(b)?A(Z,a,b):a};function bs(a,b,c){b=Fo.b(Xh(a),Xh(Z(Cd,b)));if(!Nd(b))throw vj(["Join variable not declared inside clauses: ",Di.h(M([ag.b(Rk,b)]))].join(""),new q(null,2,[qn,Ck,zn,c],null));if(Nd(a))throw vj("Join variables should not be empty",new q(null,2,[qn,Ck,zn,c],null));}
function cs(a,b){bs(xo.c(a),xn.c(a),b);return a}function ds(a,b){var c=null!=a&&(a.m&64||n===a.Ga)?jf(Ff,a):a,d=F.b(c,Kk),e=null!=d&&(d.m&64||n===d.Ga)?jf(Ff,d):d;d=F.b(e,no);e=F.b(e,Lk);var g=F.b(c,xn);c=T.b(d,e);d=I(g);e=null;for(var h=g=0;;)if(h<g){var k=e.Z(null,h);bs(c,new U(null,1,5,V,[k],null),b);h+=1}else if(d=I(d))e=d,Ud(e)?(d=tc(e),h=uc(e),e=d,g=L(d),d=h):(d=x(e),bs(c,new U(null,1,5,V,[d],null),b),d=y(e),e=null,g=0),h=0;else break;return a}
function Lf(a){if(Qd(a)&&J.b(po,x(a))){var b=y(a);b=es.c?es.c(b):es.call(null,b);if(r(mf(b)))return new Yr(b,null,null,null);throw vj("Cannot parse 'and' clause, expected [ 'and' clause+ ]",new q(null,2,[qn,Ck,zn,a],null));}return null}
function Mf(a){a:{var b=$r(a);if(r(b)){var c=O(b,0);b=O(b,1);var d=I(b);b=x(d);d=y(d);if(J.b(Im,b)){b=es.c?es.c(d):es.call(null,d);if(r(b)){c=cs(gr(new Wr(c,yg(Yh(Z(Cd,b))),b,null,null,null),a),a);break a}throw vj("Cannot parse 'not' clause, expected [ src-var? 'not' clause+ ]",new q(null,2,[qn,Ck,zn,a],null));}}c=null}if(r(c))return c;a:{b=$r(a);if(r(b)){c=O(b,0);b=O(b,1);d=I(b);b=x(d);var e=y(d);d=x(e);e=y(e);if(J.b(Qm,b)){b=cr(pr,d);d=es.c?es.c(e):es.call(null,e);if(r(r(b)?d:b)){c=cs(gr(new Wr(c,
b,d,null,null,null),a),a);break a}throw vj("Cannot parse 'not-join' clause, expected [ src-var? 'not-join' [variable+] clause+ ]",new q(null,2,[qn,Ck,zn,a],null));}}c=null}if(r(c))return c;a:{b=$r(a);if(r(b)&&(c=O(b,0),b=O(b,1),d=I(b),b=x(d),d=y(d),J.b(lm,b))){b=cr(Kf(),d);if(r(b)){c=ds(gr(new Xr(c,new wr(null,yg(Yh(Z(Cd,b))),null,null,null),b,null,null,null),a),a);break a}throw vj("Cannot parse 'or' clause, expected [ src-var? 'or' clause+ ]",new q(null,2,[qn,Ck,zn,a],null));}c=null}if(r(c))return c;
a:{b=$r(a);if(r(b)&&(c=O(b,0),b=O(b,1),b=I(b),e=x(b),d=y(b),b=x(d),d=y(d),J.b(Al,e))){if(Qd(b)){var g=Qd(x(b))?new U(null,2,5,V,[x(b),y(b)],null):new U(null,2,5,V,[null,b],null);e=O(g,0);g=O(g,1);e=cr(pr,e);g=cr(pr,g);if(Nd(e)&&Nd(g))throw vj("Cannot parse rule-vars, expected [ variable+ | ([ variable+ ] variable*) ]",new q(null,2,[qn,Hk,zn,b],null));if(!r(fr(T.b(e,g))))throw vj("Rule variables should be distinct",new q(null,2,[qn,Hk,zn,b],null));b=new wr(e,g,null,null,null)}else throw vj("Cannot parse rule-vars, expected [ variable+ | ([ variable+ ] variable*) ]",
new q(null,2,[qn,Hk,zn,b],null));d=cr(Kf(),d);if(r(r(b)?d:b)){c=ds(gr(new Xr(c,b,d,null,null,null),a),a);break a}throw vj("Cannot parse 'or-join' clause, expected [ src-var? 'or-join' [variable+] clause+ ]",new q(null,2,[qn,Ck,zn,a],null));}c=null}if(r(c))return c;a:{if(br(a,1)&&(b=as(x(a)),r(b))){c=O(b,0);b=O(b,1);c=gr(new Tr(c,b,null,null,null),a);break a}c=null}if(r(c))return c;a:{if(br(a,2)&&(b=O(a,0),c=O(a,1),d=as(b),r(d))){b=O(d,0);d=O(d,1);c=Dr(c);c=r(c)?gr(new Ur(b,d,c,null,null,null),a):
null;break a}c=null}if(r(c))return c;a:{b=$r(a);if(r(b)&&(c=O(b,0),b=O(b,1),b=I(b),d=x(b),b=y(b),d=tr(d),e=cr(Zr,b),r(d))){if(Nd(b))throw vj("rule-expr requires at least one argument",new q(null,2,[qn,Ck,zn,a],null));if(null==e)throw vj("Cannot parse rule-expr arguments, expected [ (variable | constant | '_')+ ]",new q(null,2,[qn,Ck,zn,a],null));c=new Vr(c,d,e,null,null,null);break a}c=null}if(r(c))return c;a:{b=$r(a);if(r(b)&&(c=O(b,0),b=O(b,1),b=cr(Zr,b),r(b))){if(Nd(b))throw vj("Pattern could not be empty",
new q(null,2,[qn,Ck,zn,a],null));c=gr(new Sr(c,b,null,null,null),a);break a}c=null}if(r(c))return c;throw vj("Cannot parse clause, expected (data-pattern | pred-expr | fn-expr | rule-expr | not-clause | not-join-clause | or-clause | or-join-clause)",new q(null,2,[qn,Ck,zn,a],null));}function es(a){return cr(Mf,a)}function fs(a,b,c,d,e,g,h){this.kb=a;this.nb=b;this.lb=c;this.mb=d;this.i=e;this.g=g;this.j=h;this.m=2230716170;this.F=139264}f=fs.prototype;f.M=function(a,b){return this.o(null,b,null)};
f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "qfind":return this.kb;case "qwith":return this.nb;case "qin":return this.lb;case "qwhere":return this.mb;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.parser.Query{",", ","}",c,T.b(new U(null,4,5,V,[new U(null,2,5,V,[ul,this.kb],null),new U(null,2,5,V,[jm,this.nb],null),new U(null,2,5,V,[dm,this.lb],null),new U(null,2,5,V,[Xl,this.mb],null)],null),this.g))};f.W=function(){return new Og(this,4,new U(null,4,5,V,[ul,jm,dm,Xl],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 4+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 181307977^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.kb,b.kb)&&J.b(this.nb,b.nb)&&J.b(this.lb,b.lb)&&J.b(this.mb,b.mb)&&J.b(this.g,b.g)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,4,[ul,null,Xl,null,dm,null,jm,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new fs(this.kb,this.nb,this.lb,this.mb,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(ul,b):S.call(null,ul,b))?new fs(c,this.nb,this.lb,this.mb,this.i,this.g,null):r(S.b?S.b(jm,b):S.call(null,jm,b))?new fs(this.kb,c,this.lb,this.mb,this.i,this.g,null):r(S.b?S.b(dm,b):S.call(null,dm,b))?new fs(this.kb,this.nb,c,this.mb,this.i,this.g,null):r(S.b?S.b(Xl,b):S.call(null,Xl,b))?new fs(this.kb,this.nb,this.lb,c,this.i,this.g,null):new fs(this.kb,this.nb,this.lb,this.mb,this.i,P.f(this.g,b,c),null)};
f.N=function(){return I(T.b(new U(null,4,5,V,[new W(ul,this.kb),new W(jm,this.nb),new W(dm,this.lb),new W(Xl,this.mb)],null),this.g))};f.S=function(a,b){return new fs(this.kb,this.nb,this.lb,this.mb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};f.qa=n;f.ra=function(a,b,c){return er(b,this.mb,er(b,this.lb,er(b,this.nb,er(b,this.kb,c))))};f.sa=function(a,b){return Z(Z(Z(Z(b,this.kb),this.nb),this.lb),this.mb)};
function hs(a){for(var b=pf,c=null;;){var d=x(a);if(r(d))d instanceof H?(c=d,a=y(a)):(b=fg.B(b,new U(null,1,5,V,[c],null),zf(Bd,Cd),d),a=y(a));else return b}}
function is(a,b){var c=Xh(Z(Cd,ul.c(a))),d=Xh(jm.c(a)),e=Xh(Z(Cd,dm.c(a))),g=Xh(Z(Cd,Xl.c(a)));e=Fo.b(Do(c,d),Do(g,e));c=Eo.b(c,d);if(!Nd(e))throw vj(["Query for unknown vars: ",Di.h(M([ag.b(Rk,e)]))].join(""),new q(null,3,[qn,zo,xo,e,zn,b],null));if(!Nd(c))throw vj([":find and :with should not use same variables: ",Di.h(M([ag.b(Rk,c)]))].join(""),new q(null,3,[qn,zo,xo,c,zn,b],null));var h=Z(Cd,dm.c(a)),k=dr(function(){return function(a){return a instanceof kr}}(h),dm.c(a)),l=dr(function(){return function(a){return a instanceof
mr}}(h,k),dm.c(a));if(!r(function(){var a=fr(h);return r(a)?(a=fr(k),r(a)?fr(l):a):a}()))throw vj("Vars used in :in should be distinct",new q(null,2,[qn,zo,zn,b],null));c=Z(Cd,jm.c(a));if(!r(fr(c)))throw vj("Vars used in :with should be distinct",new q(null,2,[qn,zo,zn,b],null));c=er(function(a){return a instanceof kr},dm.c(a),Wh);d=er(function(){return function(a){return a instanceof kr}}(c),Xl.c(a),Wh);c=Fo.b(d,c);if(!Nd(c))throw vj(["Where uses unknown source vars: ",Di.h(M([ag.b(Rk,c)]))].join(""),
new q(null,3,[qn,zo,xo,c,zn,b],null));c=dr(function(a){return a instanceof Vr},Xl.c(a));a=dr(function(){return function(a){return a instanceof mr}}(c),dm.c(a));if(!Nd(c)&&Nd(a))throw vj("Missing rules var '%' in :in",new q(null,2,[qn,zo,zn,b],null));};function js(a,b,c,d,e){this.vc=a;this.Sd=b;this.Td=c;this.Rd=d;this.Aa=e;this.m=2147484416;this.F=0}js.prototype.I=function(a,b,c){return ks.f?ks.f(this,b,c):ks.call(null,this,b,c)};js.prototype.M=function(a,b){return Eb.f(this.vc,b,null)};js.prototype.o=function(a,b,c){return Eb.f(this.vc,b,c)};js.prototype.L=function(a,b,c){return kc(this.vc,b,c)};function ls(a,b,c,d,e){return new js(a,b,c,d,e)}
function ks(a,b,c){var d=a.vc,e=a.Sd,g=a.Td,h=a.Rd;a=a.Aa;var k=g.b?g.b(b,null):g.call(null,b,null);if(r(k))return ls(d,P.f(Q.b(e,k),h,b),P.f(g,b,h),h+1,a);b=ls(P.f(d,b,c),P.f(e,h,b),P.f(g,b,h),h+1,a);return ms.c?ms.c(b):ms.call(null,b)}function ms(a){if(L(a.vc)>a.Aa){var b=a.vc,c=a.Sd,d=a.Td,e=a.Rd;a=a.Aa;var g=x(c),h=O(g,0);g=O(g,1);return ls(Q.b(b,g),Q.b(c,h),Q.b(d,g),e,a)}return a};function ns(a,b,c,d,e){this.bc=a;this.Ia=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=ns.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "wildcard?":return this.bc;case "attrs":return this.Ia;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullSpec{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Qn,this.bc],null),new U(null,2,5,V,[jn,this.Ia],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Qn,jn],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 90253489^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.bc,b.bc)&&J.b(this.Ia,b.Ia)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[jn,null,Qn,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new ns(this.bc,this.Ia,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Qn,b):S.call(null,Qn,b))?new ns(c,this.Ia,this.i,this.g,null):r(S.b?S.b(jn,b):S.call(null,jn,b))?new ns(this.bc,c,this.i,this.g,null):new ns(this.bc,this.Ia,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Qn,this.bc),new W(jn,this.Ia)],null),this.g))};f.S=function(a,b){return new ns(this.bc,this.Ia,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};
var os=function os(a){if(null!=a&&null!=a.Vb)return a.Vb(a);var c=os[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=os._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IPullSpecComponent.-as-spec",a);};function ps(a,b,c,d){this.U=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=ps.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attr":return this.U;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullAttrName{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Ao,this.U],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Ao],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-838771693^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.U,b.U)&&J.b(this.g,b.g)};f.Vb=function(){return new U(null,2,5,V,[this.U,new q(null,1,[Ao,this.U],null)],null)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Ao,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new ps(this.U,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Ao,b):S.call(null,Ao,b))?new ps(c,this.i,this.g,null):new ps(this.U,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Ao,this.U)],null),this.g))};f.S=function(a,b){return new ps(this.U,b,this.g,this.j)};
f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function qs(a,b,c,d,e){this.U=a;this.Nb=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=qs.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attr":return this.U;case "rattr":return this.Nb;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullReverseAttrName{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Ao,this.U],null),new U(null,2,5,V,[wk,this.Nb],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Ao,wk],null),r(this.g)?Bc(this.g):nf())};
f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 158820207^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.U,b.U)&&J.b(this.Nb,b.Nb)&&J.b(this.g,b.g)};f.Vb=function(){return new U(null,2,5,V,[this.Nb,new q(null,1,[Ao,this.U],null)],null)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[wk,null,Ao,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new qs(this.U,this.Nb,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Ao,b):S.call(null,Ao,b))?new qs(c,this.Nb,this.i,this.g,null):r(S.b?S.b(wk,b):S.call(null,wk,b))?new qs(this.U,c,this.i,this.g,null):new qs(this.U,this.Nb,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Ao,this.U),new W(wk,this.Nb)],null),this.g))};
f.S=function(a,b){return new qs(this.U,this.Nb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function rs(a,b,c,d,e){this.U=a;this.Aa=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=rs.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attr":return this.U;case "limit":return this.Aa;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullLimitExpr{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Ao,this.U],null),new U(null,2,5,V,[Ak,this.Aa],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Ao,Ak],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 2109320956^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.U,b.U)&&J.b(this.Aa,b.Aa)&&J.b(this.g,b.g)};f.Vb=function(){return eg(os(this.U),new U(null,2,5,V,[1,Ak],null),this.Aa)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Ak,null,Ao,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new rs(this.U,this.Aa,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Ao,b):S.call(null,Ao,b))?new rs(c,this.Aa,this.i,this.g,null):r(S.b?S.b(Ak,b):S.call(null,Ak,b))?new rs(this.U,c,this.i,this.g,null):new rs(this.U,this.Aa,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Ao,this.U),new W(Ak,this.Aa)],null),this.g))};
f.S=function(a,b){return new rs(this.U,this.Aa,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function ss(a,b,c,d,e){this.U=a;this.value=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=ss.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attr":return this.U;case "value":return this.value;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullDefaultExpr{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Ao,this.U],null),new U(null,2,5,V,[dl,this.value],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Ao,dl],null),r(this.g)?Bc(this.g):nf())};
f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-1499761615^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.U,b.U)&&J.b(this.value,b.value)&&J.b(this.g,b.g)};f.Vb=function(){return eg(os(this.U),new U(null,2,5,V,[1,pj],null),this.value)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[dl,null,Ao,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new ss(this.U,this.value,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Ao,b):S.call(null,Ao,b))?new ss(c,this.value,this.i,this.g,null):r(S.b?S.b(dl,b):S.call(null,dl,b))?new ss(this.U,c,this.i,this.g,null):new ss(this.U,this.value,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Ao,this.U),new W(dl,this.value)],null),this.g))};
f.S=function(a,b){return new ss(this.U,this.value,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function ts(a,b,c){this.i=a;this.g=b;this.j=c;this.m=2230716170;this.F=139264}f=ts.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){return F.f(this.g,b,c)};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullWildcard{",", ","}",c,T.b(Cd,this.g))};f.W=function(){return new Og(this,0,Cd,r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 0+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-163917799^bd(a)}}(b,a)(a)}();return this.j=c};
f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(Wh,b)?Q.b(Ub($f.b(pf,this),this.i),b):new ts(this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return new ts(this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(Cd,this.g))};f.S=function(a,b){return new ts(b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};
function us(a,b,c,d){this.Aa=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=us.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "limit":return this.Aa;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullRecursionLimit{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Ak,this.Aa],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Ak],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 1+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 1552688154^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.Aa,b.Aa)&&J.b(this.g,b.g)};f.Vb=function(){return new U(null,2,5,V,[Bm,this.Aa],null)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Ak,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new us(this.Aa,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(Ak,b):S.call(null,Ak,b))?new us(c,this.i,this.g,null):new us(this.Aa,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Ak,this.Aa)],null),this.g))};f.S=function(a,b){return new us(this.Aa,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function vs(a,b,c,d,e){this.U=a;this.Mb=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=vs.prototype;
f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attr":return this.U;case "porrl":return this.Mb;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullMapSpecEntry{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Ao,this.U],null),new U(null,2,5,V,[ym,this.Mb],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Ao,ym],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 152088668^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.U,b.U)&&J.b(this.Mb,b.Mb)&&J.b(this.g,b.g)};f.Vb=function(){return hg(os(this.U),1,Bd,os(this.Mb))};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[ym,null,Ao,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new vs(this.U,this.Mb,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Ao,b):S.call(null,Ao,b))?new vs(c,this.Mb,this.i,this.g,null):r(S.b?S.b(ym,b):S.call(null,ym,b))?new vs(this.U,c,this.i,this.g,null):new vs(this.U,this.Mb,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Ao,this.U),new W(ym,this.Mb)],null),this.g))};
f.S=function(a,b){return new vs(this.U,this.Mb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function ws(a,b,c,d,e){this.U=a;this.Lb=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=ws.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attr":return this.U;case "opts":return this.Lb;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullAttrWithOpts{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[Ao,this.U],null),new U(null,2,5,V,[Um,this.Lb],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[Ao,Um],null),r(this.g)?Bc(this.g):nf())};
f.R=function(){return this.i};f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-429987476^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.U,b.U)&&J.b(this.Lb,b.Lb)&&J.b(this.g,b.g)};f.Vb=function(){return hg(os(this.U),1,Qh,this.Lb)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Um,null,Ao,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new ws(this.U,this.Lb,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Ao,b):S.call(null,Ao,b))?new ws(c,this.Lb,this.i,this.g,null):r(S.b?S.b(Um,b):S.call(null,Um,b))?new ws(this.U,c,this.i,this.g,null):new ws(this.U,this.Lb,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(Ao,this.U),new W(Um,this.Lb)],null),this.g))};
f.S=function(a,b){return new ws(this.U,this.Lb,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function xs(a,b){return b instanceof ts?P.f(a,Qn,!0):hg(a,jn,af,os(b))}function ys(a,b,c,d){this.Yb=a;this.i=b;this.g=c;this.j=d;this.m=2230716170;this.F=139264}f=ys.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "specs":return this.Yb;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.pull-parser.PullPattern{",", ","}",c,T.b(new U(null,1,5,V,[new U(null,2,5,V,[Zm,this.Yb],null)],null),this.g))};f.W=function(){return new Og(this,1,new U(null,1,5,V,[Zm],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 1+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return-795554044^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.Yb,b.Yb)&&J.b(this.g,b.g)};f.Vb=function(){var a=new ns(!1,lc(pf),null,null,null);a=A(xs,a,this.Yb);return new U(null,2,5,V,[mn,gg(a,jn,$e)],null)};
f.ba=function(a,b){return Zd(new Uh(null,new q(null,1,[Zm,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new ys(this.Yb,this.i,mf(Q.b(this.g,b)),null)};f.I=function(a,b,c){return r(S.b?S.b(Zm,b):S.call(null,Zm,b))?new ys(c,this.i,this.g,null):new ys(this.Yb,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,1,5,V,[new W(Zm,this.Yb)],null),this.g))};f.S=function(a,b){return new ys(this.Yb,b,this.g,this.j)};
f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};var zs=new Uh(null,new q(null,3,[Yj,null,"*",null,Zk,null],null),null);function As(a){return a instanceof H||"string"===typeof a?Nq(a)?new qs(Oq(a),a,null,null,null):new ps(a,null,null,null):null}var Bs=new Uh(null,new q(null,2,["...",null,Wn,null],null),null);function Cs(a){return Qd(a)&&J.b(3,L(a))}var Ds=new Uh(null,new q(null,3,[wl,null,Ak,null,"limit",null],null),null);
function Es(a){var b=O(a,0),c=O(a,1),d=O(a,2);if(r(Ds.c?Ds.c(b):Ds.call(null,b))){c=(b=null==d||"number"===typeof d&&0<d)?As(c):b;if(r(c))return new rs(c,d,null,null,null);throw vj('Expected ["limit" attr-name (positive-number | nil)]',new q(null,2,[qn,Zn,Jk,a],null));}return null}var Fs=new Uh(null,new q(null,3,[gm,null,pj,null,"default",null],null),null);
function Gs(a){var b=O(a,0),c=O(a,1);a=function(){var a=As(b);return r(a)?a:Cs(b)?Es(b):null}();if(r(a)){var d=function(){var a=r(Bs.c?Bs.c(c):Bs.call(null,c))?new us(null,null,null,null):"number"===typeof c&&0<c?new us(c,null,null,null):null;return r(a)?a:Hs.c?Hs.c(c):Hs.call(null,c)}();if(r(d))return new vs(a,d,null,null,null);throw vj("Expected (pattern | recursion-limit)",new q(null,2,[qn,Zn,Jk,new U(null,2,5,V,[b,c],null)],null));}throw vj("Expected (attr-name | limit-expr)",new q(null,2,[qn,
Zn,Jk,new U(null,2,5,V,[b,c],null)],null));}
function Is(a){var b=As(a);if(r(b))return b;b=r(zs.c?zs.c(a):zs.call(null,a))?new ts(null,null,null):null;if(r(b))return b;b=Rd(a)?Gs(x(a)):null;if(r(b))return b;if(Qd(a)){var c=I(a);b=x(c);c=y(c);b=As(b);b=null==b?null:vf(L(c))&&tf(new Uh(null,new q(null,3,[Ak,null,pj,null,Wk,null],null),null),Nf.b(x,cg(2,2,c)))?new ws(b,jf(Mh,c),null,null,null):null}else b=null;if(r(b))return b;if(Cs(a)){if(b=Es(a),!r(b))b:{c=O(a,0);var d=O(a,1);b=O(a,2);if(r(Fs.c?Fs.c(c):Fs.call(null,c))){c=As(d);if(r(c)){b=new ss(c,
b,null,null,null);break b}throw vj('Expected ["default" attr-name any-value]',new q(null,2,[qn,Zn,Jk,a],null));}b=null}}else b=null;if(r(b))return b;throw vj("Cannot parse attr-spec, expected: (attr-name | wildcard | map-spec | attr-expr)",new q(null,2,[qn,Zn,Jk,a],null));}function Js(a){return Rd(a)?go:r(zs.c?zs.c(a):zs.call(null,a))?mk:Ok}function Ks(a){return $f.f(Cd,Nf.c(function(a){return Bd.b(pf,a)}),a)}
function Ls(a){a=Vi(Js,a);var b=r(mf(F.b(a,mk)))?new U(null,1,5,V,[Zk],null):Cd;return $f.f($f.b(b,F.b(a,Ok)),xf.b(Nf.c(Ks),Ki),F.b(a,go))}function Hs(a){return Qd(a)?new ys($f.f(Cd,Nf.c(Is),Ls(a)),null,null,null):null}function Ms(a){var b=null==a?null:Hs(a);b=null==b?null:xd(os(b));if(r(b))return b;throw vj("Cannot parse pull pattern, expected: [attr-spec+]",new q(null,2,[qn,Zn,Jk,a],null));};function Ns(a,b){return A(af,a,b)}function Os(a,b,c){return th([gk,zl,Cl,Bm,Zm,Qn,ko,yo,Bo],[c,b,yo,new q(null,2,[rn,pf,Cm,Wh],null),I(jn.c(a)),Qn.c(a),lc(pf),a,lc(Cd)])}function Ps(a,b,c,d){return P.f(Os(a,b,c),Ao,d)}function Qs(a,b,c){var d=yo.c(a);return P.h(a,zl,b,M([Zm,I(jn.c(d)),Qn,Qn.c(d),ko,lc(pf),Bo,function(){var b=Bo.c(a);return I(c)?af.b(b,c):b}()]))}
function Rs(a,b,c){var d=null!=a&&(a.m&64||n===a.Ga)?jf(Ff,a):a,e=F.b(d,rn);d=F.b(d,Cm);return P.h(a,rn,gg(e,b,zf(dd,0)),M([Cm,Bd.b(d,c)]))}function Ss(a,b,c){a:{var d=Wh;for(var e=Wd,g=a,h=I(new U(null,2,5,V,[Bm,Cm],null));;)if(null!=h){g=F.f(g,x(h),e);if(e===g)break a;h=y(h)}else{d=g;break a}}return Zd(d,c)?Bd.b(b,hg(a,Bo,af,new q(null,1,[gn,c],null))):null}function Ts(a,b){b=ko.c(b);b=null==b?null:nc(b);return null==b?null:F.b(b,a)}
function Us(a,b){var c=Ao.c(a);c=Rs(Bm.c(a),c,b);return P.f(Ps(yo.c(a),new U(null,1,5,V,[b],null),!1,fl),Bm,c)}function Vs(a){a=I(a);var b=x(a);a=y(a);var c=I(zl.c(b));if(c){b=Qs(b,Vc(c),Ts(fl,b));c=x(c);var d=Ss(b,a,c);return r(d)?d:Bd.h(a,b,M([Us(b,c)]))}c=Ts(fl,b);d=Bo.c(b);c=I(c)?af.b(d,c):d;return Bd.b(a,P.h(b,Cl,qk,M([Bo,c])))}
function Ws(a,b,c,d,e){var g=null!=d&&(d.m&64||n===d.Ga)?jf(Ff,d):d,h=F.b(g,Bm);g=F.b(g,yo);var k=F.f(F.b(h,rn),a,0);return J.b(Bm.c(F.b(jn.c(g),a)),k)?Bd.b(e,d):Vs(Bd.h(e,d,M([new q(null,7,[Cl,Bm,yo,g,Ao,a,gk,b,zl,c,Bm,h,Bo,lc(Cd)],null)])))}var Xs=function(a){return function(b,c,d,e,g){b=Rs(Bm.c(b),d,c);return P.f(Ps(a,g,e,d),Bm,b)}}(new ns(!0,pf,null,null,null));
function Ys(a,b,c,d,e,g,h,k){var l=I(k),m=x(l),p=y(l),u=F.f(h,Ak,1E3),w=function(){var a=Wk.c(h);return r(a)?a:b}(),z=mf(r(u)?$f.f(Cd,Of(u),g):g);if(r(z)){var D=Aq(a,c),C=D&&Dq(a,c,Ll),G=r(e)?Dq(a,c,Mn):!C,N=r(e)?function(){return function(a){return a.v}}(D,C,G,u,w,z,k,l,m,p,m,p):function(){return function(a){return a.e}}(D,C,G,u,w,z,k,l,m,p,m,p);if(Zd(h,mn))return Bd.h(p,m,M([Ps(mn.c(h),ag.b(N,z),G,w)]));if(Zd(h,Bm))return Ws(w,G,ag.b(N,z),m,p);if(r(C?e:C))return Bd.h(p,m,M([Xs(m,d,w,G,ag.b(N,z))]));
var K=function(){return D?xf.b(function(){return function(a){return th([gn],[a])}}(N,D,C,G,N,u,w,z,k,l,m,p,m,p),N):N}(),Y=!G;return Bd.b(p,ig(m,ko,bf,w,function(){var a=$f.f(Cd,Nf.c(K),z);return Y?x(a):a}()))}return Bd.b(p,Zd(h,pj)?ig(m,ko,bf,w,pj.c(h)):m)}var Zs=Xf(function(a){var b=O(a,0);a=O(a,1);return lf.b(b,Ao.c(a))});function $s(a,b,c){return Ps(P.h(yo.c(a),jn,c,M([Qn,!1])),new U(null,1,5,V,[b],null),!1,bk)}function at(a,b){return Bd.b(Vc(a),hg(x(a),ko,Ns,nc(b)))}
function bt(a){var b=I(a);a=x(b);b=y(b);var c=Uj.c(a);a=Ts(bk,a);return at(b,Ns(c,r(a)?a:pf))}function ct(a,b){var c=I(b);b=x(c);c=y(c);var d=I(so.c(b));if(d){var e=x(d);d=O(e,0);e=O(e,1);var g=F.f(dg(b,new U(null,2,5,V,[yo,jn],null)),d,pf);return Ys(a,d,d,En.c(b),!0,e,g,Bd.b(c,gg(b,so,Vc)))}a=mf($f.f(pf,Zs,dg(b,new U(null,2,5,V,[yo,jn],null))));return r(a)?(b=P.h(b,Cl,hl,M([Uj,ko.c(b),ko,lc(pf)])),Bd.h(c,b,M([$s(b,En.c(b),a)]))):at(c,ko.c(b))}
function dt(a,b,c,d,e){var g=Vi(function(a){return a.a},$p(a,cm,new U(null,1,5,V,[d],null))),h=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b,k=F.b(h,Ao);h=F.b(h,Bm);k=null!=k?Rs(h,k,d):h;return ct(a,Bd.h(c,b,M([new q(null,6,[Cl,co,ko,lc(new q(null,1,[gn,d],null)),En,d,yo,e,so,I(g),Bm,k],null)])))}
function et(a,b){for(;;){var c=I(b);b=x(c);var d=y(c);c=b;if(b=I(zl.c(c))){if(r(Qn.c(c))){b=P.h(c,Zm,Cd,M([En,x(b),Qn,!1]));c=d;var e=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b;d=F.b(e,En);e=F.b(e,yo);var g=Ss(b,c,d);return r(g)?g:dt(a,b,c,d,e)}if(e=I(Zm.c(c))){g=e;e=x(g);yo.c(c);c=Bd.b(d,P.f(c,Zm,Vc(g)));b=x(b);d=O(e,0);e=O(e,1);if(J.b(gn,d))a=r(mf($p(a,cm,new U(null,1,5,V,[b],null))))?Bd.b(Vc(c),ig(x(c),ko,bf,gn,b)):c;else{g=Ao.c(e);var h=J.b(d,g),k=h?$p(a,cm,new U(null,2,5,V,[b,g],null)):$p(a,Sk,new U(null,
2,5,V,[g,b],null));a=Ys(a,d,g,b,h,k,e,c)}return a}b=Bd.b(d,Qs(c,Vc(b),mf(nc(ko.c(c)))))}else return Bd.b(d,P.f(c,Cl,qk))}}
function ft(a,b){for(;;){var c=Cl.c(x(b));c=c instanceof H?c.X:null;switch(c){case "expand":c=a;b=ct(a,b);a=c;continue;case "expand-rev":b=bt(b);continue;case "pattern":c=a;b=et(a,b);a=c;continue;case "recursion":b=Vs(b);continue;case "done":c=I(b);b=x(c);c=y(c);var d=b,e=c,g=function(){var a=nc(Bo.c(d));return db(gk.c(d))?x(a):a}();if(I(e)){b=Bd.b(Vc(e),function(){var a=x(e);return r(g)?ig(a,ko,bf,Ao.c(d),g):a}());continue}else return g;default:throw Error(["No matching clause: ",t.c(c)].join(""));
}}}function gt(a,b,c,d){c=$f.f(Cd,Nf.c(function(b){return Bq(a,b)}),c);return ft(a,new Dd(null,Os(b,c,d),null,1,null))}function ht(a,b,c){return gt(a,Ms(b),new U(null,1,5,V,[c],null),!1)}function it(a,b,c){return gt(a,Ms(b),c,!0)};var jt={},kt={},lt={},mt=/[\s]/;function nt(a){return null==a?null:","===a?!0:mt.test(a)}function ot(a){return null==a?null:!/[^0-9]/.test(a)}
function pt(a,b){return function e(b){return new Ne(null,function(){for(;;){var d=I(b);if(d){if(Ud(d)){var h=tc(d),k=L(h),l=Re(k);return function(){for(var b=0;;)if(b<k){var d=B.b(h,b),e=l;if(d instanceof E||d instanceof H){var g=li();var m=g.c?g.c(d):g.call(null,d);g=O(m,0);m=O(m,1);var C=d instanceof E?Sc:Le;d=null==g?C.b?C.b(a,m):C.call(null,a,m):J.b("_",g)?C.c?C.c(m):C.call(null,m):d}e.add(d);b+=1}else return!0}()?Te(l.aa(),e(uc(d))):Te(l.aa(),null)}var m=x(d);return ud(m instanceof E||m instanceof
H?function(){var b=li();var d=b.c?b.c(m):b.call(null,m);b=O(d,0);d=O(d,1);var e=m instanceof E?Sc:Le;return null==b?e.b?e.b(a,d):e.call(null,a,d):J.b("_",b)?e.c?e.c(d):e.call(null,d):m}():m,e(Vc(d)))}return null}},null,null)}(b)}function qt(a,b){a=parseInt(a,b);return r(isNaN(a))?-1:a};var rt=function rt(a){if(null!=a&&null!=a.mc)return a.mc(a);var c=rt[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=rt._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("Reader.read-char",a);},st=function st(a){if(null!=a&&null!=a.Dc)return a.Dc(a);var c=st[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=st._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("Reader.peek-char",a);},tt=function tt(a,b){if(null!=a&&null!=a.Od)return a.Od(a,b);var d=tt[ba(null==
a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=tt._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IPushbackReader.unread",a);},ut=function ut(a){if(null!=a&&null!=a.oe)return a.oe(a);var c=ut[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=ut._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IndexingReader.get-line-number",a);},vt=function vt(a){if(null!=a&&null!=a.me)return a.me(a);var c=vt[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,
a);c=vt._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IndexingReader.get-column-number",a);},wt=function wt(a){if(null!=a&&null!=a.ne)return a.ne(a);var c=wt[ba(null==a?null:a)];if(null!=c)return c.c?c.c(a):c.call(null,a);c=wt._;if(null!=c)return c.c?c.c(a):c.call(null,a);throw gb("IndexingReader.get-file-name",a);};function xt(a,b){this.da=a;this.Xd=b;this.xc=0}xt.prototype.mc=function(){if(this.Xd>this.xc){var a=this.da.charAt(this.xc);this.xc+=1;return a}return null};
xt.prototype.Dc=function(){return this.Xd>this.xc?this.da.charAt(this.xc):null};function yt(a,b){this.Vd=a;this.jc=b;this.Ab=this.bd=1}yt.prototype.mc=function(){var a=this.Ab<this.bd?kb.b(this.jc,this.Ab):this.Vd.mc(null);this.Ab<this.bd&&(this.Ab+=1);return null==a?null:xe(a)};yt.prototype.Dc=function(){var a=this.Ab<this.bd?kb.b(this.jc,this.Ab):this.Vd.Dc(null);return null==a?null:xe(a)};
yt.prototype.Od=function(a,b){if(r(b)){if(0===this.Ab)throw Error("Pushback buffer is full");--this.Ab;return mb.f(this.jc,this.Ab,b)}return null};function zt(a){return null!=a?n===a.Ie?!0:!1:!1};var At={};function Bt(a,b,c,d){var e=L(b);a=r(a)?0:10<e?10:e;b=Nf.b(yf(sj,!0),Pf(a,b));b=jf(t,Qf(1,Vf.b(new Sf(null,-1," ",null),b)));e=a<e?"...":null;return[t.c(c),t.c(b),e,t.c(d)].join("")}function oj(a,b){return null==b?Vm:"string"===typeof b?Nl:b instanceof H?am:"number"===typeof b?am:b instanceof E?am:Td(b)?Ql:Ee(b)?Em:Rd(b)?go:Pd(b)?Jn:J.b(b,!0)?am:J.b(b,!1)?am:fb(b)}
if("undefined"===typeof Ka||"undefined"===typeof jt||"undefined"===typeof kt||"undefined"===typeof lt||"undefined"===typeof At||"undefined"===typeof sj){var sj,kj=Cf(pf),lj=Cf(pf),mj=Cf(pf),nj=Cf(pf),jj=F.f(pf,Tn,Yi.G?Yi.G():Yi.call(null));sj=new ij}rj(Nl,function(a,b){a=r(a)?5:20;var c=b.length>a?'..."':'"',d=b.length;return['"',t.c(b.substring(0,a<d?a:d)),c].join("")});rj(am,function(a,b){return t.c(b)});rj(v,function(){return"\x3cindexed seq\x3e"});rj(Sg,function(){return"\x3cmap seq\x3e"});
rj(oh,function(){return"\x3cmap seq\x3e"});rj(Ie,function(){return"\x3ccons\x3e"});rj(Ne,function(){return"\x3clazy seq\x3e"});rj(Vm,function(){return"nil"});rj(Em,function(a,b){return Bt(a,b,"(",")")});rj(go,function(a,b){var c=L(b),d=r(a)?0:c;b=jf(T,Pf(d,b));return Bt(a,b,"{",c>d?"...}":"}")});rj(Jn,function(a,b){return Bt(a,b,"#{","}")});rj(Ql,function(a,b){return Bt(a,b,"[","]")});rj(pj,function(a,b){return Di.h(M([fb(b)]))});function Ct(a){return sj.b?sj.b(!1,a):sj.call(null,!1,a)};function Dt(a,b,c){b=new q(null,2,[yl,Ek,Fj,b],null);a=zt(a)?P.h(b,gl,wt(a),M([Dm,ut(a),Pm,vt(a)])):b;var d=gl.c(a);b=Dm.c(a);var e=Pm.c(a);d=r(d)?[t.c(d)," "].join(""):null;b=r(b)?["[line ",t.c(b),", col ",t.c(e),"]"].join(""):null;c=kf(t,d,b,r(r(d)?d:b)?" ":null,c);throw vj(c,a);}function Et(a,b){return Dt(a,Lj,M([jf(t,b)]))}function Ft(a,b){return Dt(a,Rl,M([jf(t,b)]))}function Gt(a,b){return Dt(a,Sn,M([jf(t,b)]))}
function Ht(a,b,c,d){Et(a,M(["The map literal starting with ",Ct(x(d)),r(b)?[" on line ",t.c(b)," column ",t.c(c)].join(""):null," contains ",L(d)," form(s). Map literals must contain an even number of forms."]))}function It(a,b,c){return Et(a,M(["Invalid ",Me(b),": ",c,"."]))}function Jt(a,b,c){return Et(a,M(["Invalid character: ",c," found while reading ",Me(b),"."]))}
function Kt(a,b){a:{var c=Nl instanceof H?Nl.X:null;switch(c){case "regex":c='#"';break a;case "string":c='"';break a;default:throw Error(["No matching clause: ",t.c(c)].join(""));}}return Gt(a,M(["Unexpected EOF reading ",Me(Nl)," starting ",lb(t,c,b),"."]))}function Lt(a,b){return Ft(a,M(["Invalid digit ",b," in unicode character."]))}function Mt(a){return Et(a,M(["Octal escape sequence must be in range [0, 377]."]))}
function Nt(a,b){b=function(a){return function g(a){return new Ne(null,function(){for(var b=a;;)if(b=I(b)){if(Ud(b)){var c=tc(b),e=L(c),m=Re(e);a:for(var p=0;;)if(p<e){var u=B.b(c,p),w=O(u,0);1<O(u,1)&&m.add(w);p+=1}else{c=!0;break a}return c?Te(m.aa(),g(uc(b))):Te(m.aa(),null)}m=x(b);c=O(m,0);if(1<O(m,1))return ud(c,g(Vc(b)));b=Vc(b)}else return null},null,null)}(ki(a))}(b);return kf(t,a,1<L(b)?"s":null,": ",Qf(1,Vf.b(new Sf(null,-1,", ",null),b)))}
function Ot(a,b,c){Et(a,M([Nt([t.c(ha(Me(b)))," literal contains duplicate key"].join(""),c)]))};function Pt(a){for(var b=a.mc(null);;)if(nt.c?nt.c(b):nt.call(null,b))b=a.mc(null);else return b}var Qt=/^([-+]?)(?:(0)|([1-9][0-9]*)|0[xX]([0-9A-Fa-f]+)|0([0-7]+)|([1-9][0-9]?)[rR]([0-9A-Za-z]+)|0[0-9]+)(N)?$/,Rt=/([-+]?[0-9]+)\/([0-9]+)/,St=/([-+]?[0-9]+(\.[0-9]*)?([eE][-+]?[0-9]+)?)(M)?/;function Tt(a,b){a=oi(a,b);return O(a,0)===b}
function Ut(a){if(Tt(Qt,a)){var b=yg(oi(Qt,a));if(null!=(b.c?b.c(2):b.call(null,2)))a=0;else{a="-"===(b.c?b.c(1):b.call(null,1));b=null!=(b.c?b.c(3):b.call(null,3))?new U(null,2,5,V,[b.c?b.c(3):b.call(null,3),10],null):null!=(b.c?b.c(4):b.call(null,4))?new U(null,2,5,V,[b.c?b.c(4):b.call(null,4),16],null):null!=(b.c?b.c(5):b.call(null,5))?new U(null,2,5,V,[b.c?b.c(5):b.call(null,5),8],null):null!=(b.c?b.c(7):b.call(null,7))?new U(null,2,5,V,[b.c?b.c(7):b.call(null,7),parseInt(b.c?b.c(6):b.call(null,
6))],null):new U(null,2,5,V,[null,null],null);var c=b.c?b.c(0):b.call(null,0);null==c?a=null:(b=parseInt(c,b.c?b.c(1):b.call(null,1)),a=a?-1*b:b,a=r(isNaN(a))?null:a)}}else Tt(St,a)?(b=yg(oi(St,a)),a=null!=(b.c?b.c(4):b.call(null,4))?parseFloat(b.c?b.c(1):b.call(null,1)):parseFloat(a)):Tt(Rt,a)?(b=yg(oi(Rt,a)),a=b.c?b.c(1):b.call(null,1),b=b.c?b.c(2):b.call(null,2),a=r(oi(/^\+/,a))?De.b(a,1):a,a=parseInt(a)/parseInt(b)):a=null;return a}
function Vt(a){if(""===a||!0===/:$/.test(a)||!0===/^::/.test(a))return null;var b=a.indexOf("/"),c=0<b?De.f(a,0,b):null;if(null!=c){b+=1;if(b===L(a))return null;a=De.b(a,b);return ot(pd(a,0))||""===a||!1!==/:$/.test(c)||"/"!==a&&-1!==a.indexOf("/")?null:new U(null,2,5,V,[c,a],null)}return"/"===a||-1===a.indexOf("/")?new U(null,2,5,V,[null,a],null):null}
var Wt=function Wt(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Wt.h(arguments[0],1<c.length?new v(c.slice(1),0,null):null)};Wt.h=function(a){for(;;){var b=a.mc(null);if("\n"===b||"\n"===b||null==b)break}return a};Wt.H=1;Wt.K=function(a){var b=x(a);a=y(a);return this.h(b,a)};
function Xt(){return function(){function a(a,d){var c=null;if(1<arguments.length){c=0;for(var g=Array(arguments.length-1);c<g.length;)g[c]=arguments[c+1],++c;c=new v(g,0,null)}return b.call(this,a,c)}function b(a){return Et(a,M(["Unreadable form"]))}a.H=1;a.K=function(a){var c=x(a);a=Vc(a);return b(c,a)};a.h=b;return a}()};new Ia;if("undefined"===typeof Ka||"undefined"===typeof jt||"undefined"===typeof kt||"undefined"===typeof Yt)var Yt={};if("undefined"===typeof Ka||"undefined"===typeof jt||"undefined"===typeof kt||"undefined"===typeof Zt)var Zt={};if("undefined"===typeof Ka||"undefined"===typeof jt||"undefined"===typeof kt||"undefined"===typeof $t)var $t={};function au(a){var b="#"!==a;return b&&(b="'"!==a)?(b=":"!==a)?bu.c?bu.c(a):bu.call(null,a):b:b}function cu(a){return"@"===a||"`"===a||"~"===a}function du(a,b,c,d){if(db(c))return Gt(a,M(["Unexpected EOF while reading start of ",Me(b),"."]));if(r(r(d)?cu(c):d))return Jt(a,b,c);d=new Ia;for(tt(a,c);;){if(nt(c)||au(c)||null==c)return t.c(d);if(cu(c))return Jt(a,b,c);d.append(rt(a));c=st(a)}}
function eu(a,b,c){b=rt(a);if(r(b)){var d=fu.c?fu.c(b):fu.call(null,b);if(r(d))return d.f?d.f(a,b,c):d.call(null,a,b,c);tt(a,b);c=gu.f?gu.f(a,b,c):gu.call(null,a,b,c);return r(c)?c:Et(a,M(["No dispatch macro for ",b,"."]))}return Gt(a,M(["Unexpected EOF while reading dispatch character."]))}function hu(a,b){return Et(a,M(["Unmatched delimiter ",b,"."]))}
function iu(a,b,c){b=1+b;if(L(a)!==b)throw Ft(null,M(["Invalid unicode literal: \\",a,"."]));for(var d=1,e=0;;){if(d===b)return String.fromCharCode(e);var g=qt(pd(a,d),c);if(-1===g)return c=pd(a,d),Ft(null,M(["Invalid digit ",c," in unicode character \\",a,"."]));e=g+e*c;d+=1}}
function ju(a,b,c,d,e){for(var g=1,h=qt(b,c);;){if(-1===h)return Lt(a,b);if(g!==d){var k=st(a);var l=nt(k);l||(l=bu.c?bu.c(k):bu.call(null,k),l=r(l)?l:null==k);if(r(l))return r(e)?Ft(a,M(["Invalid unicode literal. Unicode literals should be ",d,"characters long.  ","value suppled is ",g,"characters long."])):String.fromCharCode(h);l=qt(k,c);rt(a);if(-1===l)return Lt(a,k);h=l+h*c;g+=1}else return String.fromCharCode(h)}}
function ku(a){var b=rt(a);if(null!=b){b=au(b)||cu(b)||nt(b)?t.c(b):du(a,fo,b,!1);var c=L(b);if(1===c)return pd(b,0);if("newline"===b)return"\n";if("space"===b)return" ";if("tab"===b)return"\t";if("backspace"===b)return"\b";if("formfeed"===b)return"\f";if("return"===b)return"\r";if(r(0==b.lastIndexOf("u",0)))return b=iu(b,4,16),c=b.charCodeAt(),55295<c&&57344>c?(b=c.toString(16),a=Et(a,M(["Invalid character literal \\u",b,"."]))):a=b,a;if(r(0==b.lastIndexOf("o",0))){--c;if(3<c)return Et(a,M(["Invalid octal escape sequence in a character literal:",
b,". Octal escape sequences must be 3 or fewer digits."]));b=iu(b,c,8);return 255<(b|0)?Mt(a):b}return Et(a,M(["Unsupported character: ",b,"."]))}return Gt(a,M(["Unexpected EOF while reading character."]))}function lu(a){return zt(a)?new U(null,2,5,V,[ut(a),(vt(a)|0)-1|0],null):null}
function mu(a,b,c,d){var e=lu(c),g=O(e,0);e=O(e,1);b=null==b?null:xe(b);for(var h=lc(Cd);;){var k=Pt(c);if(!r(k)){var l=a,m=g,p=e,u=L(h);Gt(c,M(["Unexpected EOF while reading ",r(u)?["item ",t.c(u)," of "].join(""):null,Me(l),r(m)?[", starting at line ",t.c(m)," and column ",t.c(p)].join(""):null,"."]))}if(J.b(b,null==k?null:xe(k)))return nc(h);l=bu.c?bu.c(k):bu.call(null,k);r(l)?(k=l.f?l.f(c,k,d):l.call(null,c,k,d),h=k!==c?af.b(h,k):h):(tt(c,k),k=nu?nu(c,!0,null,d):ou.call(null,c,!0,null,d),h=k!==
c?af.b(h,k):h)}}function pu(a,b,c){a=mu(Em,")",a,c);return Nd(a)?Wc:jf(He,a)}function qu(a,b,c){return mu(Ql,"]",a,c)}function ru(a,b,c){var d=lu(a);b=O(d,0);d=O(d,1);c=mu(go,"}",a,c);var e=L(c),g=hi(2,c),h=Xh(g);!vf(e)&&Ht(a,b,d,c);J.b(L(h),L(g))||Ot(a,go,g);if(e<=2*Xg)a=fe(c),a=new q(null,a.length/2,a,null);else a:for(a=fe(c),b=a.length,d=0,e=lc(Yg);;)if(d<b)c=d+2,e=oc(e,a[d],a[d+1]),d=c;else{a=nc(e);break a}return a}
function su(a,b){for(var c=function(){var a=new Ia;a.append(b);return a}(),d=rt(a);;){if(r(function(){var a=nt(d);if(a)return a;a=bu.c?bu.c(d):bu.call(null,d);return r(a)?a:null==d}())){var e=t.c(c);tt(a,d);var g=Ut(e);return r(g)?g:Et(a,M(["Invalid number: ",e,"."]))}e=function(){var a=c;a.append(d);return a}();g=rt(a);c=e;d=g}}
function tu(a){var b=rt(a);switch(b){case "t":return"\t";case "r":return"\r";case "n":return"\n";case "\\":return"\\";case '"':return'"';case "b":return"\b";case "f":return"\f";case "u":return b=rt(a),-1===parseInt(b|0,16)?Et(a,M(["Invalid unicode escape: \\u",b,"."])):ju(a,b,16,4,!0);default:return ot(b)?(b=ju(a,b,8,3,!1),255<(b|0)?Mt(a):b):Et(a,M(["Unsupported escape character: \\",b,"."]))}}
function uu(a){for(var b=new Ia,c=rt(a);;){var d=c;if(J.b(null,d))return Kt(a,M(['"',b]));if(J.b("\\",d)){d=function(){var c=b;c.append(tu(a));return c}();var e=rt(a);b=d;c=e}else{if(J.b('"',d))return t.c(b);d=function(){var a=b;a.append(c);return a}();e=rt(a);b=d;c=e}}}
function vu(a,b){b=du(a,Rk,b,!0);if(r(b))switch(b){case "nil":return null;case "true":return!0;case "false":return!1;case "/":return bn;default:var c=Vt(b);c=r(c)?Sc.b(c.c?c.c(0):c.call(null,0),c.c?c.c(1):c.call(null,1)):null;return r(c)?c:It(a,Rk,b)}else return null}
function wu(a){var b=rt(a);if(nt(b))return Et(a,M(["A single colon is not a valid keyword."]));b=du(a,Hm,b,!0);var c=Vt(b);if(r(r(c)?-1===b.indexOf("::"):c)){var d=c.c?c.c(0):c.call(null,0);c=c.c?c.c(1):c.call(null,1);return":"===pd(b,0)?It(a,Hm,b):Le.b(d,c)}return It(a,Hm,b)}
function xu(a,b,c){b=nu?nu(a,!0,null,c):ou.call(null,a,!0,null,c);b=b instanceof H?Gd([b,!0]):b instanceof E?new q(null,1,[An,b],null):"string"===typeof b?new q(null,1,[An,b],null):b;Rd(b)||Et(a,M(["Metadata cannot be ",Ct(b),". Metadata must be a Symbol, Keyword, String or Map."]));c=nu?nu(a,!0,null,c):ou.call(null,a,!0,null,c);return null!=c&&(c.m&131072||n===c.Kd)?Kd(c,Qh.h(M([Ld(c),b]))):Et(a,M(["Metadata can not be applied to ",Ct(c),". ","Metadata can only be applied to IMetas."]))}
function yu(a,b,c){b=mu(Jn,"}",a,c);c=Xh(b);J.b(L(b),L(c))||Ot(a,Jn,b);return c}function zu(a){nu?nu(a,!0,null,!0):ou.call(null,a,!0,null,!0);return a}
function Au(a,b,c){b=rt(a);b=du(a,ok,b,!0);var d=null==b?null:Vt(b);if(null==d)var e=null;else e=O(d,0),d=O(d,1),e=r(e)?null:d;return r(e)?"{"===Pt(a)?(c=mu(ok,"}",a,c),!vf(L(c))&&Ht(a,null,null,c),b=pt(t.c(e),hi(2,c)),c=hi(2,Vc(c)),J.b(L(Xh(b)),L(b))||Ot(a,ok,b),$h(b,c)):Et(a,M(["Namespaced map with namespace ",b," does not specify a map."])):Et(a,M(["Invalid value used as namespace in namespaced map: ",b,"."]))}
function Bu(a,b,c){b=nu?nu(a,!0,null,c):ou.call(null,a,!0,null,c);return J.b(Xk,b)?Number.NaN:J.b(ln,b)?Number.NEGATIVE_INFINITY:J.b(Hl,b)?Number.POSITIVE_INFINITY:Et(a,M([["Invalid token: ##",t.c(b)].join("")]))}function bu(a){switch(a){case '"':return uu;case ":":return wu;case ";":return Wt;case "^":return xu;case "(":return pu;case ")":return hu;case "[":return qu;case "]":return hu;case "{":return ru;case "}":return hu;case "\\":return ku;case "#":return eu;default:return null}}
function fu(a){switch(a){case "^":return xu;case "{":return yu;case "\x3c":return Xt();case "!":return Wt;case "_":return zu;case ":":return Au;case "#":return Bu;default:return null}}
function gu(a,b,c){b=nu?nu(a,!0,null,c):ou.call(null,a,!0,null,c);var d=nu?nu(a,!0,null,c):ou.call(null,a,!0,null,c);b instanceof E||Et(a,M(["Invalid reader tag: ",Ct("Reader tag must be a symbol"),". Reader tags must be symbols."]));var e=F.b(ml.c(c),b);e=r(e)?e:pf.c?pf.c(b):pf.call(null,b);if(r(e))return e.c?e.c(d):e.call(null,d);c=pj.c(c);return r(c)?c.b?c.b(b,d):c.call(null,b,d):Et(a,M(["No reader function for tag ",Ct(b),"."]))}
function ou(a){switch(arguments.length){case 1:return Cu(pf,arguments[0]);case 2:return Cu(arguments[0],arguments[1]);case 4:return nu(arguments[0],arguments[1],arguments[2],arguments[3]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}}function Cu(a,b){a=null!=a&&(a.m&64||n===a.Ga)?jf(Ff,a):a;var c=F.b(a,Sn),d=!Zd(a,Sn);return nu(b,d,c,a)}
function nu(a,b,c,d){try{for(;;){var e=rt(a);if(!nt(e)){if(null==e){if(r(b)){b=a;var g=r(null)?Gt(b,M(["EOF while reading, starting at line ",null,"."])):Gt(b,M(["EOF while reading."]))}else g=c;return g}if(ot(e)||("+"===e||"-"===e)&&ot(a.Dc(null)))return su(a,e);var h=bu(e);if(r(h)){var k=h.f?h.f(a,e,d):h.call(null,a,e,d);if(k!==a)return k}else return vu(a,e)}}}catch(l){if(l instanceof Error){g=l;if(g instanceof uj){b=g instanceof uj?g.data:null;if(J.b(Ek,yl.c(b)))throw g;a=Qh.h(M([new q(null,1,
[yl,Ek],null),b,zt(a)?new q(null,3,[Dm,ut(a),fm,vt(a),gl,wt(a)],null):null]));throw new uj(g.message,a,g);}a=Qh.h(M([new q(null,1,[yl,Ek],null),zt(a)?new q(null,3,[Dm,ut(a),fm,vt(a),gl,wt(a)],null):null]));throw new uj(g.message,a,g);}throw l;}};var Du=function(a,b){return function(c,d){return F.b(r(d)?b:a,c)}}(new U(null,13,5,V,[null,31,28,31,30,31,30,31,31,30,31,30,31],null),new U(null,13,5,V,[null,31,29,31,30,31,30,31,31,30,31,30,31],null)),Eu=/(\d\d\d\d)(?:-(\d\d)(?:-(\d\d)(?:[T](\d\d)(?::(\d\d)(?::(\d\d)(?:[.](\d+))?)?)?)?)?)?(?:[Z]|([-+])(\d\d):(\d\d))?/;function Fu(a){a=parseInt(a,10);return db(isNaN(a))?a:null}
function Gu(a,b,c,d){if(!(a<=b&&b<=c))throw Error([t.c(d)," Failed:  ",t.c(a),"\x3c\x3d",t.c(b),"\x3c\x3d",t.c(c)].join(""));return b}
function Hu(a){var b=ni(Eu,a);O(b,0);var c=O(b,1),d=O(b,2),e=O(b,3),g=O(b,4),h=O(b,5),k=O(b,6),l=O(b,7),m=O(b,8),p=O(b,9),u=O(b,10);if(db(b))throw Error(["Unrecognized date/time syntax: ",t.c(a)].join(""));var w=Fu(c),z=function(){var a=Fu(d);return r(a)?a:1}();a=function(){var a=Fu(e);return r(a)?a:1}();b=function(){var a=Fu(g);return r(a)?a:0}();c=function(){var a=Fu(h);return r(a)?a:0}();var D=function(){var a=Fu(k);return r(a)?a:0}(),C=function(){a:if(J.b(3,L(l)))var a=l;else if(3<L(l))a=De.f(l,
0,3);else for(a=new Ia(l);;)if(3>a.cc.length)a=a.append("0");else{a=a.toString();break a}a=Fu(a);return r(a)?a:0}();m=(J.b(m,"-")?-1:1)*(60*function(){var a=Fu(p);return r(a)?a:0}()+function(){var a=Fu(u);return r(a)?a:0}());return new U(null,8,5,V,[w,Gu(1,z,12,"timestamp month field must be in range 1..12"),Gu(1,a,function(){var a=0===ze(w,4)&&(0!==ze(w,100)||0===ze(w,400));return Du.b?Du.b(z,a):Du.call(null,z,a)}(),"timestamp day field must be in range 1..last day in month"),Gu(0,b,23,"timestamp hour field must be in range 0..23"),
Gu(0,c,59,"timestamp minute field must be in range 0..59"),Gu(0,D,J.b(c,59)?60:59,"timestamp second field must be in range 0..60"),Gu(0,C,999,"timestamp millisecond field must be in range 0..999"),m],null)}
var Iu=Cf(null),Ju=Cf(Qh.h(M([new q(null,4,[xl,function(a){if("string"===typeof a){var b=Hu(a);if(r(b)){a=O(b,0);var c=O(b,1),d=O(b,2),e=O(b,3),g=O(b,4),h=O(b,5),k=O(b,6);b=O(b,7);b=new Date(Date.UTC(a,c-1,d,e,g,h,k)-6E4*b)}else throw Error(["Unrecognized date/time syntax: ",t.c(a)].join(""));return b}throw Error("Instance literal expects a string for its timestamp.");},Cj,function(a){if("string"===typeof a)return new tj(a.toLowerCase());throw Error("UUID literal expects a string as its representation.");
},Ol,function(a){if(Td(a))return $f.b(Kg,a);throw Error("Queue literal expects a vector for its elements.");},ll,function(a){if(Td(a)){var b=[];a=I(a);for(var c=null,d=0,e=0;;)if(e<d){var g=c.Z(null,e);b.push(g);e+=1}else if(a=I(a))c=a,Ud(c)?(a=tc(c),e=uc(c),c=a,d=L(a),a=e):(a=x(c),b.push(a),a=y(c),c=null,d=0),e=0;else break;return b}if(Rd(a)){b={};a=I(a);c=null;for(e=d=0;;)if(e<d){var h=c.Z(null,e);g=O(h,0);h=O(h,1);var k=b;g=Me(g);k[g]=h;e+=1}else if(a=I(a))Ud(a)?(d=tc(a),a=uc(a),c=d,d=L(d)):(d=
x(a),c=O(d,0),d=O(d,1),e=b,c=Me(c),e[c]=d,a=y(a),c=null,d=0),e=0;else break;return b}throw Error("JS literal expects a vector or map containing only string or unqualified keyword keys");}],null),pf])));
function Ku(a){var b=new q(null,3,[ml,Rb(Ju),pj,Rb(Iu),Sn,null],null);if(r(r(a)?lf.b(a,""):a)){a=new xt(a,L(a));a:{var c=Array(1);if(Xd(null))for(var d=0,e=I(null);;)if(e&&1>d)c[d]=x(e),d+=1,e=y(e);else break a;else for(d=0;;)if(1>d)c[d]=null,d+=1;else break}b=Cu(b,new yt(a,c))}else b=null;return b};function Lu(a,b){b="number"===typeof b||Qd(b)||b instanceof H?Eq(a,b):null;if(r(b)){var c=new Jf(!1),d=new Jf(pf);return Mu.B?Mu.B(a,b,c,d):Mu.call(null,a,b,c,d)}return null}function Nu(a,b,c){return Dq(a,b,Mn)?Aq(a,b)?A(function(b,c){return Bd.b(b,Lu(a,ik.c(c)))},Wh,c):A(function(a,b){return Bd.b(a,ik.c(b))},Wh,c):Aq(a,b)?Lu(a,ik.c(x(c))):ik.c(x(c))}
function Ou(a,b,c,d){b=mf(Zp(a,new U(null,3,5,V,[null,c,b],null)));return r(b)?Dq(a,c,Ll)?Lu(a,Vl.c(x(b))):A(function(){return function(b,c){return Bd.b(b,Lu(a,Vl.c(c)))}}(b,b),Wh,b):d}function Pu(a){return r(a)?fe(a):null}
function Qu(a){Ru.c?Ru.c(a):Ru.call(null,a);return function d(c){return new Ne(null,function(){for(;;){var e=I(c);if(e){if(Ud(e)){var g=tc(e),h=L(g),k=Re(h);a:for(var l=0;;)if(l<h){var m=B.b(g,l),p=O(m,0);m=O(m,1);p=Dq(a.db,p,Mn)?new U(null,2,5,V,[p,Pu(m)],null):new U(null,2,5,V,[p,m],null);k.add(p);l+=1}else{g=!0;break a}return g?Te(k.aa(),d(uc(e))):Te(k.aa(),null)}g=x(e);k=O(g,0);g=O(g,1);return ud(Dq(a.db,k,Mn)?new U(null,2,5,V,[k,Pu(g)],null):new U(null,2,5,V,[k,g],null),d(Vc(e)))}return null}},
null,null)}(Rb(a.cache))}function Su(a,b,c,d){this.db=a;this.eid=b;this.zd=c;this.cache=d;this.m=2162164483;this.F=0}f=Su.prototype;f.entry_set=function(){return fe(Nf.b(fe,Qu(this)))};
f.forEach=function(){function a(a,b){for(var c=I(Qu(this)),d=null,e=0,l=0;;)if(l<e){var m=d.Z(null,l),p=O(m,0);m=O(m,1);a.call(b,m,p,this);l+=1}else if(c=I(c))Ud(c)?(d=tc(c),c=uc(c),p=d,e=L(d),d=p):(d=x(c),p=O(d,0),m=O(d,1),a.call(b,m,p,this),c=y(c),d=null,e=0),l=0;else return null}function b(a){for(var b=I(Qu(this)),c=null,d=0,k=0;;)if(k<d){var l=c.Z(null,k),m=O(l,0);l=O(l,1);a.f?a.f(l,m,this):a.call(null,l,m,this);k+=1}else if(b=I(b))Ud(b)?(c=tc(b),b=uc(b),m=c,d=L(c),c=m):(c=x(b),m=O(c,0),l=O(c,
1),a.f?a.f(l,m,this):a.call(null,l,m,this),b=y(b),c=null,d=0),k=0;else return null}var c=null;c=function(c,e){switch(arguments.length){case 1:return b.call(this,c);case 2:return a.call(this,c,e)}throw Error("Invalid arity: "+arguments.length);};c.c=b;c.b=a;return c}();f.get=function(a){if(J.b(a,":db/id"))return this.eid;if(Nq(a))return Pu(Ou(this.db,this.eid,Oq(a),null));var b=Tu?Tu(this,a):Uu.call(null,this,a);return Dq(this.db,a,Mn)?Pu(b):b};f.key_set=function(){return fe(Ug(this))};f.entries=function(){return new Pg(I(Qu(this)))};
f.value_set=function(){return fe(Nf.b(xd,Qu(this)))};f.toString=function(){return Dc(this)};f.keys=function(){return Yc(Ug(this))};f.values=function(){return Yc(Nf.b(xd,Qu(this)))};f.equiv=function(a){return Vu.b?Vu.b(this,a):Vu.call(null,this,a)};f.has=function(a){return null!=this.get(a)};f.M=function(a,b){return Wu?Wu(this,b,null):Uu.call(null,this,b,null)};f.o=function(a,b,c){return Wu?Wu(this,b,c):Uu.call(null,this,b,c)};f.L=function(a,b,c){return kc(P.f(Rb(this.cache),gn,this.eid),b,c)};
f.P=function(){Ru.c?Ru.c(this):Ru.call(null,this);return L(Rb(this.cache))};f.O=function(){return Oc(this.eid)};f.C=function(a,b){return Vu.b?Vu.b(this,b):Vu.call(null,this,b)};f.N=function(){Ru.c?Ru.c(this):Ru.call(null,this);return I(Rb(this.cache))};
f.call=function(){function a(a,b,c){return Wu?Wu(this,b,c):Uu.call(null,this,b,c)}function b(a,b){return Tu?Tu(this,b):Uu.call(null,this,b)}var c=null;c=function(c,e,g){switch(arguments.length){case 2:return b.call(this,c,e);case 3:return a.call(this,c,e,g)}throw Error("Invalid arity: "+(arguments.length-1));};c.b=b;c.f=a;return c}();f.apply=function(a,b){return this.call.apply(this,[this].concat(jb(b)))};f.c=function(a){return Tu?Tu(this,a):Uu.call(null,this,a)};
f.b=function(a,b){return Wu?Wu(this,a,b):Uu.call(null,this,a,b)};function Mu(a,b,c,d){return new Su(a,b,c,d)}function Vu(a,b){return b instanceof Su&&J.b(a.eid,b.eid)}function Uu(a){switch(arguments.length){case 2:return Tu(arguments[0],arguments[1]);case 3:return Wu(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}}function Tu(a,b){return Wu(a,b,null)}
function Wu(a,b,c){if(J.b(b,gn))return a.eid;if(Nq(b))return Ou(a.db,a.eid,Oq(b),c);var d=Rb(a.cache);d=d.c?d.c(b):d.call(null,b);if(null==d){if(r(Rb(a.zd)))return c;d=mf(Zp(a.db,new U(null,2,5,V,[a.eid,b],null)));if(null==d)return c;c=Nu(a.db,b,d);b=P.f(Rb(a.cache),b,c);zc(a.cache,b);return c}return d}function Xu(a,b){return je(function(b,d,e){return P.f(b,d,Dq(a,d,Ll)?Dq(a,d,Mn)?Xh(Nf.b(Ru,e)):Ru.c?Ru.c(e):Ru.call(null,e):e)},pf,b)}
function Yu(a,b){return A(function(b,d){var c=qo.c(x(d));return P.f(b,c,Nu(a,c,d))},pf,ji(qo,b))}function Ru(a){if(!r(Rb(a.zd))){var b=mf(Zp(a.db,new U(null,1,5,V,[a.eid],null)));r(b)&&(b=Xu(a.db,Yu(a.db,b)),zc(a.cache,b),zc(a.zd,!0))}return a}fa("datascript.impl.entity.Entity",Su);function Zu(a,b,c,d,e,g){this.Ob=a;this.Pb=b;this.rules=c;this.i=d;this.g=e;this.j=g;this.m=2230716170;this.F=139264}f=Zu.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "rels":return this.Ob;case "sources":return this.Pb;case "rules":return this.rules;default:return F.f(this.g,b,c)}};f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};
f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.query.Context{",", ","}",c,T.b(new U(null,3,5,V,[new U(null,2,5,V,[pm,this.Ob],null),new U(null,2,5,V,[Tk,this.Pb],null),new U(null,2,5,V,[Wl,this.rules],null)],null),this.g))};f.W=function(){return new Og(this,3,new U(null,3,5,V,[pm,Tk,Wl],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};f.P=function(){return 3+L(this.g)};
f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 1014232958^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.Ob,b.Ob)&&J.b(this.Pb,b.Pb)&&J.b(this.rules,b.rules)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,3,[Tk,null,Wl,null,pm,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new Zu(this.Ob,this.Pb,this.rules,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(pm,b):S.call(null,pm,b))?new Zu(c,this.Pb,this.rules,this.i,this.g,null):r(S.b?S.b(Tk,b):S.call(null,Tk,b))?new Zu(this.Ob,c,this.rules,this.i,this.g,null):r(S.b?S.b(Wl,b):S.call(null,Wl,b))?new Zu(this.Ob,this.Pb,c,this.i,this.g,null):new Zu(this.Ob,this.Pb,this.rules,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,3,5,V,[new W(pm,this.Ob),new W(Tk,this.Pb),new W(Wl,this.rules)],null),this.g))};
f.S=function(a,b){return new Zu(this.Ob,this.Pb,this.rules,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};function $u(a,b,c,d,e){this.Ia=a;this.ac=b;this.i=c;this.g=d;this.j=e;this.m=2230716170;this.F=139264}f=$u.prototype;f.M=function(a,b){return this.o(null,b,null)};f.o=function(a,b,c){switch(b instanceof H?b.X:null){case "attrs":return this.Ia;case "tuples":return this.ac;default:return F.f(this.g,b,c)}};
f.$=function(a,b,c){return A(function(){return function(a,c){var d=O(c,0);c=O(c,1);return b.f?b.f(a,d,c):b.call(null,a,d,c)}}(this),c,this)};f.L=function(a,b,c){return X(b,function(){return function(a){return X(b,wi,""," ","",c,a)}}(this),"#datascript.query.Relation{",", ","}",c,T.b(new U(null,2,5,V,[new U(null,2,5,V,[jn,this.Ia],null),new U(null,2,5,V,[Nj,this.ac],null)],null),this.g))};f.W=function(){return new Og(this,2,new U(null,2,5,V,[jn,Nj],null),r(this.g)?Bc(this.g):nf())};f.R=function(){return this.i};
f.P=function(){return 2+L(this.g)};f.O=function(){var a=this,b=this.j;if(null!=b)return b;var c=function(){return function(){return function(a){return 1107093117^bd(a)}}(b,a)(a)}();return this.j=c};f.C=function(a,b){return null!=b&&this.constructor===b.constructor&&J.b(this.Ia,b.Ia)&&J.b(this.ac,b.ac)&&J.b(this.g,b.g)};f.ba=function(a,b){return Zd(new Uh(null,new q(null,2,[Nj,null,jn,null],null),null),b)?Q.b(Ub($f.b(pf,this),this.i),b):new $u(this.Ia,this.ac,this.i,mf(Q.b(this.g,b)),null)};
f.I=function(a,b,c){return r(S.b?S.b(jn,b):S.call(null,jn,b))?new $u(c,this.ac,this.i,this.g,null):r(S.b?S.b(Nj,b):S.call(null,Nj,b))?new $u(this.Ia,c,this.i,this.g,null):new $u(this.Ia,this.ac,this.i,P.f(this.g,b,c),null)};f.N=function(){return I(T.b(new U(null,2,5,V,[new W(jn,this.Ia),new W(Nj,this.ac)],null),this.g))};f.S=function(a,b){return new $u(this.Ia,this.ac,b,this.g,this.j)};f.T=function(a,b){return Td(b)?this.I(null,B.b(b,0),B.b(b,1)):A(wb,this,b)};
function av(a,b){return Eo.b(Xh(Ug(a)),Xh(Ug(b)))}function bv(a,b){return J.b(L(a),L(b))&&tf(function(a){return Zd(b,a)},Ug(a))&&tf(function(a){return Zd(b,a)},Ug(a))}
var cv=function cv(a,b){return J.b(Pl,a)?!0:J.b(new U(null,1,5,V,[Zk],null),a)?Qd(b):a instanceof E?J.b(b,a):Qd(a)?J.b(Ad(a),Zk)?Qd(b)&&tf(function(a){var b=O(a,0);a=O(a,1);return cv.b?cv.b(b,a):cv.call(null,b,a)},Nf.f(Ag,Zh(a),b)):Qd(b)&&J.b(L(b),L(a))&&tf(function(a){var b=O(a,0);a=O(a,1);return cv.b?cv.b(b,a):cv.call(null,b,a)},Nf.f(Ag,a,b)):a.c?a.c(b):a.call(null,b)};function dv(a){return a instanceof E&&J.b("$",x(Me(a)))}function ev(a){return a instanceof E&&J.b("?",x(Me(a)))}
function fv(a){return a instanceof H||"string"===typeof a}function gv(a){return cv(new U(null,2,5,V,[fv,Pl],null),a)}function hv(a,b,c,d){for(var e=b.length,g=d.length,h=Array(e+g),k=0;;)if(k<e)mb.f(h,k,a[kb.b(b,k)]),k+=1;else break;for(a=0;;)if(a<g)mb.f(h,e+a,c[kb.b(d,a)]),a+=1;else break;return h}
var iv=function iv(a,b){var d=null!=a&&(a.m&64||n===a.Ga)?jf(Ff,a):a,e=F.b(d,jn),g=F.b(d,Nj),h=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b,k=F.b(h,jn),l=F.b(h,Nj);if(J.b(e,k))return new $u(e,$f.b(yg(g),l),null,null,null);if(bv(e,k)){if(tf(cb,Vg(e))){var m=yg(function(){return function(a,b,d,e,g,h,k,l){return function R(m){return new Ne(null,function(a,b,d){return function(){for(;;){var a=I(m);if(a){if(Ud(a)){var b=tc(a),e=L(b),g=Re(e);a:for(var h=0;;)if(h<e){var k=B.b(b,h),l=O(k,0);k=O(k,1);l=new U(null,
2,5,V,[k,d.c?d.c(l):d.call(null,l)],null);g.add(l);h+=1}else{b=!0;break a}return b?Te(g.aa(),R(uc(a))):Te(g.aa(),null)}b=x(a);g=O(b,0);b=O(b,1);return ud(new U(null,2,5,V,[b,d.c?d.c(g):d.call(null,g)],null),R(Vc(a)))}return null}}}(a,b,d,e,g,h,k,l),null,null)}}(a,d,e,g,b,h,k,l)(k)}()),p=ie(ve,Vg(e))+1;m=nc(A(function(a,b){return function(d,e){for(var g=Array(b),h=I(a),k=null,l=0,m=0;;)if(m<l){var p=k.Z(null,m),u=O(p,0);p=O(p,1);mb.f(g,p,e[u]);m+=1}else if(h=I(h))Ud(h)?(l=tc(h),h=uc(h),k=l,l=L(l)):
(l=x(h),k=O(l,0),l=O(l,1),mb.f(g,l,e[k]),h=y(h),k=null,l=0),m=0;else break;return af.b(d,g)}}(m,p,a,d,e,g,b,h,k,l),lc(yg(g)),l));return new $u(e,m,null,null,null)}var u=$h(Ug(Qh.h(M([e,k]))),gi.G());m=function(){var b=new $u(u,Cd,null,null,null);return iv.b?iv.b(b,a):iv.call(null,b,a)}();return iv.b?iv.b(m,b):iv.call(null,m,b)}throw vj(["Can’t sum relations with different attrs: ",Di.h(M([e]))," and ",Di.h(M([k]))].join(""),new q(null,1,[qn,Vn],null));},jv=function jv(a){switch(arguments.length){case 0:return jv.G();
case 2:return jv.b(arguments[0],arguments[1]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};jv.G=function(){return new $u(pf,new U(null,1,5,V,[[]],null),null,null,null)};
jv.b=function(a,b){var c=Ug(jn.c(a)),d=Ug(jn.c(b)),e=fe(Nf.b(jn.c(a),c)),g=fe(Nf.b(jn.c(b),d));return new $u($h(T.b(c,d),gi.G()),nc(A(function(a,c,d,e){return function(g,h){return A(function(a,b,c,d){return function(a,b){return af.b(a,hv(h,c,b,d))}}(a,c,d,e),g,Nj.c(b))}}(c,d,e,g),lc(Cd),Nj.c(a))),null,null,null)};jv.H=2;var kv=function kv(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return kv.h(0<c.length?new v(c.slice(0),0,null):null)};
kv.h=function(a){var b=L(a);return lf.b(Pf(b/2,a),Qf(b/2,a))};kv.H=0;kv.K=function(a){return this.h(I(a))};var lv=function lv(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return lv.h(arguments[0],arguments[1],2<c.length?new v(c.slice(2),0,null):null)};lv.h=function(a,b,c){return A(function(c,e){c=x(Zp(a,new U(null,2,5,V,[b,e],null)));return null==c?null:new ed(new U(null,2,5,V,[qo.c(c),ik.c(c)],null))},null,c)};lv.H=2;
lv.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};var mv=function mv(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return mv.h(0<c.length?new v(c.slice(0),0,null):null)};mv.h=function(a){return A(function(a,c){return r(c)?c:new ed(c)},!0,a)};mv.H=0;mv.K=function(a){return this.h(I(a))};var nv=function nv(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return nv.h(0<c.length?new v(c.slice(0),0,null):null)};
nv.h=function(a){return A(function(a,c){return r(c)?new ed(c):c},null,a)};nv.H=0;nv.K=function(a){return this.h(I(a))};
var ov=th([Ym,po,yn,Kj,dn,ro,Fl,$n,jl,xm,Cn,bn,rl,Rn,Im,kl,eo,sk,Vk,Sj,ck,al,Gn,mm,Hn,Bl,ek,jo,Yn,Pn,ho,xk,Un,ql,Zk,Zl,Mj,ol,sm,Xn,cl,fk,$k,cn,vl,On,kk,Zj,km,tk,Fk,Dl,sn,Fn,Dj,pl,Gj,bm,sl,tn,vm,Ml,Jm,Ik,pk,en,lm,Km,Hj,Gm],[function(a){return!0===a},mv,function(a){return!vf(a)},function(a,b,c,d){if(null==d)throw vj("get-else: nil default value is not supported",new q(null,1,[qn,Vn],null));a=x(Zp(a,new U(null,2,5,V,[b,c],null)));return null==a?d:ik.c(a)},ue,Fi,te,L,lv,$a,dd,qe,Ae,function(a){return!1===
a},db,ke,kv,function(a,b){if("string"===typeof b)return pi(a,b);throw new TypeError("re-seq must match against a string.");},se,function(a,b){return 0==a.lastIndexOf(b,0)},J,we,me,Me,function(a,b,c){return null==F.b(Lu(a,b),c)},ke,Ui,wf,Ce,Ff,be,gi,ve,Ed,pe,Di,Gi,Ld,function(a){return 0===a},lf,Ei,function(a){return a-1},function(a){if(a instanceof RegExp)return a;var b=oi(/^\(\?([idmsux]*)\)/,a),c=O(b,0);b=O(b,1);a=De.b(a,L(c));return new RegExp(a,r(b)?b:"")},Ag,lf,t,re,Ke,oe,function(a){return null!=
a},function(a){return 0<a},Ti,ni,He,Zd,function(a,b){var c=a.length-b.length;return 0<=c&&a.indexOf(b,c)==c},De,ze,function(a,b){return-1!=a.indexOf(b)},Mh,function(a,b){return a-b*Ae(a,b)},vf,fb,function(a){return 0>a},function(a){return/^[\s\xa0]*$/.test(null==a?"":String(a))},mf,nv,function(a,b){return a===b},Xh,oi]),pv=function(){function a(a){var d=b(a);return c(function(){return function(a){return function l(b){return new Ne(null,function(a){return function(){for(;;){var c=I(b);if(c){if(Ud(c)){var d=
tc(c),e=L(d),g=Re(e);a:for(var k=0;;)if(k<e){var m=B.b(d,k)-a;g.add(m*m);k+=1}else{d=!0;break a}return d?Te(g.aa(),l(uc(c))):Te(g.aa(),null)}g=x(c)-a;return ud(g*g,l(Vc(c)))}return null}}}(a),null,null)}}(d)(a)}())/L(a)}function b(a){return c(a)/L(a)}function c(a){return A(me,0,a)}return th([zm,$n,Ln,Bk,al,Un,lo,fn,vo,tl,Dl,nn],[a,L,function(a){var b=ee(a);a=L(a);var c=a>>1,d=pd(b,c);return vf(a)?(d+pd(b,c-1))/2:d},c,function(){function a(a,b){return yg(A(function(b,c){return L(b)<a?ee(Bd.b(b,c)):
0>be(c,Ad(b))?ee(Bd.b(Zh(b),c)):b},Cd,b))}function b(a){return A(function(a,b){return 0>be(b,a)?b:a},x(a),y(a))}var c=null;c=function(c,d){switch(arguments.length){case 1:return b.call(this,c);case 2:return a.call(this,c,d)}throw Error("Invalid arity: "+arguments.length);};c.c=b;c.b=a;return c}(),function(){function a(a,b){return yg(A(function(b,c){return L(b)<a?ee(Bd.b(b,c)):0<be(c,x(b))?ee(Bd.b(y(b),c)):b},Cd,b))}function b(a){return A(function(a,b){return 0<be(b,a)?b:a},x(a),y(a))}var c=null;c=
function(c,d){switch(arguments.length){case 1:return b.call(this,c);case 2:return a.call(this,c,d)}throw Error("Invalid arity: "+arguments.length);};c.c=b;c.b=a;return c}(),function(a){return L(Yh(a))},Xh,b,function(b){return Math.sqrt(a(b))},function(){function a(a,b){return yg(Uf(a,function(){return pd(b,Ui(L(b)))}))}var b=null;b=function(b,c){switch(arguments.length){case 1:return pd(b,Ui(L(b)));case 2:return a.call(this,b,c)}throw Error("Invalid arity: "+arguments.length);};b.c=function(a){return pd(a,
Ui(L(a)))};b.b=a;return b}(),function(a,b){var c=Pf;b=fe(b);for(var d=Math.random,e=b.length-1;0<e;e--){var l=Math.floor(d()*(e+1)),m=b[e];b[e]=b[l];b[l]=m}b=yg(b);return yg(c(a,b))}])}();function qv(a){a="string"===typeof a?Ku(a):a;return Vi(zd,a)}function rv(a){a=Nf.b(Rk,yg(Yh(Z(Cd,a))));return new $u($h(a,gi.G()),Cd,null,null,null)}
var sv=function sv(a,b){if(null!=a&&null!=a.Fc)return a.Fc(a,b);var d=sv[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=sv._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IBinding.in-\x3erel",a);};xr.prototype.Fc=function(){return jv.G()};yr.prototype.Fc=function(a,b){return new $u(Gd([dg(this,new U(null,2,5,V,[rk,Rk],null)),0]),new U(null,1,5,V,[ob(new U(null,1,5,V,[b],null))],null),null,null,null)};
Ar.prototype.Fc=function(a,b){if(Ep(b))return Nd(b)?rv(this):ie(iv,Nf.b(function(a){return function(b){return sv(um.c(a),b)}}(this),b));throw vj(["Cannot bind value ",Di.h(M([b]))," to collection ",Di.h(M([hr(this)]))].join(""),new q(null,3,[qn,Yk,dl,b,um,hr(this)],null));};
zr.prototype.Fc=function(a,b){if(Ep(b)){if(L(b)<L(Pk.c(this)))throw vj(["Not enough elements in a collection ",Di.h(M([b]))," to bind tuple ",Di.h(M([hr(this)]))].join(""),new q(null,3,[qn,Yk,dl,b,um,hr(this)],null));return ie(jv,Nf.f(function(){return function(a,b){return sv(a,b)}}(this),Pk.c(this),b))}throw vj(["Cannot bind value ",Di.h(M([b]))," to tuple ",Di.h(M([hr(this)]))].join(""),new q(null,3,[qn,Yk,dl,b,um,hr(this)],null));};
function tv(a,b){var c=O(b,0);b=O(b,1);return c instanceof yr&&rk.c(c)instanceof kr?ig(a,Tk,P,dg(c,new U(null,2,5,V,[rk,Rk],null)),b):c instanceof yr&&rk.c(c)instanceof mr?P.f(a,Wl,qv(b)):hg(a,pm,Bd,sv(c,b))}function uv(a,b,c){return A(tv,a,$h(b,c))}var vv=null,wv=null;function xv(a,b){a=a.c?a.c(b):a.call(null,b);return Zd(vv,b)?function(a){return function(b){b=b[a];return"number"===typeof b?b:Qd(b)?Eq(wv,b):b instanceof Array?Eq(wv,b):b}}(a):function(a){return function(b){return b[a]}}(a)}
function yv(a){return 1===L(a)?x(a):function(a){return function(b){return I(a.map(function(){return function(a){return a.c?a.c(b):a.call(null,b)}}(a)))}}(fe(a))}function zv(a,b){for(var c=lc(pf);;){var d=x(b);if(null==d)return nc(c);var e=a.c?a.c(d):a.call(null,d);b=y(b);c=bf.f(c,e,Bd.b(F.f(c,e,Wc),d))}}
function Av(a,b){var c=Nj.c(a),d=Nj.c(b),e=jn.c(a),g=jn.c(b),h=yg(av(jn.c(a),jn.c(b))),k=Nf.b(function(a,b,c){return function(a){return xv(c,a)}}(c,d,e,g,h),h),l=Nf.b(function(a,b,c,d){return function(a){return xv(d,a)}}(c,d,e,g,h,k),h);a=Ug(e);b=yg(Fo.b(Xh(Ug(g)),Xh(Ug(e))));var m=fe(Nf.b(e,a)),p=fe(Nf.b(g,b)),u=yv(k),w=zv(u,c),z=yv(l);c=nc(A(function(a,b,c,d,e,g,h,k,l,m,p,u,w,z){return function(D,C){var G=z.c?z.c(C):z.call(null,C),N=F.b(w,G);return null==N?D:A(function(a,b,c,d,e,g,h,k,l,m,p,u,w,
z){return function(a,b){return af.b(a,hv(b,w,C,z))}}(N,N,G,a,b,c,d,e,g,h,k,l,m,p,u,w,z),D,N)}}(c,d,e,g,h,k,l,a,b,m,p,u,w,z),lc(Cd),d));return new $u($h(T.b(a,b),gi.G()),c,null,null,null)}
function Bv(a,b){var c=null!=a&&(a.m&64||n===a.Ga)?jf(Ff,a):a,d=F.b(c,jn),e=F.b(c,Nj),g=null!=b&&(b.m&64||n===b.Ga)?jf(Ff,b):b,h=F.b(g,jn),k=F.b(g,Nj),l=av(d,h),m=Nf.b(function(a,b,c,d,e,g,h){return function(a){return xv(h,a)}}(a,c,d,e,b,g,h,k,l),l),p=yv(m),u=zv(p,k),w=Nf.b(function(a,b,c){return function(a){return xv(c,a)}}(a,c,d,e,b,g,h,k,l,m,p,u),l),z=yv(w);return P.f(a,Nj,bg(function(a,b,c,d,e,g,h,k,l,m,p,u,w,z){return function(a){a=z.c?z.c(a):z.call(null,a);return null==(u.c?u.c(a):u.call(null,
a))}}(a,c,d,e,b,g,h,k,l,m,p,u,w,z),e))}function Cv(a,b){var c=ag.b(function(a){return a instanceof E?null:a},b);a=Zp(a,c);b=$f.b(pf,Yf(function(){return function(a){var b=O(a,0);O(a,1);return ev(b)}}(c,a),Nf.f(Ag,b,new U(null,4,5,V,["e","a","v","tx"],null))));return new $u(b,a,null,null,null)}
function Dv(a,b){a=Yf(function(a){a:for(var c=b;;){var d=a;if(r(r(d)?c:d)){d=x(a);var h=x(c);if(h instanceof E||J.b(d,h))a=y(a),c=y(c);else{a=!1;break a}}else{a=!0;break a}}return a},a);var c=$f.b(pf,Yf(function(){return function(a){var b=O(a,0);O(a,1);return ev(b)}}(a),Nf.f(Ag,b,gi.G())));return new $u(c,ag.b(fe,a),null,null,null)}function Ev(a,b){return(null!=a?n===a.Pd||(a.gc?0:eb(Yp,a)):eb(Yp,a))?Cv(a,b):Dv(a,b)}
function Fv(a,b){for(var c=Cd;;){var d=x(a);if(null==d)return Bd.b(c,b);r(mf(av(jn.c(b),jn.c(d))))?(a=y(a),b=Av(d,b)):(a=y(a),c=Bd.b(c,d))}}function Gv(a,b){return uf(function(a){return Zd(jn.c(a),b)?a:null},pm.c(a))}function Hv(a,b){var c=Gv(a,b);if(null==c)return null;a=x(Nj.c(c));null==a?b=null:(c=jn.c(c),b=c.c?c.c(b):c.call(null,b),b=a[b]);return b}function Iv(a,b){return uf(function(b){return Zd(jn.c(a),b)},b)}
function Jv(a,b){var c=Yf(function(a){return Iv(a,b)},pm.c(a)),d=ie(jv,c);return new U(null,2,5,V,[gg(a,pm,function(a){return function(b){return Zf(Xh(a),b)}}(c,d)),d],null)}
function Kv(a,b,c,d){a=Tk.c(a);b=jn.c(b);for(var e=L(d),g=Array(e),h=Array(e),k=0;;)if(k<e){var l=pd(d,k);if(l instanceof E){var m=F.b(a,l);null==m?h[k]=F.b(b,l):g[k]=m}else g[k]=l;k+=1}else break;return c===Ag?function(a,b,d,e,g){return function(a){for(var b=e.slice(0),h=0;;)if(h<d){var k=kb.b(g,h);null!=k&&(b[h]=a[k]);h+=1}else break;return jf(c,b)}}(a,b,e,g,h):function(a,b,d,e,g){return function(a){for(var b=0;;)if(b<d){var h=kb.b(g,b);null!=h&&(e[b]=a[h]);b+=1}else break;return jf(c,e)}}(a,b,
e,g,h)}function Lv(a,b){var c=O(b,0),d=I(c),e=x(d),g=y(d),h=function(){var c=F.b(ov,e);if(r(c))return c;c=Hv(a,e);if(r(c))return c;if(r(null))return null;if(null==Gv(a,e))throw vj(["Unknown predicate '",Di.h(M([e]))," in ",Di.h(M([b]))].join(""),new q(null,3,[qn,Vn,zn,b,Fm,e],null));return null}(),k=Jv(a,Yf(Qc,g)),l=O(k,0),m=O(k,1),p=r(h)?function(){var a=Kv(l,m,h,g);return gg(m,Nj,function(a){return function(b){return Yf(a,b)}}(a,b,c,d,e,g,e,g,h,k,l,m))}():P.f(m,Nj,Cd);return hg(l,pm,Bd,p)}
function Mv(a,b){var c=O(b,0),d=I(c),e=x(d),g=y(d),h=O(b,1),k=Dr(h),l=function(){var c=F.b(ov,e);if(r(c))return c;c=Hv(a,e);if(r(c))return c;if(r(null))return null;if(null==Gv(a,e))throw vj(["Unknown function '",Di.h(M([e]))," in ",Di.h(M([b]))].join(""),new q(null,3,[qn,Vn,zn,b,Fm,e],null));return null}(),m=Jv(a,Yf(Qc,g)),p=O(m,0),u=O(m,1),w=r(l)?function(){var a=Kv(p,u,l,g),w=function(){return function(a,b,c,d,e,g,h,k,l,m,p,u,w,z){return function bb(D){return new Ne(null,function(a,b,c,d,e,g,h,
k,l,m,p,u,w,z){return function(){for(var b=D;;)if(b=I(b)){if(Ud(b)){var c=tc(b),d=L(c),e=Re(d);a:for(var g=0;;)if(g<d){var h=B.b(c,g),k=a.c?a.c(h):a.call(null,h);null!=k&&(h=jv.b(new $u(jn.c(z),new U(null,1,5,V,[h],null),null,null,null),sv(m,k)),e.add(h));g+=1}else{c=!0;break a}return c?Te(e.aa(),bb(uc(b))):Te(e.aa(),null)}e=x(b);c=a.c?a.c(e):a.call(null,e);if(null!=c)return ud(jv.b(new $u(jn.c(z),new U(null,1,5,V,[e],null),null,null,null),sv(m,c)),bb(Vc(b)));b=Vc(b)}else return null}}(a,b,c,d,e,
g,h,k,l,m,p,u,w,z),null,null)}}(a,b,c,d,e,g,e,g,h,k,l,m,p,u)(Nj.c(u))}();return Nd(w)?jv.b(u,rv(k)):ie(iv,w)}():jv.b(P.f(u,Nj,Cd),rv(k));return hg(p,pm,Fv,w)}function Nv(a,b){return Qd(b)&&Zd(Wl.c(a),dv(x(b))?xd(b):x(b))}var Ov=Cf(0);
function Pv(a,b){var c=I(a),d=x(c),e=y(c),g=If.b(Ov,dd);b=F.b(Wl.c(b),d);return function(a,b,c,d,e,g,w,z){return function G(h){return new Ne(null,function(a,b,c,d,e,g,k,l){return function(){for(;;){var m=I(h);if(m){var p=m;if(Ud(p)){var u=tc(p),w=L(u),z=Re(w);return function(){for(var h=0;;)if(h<w){var C=B.b(u,h),G=C,N=I(G),K=x(N),R=y(N),Y=K,ca=I(Y),ma=x(ca),ta=y(ca),ya=ma,Da=ta,Ba=R,Ea=$h(Da,g);Ue(z,Cp(function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,C,G,N,K,R,Y,ca,ma,ta,ya,Da,Ba){return function(a){if(ev(a)){var b=
w.c?w.c(a):w.call(null,a);return null==b?Sc.c([Me(a),"__auto__",t.c(Ba)].join("")):b}return a}}(h,G,N,K,R,Y,ca,ma,ta,ya,Da,Ba,Ea,C,u,w,z,p,m,a,b,c,d,e,g,k,l),Ba));h+=1}else return!0}()?Te(z.aa(),G(uc(p))):Te(z.aa(),null)}var C=x(p),N=C,K=I(N),R=x(K),Y=y(K),ca=R,ma=I(ca),ta=x(ma),ya=y(ma),Mc=ta,Tc=ya,yd=Y,Ye=$h(Tc,g);return ud(Cp(function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,C,G,N,K,R,Y,ca,ma){return function(a){if(ev(a)){var b=u.c?u.c(a):u.call(null,a);return null==b?Sc.c([Me(a),"__auto__",t.c(ma)].join("")):
b}return a}}(N,K,R,Y,ca,ma,ta,ya,Mc,Tc,yd,Ye,C,p,m,a,b,c,d,e,g,k,l),yd),G(Vc(p)))}return null}}}(a,b,c,d,e,g,w,z),null,null)}}(a,c,d,e,d,e,g,b)(b)}function Qv(a,b){a=Zf(function(a){var b=O(a,0);a=O(a,1);return J.b(b,a)},Nf.f(Ag,a,b));return new U(null,2,5,V,[Nf.b(x,a),Nf.b(xd,a)],null)}
function Rv(a,b){var c=I(a),d=x(c),e=y(c);b=F.b(b,d);return function(a,b,c,d,e,p,u){return function D(g){return new Ne(null,function(a,b,c,d,e,h){return function(){for(;;){var a=I(g);if(a){if(Ud(a)){var b=tc(a),c=L(b),d=Re(c);a:for(var e=0;;)if(e<c){var k=B.b(b,e),l=Qv(h,k);k=O(l,0);l=O(l,1);k=new U(null,1,5,V,[T.h(new U(null,1,5,V,[eo],null),k,M([l]))],null);d.add(k);e+=1}else{b=!0;break a}return b?Te(d.aa(),D(uc(a))):Te(d.aa(),null)}d=x(a);b=Qv(h,d);d=O(b,0);b=O(b,1);return ud(new U(null,1,5,V,
[T.h(new U(null,1,5,V,[eo],null),d,M([b]))],null),D(Vc(a)))}return null}}}(a,b,c,d,e,p,u),null,null)}}(a,c,d,e,d,e,b)(b)}function Sv(a){var b=Cf(Cd);Cp(function(a){return function(b){r(ev.c?ev.c(b):ev.call(null,b))&&If.f(a,Bd,b);return b}}(b),a);return Rb(b)}function Tv(a,b){a=function(a){return function(b){b=O(b,0);b=I(b);x(b);b=y(b);return tf(a,b)}}(Xh(Sv(a)));return new U(null,2,5,V,[Yf(a,b),Zf(a,b)],null)}
function Uv(a,b){for(var c=Yf(ev,b),d=$h(c,gi.G()),e=function(){return function(a,b){return A(Vv,a,b)}}(c,d),g=function(a,b,c){return function(d){return uf(function(){return function(a){return Nd(Nj.c(a))}}(a,b,c),pm.c(d))}}(c,d,e),h=new Dd(null,new q(null,5,[bo,Cd,el,a,xn,new U(null,1,5,V,[b],null),zj,pf,Nm,pf],null),null,1,null),k=new $u(d,Cd,null,null,null);;){var l=x(h);if(null==l)return k;var m=l,p=ii(function(){return function(b){return!Nv(a,b)}}(h,k,m,l,c,d,e,g),xn.c(m)),u=O(p,0),w=O(p,1),
z=I(w),D=x(z),C=y(z),G=D,N=C;if(null==G){b=e(el.c(m),u);b=Wv?Wv(b,c):Xv.call(null,b,c);var K=new $u(d,b,null,null,null);b=y(h);K=iv(k,K);h=b;k=K}else{var Y=G,ma=I(Y),ya=x(ma),R=y(ma),ta=ya,ca=R,Ea=Rv(G,zj.c(m)),Da=Tv(T.b(bo.c(m),u),T.b(Ea,Nm.c(m))),Ba=O(Da,0),Za=O(Da,1);if(r(uf(function(){return function(a){return J.b(a,new U(null,1,5,V,[He(eo)],null))}}(h,k,Y,ma,ya,R,ta,ca,Ea,Da,Ba,Za,p,u,w,z,D,C,G,N,m,l,c,d,e,g),Ba)))b=y(h),K=k,h=b,k=K;else{var Ja=T.b(u,Ba),Ta=e(el.c(m),Ja);if(r(g(Ta)))b=y(h),K=
k,h=b,k=K;else{var bb=P.f(zj.c(m),ta,Bd.b(F.f(zj.c(m),ta,Cd),ca)),Na=Pv(G,a);b=T.b(function(){return function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,C,D,G,N,K,R,Y,ca,ma,ta,ya,Ba,Da,Ea,Ja,Ta){return function gs(Na){return new Ne(null,function(a,b,c,d,e,g,h,k,l,m,p,u,w,z,C,D,G,N,K,R,Y,ca,ma,ta){return function(){for(;;){var a=I(Na);if(a){if(Ud(a)){var b=tc(a),d=L(b),h=Re(d);a:for(var k=0;;)if(k<d){var l=B.b(b,k);l=new q(null,5,[bo,e,el,g,xn,$f.f(Cd,Ki,M([l,ta])),zj,c,Nm,D],null);h.add(l);k+=1}else{b=!0;break a}return b?
Te(h.aa(),gs(uc(a))):Te(h.aa(),null)}h=x(a);return ud(new q(null,5,[bo,e,el,g,xn,$f.f(Cd,Ki,M([h,ta])),zj,c,Nm,D],null),gs(Vc(a)))}return null}}}(a,b,c,d,e,g,h,k,l,m,p,u,w,z,C,D,G,N,K,R,Y,ca,ma,ta,ya,Ba,Da,Ea,Ja,Ta),null,null)}}(h,k,bb,Na,Ja,Ta,Y,ma,ya,R,ta,ca,Ea,Da,Ba,Za,p,u,w,z,D,C,G,N,m,l,c,d,e,g)(Na)}(),y(h));K=k;h=b;k=K}}}}}
function Yv(a,b){if(null!=a?n===a.kd||(a.gc?0:eb(cq,a)):eb(cq,a)){var c=O(b,0),d=O(b,1),e=O(b,2),g=O(b,3);return Dg(new U(null,4,5,V,[r(function(){var a=gv(c);return r(a)?a:fv(c)}())?Bq(a,c):c,d,r(function(){if(r(e)){var b=fv(d);return b&&(b=Aq(a,d))?(b=gv(e),r(b)?b:fv(e)):b}return e}())?Bq(a,e):e,r(gv(g))?Bq(a,g):g],null),L(b))}return b}function Zv(a,b){var c=O(b,0),d=O(b,1),e=O(b,2);b=O(b,3);c=ev(c)?Bd.b(Wh,c):Wh;c=ev(b)?Bd.b(c,b):c;return ev(e)&&!ev(d)&&Aq(a,d)?Bd.b(c,e):c}
function $v(a,b){return P.f(a,pm,Af(function(a){var c=mf(Rh(jn.c(a),b));return null==c?null:P.f(a,jn,c)},pm.c(a)))}function aw(a,b,c){a=$f.b(Wh,Wf(function(a){return Ug(jn.c(a))},M([pm.c(a)])));if(!Go(b,a))throw b=Fo.b(Xh(b),a),vj(["Insufficient bindings: ",Di.h(M([b]))," not bound in ",Di.h(M([c]))].join(""),new q(null,3,[qn,Vn,zn,c,xo,b],null));}
var Vv=function Vv(a){switch(arguments.length){case 2:return Vv.b(arguments[0],arguments[1]);case 3:return Vv.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};Vv.b=function(a,b){return Vv.f(a,b,b)};
Vv.f=function(a,b,c){for(;;){var d=cv,e=b;if(r(function(){var a=new U(null,1,5,V,[new U(null,2,5,V,[Qc,Zk],null)],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}()))return Lv(a,b);if(r(function(){var a=new U(null,2,5,V,[new U(null,2,5,V,[Qc,Zk],null),Pl],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}()))return Mv(a,b);if(r(function(){var a=new U(null,2,5,V,[dv,Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}())){var g=I(b);c=x(g);g=y(g);var h=wv;wv=F.b(Tk.c(a),c);try{return Vv.f(a,g,b)}finally{wv=
h}}else{if(r(function(){var a=new U(null,2,5,V,[lm,Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}())){var k=b,l=I(k),m=x(l),p=y(l);g=m;h=p;var u=Nf.b(function(a){return function(b){return bw.b?bw.b(a,b):bw.call(null,a,b)}}(a,b,c,k,l,m,p,g,h,d,e),h);b=Nf.b(function(){return function(a){return ie(Av,pm.c(a))}}(a,b,c,k,l,m,p,g,h,u,d,e),u);return P.f(x(u),pm,new U(null,1,5,V,[ie(iv,b)],null))}if(r(function(){var a=new U(null,3,5,V,[Al,new U(null,2,5,V,[new U(null,1,5,V,[Zk],null),Zk],null),Zk],null),
b=e;return d.b?d.b(a,b):d.call(null,a,b)}())){h=I(b);g=x(h);h=y(h);k=x(h);g=y(h);k=I(k);h=x(k);k=y(k);u=h;h=g;aw(a,u,c);c=Xe(Al,T.b(u,k),h);g=b;b=c;c=g;continue}else{if(r(function(){var a=new U(null,3,5,V,[Al,new U(null,1,5,V,[Zk],null),Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}())){m=b;p=I(m);var w=x(p),z=y(p);g=w;var D=x(z),C=y(z);k=D;h=C;var G=Xh(k);l=$v(a,G);u=Nf.b(function(a,b,c,d,e,g,h,k,l,m,p,u,w,z){return function(a){return $v(bw.b?bw.b(z,a):bw.call(null,z,a),w)}}(a,b,c,m,p,w,z,g,
D,C,k,h,G,l,d,e),h);b=Nf.b(function(){return function(a){return ie(Av,pm.c(a))}}(a,b,c,m,p,w,z,g,D,C,k,h,G,l,u,d,e),u);b=ie(iv,b);return hg(a,pm,Fv,b)}if(r(function(){var a=new U(null,2,5,V,[po,Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}()))return c=I(b),b=x(c),c=y(c),g=b,h=c,A(bw,a,h);if(r(function(){var a=new U(null,2,5,V,[Im,Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}())){k=b;u=I(k);l=x(u);m=y(u);g=l;h=m;b=Xh(Wf(function(){return function(a){return Ug(jn.c(a))}}(a,b,c,k,u,l,m,g,
h,d,e),M([pm.c(a)])));g=Xh(Sv(h));if(Nd(Eo.b(b,g)))throw vj(["Insufficient bindings: none of ",Di.h(M([g]))," is bound in ",Di.h(M([c]))].join(""),new q(null,2,[qn,Vn,zn,c],null));a=P.f(a,pm,new U(null,1,5,V,[ie(Av,pm.c(a))],null));b=A(bw,a,h);b=Bv(x(pm.c(a)),ie(Av,pm.c(b)));return P.f(a,pm,new U(null,1,5,V,[b],null))}if(r(function(){var a=new U(null,3,5,V,[Qm,new U(null,1,5,V,[Zk],null),Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}()))return b=I(b),g=x(b),b=y(b),g=x(b),b=y(b),k=g,h=b,aw(a,
k,c),a=P.f(a,pm,new U(null,1,5,V,[ie(Av,pm.c(a))],null)),l=$v(a,k),b=$v(A(bw,l,h),k),b=Bv(x(pm.c(a)),ie(Av,pm.c(b))),P.f(a,pm,new U(null,1,5,V,[b],null));if(r(function(){var a=new U(null,1,5,V,[Zk],null),b=e;return d.b?d.b(a,b):d.call(null,a,b)}())){c=wv;b=Yv(c,b);g=Ev(c,b);h=vv;vv=(null!=c?n===c.kd||(c.gc?0:eb(cq,c)):eb(cq,c))?Zv(c,b):vv;try{return hg(a,pm,Fv,g)}finally{vv=h}}else throw Error(["No matching clause: ",t.c(e)].join(""));}}break}};Vv.H=3;
var bw=function bw(a,b){if(Nv(a,b))if(dv(x(b))){var d=wv;wv=F.b(Tk.c(a),x(b));try{var e=y(b);return bw.b?bw.b(a,e):bw.call(null,a,e)}finally{wv=d}}else return hg(a,pm,Fv,Uv(a,b));else return Vv.b(a,b)};function cw(a,b){var c=wv;wv=F.b(Tk.c(a),Lm);try{return A(bw,a,b)}finally{wv=c}}function Xv(a){switch(arguments.length){case 2:return Wv(arguments[0],arguments[1]);case 3:return dw(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}}
function Wv(a,b){a=pm.c(a);return dw(new U(null,1,5,V,[Array(L(b))],null),a,b)}
function dw(a,b,c){for(;;){var d=x(b);if(null==d)return a;var e=d,g=Rh(jn.c(e),c);if(Nd(g)){var h=a,k=y(b),l=c;a=h;b=k;c=l}else{var m=fe(Nf.b(function(a,b,c,d){return function(a){return F.b(d,a)}}(a,b,c,g,e,d),c)),p=L(c);h=function(){return function(a,b,c,d,e,g,h,k){return function ya(l){return new Ne(null,function(a,b,c,d,e,g,h,k){return function(){for(var m=l;;){var p=I(m);if(p){var u=p,w=x(u);if(p=I(function(a,b,c,d,e,g,h,k,l,m,p,u){return function sr(w){return new Ne(null,function(a,b,c,d,e,g,
h,k,l){return function(){for(;;){var a=I(w);if(a){if(Ud(a)){var b=tc(a),c=L(b),d=Re(c);return function(){for(var a=0;;)if(a<c){for(var g=B.b(b,a),h=d,m=jb(e),p=0;;)if(p<l){var u=kb.b(k,p);null!=u&&mb.f(m,p,g[u]);p+=1}else break;h.add(m);a+=1}else return!0}()?Te(d.aa(),sr(uc(a))):Te(d.aa(),null)}var g=x(a);return ud(function(){for(var a=jb(e),b=0;;)if(b<l){var c=kb.b(k,b);null!=c&&mb.f(a,b,g[c]);b+=1}else break;return a}(),sr(Vc(a)))}return null}}}(a,b,c,d,e,g,h,k,l,m,p,u),null,null)}}(m,a,b,c,w,u,
p,d,e,g,h,k)(Nj.c(h))))return T.b(p,ya(Vc(m)));m=Vc(m)}else return null}}}(a,b,c,d,e,g,h,k),null,null)}}(a,b,c,m,p,g,e,d)(a)}();k=y(b);l=c;a=h;b=k;c=l}}}function ew(a,b){return Xh(Nf.b(yg,Wv(a,b)))}var fw=function fw(a,b){if(null!=a&&null!=a.Gc)return a.Gc(a,b);var d=fw[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=fw._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IContextResolve.-context-resolve",a);};jr.prototype.Gc=function(a,b){return Hv(b,this.ea)};
kr.prototype.Gc=function(a,b){return dg(b,new U(null,2,5,V,[Tk,this.ea],null))};or.prototype.Gc=function(){var a=F.b(pv,this.ea);return r(a)?a:null};nr.prototype.Gc=function(){return this.value};function gw(a,b,c){return ag.B(function(a,e,g){if(Nr(a)){e=fw(jk.c(a),b);a=Nf.b(function(){return function(a){return fw(a,b)}}(e),Zh(Aj.c(a)));var d=Nf.b(function(){return function(a){return pd(a,g)}}(e,a),c);return jf(e,T.b(a,new U(null,1,5,V,[d],null)))}return e},a,x(c),gi.G())}
function hw(a){var b=wf(Nr);return Zf($a,Nf.f(function(a,d){return r(b.c?b.c(a):b.call(null,a))?d:null},a,gi.G()))}
function iw(a,b,c){var d=hw(a),e=function(a){return function(b){return Nf.b(function(){return function(a){return pd(b,a)}}(a),a)}}(d);c=Vi(e,c);return function(c,d,e){return function p(g){return new Ne(null,function(){return function(){for(;;){var c=I(g);if(c){if(Ud(c)){var d=tc(c),e=L(d),h=Re(e);a:for(var k=0;;)if(k<e){var m=B.b(d,k);O(m,0);m=O(m,1);m=gw(a,b,m);h.add(m);k+=1}else{d=!0;break a}return d?Te(h.aa(),p(uc(c))):Te(h.aa(),null)}h=x(c);O(h,0);h=O(h,1);return ud(gw(a,b,h),p(Vc(c)))}return null}}}(c,
d,e),null,null)}}(d,e,c)(c)}var jw=function jw(a,b){if(null!=a&&null!=a.Hc)return a.Hc(a,b);var d=jw[ba(null==a?null:a)];if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);d=jw._;if(null!=d)return d.b?d.b(a,b):d.call(null,a,b);throw gb("IPostProcess.-post-process",a);};Jr.prototype.Hc=function(a,b){return b};Kr.prototype.Hc=function(a,b){return $f.f(Cd,Nf.c(x),b)};Lr.prototype.Hc=function(a,b){return zd(b)};Mr.prototype.Hc=function(a,b){return x(b)};
function kw(a,b,c){return function(a){return function h(b){return new Ne(null,function(a){return function(){for(;;){var c=I(b);if(c){var d=c;if(Ud(d)){var g=tc(d),k=L(g),w=Re(k);return function(){for(var b=0;;)if(b<k){var h=B.b(g,b);Ue(w,ag.f(function(){return function(a,b){if(r(a)){var c=O(a,0);a=O(a,1);return gt(c,a,new U(null,1,5,V,[b],null),!1)}return b}}(b,h,g,k,w,d,c,a),a,h));b+=1}else return!0}()?Te(w.aa(),h(uc(d))):Te(w.aa(),null)}var z=x(d);return ud(ag.f(function(){return function(a,b){if(r(a)){var c=
O(a,0);a=O(a,1);return gt(c,a,new U(null,1,5,V,[b],null),!1)}return b}}(z,d,c,a),a,z),h(Vc(d)))}return null}}}(a),null,null)}}(function(){return function g(a){return new Ne(null,function(){for(;;){var c=I(a);if(c){if(Ud(c)){var e=tc(c),l=L(e),m=Re(l);a:for(var p=0;;)if(p<l){var u=B.b(e,p);u=Or(u)?new U(null,2,5,V,[fw(Il.c(u),b),Ms(fw(yo.c(u),b))],null):null;m.add(u);p+=1}else{e=!0;break a}return e?Te(m.aa(),g(uc(c))):Te(m.aa(),null)}m=x(c);return ud(Or(m)?new U(null,2,5,V,[fw(Il.c(m),b),Ms(fw(yo.c(m),
b))],null):null,g(Vc(c)))}return null}},null,null)}(a)}())(c)}var lw=new Jf(ls(pf,Nh(),pf,0,100));
function mw(a){var b=F.f(Rb(lw),a,null);if(null==b){if(Rd(a))b=a;else if(Qd(a))b=hs(a);else throw vj("Query should be a vector or a map",new q(null,2,[qn,zo,zn,a],null));var c=b;b=Qr(Ej.c(c));var d=Mm.c(c);if(r(d)){var e=cr(pr,d);if(r(e))d=e;else throw vj("Cannot parse :with clause, expected [ variable+ ]",new q(null,2,[qn,Am,zn,d],null));}else d=null;e=wo.b(c,new U(null,1,5,V,[Lm],null));var g=cr(Rr,e);if(!r(g))throw vj("Cannot parse :in clause, expected (src-var | % | plain-symbol | bind-scalar | bind-tuple | bind-coll | bind-rel)",
new q(null,2,[qn,Bj,zn,e],null));e=g;c=hk.b(c,Cd);g=es(c);if(!r(g))throw vj("Cannot parse :where clause, expected [clause+]",new q(null,2,[qn,Ck,zn,c],null));b=new q(null,4,[ul,b,jm,d,dm,e,Xl,g],null);c=Q.h(b,ul,M([jm,dm,Xl]));c=Sd(b)?$f.b(pf,c):c;b=new fs(ul.c(b),jm.c(b),dm.c(b),Xl.c(b),null,mf(c),null);is(b,a);lw.Uc(null,P.f(lw.rc(null),a,b))}return b}
var nw=function nw(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return nw.h(arguments[0],1<c.length?new v(c.slice(1),0,null):null)};
nw.h=function(a,b){var c=mw(a),d=ul.c(c),e=Ir(d),g=Wf(Fr,M([Ir(d)])),h=L(e),k=jm.c(c),l=T.b(g,Nf.b(Rk,k));a=Qd(a)?hs(a):a;var m=hk.c(a);b=uv(new Zu(Cd,pf,pf,null,null,null),dm.c(c),b);var p=ew(cw(b,m),l);c=r(Mm.c(a))?ag.b(function(a,b,c,d,e,g){return function(a){return yg(Dg(a,g))}}(p,c,d,e,g,h,k,l,a,m,b,p),p):p;c=r(uf(Nr,e))?iw(e,b,c):c;e=r(uf(Or,e))?kw(e,b,c):c;return jw(d,e)};nw.H=1;nw.K=function(a){var b=x(a);a=y(a);return this.h(b,a)};function ow(a){return a instanceof qq}function pw(a,b,c){if(ow(a))throw vj("Filtered DB cannot be modified",new q(null,1,[qn,Jl],null));var d=Xq;a=new q(null,5,[nm,a,Gk,a,om,Cd,Ij,pf,Kn,c],null);c=Q.h(a,nm,M([Gk,om,Ij,Kn]));c=Sd(a)?$f.b(pf,c):c;a=new Cq(nm.c(a),Gk.c(a),om.c(a),Ij.c(a),Kn.c(a),null,mf(c),null);return d(a,b)}
var qw=function qw(a){switch(arguments.length){case 2:return qw.b(arguments[0],arguments[1]);case 3:return qw.f(arguments[0],arguments[1],arguments[2]);case 4:return qw.B(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return qw.V(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);case 6:return qw.la(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};
qw.b=function(a,b){return $p(a,b,Cd)};qw.f=function(a,b,c){return $p(a,b,new U(null,1,5,V,[c],null))};qw.B=function(a,b,c,d){return $p(a,b,new U(null,2,5,V,[c,d],null))};qw.V=function(a,b,c,d,e){return $p(a,b,new U(null,3,5,V,[c,d,e],null))};qw.la=function(a,b,c,d,e,g){return $p(a,b,new U(null,4,5,V,[c,d,e,g],null))};qw.H=6;
var rw=function rw(a){switch(arguments.length){case 2:return rw.b(arguments[0],arguments[1]);case 3:return rw.f(arguments[0],arguments[1],arguments[2]);case 4:return rw.B(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return rw.V(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);case 6:return rw.la(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};
rw.b=function(a,b){return aq(a,b,Cd)};rw.f=function(a,b,c){return aq(a,b,new U(null,1,5,V,[c],null))};rw.B=function(a,b,c,d){return aq(a,b,new U(null,2,5,V,[c,d],null))};rw.V=function(a,b,c,d,e){return aq(a,b,new U(null,3,5,V,[c,d,e],null))};rw.la=function(a,b,c,d,e,g){return aq(a,b,new U(null,4,5,V,[c,d,e,g],null))};rw.H=6;function sw(a){return Df(a)}function tw(a,b,c){var d=Cf(null);If.b(a,function(a){return function(d){d=pw(d,b,c);Hf(a,d);return Gk.c(d)}}(d));return Rb(d)}
var uw=function uw(a){switch(arguments.length){case 2:return uw.b(arguments[0],arguments[1]);case 3:return uw.f(arguments[0],arguments[1],arguments[2]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};uw.b=function(a,b){return uw.f(a,Ti.G(),b)};uw.f=function(a,b,c){If.B(Ef.c(Ld(a)),P,b,c);return b};uw.H=3;
for(var vw=I(new q(null,2,[hm,function(a){return jf(yp,a)},on,function(a){var b=null!=a&&(a.m&64||n===a.Ga)?jf(Ff,a):a,c=F.b(b,Jj),d=F.b(b,so);return yq(Nf.b(function(){return function(a){var b=O(a,0),c=O(a,1),d=O(a,2);a=O(a,3);return yp.B(b,c,d,a)}}(a,b,c,d),d),c)}],null)),ww=null,xw=0,yw=0;;)if(yw<xw){var zw=ww.Z(null,yw),Aw=O(zw,0),Bw=O(zw,1),Cw=Aw,Dw=Bw;F.b(Rb(Ju),Cw);If.B(Ju,P,Cw,Dw);yw+=1}else{var Ew=I(vw);if(Ew){var Fw=Ew;if(Ud(Fw)){var Gw=tc(Fw),Hw=uc(Fw),Iw=Gw,Jw=L(Gw);vw=Hw;ww=Iw;xw=Jw}else{var Kw=
x(Fw),Lw=O(Kw,0),Mw=O(Kw,1),Nw=Lw,Ow=Mw;F.b(Rb(Ju),Nw);If.B(Ju,P,Nw,Ow);vw=y(Fw);ww=null;xw=0}yw=0}else break}function Pw(a,b){a=a.toString(16);var c=L(a);c>b?b=De.f(a,0,b):c<b?(b-=c,b=[t.c(jf(t,0<b?new Sf(null,b,"0",null):Wc)),t.c(a)].join("")):b=a;return b};Nh();function Qw(a){return"string"===typeof a&&J.b(De.f(a,0,1),":")?Le.c(De.b(a,1)):a}function Rw(a){return je(function(a,c,d){return P.f(a,c,Cp(Qw,d))},pf,Ri(a))}function Sw(a){return Cp(function(a){return Rd(a)&&Zd(a,":db/id")?P.f(Q.b(a,":db/id"),gn,F.b(a,":db/id")):a},a)}
function Tw(a){if(Rd(a))return Sw(a);if(J.b(x(a),":db.fn/call")){var b=I(a),c=x(b),d=y(b),e=x(d),g=y(d);return T.b(new U(null,2,5,V,[Sl,function(a,b,c,d,e,g,w,z){return function(){function a(a){var c=null;if(0<arguments.length){c=0;for(var d=Array(arguments.length-0);c<d.length;)d[c]=arguments[c+0],++c;c=new v(d,0,null)}return b.call(this,c)}function b(a){a=jf(z,a);return Uw.c?Uw.c(a):Uw.call(null,a)}a.H=0;a.K=function(a){a=I(a);return b(a)};a.h=b;return a}()}(a,b,c,d,c,e,g,e,g)],null),g)}return Qd(a)?
(b=I(a),a=x(b),b=y(b),T.b(new U(null,1,5,V,[Qw(a)],null),b)):null}function Uw(a){return Nf.b(Tw,Ri(a))}function Vw(a){if(ab(a)){var b=kb.b(a,0),c=kb.b(a,1),d=kb.b(a,2),e=function(){var b=kb.b(a,3);return r(b)?b:536870912}(),g=function(){var b=kb.b(a,4);return r(b)?b:!0}();return yp.V?yp.V(b,c,d,e,g):yp.call(null,b,c,d,e,g)}b=a.e;c=a.a;d=a.v;e=function(){var b=a.tx;return r(b)?b:536870912}();g=function(){var b=a.we;return r(b)?b:!0}();return yp.V?yp.V(b,c,d,e,g):yp.call(null,b,c,d,e,g)}
function Ww(a){return Ni(Cp(function(a){return a instanceof H?t.c(a):a},a))}var Xw=function Xw(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Xw.h(0<c.length?new v(c.slice(0),0,null):null)};fa("datascript.js.empty_db",Xw);Xw.h=function(a){a=O(a,0);a=Rw(a);return kq?kq(a):lq.call(null,a)};Xw.H=0;Xw.K=function(a){return this.h(I(a))};
var Yw=function Yw(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Yw.h(arguments[0],1<c.length?new v(c.slice(1),0,null):null)};fa("datascript.js.init_db",Yw);Yw.h=function(a,b){b=O(b,0);a=Nf.b(Vw,a);b=Rw(b);return yq?yq(a,b):xq.call(null,a,b)};Yw.H=1;Yw.K=function(a){var b=x(a);a=y(a);return this.h(b,a)};
var Zw=function Zw(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return Zw.h(arguments[0],1<c.length?new v(c.slice(1),0,null):null)};fa("datascript.js.q",Zw);Zw.h=function(a,b){a=Ku(a);b=lb(nw,a,b);return Ni(b)};Zw.H=1;Zw.K=function(a){var b=x(a);a=y(a);return this.h(b,a)};fa("datascript.js.pull",function(a,b,c){b=Ku(b);c=Ri(c);a=ht.f?ht.f(a,b,c):ht.call(null,a,b,c);return Ww(a)});
fa("datascript.js.pull_many",function(a,b,c){b=Ku(b);c=Ri(c);a=it.f?it.f(a,b,c):it.call(null,a,b,c);return Ww(a)});fa("datascript.js.db_with",function(a,b){b=Uw(b);return Gk.c(pw(a,b,null))});fa("datascript.js.entity",function(a,b){b=Ri(b);return Lu.b?Lu.b(a,b):Lu.call(null,a,b)});fa("datascript.js.touch",Ru);fa("datascript.js.entity_db",function(a){return a.db});
fa("datascript.js.filter",function(a,b){if(ow(a)){var c=a.$a;return new qq(c,function(a,c,g){return function(a){var d=c.c?c.c(a):c.call(null,a);return r(d)?b.b?b.b(g,a):b.call(null,g,a):d}}(a,a.gb,c),Cf(0),null,null,null)}return new qq(a,function(c){return b.b?b.b(a,c):b.call(null,a,c)},Cf(0),null,null,null)});fa("datascript.js.is_filtered",ow);var $w=function $w(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return $w.h(0<c.length?new v(c.slice(0),0,null):null)};
fa("datascript.js.create_conn",$w);$w.h=function(a){a=O(a,0);a=Rw(a);return Df(kq?kq(a):lq.call(null,a))};$w.H=0;$w.K=function(a){return this.h(I(a))};fa("datascript.js.conn_from_db",sw);var ax=function ax(a){switch(arguments.length){case 1:return ax.c(arguments[0]);case 2:return ax.b(arguments[0],arguments[1]);default:throw Error(["Invalid arity: ",t.c(arguments.length)].join(""));}};fa("datascript.js.conn_from_datoms",ax);ax.c=function(a){a=Yw(a);return sw.c?sw.c(a):sw.call(null,a)};
ax.b=function(a,b){a=Yw.h(a,M([b]));return sw.c?sw.c(a):sw.call(null,a)};ax.H=2;fa("datascript.js.db",function(a){return Rb(a)});var bx=function bx(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return bx.h(arguments[0],arguments[1],2<c.length?new v(c.slice(2),0,null):null)};fa("datascript.js.transact",bx);
bx.h=function(a,b,c){c=O(c,0);b=Uw(b);b=tw(a,b,c);c=nm.c(b);var d=Gk.c(b),e=ob(om.c(b)),g=Ij.c(b),h={};g=I(g);for(var k=null,l=0,m=0;;)if(m<l){var p=k.Z(null,m),u=O(p,0);p=O(p,1);var w=h;u=t.c(u);w[u]=p;m+=1}else if(g=I(g))Ud(g)?(l=tc(g),g=uc(g),k=l,l=L(l)):(l=x(g),k=O(l,0),l=O(l,1),m=h,k=t.c(k),m[k]=l,g=y(g),k=null,l=0),m=0;else break;b={db_before:c,db_after:d,tx_data:e,tempids:h,tx_meta:Kn.c(b)};a=I(Rb(Ef.c(Ld(a))));c=null;for(e=d=0;;)if(e<d)h=c.Z(null,e),O(h,0),h=O(h,1),h.c?h.c(b):h.call(null,
b),e+=1;else if(a=I(a))Ud(a)?(d=tc(a),a=uc(a),c=d,d=L(d)):(c=x(a),O(c,0),c=O(c,1),c.c?c.c(b):c.call(null,b),a=y(a),c=null,d=0),e=0;else break;return b};bx.H=2;bx.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};var cx=function cx(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return cx.h(arguments[0],arguments[1],2<c.length?new v(c.slice(2),0,null):null)};fa("datascript.js.reset_conn",cx);
cx.h=function(a,b,c){var d=O(c,0);c={db_before:Rb(a),db_after:b,tx_data:ob(T.b(Nf.b(function(){return function(a){return P.f(a,Mk,!1)}}(c,d),qw.b(Rb(a),cm)),qw.b(b,cm))),tx_meta:d};Hf(a,b);a=I(Rb(Ef.c(Ld(a))));d=null;for(var e=0,g=0;;)if(g<e){var h=d.Z(null,g);O(h,0);h=O(h,1);h.c?h.c(c):h.call(null,c);g+=1}else if(a=I(a))Ud(a)?(e=tc(a),a=uc(a),d=e,e=L(e)):(d=x(a),O(d,0),d=O(d,1),d.c?d.c(c):d.call(null,c),a=y(a),d=null,e=0),g=0;else break;return b};cx.H=2;
cx.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};fa("datascript.js.listen",uw);fa("datascript.js.unlisten",function(a,b){return If.f(Ef.c(Ld(a)),Q,b)});fa("datascript.js.resolve_tempid",function(a,b){b=t.c(b);return null!==a&&b in a?a[b]:void 0});var dx=function dx(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return dx.h(arguments[0],arguments[1],2<c.length?new v(c.slice(2),0,null):null)};fa("datascript.js.datoms",dx);
dx.h=function(a,b,c){return ob(nb(qw,a,Qw(b),c))};dx.H=2;dx.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};var ex=function ex(a){for(var c=[],d=arguments.length,e=0;;)if(e<d)c.push(arguments[e]),e+=1;else break;return ex.h(arguments[0],arguments[1],2<c.length?new v(c.slice(2),0,null):null)};fa("datascript.js.seek_datoms",ex);ex.h=function(a,b,c){return ob(nb(rw,a,Qw(b),c))};ex.H=2;ex.K=function(a){var b=x(a),c=y(a);a=x(c);c=y(c);return this.h(b,a,c)};
fa("datascript.js.index_range",function(a,b,c,d){return ob(bq(a,b,c,d))});fa("datascript.js.squuid",function(){return t.c(new tj([t.c(Pw((new Date).getTime()/1E3|0,8)),"-",t.c(Pw(Ui(65536),4)),"-",t.c(Pw(Ui(65536)&4095|16384,4)),"-",t.c(Pw(Ui(65536)&16383|32768,4)),"-",t.c(Pw(Ui(65536),4)),t.c(Pw(Ui(65536),4)),t.c(Pw(Ui(65536),4))].join("").toLowerCase()))});fa("datascript.js.squuid_time_millis",function(a){return 1E3*parseInt(De.f(t.c(new tj(a.toLowerCase())),0,8),16)});
        ;return this.datascript.js;

    }.call({});

});